%% Fetch data

load('guidance_saved.mat');
load('theta.mat');
load('eta_s.mat');
load('eta_i.mat');
load('nu_s.mat');
load('nu_i.mat');
load('T.mat');
load('v_s_test.mat');

time = guidance_vars(1,:);
eta_d_N = guidance_vars(2,:);
eta_d_E = guidance_vars(3,:);
eta_d_psi = guidance_vars(4,:);

eta_d_theta_N = guidance_vars(5,:);
eta_d_theta_E = guidance_vars(6,:);
eta_d_theta_psi = guidance_vars(7,:);

eta_d_theta2_N = guidance_vars(8,:);
eta_d_theta2_E = guidance_vars(9,:);
eta_d_theta2_psi = guidance_vars(10,:);

v_s = guidance_vars(11,:);
v_s_theta = guidance_vars(12,:);
v_s_t = guidance_vars(13,:);

theta_time = theta_saved(1,:);
theta = theta_saved(2,:);

eta_s_N = eta_s(2,:);
eta_s_E = eta_s(3,:);
eta_s_psi = eta_s(4,:);

nu_s_N = nu_s(2,:);
nu_s_E = nu_s(3,:);
nu_s_psi = nu_s(4,:);

eta_i_N = eta_i(2,:);
eta_i_E = eta_i(3,:);
eta_i_psi = eta_i(4,:);

X_tow = T(2,:);
Y_tow = T(3,:);
N_tow = T(4,:);

v_s_test_plot = v_s_test(2,:);

%% theta plot

plot(theta_time, theta)

%% Plot v_s_test

plot(time, v_s_test_plot)
hold on
plot(time, v_s, 'r--')
legend('test', 'original')

%% Plot NE for eta_d

plot(eta_d_E, eta_d_N)
xlabel('East [m]')
ylabel('North [m]')

%% Plot NE for eta_s

plot(eta_s_E, eta_s_N)
xlabel('East [m]')
ylabel('North [m]')

%% Plot NE for eta_i

plot(eta_i_E, eta_i_N)
xlabel('East [m]')
ylabel('North [m]')

%% Plot NE for eta_d, eta_s, eta_i

plot(eta_d_E, eta_d_N)
hold on
plot(eta_s_E, eta_s_N, 'r')
plot(eta_i_E, eta_i_N, 'g')
xlabel('East [m]')
ylabel('North [m]')
title('NE plot of \eta_d, \eta_s and \eta_d')
legend('\eta_d', '\eta_s', '\eta_i')

%% Subplot for eta_d, eta_s, eta_i

subplot(3,1,1), plot(time, eta_d_N);
hold on
plot(time, eta_s_N, 'r--')
plot(time, eta_i_N, 'g')
title('Plot of \eta_d, \eta_s and \eta_i')
ylabel('North')
xlabel('Time [s]')
legend('\eta_d', '\eta_s', '\eta_i')
subplot(3,1,2), plot(time, eta_d_E);
hold on
plot(time, eta_s_E, 'r--')
plot(time, eta_i_E, 'g')
ylabel('East')
xlabel('Time [s]')
subplot(3,1,3), plot(time, eta_d_psi);
hold on
plot(time, eta_s_psi, 'r--')
plot(time, eta_i_psi, 'g')
ylabel('\psi')
xlabel('Time [s]')

%% Plot eta_d

subplot(3,1,1), plot(time, eta_d_N);
title('Plot of \eta_d')
ylabel('North')
xlabel('Time [s]')
subplot(3,1,2), plot(time, eta_d_E);
ylabel('East')
xlabel('Time [s]')
subplot(3,1,3), plot(time, eta_d_psi);
ylabel('\psi')
xlabel('Time [s]')

%% Plot nu_s

subplot(3,1,1), plot(time, nu_s_N);
title('Plot of \nu_s')
ylabel('North')
xlabel('Time [s]')
subplot(3,1,2), plot(time, nu_s_E);
ylabel('East')
xlabel('Time [s]')
subplot(3,1,3), plot(time, nu_s_psi);
ylabel('\psi')
xlabel('Time [s]')

%% Plot v_s

plot(time, v_s)
xlabel('Time [s]')
ylabel('Velocity [m/s]')

%% Plot v_s_t

plot(time, v_s_t)
xlabel('Time')
ylabel('Acceleration')

%% Plot v_s_theta

plot(time, v_s_theta)
xlabel('Time')
ylabel('v_s^{\theta}')

%% Plot tow forces

subplot(3,1,1), plot(time, X_tow);
title('Plot of tow forces with respect to time')
ylabel('X_{tow}')
xlabel('Time [s]')
subplot(3,1,2), plot(time, Y_tow);
ylabel('Y_{tow}')
xlabel('Time [s]')
subplot(3,1,3), plot(time, N_tow);
ylabel('N_{tow}')
xlabel('Time [s]')