/*
 * CA_CSE1_V1e_wo_LOSV2b.c
 *
 * Real-Time Workshop code generation for Simulink model "CA_CSE1_V1e_wo_LOSV2b.mdl".
 *
 * Model Version              : 1.274
 * Real-Time Workshop version : 7.3  (R2009a)  15-Jan-2009
 * C source code generated on : Wed Apr 17 14:28:20 2013
 *
 * Target selection: nidll_vxworks.tlc
 *   Note: GRT includes extra infrastructure and instrumentation for prototyping
 * Embedded hardware selection: 32-bit Generic
 * Code generation objectives: Unspecified
 * Validation result: Not run
 */

#include "CA_CSE1_V1e_wo_LOSV2b.h"
#include "CA_CSE1_V1e_wo_LOSV2b_private.h"

/* Block signals (auto storage) */
BlockIO_CA_CSE1_V1e_wo_LOSV2b CA_CSE1_V1e_wo_LOSV2b_B;

/* Continuous states */
ContinuousStates_CA_CSE1_V1e_wo CA_CSE1_V1e_wo_LOSV2b_X;

/* Solver Matrices */

/* A and B matrices used by ODE3 fixed-step solver */
static const real_T rt_ODE3_A[3] = {
  1.0/2.0, 3.0/4.0, 1.0
};

static const real_T rt_ODE3_B[3][3] = {
  { 1.0/2.0, 0.0, 0.0 },

  { 0.0, 3.0/4.0, 0.0 },

  { 2.0/9.0, 1.0/3.0, 4.0/9.0 }
};

/* Block states (auto storage) */
D_Work_CA_CSE1_V1e_wo_LOSV2b CA_CSE1_V1e_wo_LOSV2b_DWork;

/* Previous zero-crossings (trigger) states */
PrevZCSigStates_CA_CSE1_V1e_wo_ CA_CSE1_V1e_wo_L_PrevZCSigState;

/* Real-time model */
RT_MODEL_CA_CSE1_V1e_wo_LOSV2b CA_CSE1_V1e_wo_LOSV2b_M_;
RT_MODEL_CA_CSE1_V1e_wo_LOSV2b *CA_CSE1_V1e_wo_LOSV2b_M =
  &CA_CSE1_V1e_wo_LOSV2b_M_;

/* Function: rt_WriteMat4FileHeader =========================================
 * Abstract:
 *      Writes out MAT-file header.  Returns success or failure.
 *
 * Returns:
 *      0 - success
 *      1 - failure
 */
int_T rt_WriteMat4FileHeader(FILE *fp, int32_T m, int32_T n, const char *name)
{
  typedef enum { ELITTLE_ENDIAN, EBIG_ENDIAN } ByteOrder;

  int16_T one = 1;
  ByteOrder byteOrder = (*((int8_T *)&one)==1) ? ELITTLE_ENDIAN : EBIG_ENDIAN;
  int32_T type = (byteOrder == ELITTLE_ENDIAN) ? 0: 1000;
  int32_T imagf = 0;
  int32_T name_len = strlen(name) + 1;
  if ((fwrite(&type, sizeof(int32_T), 1, fp) == 0) ||
      (fwrite(&m, sizeof(int32_T), 1, fp) == 0) ||
      (fwrite(&n, sizeof(int32_T), 1, fp) == 0) ||
      (fwrite(&imagf, sizeof(int32_T), 1, fp) == 0) ||
      (fwrite(&name_len, sizeof(int32_T), 1, fp) == 0) ||
      (fwrite(name, sizeof(char), name_len, fp) == 0)) {
    return(1);
  } else {
    return(0);
  }
}                                      /* end rt_WriteMat4FileHeader */

void MWDSPCG_Pseudoinverse_D(real_T pS[], real_T pU[], real_T pV[], real_T pX[],
  const int32_T M, const int32_T N)
{
  int32_T ppSIdx;
  real_T tol;
  real_T cabsS;
  int32_T P;
  int32_T rank;
  int32_T ppXIdx;
  int32_T ppUIdx;
  int32_T ppVIdx;
  int32_T j;
  int32_T k;
  rank = 0;
  P = rt_MIN(M, N);
  tol = (real_T)rt_MAX(M, N) * pS[0U] * 2.2204460492503131E-016;
  ppSIdx = P - 1;
  while (P > 0) {
    cabsS = fabs(pS[ppSIdx]);
    ppSIdx = ppSIdx - 1;
    if (cabsS >= tol) {
      rank = P;
      P = 0;
    }

    P = P - 1;
  }

  if (rank != 0) {
    ppXIdx = 0;

    /* Initialize output array */
    for (P = 0; P < N * M; P = P + 1) {
      pX[ppXIdx] = 0.0;
      ppXIdx = ppXIdx + 1;
    }

    ppXIdx = 0;
    for (j = 0; j < M; j = j + 1) {
      for (P = 0; P < N; P = P + 1) {
        ppVIdx = P;
        ppUIdx = j;
        ppSIdx = 0;
        for (k = 0; k < rank; k = k + 1) {
          tol = pV[ppVIdx] * pU[ppUIdx] / pS[ppSIdx];
          pX[ppXIdx] = pX[ppXIdx] + tol;
          ppSIdx = ppSIdx + 1;
          ppVIdx = ppVIdx + N;
          ppUIdx = ppUIdx + M;
        }

        ppXIdx = ppXIdx + 1;
      }
    }
  }
}

/* This function updates continuous states using the ODE3 fixed-step
 * solver algorithm
 */
static void rt_ertODEUpdateContinuousStates(RTWSolverInfo *si )
{
  time_T t = rtsiGetT(si);
  time_T tnew = rtsiGetSolverStopTime(si);
  time_T h = rtsiGetStepSize(si);
  real_T *x = rtsiGetContStates(si);
  ODE3_IntgData *id = (ODE3_IntgData *)rtsiGetSolverData(si);
  real_T *y = id->y;
  real_T *f0 = id->f[0];
  real_T *f1 = id->f[1];
  real_T *f2 = id->f[2];
  real_T hB[3];
  int_T i;
  int_T nXc = 28;
  rtsiSetSimTimeStep(si,MINOR_TIME_STEP);

  /* Save the state values at time t in y, we'll use x as ynew. */
  (void) memcpy(y,x,
                nXc*sizeof(real_T));

  /* Assumes that rtsiSetT and ModelOutputs are up-to-date */
  /* f0 = f(t,y) */
  rtsiSetdX(si, f0);
  CA_CSE1_V1e_wo_LOSV2b_derivatives();

  /* f(:,2) = feval(odefile, t + hA(1), y + f*hB(:,1), args(:)(*)); */
  hB[0] = h * rt_ODE3_B[0][0];
  for (i = 0; i < nXc; i++) {
    x[i] = y[i] + (f0[i]*hB[0]);
  }

  rtsiSetT(si, t + h*rt_ODE3_A[0]);
  rtsiSetdX(si, f1);
  CA_CSE1_V1e_wo_LOSV2b_output(0);
  CA_CSE1_V1e_wo_LOSV2b_derivatives();

  /* f(:,3) = feval(odefile, t + hA(2), y + f*hB(:,2), args(:)(*)); */
  for (i = 0; i <= 1; i++)
    hB[i] = h * rt_ODE3_B[1][i];
  for (i = 0; i < nXc; i++) {
    x[i] = y[i] + (f0[i]*hB[0] + f1[i]*hB[1]);
  }

  rtsiSetT(si, t + h*rt_ODE3_A[1]);
  rtsiSetdX(si, f2);
  CA_CSE1_V1e_wo_LOSV2b_output(0);
  CA_CSE1_V1e_wo_LOSV2b_derivatives();

  /* tnew = t + hA(3);
     ynew = y + f*hB(:,3); */
  for (i = 0; i <= 2; i++)
    hB[i] = h * rt_ODE3_B[2][i];
  for (i = 0; i < nXc; i++) {
    x[i] = y[i] + (f0[i]*hB[0] + f1[i]*hB[1] + f2[i]*hB[2]);
  }

  rtsiSetT(si, tnew);
  rtsiSetSimTimeStep(si,MAJOR_TIME_STEP);
}

/* Output and update for atomic system:
 *   '<S54>/null checker'
 *   '<S54>/null checker1'
 */
void CA_CSE1_V1e_wo_LOSV_nullchecker(real_T rtu_u,
  rtB_nullchecker_CA_CSE1_V1e_wo_ *localB)
{
  /* Embedded MATLAB: '<S54>/null checker' */
  /* Embedded MATLAB Function 'Guidance Systems/Path generator (iceberg towing)/v_s and v_s_t maker/null checker': '<S56>:1' */
  if (rtu_u != 0.0) {
    /* '<S56>:1:5' */
    /* '<S56>:1:6' */
    localB->y = rtu_u;
  } else {
    /* '<S56>:1:8' */
    localB->y = 1.0;
  }
}

/* Model output function */
void CA_CSE1_V1e_wo_LOSV2b_output(int_T tid)
{
  /* Update absolute time of base rate at minor time step */
  if (rtmIsMinorTimeStep(CA_CSE1_V1e_wo_LOSV2b_M)) {
    CA_CSE1_V1e_wo_LOSV2b_M->Timing.t[0] = rtsiGetT
      (&CA_CSE1_V1e_wo_LOSV2b_M->solverInfo);
  }

  if (rtmIsMajorTimeStep(CA_CSE1_V1e_wo_LOSV2b_M)) {
    /* set solver stop time */
    rtsiSetSolverStopTime(&CA_CSE1_V1e_wo_LOSV2b_M->solverInfo,
                          ((CA_CSE1_V1e_wo_LOSV2b_M->Timing.clockTick0+1)*
      CA_CSE1_V1e_wo_LOSV2b_M->Timing.stepSize0));
  }                                    /* end MajorTimeStep */

  {
    real_T tmp[5];
    real_T currentTime;
    int32_T i;
    real_T tmp_0[18];
    real_T tmp_1[3];
    real_T tmp_2[15];
    int32_T tmp_3;
    int32_T tmp_4;

    /* Gain: '<S63>/QTM In3' */
    CA_CSE1_V1e_wo_LOSV2b_B.QTMIn3 = CA_CSE1_V1e_wo_LOSV2b_P.QTMIn3_Gain *
      CA_CSE1_V1e_wo_LOSV2b_B.QTMIn[2];

    /* Gain: '<S63>/mm2m x' */
    CA_CSE1_V1e_wo_LOSV2b_B.mm2mx = CA_CSE1_V1e_wo_LOSV2b_P.mm2mx_Gain *
      CA_CSE1_V1e_wo_LOSV2b_B.QTMIn3;

    /* Gain: '<S63>/QTM In4' */
    CA_CSE1_V1e_wo_LOSV2b_B.QTMIn4 = CA_CSE1_V1e_wo_LOSV2b_P.QTMIn4_Gain *
      CA_CSE1_V1e_wo_LOSV2b_B.QTMIn[3];

    /* Gain: '<S63>/mm2m y' */
    CA_CSE1_V1e_wo_LOSV2b_B.mm2my = CA_CSE1_V1e_wo_LOSV2b_P.mm2my_Gain *
      CA_CSE1_V1e_wo_LOSV2b_B.QTMIn4;

    /* Gain: '<S63>/QTM In5' */
    CA_CSE1_V1e_wo_LOSV2b_B.QTMIn5 = CA_CSE1_V1e_wo_LOSV2b_P.QTMIn5_Gain *
      CA_CSE1_V1e_wo_LOSV2b_B.QTMIn[4];

    /* Gain: '<S63>/mm2m z' */
    CA_CSE1_V1e_wo_LOSV2b_B.mm2mz = CA_CSE1_V1e_wo_LOSV2b_P.mm2mz_Gain *
      CA_CSE1_V1e_wo_LOSV2b_B.QTMIn5;

    /* Gain: '<S63>/QTM In8' */
    CA_CSE1_V1e_wo_LOSV2b_B.QTMIn8 = CA_CSE1_V1e_wo_LOSV2b_P.QTMIn8_Gain *
      CA_CSE1_V1e_wo_LOSV2b_B.QTMIn[7];

    /* Gain: '<S63>/d2r roll' */
    CA_CSE1_V1e_wo_LOSV2b_B.d2rroll = CA_CSE1_V1e_wo_LOSV2b_P.d2rroll_Gain *
      CA_CSE1_V1e_wo_LOSV2b_B.QTMIn8;

    /* Gain: '<S63>/QTM In7' */
    CA_CSE1_V1e_wo_LOSV2b_B.QTMIn7 = CA_CSE1_V1e_wo_LOSV2b_P.QTMIn7_Gain *
      CA_CSE1_V1e_wo_LOSV2b_B.QTMIn[6];

    /* Gain: '<S63>/d2r pitch' */
    CA_CSE1_V1e_wo_LOSV2b_B.d2rpitch = CA_CSE1_V1e_wo_LOSV2b_P.d2rpitch_Gain *
      CA_CSE1_V1e_wo_LOSV2b_B.QTMIn7;

    /* Gain: '<S63>/QTM In6' */
    CA_CSE1_V1e_wo_LOSV2b_B.QTMIn6 = CA_CSE1_V1e_wo_LOSV2b_P.QTMIn6_Gain *
      CA_CSE1_V1e_wo_LOSV2b_B.QTMIn[5];

    /* Gain: '<S63>/d2r yaw' */
    CA_CSE1_V1e_wo_LOSV2b_B.d2ryaw = CA_CSE1_V1e_wo_LOSV2b_P.d2ryaw_Gain *
      CA_CSE1_V1e_wo_LOSV2b_B.QTMIn6;
    if (rtmIsMajorTimeStep(CA_CSE1_V1e_wo_LOSV2b_M)) {
      /* Gain: '<S60>/Panel  u_1' incorporates:
       *  Constant: '<S60>/u1'
       */
      CA_CSE1_V1e_wo_LOSV2b_B.Panelu_1 = CA_CSE1_V1e_wo_LOSV2b_P.Panelu_1_Gain *
        CA_CSE1_V1e_wo_LOSV2b_P.u1_Value;

      /* Gain: '<S60>/Panel u_2' incorporates:
       *  Constant: '<S60>/u2'
       */
      CA_CSE1_V1e_wo_LOSV2b_B.Panelu_2 = CA_CSE1_V1e_wo_LOSV2b_P.Panelu_2_Gain *
        CA_CSE1_V1e_wo_LOSV2b_P.u2_Value;

      /* Gain: '<S60>/Panel u_3' incorporates:
       *  Constant: '<S60>/u3'
       */
      CA_CSE1_V1e_wo_LOSV2b_B.Panelu_3 = CA_CSE1_V1e_wo_LOSV2b_P.Panelu_3_Gain *
        CA_CSE1_V1e_wo_LOSV2b_P.u3_Value;

      /* Gain: '<S60>/Panel u_4' incorporates:
       *  Constant: '<S60>/u4'
       */
      CA_CSE1_V1e_wo_LOSV2b_B.Panelu_4 = CA_CSE1_V1e_wo_LOSV2b_P.Panelu_4_Gain *
        CA_CSE1_V1e_wo_LOSV2b_P.u4_Value;

      /* Gain: '<S60>/Panel u_5' incorporates:
       *  Constant: '<S60>/u5'
       */
      CA_CSE1_V1e_wo_LOSV2b_B.Panelu_5 = CA_CSE1_V1e_wo_LOSV2b_P.Panelu_5_Gain *
        CA_CSE1_V1e_wo_LOSV2b_P.u5_Value;

      /* Gain: '<S62>/Scaling_JS_L_Y' incorporates:
       *  Constant: '<S62>/JS_L_Y'
       */
      CA_CSE1_V1e_wo_LOSV2b_B.u1 = CA_CSE1_V1e_wo_LOSV2b_P.Scaling_JS_L_Y_Gain *
        CA_CSE1_V1e_wo_LOSV2b_P.JS_L_Y_Value;

      /* Gain: '<S9>/PS3 u_1' */
      CA_CSE1_V1e_wo_LOSV2b_B.PS3u_1 = CA_CSE1_V1e_wo_LOSV2b_P.PS3u_1_Gain *
        CA_CSE1_V1e_wo_LOSV2b_B.u1;

      /* Gain: '<S62>/Scaling_JS_L_X' incorporates:
       *  Constant: '<S62>/JS_L_X'
       */
      CA_CSE1_V1e_wo_LOSV2b_B.u1_p = CA_CSE1_V1e_wo_LOSV2b_P.Scaling_JS_L_X_Gain
        * CA_CSE1_V1e_wo_LOSV2b_P.JS_L_X_Value;

      /* Gain: '<S9>/PS3 u_2' */
      CA_CSE1_V1e_wo_LOSV2b_B.PS3u_2 = CA_CSE1_V1e_wo_LOSV2b_P.PS3u_2_Gain *
        CA_CSE1_V1e_wo_LOSV2b_B.u1_p;

      /* Gain: '<S62>/Scaling_JS_R_Y' incorporates:
       *  Constant: '<S62>/JS_R_Y'
       */
      CA_CSE1_V1e_wo_LOSV2b_B.u1_a = CA_CSE1_V1e_wo_LOSV2b_P.Scaling_JS_R_Y_Gain
        * CA_CSE1_V1e_wo_LOSV2b_P.JS_R_Y_Value;

      /* Gain: '<S9>/PS3 u_3' */
      CA_CSE1_V1e_wo_LOSV2b_B.PS3u_3 = CA_CSE1_V1e_wo_LOSV2b_P.PS3u_3_Gain *
        CA_CSE1_V1e_wo_LOSV2b_B.u1_a;

      /* Gain: '<S62>/Scaling_JS_R_X' incorporates:
       *  Constant: '<S62>/JS_R_X'
       */
      CA_CSE1_V1e_wo_LOSV2b_B.u1_i = CA_CSE1_V1e_wo_LOSV2b_P.Scaling_JS_R_X_Gain
        * CA_CSE1_V1e_wo_LOSV2b_P.JS_R_X_Value;

      /* Gain: '<S9>/PS3 u_4' */
      CA_CSE1_V1e_wo_LOSV2b_B.PS3u_4 = CA_CSE1_V1e_wo_LOSV2b_P.PS3u_4_Gain *
        CA_CSE1_V1e_wo_LOSV2b_B.u1_i;

      /* Sum: '<S9>/Add' incorporates:
       *  Constant: '<S62>/L2'
       *  Constant: '<S62>/R2'
       */
      CA_CSE1_V1e_wo_LOSV2b_B.BowThrusterdirection =
        CA_CSE1_V1e_wo_LOSV2b_P.L2_Value + CA_CSE1_V1e_wo_LOSV2b_P.R2_Value;

      /* Gain: '<S9>/PS3 u_5' */
      CA_CSE1_V1e_wo_LOSV2b_B.PS3u_5 = CA_CSE1_V1e_wo_LOSV2b_P.PS3u_5_Gain *
        CA_CSE1_V1e_wo_LOSV2b_B.BowThrusterdirection;

      /* Gain: '<S26>/Gain K_e1_joystick' incorporates:
       *  Constant: '<S26>/K_e1_joystick'
       */
      CA_CSE1_V1e_wo_LOSV2b_B.GainK_e1_joystick =
        CA_CSE1_V1e_wo_LOSV2b_P.GainK_e1_joystick_Gain *
        CA_CSE1_V1e_wo_LOSV2b_P.K_e1_joystick_Value;

      /* Gain: '<S26>/Gain K_e2_joystick' incorporates:
       *  Constant: '<S26>/K_e2_joystick'
       */
      CA_CSE1_V1e_wo_LOSV2b_B.GainK_e2_joystick =
        CA_CSE1_V1e_wo_LOSV2b_P.GainK_e2_joystick_Gain *
        CA_CSE1_V1e_wo_LOSV2b_P.K_e2_joystick_Value;

      /* Gain: '<S26>/Gain K_e3_joystick' incorporates:
       *  Constant: '<S26>/K_e3_joystick'
       */
      CA_CSE1_V1e_wo_LOSV2b_B.GainK_e3_joystick =
        CA_CSE1_V1e_wo_LOSV2b_P.GainK_e3_joystick_Gain *
        CA_CSE1_V1e_wo_LOSV2b_P.K_e3_joystick_Value;

      /* Gain: '<S26>/Gain K_e4_joystick' incorporates:
       *  Constant: '<S26>/K_e4_joystick'
       */
      CA_CSE1_V1e_wo_LOSV2b_B.GainK_e4_joystick =
        CA_CSE1_V1e_wo_LOSV2b_P.GainK_e4_joystick_Gain *
        CA_CSE1_V1e_wo_LOSV2b_P.K_e4_joystick_Value;

      /* Gain: '<S26>/Gain K_e5_joystick' incorporates:
       *  Constant: '<S26>/K_e5_joystick'
       */
      CA_CSE1_V1e_wo_LOSV2b_B.GainK_e5_joystick =
        CA_CSE1_V1e_wo_LOSV2b_P.GainK_e5_joystick_Gain *
        CA_CSE1_V1e_wo_LOSV2b_P.K_e5_joystick_Value;

      /* Reshape: '<S26>/Thruster Gain matrix' incorporates:
       *  Constant: '<S26>/Constant'
       */
      CA_CSE1_V1e_wo_LOSV2b_B.ThrusterGainmatrix[0] =
        CA_CSE1_V1e_wo_LOSV2b_B.GainK_e1_joystick;
      CA_CSE1_V1e_wo_LOSV2b_B.ThrusterGainmatrix[1] =
        CA_CSE1_V1e_wo_LOSV2b_P.Constant_Value;
      CA_CSE1_V1e_wo_LOSV2b_B.ThrusterGainmatrix[2] =
        CA_CSE1_V1e_wo_LOSV2b_P.Constant_Value;
      CA_CSE1_V1e_wo_LOSV2b_B.ThrusterGainmatrix[3] =
        CA_CSE1_V1e_wo_LOSV2b_P.Constant_Value;
      CA_CSE1_V1e_wo_LOSV2b_B.ThrusterGainmatrix[4] =
        CA_CSE1_V1e_wo_LOSV2b_P.Constant_Value;
      CA_CSE1_V1e_wo_LOSV2b_B.ThrusterGainmatrix[5] =
        CA_CSE1_V1e_wo_LOSV2b_P.Constant_Value;
      CA_CSE1_V1e_wo_LOSV2b_B.ThrusterGainmatrix[6] =
        CA_CSE1_V1e_wo_LOSV2b_B.GainK_e2_joystick;
      CA_CSE1_V1e_wo_LOSV2b_B.ThrusterGainmatrix[7] =
        CA_CSE1_V1e_wo_LOSV2b_P.Constant_Value;
      CA_CSE1_V1e_wo_LOSV2b_B.ThrusterGainmatrix[8] =
        CA_CSE1_V1e_wo_LOSV2b_P.Constant_Value;
      CA_CSE1_V1e_wo_LOSV2b_B.ThrusterGainmatrix[9] =
        CA_CSE1_V1e_wo_LOSV2b_P.Constant_Value;
      CA_CSE1_V1e_wo_LOSV2b_B.ThrusterGainmatrix[10] =
        CA_CSE1_V1e_wo_LOSV2b_P.Constant_Value;
      CA_CSE1_V1e_wo_LOSV2b_B.ThrusterGainmatrix[11] =
        CA_CSE1_V1e_wo_LOSV2b_P.Constant_Value;
      CA_CSE1_V1e_wo_LOSV2b_B.ThrusterGainmatrix[12] =
        CA_CSE1_V1e_wo_LOSV2b_B.GainK_e3_joystick;
      CA_CSE1_V1e_wo_LOSV2b_B.ThrusterGainmatrix[13] =
        CA_CSE1_V1e_wo_LOSV2b_P.Constant_Value;
      CA_CSE1_V1e_wo_LOSV2b_B.ThrusterGainmatrix[14] =
        CA_CSE1_V1e_wo_LOSV2b_P.Constant_Value;
      CA_CSE1_V1e_wo_LOSV2b_B.ThrusterGainmatrix[15] =
        CA_CSE1_V1e_wo_LOSV2b_P.Constant_Value;
      CA_CSE1_V1e_wo_LOSV2b_B.ThrusterGainmatrix[16] =
        CA_CSE1_V1e_wo_LOSV2b_P.Constant_Value;
      CA_CSE1_V1e_wo_LOSV2b_B.ThrusterGainmatrix[17] =
        CA_CSE1_V1e_wo_LOSV2b_P.Constant_Value;
      CA_CSE1_V1e_wo_LOSV2b_B.ThrusterGainmatrix[18] =
        CA_CSE1_V1e_wo_LOSV2b_B.GainK_e4_joystick;
      CA_CSE1_V1e_wo_LOSV2b_B.ThrusterGainmatrix[19] =
        CA_CSE1_V1e_wo_LOSV2b_P.Constant_Value;
      CA_CSE1_V1e_wo_LOSV2b_B.ThrusterGainmatrix[20] =
        CA_CSE1_V1e_wo_LOSV2b_P.Constant_Value;
      CA_CSE1_V1e_wo_LOSV2b_B.ThrusterGainmatrix[21] =
        CA_CSE1_V1e_wo_LOSV2b_P.Constant_Value;
      CA_CSE1_V1e_wo_LOSV2b_B.ThrusterGainmatrix[22] =
        CA_CSE1_V1e_wo_LOSV2b_P.Constant_Value;
      CA_CSE1_V1e_wo_LOSV2b_B.ThrusterGainmatrix[23] =
        CA_CSE1_V1e_wo_LOSV2b_P.Constant_Value;
      CA_CSE1_V1e_wo_LOSV2b_B.ThrusterGainmatrix[24] =
        CA_CSE1_V1e_wo_LOSV2b_B.GainK_e5_joystick;

      /* Product Block: '<S7>/K_e^-1' */
      {
        static const int_T dims[3] = { 5, 5, 5 };

        rt_MatDivRR_Dbl(CA_CSE1_V1e_wo_LOSV2b_B.K_e1,
                        CA_CSE1_V1e_wo_LOSV2b_B.ThrusterGainmatrix,
                        &CA_CSE1_V1e_wo_LOSV2b_DWork.K_e1_DWORK4[0], (real_T*)
                        &CA_CSE1_V1e_wo_LOSV2b_DWork.K_e1_DWORK1[0],
                        &CA_CSE1_V1e_wo_LOSV2b_DWork.K_e1_DWORK2[0], (real_T*)
                        &CA_CSE1_V1e_wo_LOSV2b_DWork.K_e1_DWORK3[0],
                        &dims[0]);
      }

      /* Gain: '<S27>/-l_x1' incorporates:
       *  Constant: '<S27>/l_x1'
       */
      CA_CSE1_V1e_wo_LOSV2b_B.l_x1 = CA_CSE1_V1e_wo_LOSV2b_P.l_x1_Gain *
        CA_CSE1_V1e_wo_LOSV2b_P.l_x1_Value;

      /* Gain: '<S27>/-l_y2' incorporates:
       *  Constant: '<S27>/l_y2'
       */
      CA_CSE1_V1e_wo_LOSV2b_B.l_y2 = CA_CSE1_V1e_wo_LOSV2b_P.l_y2_Gain *
        CA_CSE1_V1e_wo_LOSV2b_P.l_y2_Value;

      /* Gain: '<S27>/-l_x2' incorporates:
       *  Constant: '<S27>/l_x2'
       */
      CA_CSE1_V1e_wo_LOSV2b_B.l_x2 = CA_CSE1_V1e_wo_LOSV2b_P.l_x2_Gain *
        CA_CSE1_V1e_wo_LOSV2b_P.l_x2_Value;

      /* Reshape: '<S27>/3x5' incorporates:
       *  Constant: '<S27>/T_e11'
       *  Constant: '<S27>/T_e12'
       *  Constant: '<S27>/T_e13'
       *  Constant: '<S27>/T_e14'
       *  Constant: '<S27>/T_e15'
       *  Constant: '<S27>/T_e21'
       *  Constant: '<S27>/T_e22'
       *  Constant: '<S27>/T_e23'
       *  Constant: '<S27>/T_e24'
       *  Constant: '<S27>/T_e25'
       *  Constant: '<S27>/l_x3'
       *  Constant: '<S27>/l_y1'
       */
      CA_CSE1_V1e_wo_LOSV2b_B.x5[0] = CA_CSE1_V1e_wo_LOSV2b_P.T_e11_Value;
      CA_CSE1_V1e_wo_LOSV2b_B.x5[1] = CA_CSE1_V1e_wo_LOSV2b_P.T_e21_Value;
      CA_CSE1_V1e_wo_LOSV2b_B.x5[2] = CA_CSE1_V1e_wo_LOSV2b_P.l_y1_Value;
      CA_CSE1_V1e_wo_LOSV2b_B.x5[3] = CA_CSE1_V1e_wo_LOSV2b_P.T_e12_Value;
      CA_CSE1_V1e_wo_LOSV2b_B.x5[4] = CA_CSE1_V1e_wo_LOSV2b_P.T_e22_Value;
      CA_CSE1_V1e_wo_LOSV2b_B.x5[5] = CA_CSE1_V1e_wo_LOSV2b_B.l_x1;
      CA_CSE1_V1e_wo_LOSV2b_B.x5[6] = CA_CSE1_V1e_wo_LOSV2b_P.T_e13_Value;
      CA_CSE1_V1e_wo_LOSV2b_B.x5[7] = CA_CSE1_V1e_wo_LOSV2b_P.T_e23_Value;
      CA_CSE1_V1e_wo_LOSV2b_B.x5[8] = CA_CSE1_V1e_wo_LOSV2b_B.l_y2;
      CA_CSE1_V1e_wo_LOSV2b_B.x5[9] = CA_CSE1_V1e_wo_LOSV2b_P.T_e14_Value;
      CA_CSE1_V1e_wo_LOSV2b_B.x5[10] = CA_CSE1_V1e_wo_LOSV2b_P.T_e24_Value;
      CA_CSE1_V1e_wo_LOSV2b_B.x5[11] = CA_CSE1_V1e_wo_LOSV2b_B.l_x2;
      CA_CSE1_V1e_wo_LOSV2b_B.x5[12] = CA_CSE1_V1e_wo_LOSV2b_P.T_e15_Value;
      CA_CSE1_V1e_wo_LOSV2b_B.x5[13] = CA_CSE1_V1e_wo_LOSV2b_P.T_e25_Value;
      CA_CSE1_V1e_wo_LOSV2b_B.x5[14] = CA_CSE1_V1e_wo_LOSV2b_P.l_x3_Value;

      /* S-Function (sdsppinv): '<S7>/T_e^+' */
      /* Copy input to temporary space */
      memcpy((void *)(&CA_CSE1_V1e_wo_LOSV2b_DWork.K_e1_DWORK1[0]), (void *)
             (&CA_CSE1_V1e_wo_LOSV2b_B.x5[0]), 15U * sizeof(real_T));

      /* Call SVD */
      i = MWDSP_SVD_D(&CA_CSE1_V1e_wo_LOSV2b_DWork.K_e1_DWORK1[0], 3, 5,
                      &CA_CSE1_V1e_wo_LOSV2b_DWork.T_e_S[0],
                      &CA_CSE1_V1e_wo_LOSV2b_DWork.K_e1_DWORK3[0],
                      &CA_CSE1_V1e_wo_LOSV2b_DWork.T_e_WORK[0],
                      &CA_CSE1_V1e_wo_LOSV2b_DWork.T_e_U[0],
                      &CA_CSE1_V1e_wo_LOSV2b_DWork.T_e_V[0], 1);

      /* Only call 'pinv' function if SVD succeeded */
      if (i == 0) {
        MWDSPCG_Pseudoinverse_D(&CA_CSE1_V1e_wo_LOSV2b_DWork.T_e_S[0],
          &CA_CSE1_V1e_wo_LOSV2b_DWork.T_e_U[0],
          &CA_CSE1_V1e_wo_LOSV2b_DWork.T_e_V[0], &CA_CSE1_V1e_wo_LOSV2b_B.T_e[0],
                                (const int32_T)3, (const int32_T)5);
      }

      /* Product: '<S7>/T_e^+ K_e^-1' */
      for (i = 0; i < 5; i++) {
        for (tmp_4 = 0; tmp_4 < 3; tmp_4++) {
          CA_CSE1_V1e_wo_LOSV2b_B.T_eK_e1[i + 5 * tmp_4] = 0.0;
          for (tmp_3 = 0; tmp_3 < 5; tmp_3++) {
            CA_CSE1_V1e_wo_LOSV2b_B.T_eK_e1[i + 5 * tmp_4] =
              CA_CSE1_V1e_wo_LOSV2b_B.K_e1[5 * tmp_3 + i] *
              CA_CSE1_V1e_wo_LOSV2b_B.T_e[5 * tmp_4 + tmp_3] +
              CA_CSE1_V1e_wo_LOSV2b_B.T_eK_e1[5 * tmp_4 + i];
          }
        }
      }

      /* Sum: '<S7>/Sum1' */
      CA_CSE1_V1e_wo_LOSV2b_B.Sum1 = CA_CSE1_V1e_wo_LOSV2b_B.u1 +
        CA_CSE1_V1e_wo_LOSV2b_B.u1_a;

      /* Gain: '<S7>/Joystick tau_surge' */
      CA_CSE1_V1e_wo_LOSV2b_B.Joysticktau_surge =
        CA_CSE1_V1e_wo_LOSV2b_P.Joysticktau_surge_Gain *
        CA_CSE1_V1e_wo_LOSV2b_B.Sum1;

      /* Saturate: '<S7>/Saturation1' */
      currentTime = CA_CSE1_V1e_wo_LOSV2b_B.Joysticktau_surge;
      CA_CSE1_V1e_wo_LOSV2b_B.Saturation1 = rt_SATURATE(currentTime,
        CA_CSE1_V1e_wo_LOSV2b_P.Saturation1_LowerSat,
        CA_CSE1_V1e_wo_LOSV2b_P.Saturation1_UpperSat);

      /* Sum: '<S7>/Sum2' */
      CA_CSE1_V1e_wo_LOSV2b_B.Sum2 = CA_CSE1_V1e_wo_LOSV2b_B.u1_p +
        CA_CSE1_V1e_wo_LOSV2b_B.u1_i;

      /* Gain: '<S7>/Joystick tau_sway' */
      CA_CSE1_V1e_wo_LOSV2b_B.Joysticktau_sway =
        CA_CSE1_V1e_wo_LOSV2b_P.Joysticktau_sway_Gain *
        CA_CSE1_V1e_wo_LOSV2b_B.Sum2;

      /* Saturate: '<S7>/Saturation2' */
      currentTime = CA_CSE1_V1e_wo_LOSV2b_B.Joysticktau_sway;
      CA_CSE1_V1e_wo_LOSV2b_B.Saturation2 = rt_SATURATE(currentTime,
        CA_CSE1_V1e_wo_LOSV2b_P.Saturation2_LowerSat,
        CA_CSE1_V1e_wo_LOSV2b_P.Saturation2_UpperSat);

      /* Sum: '<S7>/Sum' incorporates:
       *  Constant: '<S62>/L2'
       *  Constant: '<S62>/R2'
       */
      CA_CSE1_V1e_wo_LOSV2b_B.Sum = CA_CSE1_V1e_wo_LOSV2b_P.L2_Value +
        CA_CSE1_V1e_wo_LOSV2b_P.R2_Value;

      /* Gain: '<S7>/Joystick tau_yaw' */
      CA_CSE1_V1e_wo_LOSV2b_B.Joysticktau_yaw =
        CA_CSE1_V1e_wo_LOSV2b_P.Joysticktau_yaw_Gain *
        CA_CSE1_V1e_wo_LOSV2b_B.Sum;

      /* Saturate: '<S7>/Saturation3' */
      currentTime = CA_CSE1_V1e_wo_LOSV2b_B.Joysticktau_yaw;
      CA_CSE1_V1e_wo_LOSV2b_B.Saturation3 = rt_SATURATE(currentTime,
        CA_CSE1_V1e_wo_LOSV2b_P.Saturation3_LowerSat,
        CA_CSE1_V1e_wo_LOSV2b_P.Saturation3_UpperSat);

      /* SignalConversion: '<S7>/TmpHiddenBufferAtProduct1Inport2' */
      CA_CSE1_V1e_wo_LOSV2b_B.TmpHiddenBufferAtProduct1Inport[0] =
        CA_CSE1_V1e_wo_LOSV2b_B.Saturation1;
      CA_CSE1_V1e_wo_LOSV2b_B.TmpHiddenBufferAtProduct1Inport[1] =
        CA_CSE1_V1e_wo_LOSV2b_B.Saturation2;
      CA_CSE1_V1e_wo_LOSV2b_B.TmpHiddenBufferAtProduct1Inport[2] =
        CA_CSE1_V1e_wo_LOSV2b_B.Saturation3;

      /* Saturate: '<S7>/Saturation' */
      for (i = 0; i < 5; i++) {
        /* Product: '<S7>/Product1' */
        CA_CSE1_V1e_wo_LOSV2b_B.Product1[i] = 0.0;
        CA_CSE1_V1e_wo_LOSV2b_B.Product1[i] = CA_CSE1_V1e_wo_LOSV2b_B.T_eK_e1[i]
          * CA_CSE1_V1e_wo_LOSV2b_B.TmpHiddenBufferAtProduct1Inport[0] +
          CA_CSE1_V1e_wo_LOSV2b_B.Product1[i];
        CA_CSE1_V1e_wo_LOSV2b_B.Product1[i] = CA_CSE1_V1e_wo_LOSV2b_B.T_eK_e1[i
          + 5] * CA_CSE1_V1e_wo_LOSV2b_B.TmpHiddenBufferAtProduct1Inport[1] +
          CA_CSE1_V1e_wo_LOSV2b_B.Product1[i];
        CA_CSE1_V1e_wo_LOSV2b_B.Product1[i] = CA_CSE1_V1e_wo_LOSV2b_B.T_eK_e1[i
          + 10] * CA_CSE1_V1e_wo_LOSV2b_B.TmpHiddenBufferAtProduct1Inport[2] +
          CA_CSE1_V1e_wo_LOSV2b_B.Product1[i];
        tmp[i] = CA_CSE1_V1e_wo_LOSV2b_B.Product1[i];
        CA_CSE1_V1e_wo_LOSV2b_B.Saturation[i] = rt_SATURATE(tmp[i],
          CA_CSE1_V1e_wo_LOSV2b_P.Saturation_LowerSat,
          CA_CSE1_V1e_wo_LOSV2b_P.Saturation_UpperSat);
      }

      /* Gain: '<S7>/Joystick u_1' */
      CA_CSE1_V1e_wo_LOSV2b_B.Joysticku_1 =
        CA_CSE1_V1e_wo_LOSV2b_P.Joysticku_1_Gain *
        CA_CSE1_V1e_wo_LOSV2b_B.Saturation[0];

      /* Gain: '<S7>/Joystick u_2' */
      CA_CSE1_V1e_wo_LOSV2b_B.Joysticku_2 =
        CA_CSE1_V1e_wo_LOSV2b_P.Joysticku_2_Gain *
        CA_CSE1_V1e_wo_LOSV2b_B.Saturation[1];

      /* Gain: '<S7>/Joystick u_3' */
      CA_CSE1_V1e_wo_LOSV2b_B.Joysticku_3 =
        CA_CSE1_V1e_wo_LOSV2b_P.Joysticku_3_Gain *
        CA_CSE1_V1e_wo_LOSV2b_B.Saturation[2];

      /* Gain: '<S7>/Joystick u_4' */
      CA_CSE1_V1e_wo_LOSV2b_B.Joysticku_4 =
        CA_CSE1_V1e_wo_LOSV2b_P.Joysticku_4_Gain *
        CA_CSE1_V1e_wo_LOSV2b_B.Saturation[3];

      /* Gain: '<S7>/Joystick u_5' */
      CA_CSE1_V1e_wo_LOSV2b_B.Joysticku_5 =
        CA_CSE1_V1e_wo_LOSV2b_P.Joysticku_5_Gain *
        CA_CSE1_V1e_wo_LOSV2b_B.Saturation[4];

      /* Gain: '<S61>/Gain1' incorporates:
       *  Constant: '<S58>/psi_d'
       */
      CA_CSE1_V1e_wo_LOSV2b_B.Gain1 = CA_CSE1_V1e_wo_LOSV2b_P.Gain1_Gain *
        CA_CSE1_V1e_wo_LOSV2b_P.psi_d_Value;
    }

    /* TransferFcn Block: '<S48>/Transfer Fcn' */
    CA_CSE1_V1e_wo_LOSV2b_B.TransferFcn = CA_CSE1_V1e_wo_LOSV2b_P.TransferFcn_C*
      CA_CSE1_V1e_wo_LOSV2b_X.TransferFcn_CSTATE;

    /* TransferFcn Block: '<S48>/Transfer Fcn1' */
    CA_CSE1_V1e_wo_LOSV2b_B.TransferFcn1 =
      CA_CSE1_V1e_wo_LOSV2b_P.TransferFcn1_C*
      CA_CSE1_V1e_wo_LOSV2b_X.TransferFcn1_CSTATE;

    /* TransferFcn Block: '<S48>/Transfer Fcn2' */
    CA_CSE1_V1e_wo_LOSV2b_B.TransferFcn2 =
      CA_CSE1_V1e_wo_LOSV2b_P.TransferFcn2_C*
      CA_CSE1_V1e_wo_LOSV2b_X.TransferFcn2_CSTATE;

    /* MultiPortSwitch: '<S48>/Multiport Switch' incorporates:
     *  Constant: '<S48>/Enable eta_d LPF'
     *  Constant: '<S58>/x_d'
     *  Constant: '<S58>/y_d'
     */
    if ((int32_T)CA_CSE1_V1e_wo_LOSV2b_P.Enableeta_dLPF_Value == 0) {
      CA_CSE1_V1e_wo_LOSV2b_B.MultiportSwitch[0] =
        CA_CSE1_V1e_wo_LOSV2b_P.x_d_Value;
      CA_CSE1_V1e_wo_LOSV2b_B.MultiportSwitch[1] =
        CA_CSE1_V1e_wo_LOSV2b_P.y_d_Value;
      CA_CSE1_V1e_wo_LOSV2b_B.MultiportSwitch[2] = CA_CSE1_V1e_wo_LOSV2b_B.Gain1;
    } else {
      CA_CSE1_V1e_wo_LOSV2b_B.MultiportSwitch[0] =
        CA_CSE1_V1e_wo_LOSV2b_B.TransferFcn;
      CA_CSE1_V1e_wo_LOSV2b_B.MultiportSwitch[1] =
        CA_CSE1_V1e_wo_LOSV2b_B.TransferFcn1;
      CA_CSE1_V1e_wo_LOSV2b_B.MultiportSwitch[2] =
        CA_CSE1_V1e_wo_LOSV2b_B.TransferFcn2;
    }

    /* Gain: '<S48>/eta_d DP N' */
    CA_CSE1_V1e_wo_LOSV2b_B.eta_dDPN = CA_CSE1_V1e_wo_LOSV2b_P.eta_dDPN_Gain *
      CA_CSE1_V1e_wo_LOSV2b_B.MultiportSwitch[0];

    /* Gain: '<S48>/eta_d DP E' */
    CA_CSE1_V1e_wo_LOSV2b_B.eta_dDPE = CA_CSE1_V1e_wo_LOSV2b_P.eta_dDPE_Gain *
      CA_CSE1_V1e_wo_LOSV2b_B.MultiportSwitch[1];

    /* Gain: '<S48>/eta_d DP Psi' */
    CA_CSE1_V1e_wo_LOSV2b_B.eta_dDPPsi = CA_CSE1_V1e_wo_LOSV2b_P.eta_dDPPsi_Gain
      * CA_CSE1_V1e_wo_LOSV2b_B.MultiportSwitch[2];

    /* Outputs for enable SubSystem: '<S5>/Linear Simulator' incorporates:
     *  Constant: '<S5>/Enable Linear Simulator'
     *  EnablePort: '<S67>/Enable'
     */
    if (rtmIsMajorTimeStep(CA_CSE1_V1e_wo_LOSV2b_M) && rtmIsMajorTimeStep
        (CA_CSE1_V1e_wo_LOSV2b_M)) {
      if (CA_CSE1_V1e_wo_LOSV2b_P.EnableLinearSimulator_Value > 0.0) {
        if (CA_CSE1_V1e_wo_LOSV2b_DWork.LinearSimulator_MODE == SUBSYS_DISABLED)
        {
          /* Integrator Block: '<S79>/Integrator' */
          if (rtmIsFirstInitCond(CA_CSE1_V1e_wo_LOSV2b_M)) {
            CA_CSE1_V1e_wo_LOSV2b_X.Integrator_CSTATE_a[0] = 0.0;
            CA_CSE1_V1e_wo_LOSV2b_X.Integrator_CSTATE_a[1] = 0.0;
            CA_CSE1_V1e_wo_LOSV2b_X.Integrator_CSTATE_a[2] = 0.0;
          }

          CA_CSE1_V1e_wo_LOSV2b_DWork.Integrator_IWORK.IcNeedsLoading = 1;

          /* Integrator Block: '<S79>/Integrator1' */
          if (rtmIsFirstInitCond(CA_CSE1_V1e_wo_LOSV2b_M)) {
            CA_CSE1_V1e_wo_LOSV2b_X.Integrator1_CSTATE[0] = 0.0;
            CA_CSE1_V1e_wo_LOSV2b_X.Integrator1_CSTATE[1] = 0.0;
            CA_CSE1_V1e_wo_LOSV2b_X.Integrator1_CSTATE[2] = 0.0;
          }

          CA_CSE1_V1e_wo_LOSV2b_DWork.Integrator1_IWORK.IcNeedsLoading = 1;

          /* InitializeConditions for UnitDelay: '<S89>/Delay Input2' */
          CA_CSE1_V1e_wo_LOSV2b_DWork.DelayInput2_DSTATE =
            CA_CSE1_V1e_wo_LOSV2b_P.DelayInput2_X0;
          CA_CSE1_V1e_wo_LOSV2b_DWork.LinearSimulator_MODE = SUBSYS_ENABLED;
        }
      } else {
        if (CA_CSE1_V1e_wo_LOSV2b_DWork.LinearSimulator_MODE == SUBSYS_ENABLED)
        {
          CA_CSE1_V1e_wo_LOSV2b_DWork.LinearSimulator_MODE = SUBSYS_DISABLED;
        }
      }
    }

    if (CA_CSE1_V1e_wo_LOSV2b_DWork.LinearSimulator_MODE == SUBSYS_ENABLED) {
      if (rtmIsMajorTimeStep(CA_CSE1_V1e_wo_LOSV2b_M)) {
        /* Gain: '<S81>/-N_r' incorporates:
         *  Constant: '<S81>/N_r'
         */
        CA_CSE1_V1e_wo_LOSV2b_B.N_r = CA_CSE1_V1e_wo_LOSV2b_P.N_r_Gain *
          CA_CSE1_V1e_wo_LOSV2b_P.N_r_Value;

        /* Gain: '<S81>/-N_v' incorporates:
         *  Constant: '<S81>/N_v'
         */
        CA_CSE1_V1e_wo_LOSV2b_B.N_v = CA_CSE1_V1e_wo_LOSV2b_P.N_v_Gain *
          CA_CSE1_V1e_wo_LOSV2b_P.N_v_Value;

        /* Gain: '<S81>/-X_u' incorporates:
         *  Constant: '<S81>/X_u'
         */
        CA_CSE1_V1e_wo_LOSV2b_B.X_u = CA_CSE1_V1e_wo_LOSV2b_P.X_u_Gain *
          CA_CSE1_V1e_wo_LOSV2b_P.X_u_Value;

        /* Gain: '<S81>/-Y_v' incorporates:
         *  Constant: '<S81>/Y_v'
         */
        CA_CSE1_V1e_wo_LOSV2b_B.Y_v = CA_CSE1_V1e_wo_LOSV2b_P.Y_v_Gain *
          CA_CSE1_V1e_wo_LOSV2b_P.Y_v_Value;

        /* Gain: '<S81>/-Y_vr' incorporates:
         *  Constant: '<S81>/Y_r'
         */
        CA_CSE1_V1e_wo_LOSV2b_B.Y_vr = CA_CSE1_V1e_wo_LOSV2b_P.Y_vr_Gain *
          CA_CSE1_V1e_wo_LOSV2b_P.Y_r_Value;

        /* Reshape: '<S81>/Linear Dampning matrix' incorporates:
         *  Constant: '<S81>/D_L_12'
         *  Constant: '<S81>/D_L_13'
         *  Constant: '<S81>/D_L_21'
         *  Constant: '<S81>/D_L_31'
         */
        CA_CSE1_V1e_wo_LOSV2b_B.LinearDampningmatrix[0] =
          CA_CSE1_V1e_wo_LOSV2b_B.X_u;
        CA_CSE1_V1e_wo_LOSV2b_B.LinearDampningmatrix[1] =
          CA_CSE1_V1e_wo_LOSV2b_P.D_L_21_Value;
        CA_CSE1_V1e_wo_LOSV2b_B.LinearDampningmatrix[2] =
          CA_CSE1_V1e_wo_LOSV2b_P.D_L_31_Value;
        CA_CSE1_V1e_wo_LOSV2b_B.LinearDampningmatrix[3] =
          CA_CSE1_V1e_wo_LOSV2b_P.D_L_12_Value;
        CA_CSE1_V1e_wo_LOSV2b_B.LinearDampningmatrix[4] =
          CA_CSE1_V1e_wo_LOSV2b_B.Y_v;
        CA_CSE1_V1e_wo_LOSV2b_B.LinearDampningmatrix[5] =
          CA_CSE1_V1e_wo_LOSV2b_B.N_v;
        CA_CSE1_V1e_wo_LOSV2b_B.LinearDampningmatrix[6] =
          CA_CSE1_V1e_wo_LOSV2b_P.D_L_13_Value;
        CA_CSE1_V1e_wo_LOSV2b_B.LinearDampningmatrix[7] =
          CA_CSE1_V1e_wo_LOSV2b_B.Y_vr;
        CA_CSE1_V1e_wo_LOSV2b_B.LinearDampningmatrix[8] =
          CA_CSE1_V1e_wo_LOSV2b_B.N_r;

        /* Constant: '<S82>/psi_0' */
        CA_CSE1_V1e_wo_LOSV2b_B.psi_0 = CA_CSE1_V1e_wo_LOSV2b_P.psi_0_Value;

        /* Constant: '<S82>/x_0' */
        CA_CSE1_V1e_wo_LOSV2b_B.x_0 = CA_CSE1_V1e_wo_LOSV2b_P.x_0_Value;

        /* Constant: '<S82>/y_0' */
        CA_CSE1_V1e_wo_LOSV2b_B.y_0 = CA_CSE1_V1e_wo_LOSV2b_P.y_0_Value;

        /* Constant: '<S83>/r_0' */
        CA_CSE1_V1e_wo_LOSV2b_B.r_0 = CA_CSE1_V1e_wo_LOSV2b_P.r_0_Value;

        /* Constant: '<S83>/u_0' */
        CA_CSE1_V1e_wo_LOSV2b_B.u_0 = CA_CSE1_V1e_wo_LOSV2b_P.u_0_Value;

        /* Constant: '<S83>/v_0' */
        CA_CSE1_V1e_wo_LOSV2b_B.v_0 = CA_CSE1_V1e_wo_LOSV2b_P.v_0_Value;
      }

      /* Integrator Block: '<S79>/Integrator'
       */
      if (rtmIsMajorTimeStep(CA_CSE1_V1e_wo_LOSV2b_M)) {
        ZCEventType zcEvent;
        zcEvent = rt_ZCFcn(ANY_ZERO_CROSSING,
                           &CA_CSE1_V1e_wo_L_PrevZCSigState.Integrator_Reset_ZCE,
                           CA_CSE1_V1e_wo_LOSV2b_P.ResetLinearSimulatorintegrator_);

        /* evaluate zero-crossings and the level of the reset signal */
        if (zcEvent || CA_CSE1_V1e_wo_LOSV2b_P.ResetLinearSimulatorintegrator_
            != 0.0 ||
            CA_CSE1_V1e_wo_LOSV2b_DWork.Integrator_IWORK.IcNeedsLoading) {
          CA_CSE1_V1e_wo_LOSV2b_X.Integrator_CSTATE_a[0] =
            CA_CSE1_V1e_wo_LOSV2b_B.u_0;
          CA_CSE1_V1e_wo_LOSV2b_X.Integrator_CSTATE_a[1] =
            CA_CSE1_V1e_wo_LOSV2b_B.v_0;
          CA_CSE1_V1e_wo_LOSV2b_X.Integrator_CSTATE_a[2] =
            CA_CSE1_V1e_wo_LOSV2b_B.r_0;
        }

        CA_CSE1_V1e_wo_LOSV2b_DWork.Integrator_IWORK.IcNeedsLoading = 0;
      }

      CA_CSE1_V1e_wo_LOSV2b_B.Integrator_o[0] =
        CA_CSE1_V1e_wo_LOSV2b_X.Integrator_CSTATE_a[0];
      CA_CSE1_V1e_wo_LOSV2b_B.Integrator_o[1] =
        CA_CSE1_V1e_wo_LOSV2b_X.Integrator_CSTATE_a[1];
      CA_CSE1_V1e_wo_LOSV2b_B.Integrator_o[2] =
        CA_CSE1_V1e_wo_LOSV2b_X.Integrator_CSTATE_a[2];

      /* Integrator Block: '<S79>/Integrator1'
       */
      if (rtmIsMajorTimeStep(CA_CSE1_V1e_wo_LOSV2b_M)) {
        ZCEventType zcEvent;
        zcEvent = rt_ZCFcn(ANY_ZERO_CROSSING,
                           &CA_CSE1_V1e_wo_L_PrevZCSigState.Integrator1_Reset_ZCE,
                           CA_CSE1_V1e_wo_LOSV2b_P.ResetLinearSimulatorintegrator_);

        /* evaluate zero-crossings and the level of the reset signal */
        if (zcEvent || CA_CSE1_V1e_wo_LOSV2b_P.ResetLinearSimulatorintegrator_
            != 0.0 ||
            CA_CSE1_V1e_wo_LOSV2b_DWork.Integrator1_IWORK.IcNeedsLoading) {
          CA_CSE1_V1e_wo_LOSV2b_X.Integrator1_CSTATE[0] =
            CA_CSE1_V1e_wo_LOSV2b_B.x_0;
          CA_CSE1_V1e_wo_LOSV2b_X.Integrator1_CSTATE[1] =
            CA_CSE1_V1e_wo_LOSV2b_B.y_0;
          CA_CSE1_V1e_wo_LOSV2b_X.Integrator1_CSTATE[2] =
            CA_CSE1_V1e_wo_LOSV2b_B.psi_0;
        }

        CA_CSE1_V1e_wo_LOSV2b_DWork.Integrator1_IWORK.IcNeedsLoading = 0;
      }

      CA_CSE1_V1e_wo_LOSV2b_B.Integrator1[0] =
        CA_CSE1_V1e_wo_LOSV2b_X.Integrator1_CSTATE[0];
      CA_CSE1_V1e_wo_LOSV2b_B.Integrator1[1] =
        CA_CSE1_V1e_wo_LOSV2b_X.Integrator1_CSTATE[1];
      CA_CSE1_V1e_wo_LOSV2b_B.Integrator1[2] =
        CA_CSE1_V1e_wo_LOSV2b_X.Integrator1_CSTATE[2];
      if (rtmIsMajorTimeStep(CA_CSE1_V1e_wo_LOSV2b_M)) {
        /* Sum: '<S84>/M_11' incorporates:
         *  Constant: '<S84>/X_udot'
         *  Constant: '<S84>/m'
         */
        CA_CSE1_V1e_wo_LOSV2b_B.M_11 = CA_CSE1_V1e_wo_LOSV2b_P.m_Value -
          CA_CSE1_V1e_wo_LOSV2b_P.X_udot_Value;

        /* Sum: '<S84>/M_22' incorporates:
         *  Constant: '<S84>/Y_vdot'
         *  Constant: '<S84>/m'
         */
        CA_CSE1_V1e_wo_LOSV2b_B.M_22 = CA_CSE1_V1e_wo_LOSV2b_P.m_Value -
          CA_CSE1_V1e_wo_LOSV2b_P.Y_vdot_Value;

        /* Product: '<S84>/m x_g' incorporates:
         *  Constant: '<S84>/m'
         *  Constant: '<S84>/x_g'
         */
        CA_CSE1_V1e_wo_LOSV2b_B.mx_g = CA_CSE1_V1e_wo_LOSV2b_P.m_Value *
          CA_CSE1_V1e_wo_LOSV2b_P.x_g_Value;

        /* Sum: '<S84>/M_32' incorporates:
         *  Constant: '<S84>/N_vdot'
         */
        CA_CSE1_V1e_wo_LOSV2b_B.M_32 = CA_CSE1_V1e_wo_LOSV2b_B.mx_g -
          CA_CSE1_V1e_wo_LOSV2b_P.N_vdot_Value;

        /* Sum: '<S84>/M_23' incorporates:
         *  Constant: '<S84>/Y_rdot'
         */
        CA_CSE1_V1e_wo_LOSV2b_B.M_23 = CA_CSE1_V1e_wo_LOSV2b_B.mx_g -
          CA_CSE1_V1e_wo_LOSV2b_P.Y_rdot_Value;

        /* Sum: '<S84>/M_33' incorporates:
         *  Constant: '<S84>/I_z'
         *  Constant: '<S84>/N_rdot'
         */
        CA_CSE1_V1e_wo_LOSV2b_B.M_33 = CA_CSE1_V1e_wo_LOSV2b_P.I_z_Value -
          CA_CSE1_V1e_wo_LOSV2b_P.N_rdot_Value;

        /* Reshape: '<S84>/M' incorporates:
         *  Constant: '<S84>/M_12'
         *  Constant: '<S84>/M_13'
         *  Constant: '<S84>/M_21'
         *  Constant: '<S84>/M_31'
         */
        CA_CSE1_V1e_wo_LOSV2b_B.M[0] = CA_CSE1_V1e_wo_LOSV2b_B.M_11;
        CA_CSE1_V1e_wo_LOSV2b_B.M[1] = CA_CSE1_V1e_wo_LOSV2b_P.M_21_Value;
        CA_CSE1_V1e_wo_LOSV2b_B.M[2] = CA_CSE1_V1e_wo_LOSV2b_P.M_31_Value;
        CA_CSE1_V1e_wo_LOSV2b_B.M[3] = CA_CSE1_V1e_wo_LOSV2b_P.M_12_Value;
        CA_CSE1_V1e_wo_LOSV2b_B.M[4] = CA_CSE1_V1e_wo_LOSV2b_B.M_22;
        CA_CSE1_V1e_wo_LOSV2b_B.M[5] = CA_CSE1_V1e_wo_LOSV2b_B.M_32;
        CA_CSE1_V1e_wo_LOSV2b_B.M[6] = CA_CSE1_V1e_wo_LOSV2b_P.M_13_Value;
        CA_CSE1_V1e_wo_LOSV2b_B.M[7] = CA_CSE1_V1e_wo_LOSV2b_B.M_23;
        CA_CSE1_V1e_wo_LOSV2b_B.M[8] = CA_CSE1_V1e_wo_LOSV2b_B.M_33;

        /* Product Block: '<S84>/Inverse' */
        {
          static const int_T dims[3] = { 3, 3, 3 };

          rt_MatDivRR_Dbl(CA_CSE1_V1e_wo_LOSV2b_B.Inverse,
                          CA_CSE1_V1e_wo_LOSV2b_B.M,
                          &CA_CSE1_V1e_wo_LOSV2b_DWork.Inverse_DWORK4[0],
                          (real_T*)&CA_CSE1_V1e_wo_LOSV2b_DWork.K_e1_DWORK1[0],
                          &CA_CSE1_V1e_wo_LOSV2b_DWork.K_e1_DWORK2[0], (real_T*)
                          &CA_CSE1_V1e_wo_LOSV2b_DWork.K_e1_DWORK3[0],
                          &dims[0]);
        }
      }

      /* Product: '<S79>/Product1' */
      for (i = 0; i < 3; i++) {
        CA_CSE1_V1e_wo_LOSV2b_B.Product1_b[i] = 0.0;
        CA_CSE1_V1e_wo_LOSV2b_B.Product1_b[i] =
          CA_CSE1_V1e_wo_LOSV2b_B.LinearDampningmatrix[i] *
          CA_CSE1_V1e_wo_LOSV2b_B.Integrator_o[0] +
          CA_CSE1_V1e_wo_LOSV2b_B.Product1_b[i];
        CA_CSE1_V1e_wo_LOSV2b_B.Product1_b[i] =
          CA_CSE1_V1e_wo_LOSV2b_B.LinearDampningmatrix[i + 3] *
          CA_CSE1_V1e_wo_LOSV2b_B.Integrator_o[1] +
          CA_CSE1_V1e_wo_LOSV2b_B.Product1_b[i];
        CA_CSE1_V1e_wo_LOSV2b_B.Product1_b[i] =
          CA_CSE1_V1e_wo_LOSV2b_B.LinearDampningmatrix[i + 6] *
          CA_CSE1_V1e_wo_LOSV2b_B.Integrator_o[2] +
          CA_CSE1_V1e_wo_LOSV2b_B.Product1_b[i];
      }

      if (rtmIsMajorTimeStep(CA_CSE1_V1e_wo_LOSV2b_M)) {
        /* Gain: '<S90>/-l_x1' incorporates:
         *  Constant: '<S90>/l_x1'
         */
        CA_CSE1_V1e_wo_LOSV2b_B.l_x1_j = CA_CSE1_V1e_wo_LOSV2b_P.l_x1_Gain_o *
          CA_CSE1_V1e_wo_LOSV2b_P.l_x1_Value_d;

        /* Gain: '<S90>/-l_y2' incorporates:
         *  Constant: '<S90>/l_y2'
         */
        CA_CSE1_V1e_wo_LOSV2b_B.l_y2_p = CA_CSE1_V1e_wo_LOSV2b_P.l_y2_Gain_h *
          CA_CSE1_V1e_wo_LOSV2b_P.l_y2_Value_j;

        /* Gain: '<S90>/-l_x2' incorporates:
         *  Constant: '<S90>/l_x2'
         */
        CA_CSE1_V1e_wo_LOSV2b_B.l_x2_o = CA_CSE1_V1e_wo_LOSV2b_P.l_x2_Gain_c *
          CA_CSE1_V1e_wo_LOSV2b_P.l_x2_Value_k;

        /* Reshape: '<S90>/3x5' incorporates:
         *  Constant: '<S90>/T_e11'
         *  Constant: '<S90>/T_e12'
         *  Constant: '<S90>/T_e13'
         *  Constant: '<S90>/T_e14'
         *  Constant: '<S90>/T_e15'
         *  Constant: '<S90>/T_e21'
         *  Constant: '<S90>/T_e22'
         *  Constant: '<S90>/T_e23'
         *  Constant: '<S90>/T_e24'
         *  Constant: '<S90>/T_e25'
         *  Constant: '<S90>/l_x3'
         *  Constant: '<S90>/l_y1'
         */
        CA_CSE1_V1e_wo_LOSV2b_B.x5_d[0] = CA_CSE1_V1e_wo_LOSV2b_P.T_e11_Value_o;
        CA_CSE1_V1e_wo_LOSV2b_B.x5_d[1] = CA_CSE1_V1e_wo_LOSV2b_P.T_e21_Value_l;
        CA_CSE1_V1e_wo_LOSV2b_B.x5_d[2] = CA_CSE1_V1e_wo_LOSV2b_P.l_y1_Value_n;
        CA_CSE1_V1e_wo_LOSV2b_B.x5_d[3] = CA_CSE1_V1e_wo_LOSV2b_P.T_e12_Value_p;
        CA_CSE1_V1e_wo_LOSV2b_B.x5_d[4] = CA_CSE1_V1e_wo_LOSV2b_P.T_e22_Value_k;
        CA_CSE1_V1e_wo_LOSV2b_B.x5_d[5] = CA_CSE1_V1e_wo_LOSV2b_B.l_x1_j;
        CA_CSE1_V1e_wo_LOSV2b_B.x5_d[6] = CA_CSE1_V1e_wo_LOSV2b_P.T_e13_Value_k;
        CA_CSE1_V1e_wo_LOSV2b_B.x5_d[7] = CA_CSE1_V1e_wo_LOSV2b_P.T_e23_Value_e;
        CA_CSE1_V1e_wo_LOSV2b_B.x5_d[8] = CA_CSE1_V1e_wo_LOSV2b_B.l_y2_p;
        CA_CSE1_V1e_wo_LOSV2b_B.x5_d[9] = CA_CSE1_V1e_wo_LOSV2b_P.T_e14_Value_d;
        CA_CSE1_V1e_wo_LOSV2b_B.x5_d[10] = CA_CSE1_V1e_wo_LOSV2b_P.T_e24_Value_g;
        CA_CSE1_V1e_wo_LOSV2b_B.x5_d[11] = CA_CSE1_V1e_wo_LOSV2b_B.l_x2_o;
        CA_CSE1_V1e_wo_LOSV2b_B.x5_d[12] = CA_CSE1_V1e_wo_LOSV2b_P.T_e15_Value_p;
        CA_CSE1_V1e_wo_LOSV2b_B.x5_d[13] = CA_CSE1_V1e_wo_LOSV2b_P.T_e25_Value_o;
        CA_CSE1_V1e_wo_LOSV2b_B.x5_d[14] = CA_CSE1_V1e_wo_LOSV2b_P.l_x3_Value_b;

        /* Gain: '<S88>/Gain K_e1_hil' incorporates:
         *  Constant: '<S88>/K_e1_hil'
         */
        CA_CSE1_V1e_wo_LOSV2b_B.GainK_e1_hil =
          CA_CSE1_V1e_wo_LOSV2b_P.GainK_e1_hil_Gain *
          CA_CSE1_V1e_wo_LOSV2b_P.K_e1_hil_Value;

        /* Gain: '<S88>/Gain K_e2_hil' incorporates:
         *  Constant: '<S88>/K_e2_hil'
         */
        CA_CSE1_V1e_wo_LOSV2b_B.GainK_e2_hil =
          CA_CSE1_V1e_wo_LOSV2b_P.GainK_e2_hil_Gain *
          CA_CSE1_V1e_wo_LOSV2b_P.K_e2_hil_Value;

        /* Gain: '<S88>/Gain K_e3_hil' incorporates:
         *  Constant: '<S88>/K_e3_hil'
         */
        CA_CSE1_V1e_wo_LOSV2b_B.GainK_e3_hil =
          CA_CSE1_V1e_wo_LOSV2b_P.GainK_e3_hil_Gain *
          CA_CSE1_V1e_wo_LOSV2b_P.K_e3_hil_Value;

        /* Gain: '<S88>/Gain K_e4_hil' incorporates:
         *  Constant: '<S88>/K_e4_hil'
         */
        CA_CSE1_V1e_wo_LOSV2b_B.GainK_e4_hil =
          CA_CSE1_V1e_wo_LOSV2b_P.GainK_e4_hil_Gain *
          CA_CSE1_V1e_wo_LOSV2b_P.K_e4_hil_Value;

        /* Gain: '<S88>/Gain K_e5_hil' incorporates:
         *  Constant: '<S88>/K_e5_hil'
         */
        CA_CSE1_V1e_wo_LOSV2b_B.GainK_e5_hil =
          CA_CSE1_V1e_wo_LOSV2b_P.GainK_e5_hil_Gain *
          CA_CSE1_V1e_wo_LOSV2b_P.K_e5_hil_Value;

        /* Reshape: '<S88>/Thruster Gain matrix' incorporates:
         *  Constant: '<S88>/Constant41'
         */
        CA_CSE1_V1e_wo_LOSV2b_B.ThrusterGainmatrix_e[0] =
          CA_CSE1_V1e_wo_LOSV2b_B.GainK_e1_hil;
        CA_CSE1_V1e_wo_LOSV2b_B.ThrusterGainmatrix_e[1] =
          CA_CSE1_V1e_wo_LOSV2b_P.Constant41_Value;
        CA_CSE1_V1e_wo_LOSV2b_B.ThrusterGainmatrix_e[2] =
          CA_CSE1_V1e_wo_LOSV2b_P.Constant41_Value;
        CA_CSE1_V1e_wo_LOSV2b_B.ThrusterGainmatrix_e[3] =
          CA_CSE1_V1e_wo_LOSV2b_P.Constant41_Value;
        CA_CSE1_V1e_wo_LOSV2b_B.ThrusterGainmatrix_e[4] =
          CA_CSE1_V1e_wo_LOSV2b_P.Constant41_Value;
        CA_CSE1_V1e_wo_LOSV2b_B.ThrusterGainmatrix_e[5] =
          CA_CSE1_V1e_wo_LOSV2b_P.Constant41_Value;
        CA_CSE1_V1e_wo_LOSV2b_B.ThrusterGainmatrix_e[6] =
          CA_CSE1_V1e_wo_LOSV2b_B.GainK_e2_hil;
        CA_CSE1_V1e_wo_LOSV2b_B.ThrusterGainmatrix_e[7] =
          CA_CSE1_V1e_wo_LOSV2b_P.Constant41_Value;
        CA_CSE1_V1e_wo_LOSV2b_B.ThrusterGainmatrix_e[8] =
          CA_CSE1_V1e_wo_LOSV2b_P.Constant41_Value;
        CA_CSE1_V1e_wo_LOSV2b_B.ThrusterGainmatrix_e[9] =
          CA_CSE1_V1e_wo_LOSV2b_P.Constant41_Value;
        CA_CSE1_V1e_wo_LOSV2b_B.ThrusterGainmatrix_e[10] =
          CA_CSE1_V1e_wo_LOSV2b_P.Constant41_Value;
        CA_CSE1_V1e_wo_LOSV2b_B.ThrusterGainmatrix_e[11] =
          CA_CSE1_V1e_wo_LOSV2b_P.Constant41_Value;
        CA_CSE1_V1e_wo_LOSV2b_B.ThrusterGainmatrix_e[12] =
          CA_CSE1_V1e_wo_LOSV2b_B.GainK_e3_hil;
        CA_CSE1_V1e_wo_LOSV2b_B.ThrusterGainmatrix_e[13] =
          CA_CSE1_V1e_wo_LOSV2b_P.Constant41_Value;
        CA_CSE1_V1e_wo_LOSV2b_B.ThrusterGainmatrix_e[14] =
          CA_CSE1_V1e_wo_LOSV2b_P.Constant41_Value;
        CA_CSE1_V1e_wo_LOSV2b_B.ThrusterGainmatrix_e[15] =
          CA_CSE1_V1e_wo_LOSV2b_P.Constant41_Value;
        CA_CSE1_V1e_wo_LOSV2b_B.ThrusterGainmatrix_e[16] =
          CA_CSE1_V1e_wo_LOSV2b_P.Constant41_Value;
        CA_CSE1_V1e_wo_LOSV2b_B.ThrusterGainmatrix_e[17] =
          CA_CSE1_V1e_wo_LOSV2b_P.Constant41_Value;
        CA_CSE1_V1e_wo_LOSV2b_B.ThrusterGainmatrix_e[18] =
          CA_CSE1_V1e_wo_LOSV2b_B.GainK_e4_hil;
        CA_CSE1_V1e_wo_LOSV2b_B.ThrusterGainmatrix_e[19] =
          CA_CSE1_V1e_wo_LOSV2b_P.Constant41_Value;
        CA_CSE1_V1e_wo_LOSV2b_B.ThrusterGainmatrix_e[20] =
          CA_CSE1_V1e_wo_LOSV2b_P.Constant41_Value;
        CA_CSE1_V1e_wo_LOSV2b_B.ThrusterGainmatrix_e[21] =
          CA_CSE1_V1e_wo_LOSV2b_P.Constant41_Value;
        CA_CSE1_V1e_wo_LOSV2b_B.ThrusterGainmatrix_e[22] =
          CA_CSE1_V1e_wo_LOSV2b_P.Constant41_Value;
        CA_CSE1_V1e_wo_LOSV2b_B.ThrusterGainmatrix_e[23] =
          CA_CSE1_V1e_wo_LOSV2b_P.Constant41_Value;
        CA_CSE1_V1e_wo_LOSV2b_B.ThrusterGainmatrix_e[24] =
          CA_CSE1_V1e_wo_LOSV2b_B.GainK_e5_hil;

        /* S-Function (sfix_tsampmath) Block: '<S89>/sample time'
         */
        /* Sample Time Math Block: '<S89>/sample time'
         *
         * y = K         where     K = ( w * Ts )
         *
         * Input0  Data Type:  Floating Point real_T
         * Output0 Data Type:  Floating Point real_T
         *
         * Parameter: WtEt == Weighted Elapsed Time
         *   Data Type:  Floating Point real_T
         *
         */
        CA_CSE1_V1e_wo_LOSV2b_B.sampletime =
          CA_CSE1_V1e_wo_LOSV2b_P.sampletime_WtEt;

        /* UnitDelay: '<S89>/Delay Input2' */
        CA_CSE1_V1e_wo_LOSV2b_B.Yk1 =
          CA_CSE1_V1e_wo_LOSV2b_DWork.DelayInput2_DSTATE;
      }

      /* Fcn: '<S85>/R11' */
      CA_CSE1_V1e_wo_LOSV2b_B.R11_b = cos(CA_CSE1_V1e_wo_LOSV2b_B.Integrator1[2]);

      /* Fcn: '<S85>/R21' */
      CA_CSE1_V1e_wo_LOSV2b_B.R21_af = sin(CA_CSE1_V1e_wo_LOSV2b_B.Integrator1[2]);

      /* Fcn: '<S85>/R12' */
      CA_CSE1_V1e_wo_LOSV2b_B.R12_m = -1.0 * sin
        (CA_CSE1_V1e_wo_LOSV2b_B.Integrator1[2]);

      /* Fcn: '<S85>/R22' */
      CA_CSE1_V1e_wo_LOSV2b_B.R22_h = cos(CA_CSE1_V1e_wo_LOSV2b_B.Integrator1[2]);

      /* Reshape: '<S85>/R(psi)' incorporates:
       *  Constant: '<S85>/R13'
       *  Constant: '<S85>/R23'
       *  Constant: '<S85>/R31'
       *  Constant: '<S85>/R32'
       *  Constant: '<S85>/R33'
       */
      CA_CSE1_V1e_wo_LOSV2b_B.Rpsi[0] = CA_CSE1_V1e_wo_LOSV2b_B.R11_b;
      CA_CSE1_V1e_wo_LOSV2b_B.Rpsi[1] = CA_CSE1_V1e_wo_LOSV2b_B.R21_af;
      CA_CSE1_V1e_wo_LOSV2b_B.Rpsi[2] = CA_CSE1_V1e_wo_LOSV2b_P.R31_Value;
      CA_CSE1_V1e_wo_LOSV2b_B.Rpsi[3] = CA_CSE1_V1e_wo_LOSV2b_B.R12_m;
      CA_CSE1_V1e_wo_LOSV2b_B.Rpsi[4] = CA_CSE1_V1e_wo_LOSV2b_B.R22_h;
      CA_CSE1_V1e_wo_LOSV2b_B.Rpsi[5] = CA_CSE1_V1e_wo_LOSV2b_P.R32_Value;
      CA_CSE1_V1e_wo_LOSV2b_B.Rpsi[6] = CA_CSE1_V1e_wo_LOSV2b_P.R13_Value;
      CA_CSE1_V1e_wo_LOSV2b_B.Rpsi[7] = CA_CSE1_V1e_wo_LOSV2b_P.R23_Value;
      CA_CSE1_V1e_wo_LOSV2b_B.Rpsi[8] = CA_CSE1_V1e_wo_LOSV2b_P.R33_Value;

      /* Product: '<S79>/Product3' */
      for (i = 0; i < 3; i++) {
        CA_CSE1_V1e_wo_LOSV2b_B.Product3_g[i] = 0.0;
        CA_CSE1_V1e_wo_LOSV2b_B.Product3_g[i] = CA_CSE1_V1e_wo_LOSV2b_B.Rpsi[i] *
          CA_CSE1_V1e_wo_LOSV2b_B.Integrator_o[0] +
          CA_CSE1_V1e_wo_LOSV2b_B.Product3_g[i];
        CA_CSE1_V1e_wo_LOSV2b_B.Product3_g[i] = CA_CSE1_V1e_wo_LOSV2b_B.Rpsi[i +
          3] * CA_CSE1_V1e_wo_LOSV2b_B.Integrator_o[1] +
          CA_CSE1_V1e_wo_LOSV2b_B.Product3_g[i];
        CA_CSE1_V1e_wo_LOSV2b_B.Product3_g[i] = CA_CSE1_V1e_wo_LOSV2b_B.Rpsi[i +
          6] * CA_CSE1_V1e_wo_LOSV2b_B.Integrator_o[2] +
          CA_CSE1_V1e_wo_LOSV2b_B.Product3_g[i];
      }

      /* Gain: '<S67>/eta_surge_hil' */
      CA_CSE1_V1e_wo_LOSV2b_B.eta_surge_hil =
        CA_CSE1_V1e_wo_LOSV2b_P.eta_surge_hil_Gain *
        CA_CSE1_V1e_wo_LOSV2b_B.Integrator1[0];

      /* Gain: '<S67>/eta_sway_hil' */
      CA_CSE1_V1e_wo_LOSV2b_B.eta_sway_hil =
        CA_CSE1_V1e_wo_LOSV2b_P.eta_sway_hil_Gain *
        CA_CSE1_V1e_wo_LOSV2b_B.Integrator1[1];

      /* Gain: '<S67>/eta_yaw_hil' */
      CA_CSE1_V1e_wo_LOSV2b_B.eta_yaw_hil =
        CA_CSE1_V1e_wo_LOSV2b_P.eta_yaw_hil_Gain *
        CA_CSE1_V1e_wo_LOSV2b_B.Integrator1[2];

      /* Gain: '<S67>/etadot_surge_hil' */
      CA_CSE1_V1e_wo_LOSV2b_B.etadot_surge_hil =
        CA_CSE1_V1e_wo_LOSV2b_P.etadot_surge_hil_Gain *
        CA_CSE1_V1e_wo_LOSV2b_B.Product3_g[0];

      /* Gain: '<S67>/etadot_sway_hil' */
      CA_CSE1_V1e_wo_LOSV2b_B.etadot_sway_hil =
        CA_CSE1_V1e_wo_LOSV2b_P.etadot_sway_hil_Gain *
        CA_CSE1_V1e_wo_LOSV2b_B.Product3_g[1];

      /* Gain: '<S67>/etadot_yaw_hil' */
      CA_CSE1_V1e_wo_LOSV2b_B.etadot_yaw_hil =
        CA_CSE1_V1e_wo_LOSV2b_P.etadot_yaw_hil_Gain *
        CA_CSE1_V1e_wo_LOSV2b_B.Product3_g[2];

      /* Gain: '<S67>/nu_surge_hil' */
      CA_CSE1_V1e_wo_LOSV2b_B.nu_surge_hil =
        CA_CSE1_V1e_wo_LOSV2b_P.nu_surge_hil_Gain *
        CA_CSE1_V1e_wo_LOSV2b_B.Integrator_o[0];

      /* Gain: '<S67>/nu_sway_hil' */
      CA_CSE1_V1e_wo_LOSV2b_B.nu_sway_hil =
        CA_CSE1_V1e_wo_LOSV2b_P.nu_sway_hil_Gain *
        CA_CSE1_V1e_wo_LOSV2b_B.Integrator_o[1];

      /* Gain: '<S67>/nu_yaw_hil' */
      CA_CSE1_V1e_wo_LOSV2b_B.nu_yaw_hil =
        CA_CSE1_V1e_wo_LOSV2b_P.nu_yaw_hil_Gain *
        CA_CSE1_V1e_wo_LOSV2b_B.Integrator_o[2];
      if (rtmIsMajorTimeStep(CA_CSE1_V1e_wo_LOSV2b_M)) {
      }
    }

    /* end of Outputs for SubSystem: '<S5>/Linear Simulator' */

    /* MultiPortSwitch: '<S4>/Eta Switch' incorporates:
     *  Constant: '<S4>/Controller Input Selector'
     */
    if ((int32_T)CA_CSE1_V1e_wo_LOSV2b_P.ControllerInputSelector_Value == 0) {
      CA_CSE1_V1e_wo_LOSV2b_B.EtaSwitch[0] = CA_CSE1_V1e_wo_LOSV2b_B.mm2mx;
      CA_CSE1_V1e_wo_LOSV2b_B.EtaSwitch[1] = CA_CSE1_V1e_wo_LOSV2b_B.mm2my;
      CA_CSE1_V1e_wo_LOSV2b_B.EtaSwitch[2] = CA_CSE1_V1e_wo_LOSV2b_B.d2ryaw;
    } else {
      CA_CSE1_V1e_wo_LOSV2b_B.EtaSwitch[0] =
        CA_CSE1_V1e_wo_LOSV2b_B.eta_surge_hil;
      CA_CSE1_V1e_wo_LOSV2b_B.EtaSwitch[1] =
        CA_CSE1_V1e_wo_LOSV2b_B.eta_sway_hil;
      CA_CSE1_V1e_wo_LOSV2b_B.EtaSwitch[2] = CA_CSE1_V1e_wo_LOSV2b_B.eta_yaw_hil;
    }

    /* Gain: '<S4>/eta_surge' */
    CA_CSE1_V1e_wo_LOSV2b_B.eta_surge = CA_CSE1_V1e_wo_LOSV2b_P.eta_surge_Gain *
      CA_CSE1_V1e_wo_LOSV2b_B.EtaSwitch[0];

    /* Gain: '<S4>/eta_sway' */
    CA_CSE1_V1e_wo_LOSV2b_B.eta_sway = CA_CSE1_V1e_wo_LOSV2b_P.eta_sway_Gain *
      CA_CSE1_V1e_wo_LOSV2b_B.EtaSwitch[1];

    /* Gain: '<S4>/eta_yaw' */
    CA_CSE1_V1e_wo_LOSV2b_B.eta_yaw = CA_CSE1_V1e_wo_LOSV2b_P.eta_yaw_Gain *
      CA_CSE1_V1e_wo_LOSV2b_B.EtaSwitch[2];

    /* Trigonometry: '<S64>/sin(theta)' */
    CA_CSE1_V1e_wo_LOSV2b_B.sintheta[0] = sin(CA_CSE1_V1e_wo_LOSV2b_B.d2rroll);
    CA_CSE1_V1e_wo_LOSV2b_B.sintheta[1] = sin(CA_CSE1_V1e_wo_LOSV2b_B.d2rpitch);
    CA_CSE1_V1e_wo_LOSV2b_B.sintheta[2] = sin(CA_CSE1_V1e_wo_LOSV2b_B.d2ryaw);

    /* Trigonometry: '<S64>/cos(theta)' */
    CA_CSE1_V1e_wo_LOSV2b_B.costheta[0] = cos(CA_CSE1_V1e_wo_LOSV2b_B.d2rroll);
    CA_CSE1_V1e_wo_LOSV2b_B.costheta[1] = cos(CA_CSE1_V1e_wo_LOSV2b_B.d2rpitch);
    CA_CSE1_V1e_wo_LOSV2b_B.costheta[2] = cos(CA_CSE1_V1e_wo_LOSV2b_B.d2ryaw);

    /* Fcn: '<S64>/R11' */
    CA_CSE1_V1e_wo_LOSV2b_B.R11 = CA_CSE1_V1e_wo_LOSV2b_B.costheta[1] *
      CA_CSE1_V1e_wo_LOSV2b_B.costheta[2];

    /* Fcn: '<S64>/R21 ' */
    CA_CSE1_V1e_wo_LOSV2b_B.R21 = CA_CSE1_V1e_wo_LOSV2b_B.sintheta[0] *
      CA_CSE1_V1e_wo_LOSV2b_B.sintheta[1] * CA_CSE1_V1e_wo_LOSV2b_B.costheta[2]
      + (-CA_CSE1_V1e_wo_LOSV2b_B.costheta[0]) *
      CA_CSE1_V1e_wo_LOSV2b_B.sintheta[2];

    /* Fcn: '<S64>/R31 ' */
    CA_CSE1_V1e_wo_LOSV2b_B.R31 = CA_CSE1_V1e_wo_LOSV2b_B.costheta[0] *
      CA_CSE1_V1e_wo_LOSV2b_B.sintheta[1] * CA_CSE1_V1e_wo_LOSV2b_B.costheta[2]
      + CA_CSE1_V1e_wo_LOSV2b_B.sintheta[0] * CA_CSE1_V1e_wo_LOSV2b_B.sintheta[2];

    /* Fcn: '<S64>/R12' */
    CA_CSE1_V1e_wo_LOSV2b_B.R12 = CA_CSE1_V1e_wo_LOSV2b_B.costheta[1] *
      CA_CSE1_V1e_wo_LOSV2b_B.sintheta[2];

    /* Fcn: '<S64>/R22' */
    CA_CSE1_V1e_wo_LOSV2b_B.R22 = CA_CSE1_V1e_wo_LOSV2b_B.sintheta[0] *
      CA_CSE1_V1e_wo_LOSV2b_B.sintheta[1] * CA_CSE1_V1e_wo_LOSV2b_B.sintheta[2]
      + CA_CSE1_V1e_wo_LOSV2b_B.costheta[0] * CA_CSE1_V1e_wo_LOSV2b_B.costheta[2];

    /* Fcn: '<S64>/R32' */
    CA_CSE1_V1e_wo_LOSV2b_B.R32 = CA_CSE1_V1e_wo_LOSV2b_B.costheta[0] *
      CA_CSE1_V1e_wo_LOSV2b_B.sintheta[1] * CA_CSE1_V1e_wo_LOSV2b_B.sintheta[2]
      + (-CA_CSE1_V1e_wo_LOSV2b_B.sintheta[0]) *
      CA_CSE1_V1e_wo_LOSV2b_B.costheta[2];

    /* Fcn: '<S64>/R13' */
    CA_CSE1_V1e_wo_LOSV2b_B.R13 = -CA_CSE1_V1e_wo_LOSV2b_B.sintheta[1];

    /* Fcn: '<S64>/R23' */
    CA_CSE1_V1e_wo_LOSV2b_B.R23 = CA_CSE1_V1e_wo_LOSV2b_B.sintheta[0] *
      CA_CSE1_V1e_wo_LOSV2b_B.costheta[1];

    /* Fcn: '<S64>/R33' */
    CA_CSE1_V1e_wo_LOSV2b_B.R33 = CA_CSE1_V1e_wo_LOSV2b_B.costheta[0] *
      CA_CSE1_V1e_wo_LOSV2b_B.costheta[1];

    /* Reshape: '<S64>/Reshape 9x1->3x3' */
    CA_CSE1_V1e_wo_LOSV2b_B.Reshape9x13x3[0] = CA_CSE1_V1e_wo_LOSV2b_B.R11;
    CA_CSE1_V1e_wo_LOSV2b_B.Reshape9x13x3[1] = CA_CSE1_V1e_wo_LOSV2b_B.R21;
    CA_CSE1_V1e_wo_LOSV2b_B.Reshape9x13x3[2] = CA_CSE1_V1e_wo_LOSV2b_B.R31;
    CA_CSE1_V1e_wo_LOSV2b_B.Reshape9x13x3[3] = CA_CSE1_V1e_wo_LOSV2b_B.R12;
    CA_CSE1_V1e_wo_LOSV2b_B.Reshape9x13x3[4] = CA_CSE1_V1e_wo_LOSV2b_B.R22;
    CA_CSE1_V1e_wo_LOSV2b_B.Reshape9x13x3[5] = CA_CSE1_V1e_wo_LOSV2b_B.R32;
    CA_CSE1_V1e_wo_LOSV2b_B.Reshape9x13x3[6] = CA_CSE1_V1e_wo_LOSV2b_B.R13;
    CA_CSE1_V1e_wo_LOSV2b_B.Reshape9x13x3[7] = CA_CSE1_V1e_wo_LOSV2b_B.R23;
    CA_CSE1_V1e_wo_LOSV2b_B.Reshape9x13x3[8] = CA_CSE1_V1e_wo_LOSV2b_B.R33;

    /* Concatenate: '<S63>/Matrix Concatenate' incorporates:
     *  Constant: '<S63>/Constant1'
     */
    for (i = 0; i < 3; i++) {
      tmp_0[6 * i] = CA_CSE1_V1e_wo_LOSV2b_B.Reshape9x13x3[3 * i];
      tmp_0[1 + 6 * i] = CA_CSE1_V1e_wo_LOSV2b_B.Reshape9x13x3[3 * i + 1];
      tmp_0[2 + 6 * i] = CA_CSE1_V1e_wo_LOSV2b_B.Reshape9x13x3[3 * i + 2];
    }

    for (i = 0; i < 3; i++) {
      tmp_0[3 + 6 * i] = CA_CSE1_V1e_wo_LOSV2b_P.Constant1_Value[3 * i];
      tmp_0[4 + 6 * i] = CA_CSE1_V1e_wo_LOSV2b_P.Constant1_Value[3 * i + 1];
      tmp_0[5 + 6 * i] = CA_CSE1_V1e_wo_LOSV2b_P.Constant1_Value[3 * i + 2];
    }

    memcpy((void *)(&CA_CSE1_V1e_wo_LOSV2b_B.MatrixConcatenate2[0]), (void *)
           &tmp_0[0], 18U * sizeof(real_T));

    /* Concatenate: '<S63>/Matrix Concatenate1' incorporates:
     *  Constant: '<S63>/Constant1'
     */
    for (i = 0; i < 3; i++) {
      tmp_0[6 * i] = CA_CSE1_V1e_wo_LOSV2b_P.Constant1_Value[3 * i];
      tmp_0[1 + 6 * i] = CA_CSE1_V1e_wo_LOSV2b_P.Constant1_Value[3 * i + 1];
      tmp_0[2 + 6 * i] = CA_CSE1_V1e_wo_LOSV2b_P.Constant1_Value[3 * i + 2];
    }

    for (i = 0; i < 3; i++) {
      tmp_0[3 + 6 * i] = CA_CSE1_V1e_wo_LOSV2b_B.Reshape9x13x3[3 * i];
      tmp_0[4 + 6 * i] = CA_CSE1_V1e_wo_LOSV2b_B.Reshape9x13x3[3 * i + 1];
      tmp_0[5 + 6 * i] = CA_CSE1_V1e_wo_LOSV2b_B.Reshape9x13x3[3 * i + 2];
    }

    memcpy((void *)(&CA_CSE1_V1e_wo_LOSV2b_B.MatrixConcatenate2[18]), (void *)
           &tmp_0[0], 18U * sizeof(real_T));

    /* Derivative Block: '<S63>/Derivative' */
    {
      real_T t = CA_CSE1_V1e_wo_LOSV2b_M->Timing.t[0];
      real_T timeStampA =
        CA_CSE1_V1e_wo_LOSV2b_DWork.Derivative_RWORK.TimeStampA;
      real_T timeStampB =
        CA_CSE1_V1e_wo_LOSV2b_DWork.Derivative_RWORK.TimeStampB;
      if (timeStampA >= t && timeStampB >= t) {
        {
          int_T i1;
          real_T *y0 = CA_CSE1_V1e_wo_LOSV2b_B.Derivative;
          for (i1=0; i1 < 6; i1++) {
            y0[i1] = 0.0;
          }
        }
      } else {
        real_T deltaT;
        real_T *lastBank =
          &CA_CSE1_V1e_wo_LOSV2b_DWork.Derivative_RWORK.TimeStampA;
        if (timeStampA < timeStampB) {
          if (timeStampB < t) {
            lastBank += 7;
          }
        } else if (timeStampA >= t) {
          lastBank += 7;
        }

        deltaT = t - *lastBank++;
        CA_CSE1_V1e_wo_LOSV2b_B.Derivative[0] = (CA_CSE1_V1e_wo_LOSV2b_B.mm2mx -
          *lastBank++) / deltaT;
        CA_CSE1_V1e_wo_LOSV2b_B.Derivative[1] = (CA_CSE1_V1e_wo_LOSV2b_B.mm2my -
          *lastBank++) / deltaT;
        CA_CSE1_V1e_wo_LOSV2b_B.Derivative[2] = (CA_CSE1_V1e_wo_LOSV2b_B.mm2mz -
          *lastBank++) / deltaT;
        CA_CSE1_V1e_wo_LOSV2b_B.Derivative[3] = (CA_CSE1_V1e_wo_LOSV2b_B.d2rroll
          - *lastBank++) / deltaT;
        CA_CSE1_V1e_wo_LOSV2b_B.Derivative[4] =
          (CA_CSE1_V1e_wo_LOSV2b_B.d2rpitch - *lastBank++) / deltaT;
        CA_CSE1_V1e_wo_LOSV2b_B.Derivative[5] = (CA_CSE1_V1e_wo_LOSV2b_B.d2ryaw
          - *lastBank++) / deltaT;
      }
    }

    /* Product: '<S63>/Product' */
    for (i = 0; i < 6; i++) {
      CA_CSE1_V1e_wo_LOSV2b_B.Product[i] = 0.0;
      for (tmp_4 = 0; tmp_4 < 6; tmp_4++) {
        CA_CSE1_V1e_wo_LOSV2b_B.Product[i] =
          CA_CSE1_V1e_wo_LOSV2b_B.MatrixConcatenate2[6 * tmp_4 + i] *
          CA_CSE1_V1e_wo_LOSV2b_B.Derivative[tmp_4] +
          CA_CSE1_V1e_wo_LOSV2b_B.Product[i];
      }
    }

    /* MultiPortSwitch: '<S4>/Nu Switch' incorporates:
     *  Constant: '<S4>/Controller Input Selector'
     */
    if ((int32_T)CA_CSE1_V1e_wo_LOSV2b_P.ControllerInputSelector_Value == 0) {
      CA_CSE1_V1e_wo_LOSV2b_B.NuSwitch[0] = CA_CSE1_V1e_wo_LOSV2b_B.Product[0];
      CA_CSE1_V1e_wo_LOSV2b_B.NuSwitch[1] = CA_CSE1_V1e_wo_LOSV2b_B.Product[1];
      CA_CSE1_V1e_wo_LOSV2b_B.NuSwitch[2] = CA_CSE1_V1e_wo_LOSV2b_B.Product[5];
    } else {
      CA_CSE1_V1e_wo_LOSV2b_B.NuSwitch[0] = CA_CSE1_V1e_wo_LOSV2b_B.nu_surge_hil;
      CA_CSE1_V1e_wo_LOSV2b_B.NuSwitch[1] = CA_CSE1_V1e_wo_LOSV2b_B.nu_sway_hil;
      CA_CSE1_V1e_wo_LOSV2b_B.NuSwitch[2] = CA_CSE1_V1e_wo_LOSV2b_B.nu_yaw_hil;
    }

    /* Gain: '<S4>/nu_surge' */
    CA_CSE1_V1e_wo_LOSV2b_B.nu_surge = CA_CSE1_V1e_wo_LOSV2b_P.nu_surge_Gain *
      CA_CSE1_V1e_wo_LOSV2b_B.NuSwitch[0];

    /* Gain: '<S4>/nu_sway' */
    CA_CSE1_V1e_wo_LOSV2b_B.nu_sway = CA_CSE1_V1e_wo_LOSV2b_P.nu_sway_Gain *
      CA_CSE1_V1e_wo_LOSV2b_B.NuSwitch[1];

    /* Gain: '<S4>/nu_yaw' */
    CA_CSE1_V1e_wo_LOSV2b_B.nu_yaw = CA_CSE1_V1e_wo_LOSV2b_P.nu_yaw_Gain *
      CA_CSE1_V1e_wo_LOSV2b_B.NuSwitch[2];
    if (rtmIsMajorTimeStep(CA_CSE1_V1e_wo_LOSV2b_M)) {
      /* RelationalOperator: '<S12>/Compare' incorporates:
       *  Constant: '<S12>/Constant'
       *  Constant: '<S1>/Control Mode'
       */
      CA_CSE1_V1e_wo_LOSV2b_B.Compare =
        (CA_CSE1_V1e_wo_LOSV2b_P.ControlMode_Value ==
         CA_CSE1_V1e_wo_LOSV2b_P.Constant_Value_c);
    }

    /* Outputs for enable SubSystem: '<S1>/DP control' incorporates:
     *  EnablePort: '<S6>/Enable'
     */
    if (rtmIsMajorTimeStep(CA_CSE1_V1e_wo_LOSV2b_M) && rtmIsMajorTimeStep
        (CA_CSE1_V1e_wo_LOSV2b_M)) {
      if (CA_CSE1_V1e_wo_LOSV2b_B.Compare > 0) {
        if (CA_CSE1_V1e_wo_LOSV2b_DWork.DPcontrol_MODE == SUBSYS_DISABLED) {
          /* InitializeConditions for Integrator: '<S16>/Integrator1' */
          CA_CSE1_V1e_wo_LOSV2b_X.Integrator1_CSTATE_i[0] =
            CA_CSE1_V1e_wo_LOSV2b_P.Integrator1_IC;

          /* InitializeConditions for Integrator: '<S16>/Integrator' */
          CA_CSE1_V1e_wo_LOSV2b_X.Integrator_CSTATE_o[0] =
            CA_CSE1_V1e_wo_LOSV2b_P.Integrator_IC_n;

          /* InitializeConditions for Integrator: '<S16>/Integrator1' */
          CA_CSE1_V1e_wo_LOSV2b_X.Integrator1_CSTATE_i[1] =
            CA_CSE1_V1e_wo_LOSV2b_P.Integrator1_IC;

          /* InitializeConditions for Integrator: '<S16>/Integrator' */
          CA_CSE1_V1e_wo_LOSV2b_X.Integrator_CSTATE_o[1] =
            CA_CSE1_V1e_wo_LOSV2b_P.Integrator_IC_n;

          /* InitializeConditions for Integrator: '<S16>/Integrator1' */
          CA_CSE1_V1e_wo_LOSV2b_X.Integrator1_CSTATE_i[2] =
            CA_CSE1_V1e_wo_LOSV2b_P.Integrator1_IC;

          /* InitializeConditions for Integrator: '<S16>/Integrator' */
          CA_CSE1_V1e_wo_LOSV2b_X.Integrator_CSTATE_o[2] =
            CA_CSE1_V1e_wo_LOSV2b_P.Integrator_IC_n;

          /* Integrator Block: '<S14>/Integrator' */
          CA_CSE1_V1e_wo_LOSV2b_X.Integrator_CSTATE_e[0] =
            CA_CSE1_V1e_wo_LOSV2b_P.Integrator_IC_d;
          CA_CSE1_V1e_wo_LOSV2b_X.Integrator_CSTATE_e[1] =
            CA_CSE1_V1e_wo_LOSV2b_P.Integrator_IC_d;
          CA_CSE1_V1e_wo_LOSV2b_X.Integrator_CSTATE_e[2] =
            CA_CSE1_V1e_wo_LOSV2b_P.Integrator_IC_d;

          /* InitializeConditions for Integrator: '<S16>/Integrator4' */
          CA_CSE1_V1e_wo_LOSV2b_X.Integrator4_CSTATE[0] =
            CA_CSE1_V1e_wo_LOSV2b_P.Integrator4_IC;

          /* InitializeConditions for Integrator: '<S16>/Integrator2' */
          CA_CSE1_V1e_wo_LOSV2b_X.Integrator2_CSTATE[0] =
            CA_CSE1_V1e_wo_LOSV2b_P.Integrator2_IC;

          /* InitializeConditions for Integrator: '<S16>/Integrator3' */
          CA_CSE1_V1e_wo_LOSV2b_X.Integrator3_CSTATE[0] =
            CA_CSE1_V1e_wo_LOSV2b_P.Integrator3_IC;

          /* InitializeConditions for Integrator: '<S16>/Integrator4' */
          CA_CSE1_V1e_wo_LOSV2b_X.Integrator4_CSTATE[1] =
            CA_CSE1_V1e_wo_LOSV2b_P.Integrator4_IC;

          /* InitializeConditions for Integrator: '<S16>/Integrator2' */
          CA_CSE1_V1e_wo_LOSV2b_X.Integrator2_CSTATE[1] =
            CA_CSE1_V1e_wo_LOSV2b_P.Integrator2_IC;

          /* InitializeConditions for Integrator: '<S16>/Integrator3' */
          CA_CSE1_V1e_wo_LOSV2b_X.Integrator3_CSTATE[1] =
            CA_CSE1_V1e_wo_LOSV2b_P.Integrator3_IC;

          /* InitializeConditions for Integrator: '<S16>/Integrator4' */
          CA_CSE1_V1e_wo_LOSV2b_X.Integrator4_CSTATE[2] =
            CA_CSE1_V1e_wo_LOSV2b_P.Integrator4_IC;

          /* InitializeConditions for Integrator: '<S16>/Integrator2' */
          CA_CSE1_V1e_wo_LOSV2b_X.Integrator2_CSTATE[2] =
            CA_CSE1_V1e_wo_LOSV2b_P.Integrator2_IC;

          /* InitializeConditions for Integrator: '<S16>/Integrator3' */
          CA_CSE1_V1e_wo_LOSV2b_X.Integrator3_CSTATE[2] =
            CA_CSE1_V1e_wo_LOSV2b_P.Integrator3_IC;
          CA_CSE1_V1e_wo_LOSV2b_DWork.DPcontrol_MODE = SUBSYS_ENABLED;
        }
      } else {
        if (CA_CSE1_V1e_wo_LOSV2b_DWork.DPcontrol_MODE == SUBSYS_ENABLED) {
          CA_CSE1_V1e_wo_LOSV2b_DWork.DPcontrol_MODE = SUBSYS_DISABLED;
        }
      }
    }

    if (CA_CSE1_V1e_wo_LOSV2b_DWork.DPcontrol_MODE == SUBSYS_ENABLED) {
      /* Integrator: '<S16>/Integrator1' */
      CA_CSE1_V1e_wo_LOSV2b_B.eta_w[0] =
        CA_CSE1_V1e_wo_LOSV2b_X.Integrator1_CSTATE_i[0];
      CA_CSE1_V1e_wo_LOSV2b_B.eta_w[1] =
        CA_CSE1_V1e_wo_LOSV2b_X.Integrator1_CSTATE_i[1];
      CA_CSE1_V1e_wo_LOSV2b_B.eta_w[2] =
        CA_CSE1_V1e_wo_LOSV2b_X.Integrator1_CSTATE_i[2];
      if (rtmIsMajorTimeStep(CA_CSE1_V1e_wo_LOSV2b_M)) {
        /* ToFile Block: '<S6>/To File'
         */
        if (rtmIsMajorTimeStep(CA_CSE1_V1e_wo_LOSV2b_M)) {
          if (!(++CA_CSE1_V1e_wo_LOSV2b_DWork.ToFile_IWORK_b.Decimation % 1) &&
              (CA_CSE1_V1e_wo_LOSV2b_DWork.ToFile_IWORK_b.Count*4)+1 < 100000000
              ) {
            real_T u[4];
            FILE *fp = (FILE *)
              CA_CSE1_V1e_wo_LOSV2b_DWork.ToFile_PWORK_m.FilePtr;
            if (fp != (NULL)) {
              CA_CSE1_V1e_wo_LOSV2b_DWork.ToFile_IWORK_b.Decimation = 0;
              u[0] = CA_CSE1_V1e_wo_LOSV2b_M->Timing.t[1];
              u[1] = CA_CSE1_V1e_wo_LOSV2b_B.eta_w[0];
              u[2] = CA_CSE1_V1e_wo_LOSV2b_B.eta_w[1];
              u[3] = CA_CSE1_V1e_wo_LOSV2b_B.eta_w[2];
              if (fwrite(u, sizeof(real_T), 4, fp) != 4) {
                rtmSetErrorStatus(CA_CSE1_V1e_wo_LOSV2b_M,
                                  "Error writing to MAT-file CSE1_data_eta_w.mat");
                return;
              }

              if (((++CA_CSE1_V1e_wo_LOSV2b_DWork.ToFile_IWORK_b.Count)*4)+1 >=
                  100000000) {
                (void)fprintf(stdout,
                              "*** The ToFile block will stop logging data before\n"
                              "    the simulation has ended, because it has reached\n"
                              "    the maximum number of elements (100000000)\n"
                              "    allowed in MAT-file CSE1_data_eta_w.mat.\n");
              }
            }
          }
        }

        /* Constant: '<S6>/BT_power_limit' */
        CA_CSE1_V1e_wo_LOSV2b_B.BT_power_limit =
          CA_CSE1_V1e_wo_LOSV2b_P.BT_power_limit_Value_f;
      }

      /* Integrator: '<S16>/Integrator' */
      CA_CSE1_V1e_wo_LOSV2b_B.eta[0] =
        CA_CSE1_V1e_wo_LOSV2b_X.Integrator_CSTATE_o[0];
      CA_CSE1_V1e_wo_LOSV2b_B.eta[1] =
        CA_CSE1_V1e_wo_LOSV2b_X.Integrator_CSTATE_o[1];
      CA_CSE1_V1e_wo_LOSV2b_B.eta[2] =
        CA_CSE1_V1e_wo_LOSV2b_X.Integrator_CSTATE_o[2];

      /* Saturate: '<S24>/Saturation' */
      currentTime = CA_CSE1_V1e_wo_LOSV2b_B.eta[2];
      CA_CSE1_V1e_wo_LOSV2b_B.Saturation_m = rt_SATURATE(currentTime,
        CA_CSE1_V1e_wo_LOSV2b_P.Saturation_LowerSat_l,
        CA_CSE1_V1e_wo_LOSV2b_P.Saturation_UpperSat_gq);

      /* Signum: '<S24>/Sign' */
      CA_CSE1_V1e_wo_LOSV2b_B.Sign_k = rt_SIGNd_snf
        (CA_CSE1_V1e_wo_LOSV2b_B.Saturation_m);

      /* Gain: '<S24>/Gain' */
      CA_CSE1_V1e_wo_LOSV2b_B.Gain_k = CA_CSE1_V1e_wo_LOSV2b_P.Gain_Gain_n *
        CA_CSE1_V1e_wo_LOSV2b_B.Sign_k;

      /* Sum: '<S24>/Sum1' */
      CA_CSE1_V1e_wo_LOSV2b_B.Sum1_i = CA_CSE1_V1e_wo_LOSV2b_B.Saturation_m +
        CA_CSE1_V1e_wo_LOSV2b_B.Gain_k;

      /* Math: '<S24>/Math Function' incorporates:
       *  Constant: '<S24>/Constant'
       */
      CA_CSE1_V1e_wo_LOSV2b_B.MathFunction_i = rt_rem_snf
        (CA_CSE1_V1e_wo_LOSV2b_B.Sum1_i,
         CA_CSE1_V1e_wo_LOSV2b_P.Constant_Value_e);

      /* Sum: '<S24>/Sum' */
      CA_CSE1_V1e_wo_LOSV2b_B.Sum_jb = CA_CSE1_V1e_wo_LOSV2b_B.MathFunction_i -
        CA_CSE1_V1e_wo_LOSV2b_B.Gain_k;

      /* MultiPortSwitch: '<S6>/Multiport Switch' incorporates:
       *  Constant: '<S6>/Enable Filter'
       */
      if ((int32_T)CA_CSE1_V1e_wo_LOSV2b_P.EnableFilter_Value == 0) {
        CA_CSE1_V1e_wo_LOSV2b_B.MultiportSwitch_j[0] =
          CA_CSE1_V1e_wo_LOSV2b_B.eta_surge;
        CA_CSE1_V1e_wo_LOSV2b_B.MultiportSwitch_j[1] =
          CA_CSE1_V1e_wo_LOSV2b_B.eta_sway;
        CA_CSE1_V1e_wo_LOSV2b_B.MultiportSwitch_j[2] =
          CA_CSE1_V1e_wo_LOSV2b_B.eta_yaw;
      } else {
        CA_CSE1_V1e_wo_LOSV2b_B.MultiportSwitch_j[0] =
          CA_CSE1_V1e_wo_LOSV2b_B.eta[0];
        CA_CSE1_V1e_wo_LOSV2b_B.MultiportSwitch_j[1] =
          CA_CSE1_V1e_wo_LOSV2b_B.eta[1];
        CA_CSE1_V1e_wo_LOSV2b_B.MultiportSwitch_j[2] =
          CA_CSE1_V1e_wo_LOSV2b_B.Sum_jb;
      }

      /* Gain: '<S14>/eta N' */
      CA_CSE1_V1e_wo_LOSV2b_B.etaN = CA_CSE1_V1e_wo_LOSV2b_P.etaN_Gain *
        CA_CSE1_V1e_wo_LOSV2b_B.MultiportSwitch_j[0];

      /* Gain: '<S14>/eta E' */
      CA_CSE1_V1e_wo_LOSV2b_B.etaE = CA_CSE1_V1e_wo_LOSV2b_P.etaE_Gain *
        CA_CSE1_V1e_wo_LOSV2b_B.MultiportSwitch_j[1];

      /* Gain: '<S14>/eta Psi' */
      CA_CSE1_V1e_wo_LOSV2b_B.etaPsi = CA_CSE1_V1e_wo_LOSV2b_P.etaPsi_Gain *
        CA_CSE1_V1e_wo_LOSV2b_B.MultiportSwitch_j[2];

      /* Sum: '<S14>/Sum2' */
      CA_CSE1_V1e_wo_LOSV2b_B.regulationerror[0] =
        CA_CSE1_V1e_wo_LOSV2b_B.eta_dDPN - CA_CSE1_V1e_wo_LOSV2b_B.etaN;
      CA_CSE1_V1e_wo_LOSV2b_B.regulationerror[1] =
        CA_CSE1_V1e_wo_LOSV2b_B.eta_dDPE - CA_CSE1_V1e_wo_LOSV2b_B.etaE;
      CA_CSE1_V1e_wo_LOSV2b_B.regulationerror[2] =
        CA_CSE1_V1e_wo_LOSV2b_B.eta_dDPPsi - CA_CSE1_V1e_wo_LOSV2b_B.etaPsi;

      /* Gain: '<S14>/Reg_e_N_hil' */
      CA_CSE1_V1e_wo_LOSV2b_B.Reg_e_N_hil =
        CA_CSE1_V1e_wo_LOSV2b_P.Reg_e_N_hil_Gain *
        CA_CSE1_V1e_wo_LOSV2b_B.regulationerror[0];

      /* Gain: '<S14>/Reg_e_E_hil' */
      CA_CSE1_V1e_wo_LOSV2b_B.Reg_e_E_hil =
        CA_CSE1_V1e_wo_LOSV2b_P.Reg_e_E_hil_Gain *
        CA_CSE1_V1e_wo_LOSV2b_B.regulationerror[1];

      /* Gain: '<S14>/Reg_e_Psi_hil' */
      CA_CSE1_V1e_wo_LOSV2b_B.Reg_e_Psi_hil =
        CA_CSE1_V1e_wo_LOSV2b_P.Reg_e_Psi_hil_Gain *
        CA_CSE1_V1e_wo_LOSV2b_B.regulationerror[2];
      if (rtmIsMajorTimeStep(CA_CSE1_V1e_wo_LOSV2b_M)) {
        /* SignalConversion: '<S14>/TmpHiddenBufferAtTo FileInport1' */
        CA_CSE1_V1e_wo_LOSV2b_B.TmpHiddenBufferAtToFileInport_p[0] =
          CA_CSE1_V1e_wo_LOSV2b_B.Reg_e_N_hil;
        CA_CSE1_V1e_wo_LOSV2b_B.TmpHiddenBufferAtToFileInport_p[1] =
          CA_CSE1_V1e_wo_LOSV2b_B.Reg_e_E_hil;
        CA_CSE1_V1e_wo_LOSV2b_B.TmpHiddenBufferAtToFileInport_p[2] =
          CA_CSE1_V1e_wo_LOSV2b_B.Reg_e_Psi_hil;

        /* ToFile Block: '<S14>/To File'
         */
        if (rtmIsMajorTimeStep(CA_CSE1_V1e_wo_LOSV2b_M)) {
          if (!(++CA_CSE1_V1e_wo_LOSV2b_DWork.ToFile_IWORK_j.Decimation % 1) &&
              (CA_CSE1_V1e_wo_LOSV2b_DWork.ToFile_IWORK_j.Count*4)+1 < 100000000
              ) {
            real_T u[4];
            FILE *fp = (FILE *)
              CA_CSE1_V1e_wo_LOSV2b_DWork.ToFile_PWORK_p.FilePtr;
            if (fp != (NULL)) {
              CA_CSE1_V1e_wo_LOSV2b_DWork.ToFile_IWORK_j.Decimation = 0;
              u[0] = CA_CSE1_V1e_wo_LOSV2b_M->Timing.t[1];
              u[1] = CA_CSE1_V1e_wo_LOSV2b_B.TmpHiddenBufferAtToFileInport_p[0];
              u[2] = CA_CSE1_V1e_wo_LOSV2b_B.TmpHiddenBufferAtToFileInport_p[1];
              u[3] = CA_CSE1_V1e_wo_LOSV2b_B.TmpHiddenBufferAtToFileInport_p[2];
              if (fwrite(u, sizeof(real_T), 4, fp) != 4) {
                rtmSetErrorStatus(CA_CSE1_V1e_wo_LOSV2b_M,
                                  "Error writing to MAT-file CSE1_data_reg_error.mat");
                return;
              }

              if (((++CA_CSE1_V1e_wo_LOSV2b_DWork.ToFile_IWORK_j.Count)*4)+1 >=
                  100000000) {
                (void)fprintf(stdout,
                              "*** The ToFile block will stop logging data before\n"
                              "    the simulation has ended, because it has reached\n"
                              "    the maximum number of elements (100000000)\n"
                              "    allowed in MAT-file CSE1_data_reg_error.mat.\n");
              }
            }
          }
        }
      }

      /* Integrator Block: '<S14>/Integrator'
       */
      if (rtmIsMajorTimeStep(CA_CSE1_V1e_wo_LOSV2b_M)) {
        ZCEventType zcEvent;
        zcEvent = rt_ZCFcn(ANY_ZERO_CROSSING,
                           &CA_CSE1_V1e_wo_L_PrevZCSigState.Integrator_Reset_ZCE_b,
                           CA_CSE1_V1e_wo_LOSV2b_P.Reset_DP_integrator_Value);

        /* evaluate zero-crossings and the level of the reset signal */
        if (zcEvent || CA_CSE1_V1e_wo_LOSV2b_P.Reset_DP_integrator_Value != 0.0)
        {
          CA_CSE1_V1e_wo_LOSV2b_X.Integrator_CSTATE_e[0] =
            CA_CSE1_V1e_wo_LOSV2b_P.Integrator_IC_d;
          CA_CSE1_V1e_wo_LOSV2b_X.Integrator_CSTATE_e[1] =
            CA_CSE1_V1e_wo_LOSV2b_P.Integrator_IC_d;
          CA_CSE1_V1e_wo_LOSV2b_X.Integrator_CSTATE_e[2] =
            CA_CSE1_V1e_wo_LOSV2b_P.Integrator_IC_d;
        }
      }

      CA_CSE1_V1e_wo_LOSV2b_B.Integrator_oe[0] =
        CA_CSE1_V1e_wo_LOSV2b_X.Integrator_CSTATE_e[0];
      CA_CSE1_V1e_wo_LOSV2b_B.Integrator_oe[1] =
        CA_CSE1_V1e_wo_LOSV2b_X.Integrator_CSTATE_e[1];
      CA_CSE1_V1e_wo_LOSV2b_B.Integrator_oe[2] =
        CA_CSE1_V1e_wo_LOSV2b_X.Integrator_CSTATE_e[2];

      /* Integrator: '<S16>/Integrator4' */
      CA_CSE1_V1e_wo_LOSV2b_B.nu[0] =
        CA_CSE1_V1e_wo_LOSV2b_X.Integrator4_CSTATE[0];
      CA_CSE1_V1e_wo_LOSV2b_B.nu[1] =
        CA_CSE1_V1e_wo_LOSV2b_X.Integrator4_CSTATE[1];
      CA_CSE1_V1e_wo_LOSV2b_B.nu[2] =
        CA_CSE1_V1e_wo_LOSV2b_X.Integrator4_CSTATE[2];

      /* MultiPortSwitch: '<S6>/Multiport Switch1' incorporates:
       *  Constant: '<S6>/Enable Filter'
       */
      if ((int32_T)CA_CSE1_V1e_wo_LOSV2b_P.EnableFilter_Value == 0) {
        CA_CSE1_V1e_wo_LOSV2b_B.MultiportSwitch1[0] =
          CA_CSE1_V1e_wo_LOSV2b_B.nu_surge;
        CA_CSE1_V1e_wo_LOSV2b_B.MultiportSwitch1[1] =
          CA_CSE1_V1e_wo_LOSV2b_B.nu_sway;
        CA_CSE1_V1e_wo_LOSV2b_B.MultiportSwitch1[2] =
          CA_CSE1_V1e_wo_LOSV2b_B.nu_yaw;
      } else {
        CA_CSE1_V1e_wo_LOSV2b_B.MultiportSwitch1[0] =
          CA_CSE1_V1e_wo_LOSV2b_B.nu[0];
        CA_CSE1_V1e_wo_LOSV2b_B.MultiportSwitch1[1] =
          CA_CSE1_V1e_wo_LOSV2b_B.nu[1];
        CA_CSE1_V1e_wo_LOSV2b_B.MultiportSwitch1[2] =
          CA_CSE1_V1e_wo_LOSV2b_B.nu[2];
      }

      /* Gain: '<S14>/K_d 1' */
      for (i = 0; i < 3; i++) {
        /* Gain: '<S14>/Kd' */
        CA_CSE1_V1e_wo_LOSV2b_B.Kd[i] = 0.0;
        CA_CSE1_V1e_wo_LOSV2b_B.Kd[i] = CA_CSE1_V1e_wo_LOSV2b_P.Kd_Gain[i] *
          CA_CSE1_V1e_wo_LOSV2b_B.MultiportSwitch1[0] +
          CA_CSE1_V1e_wo_LOSV2b_B.Kd[i];
        CA_CSE1_V1e_wo_LOSV2b_B.Kd[i] = CA_CSE1_V1e_wo_LOSV2b_P.Kd_Gain[i + 3] *
          CA_CSE1_V1e_wo_LOSV2b_B.MultiportSwitch1[1] +
          CA_CSE1_V1e_wo_LOSV2b_B.Kd[i];
        CA_CSE1_V1e_wo_LOSV2b_B.Kd[i] = CA_CSE1_V1e_wo_LOSV2b_P.Kd_Gain[i + 6] *
          CA_CSE1_V1e_wo_LOSV2b_B.MultiportSwitch1[2] +
          CA_CSE1_V1e_wo_LOSV2b_B.Kd[i];

        /* Product: '<S14>/Product' incorporates:
         *  Constant: '<S14>/Kd_scale'
         */
        CA_CSE1_V1e_wo_LOSV2b_B.Product_f[i] = CA_CSE1_V1e_wo_LOSV2b_B.Kd[i] *
          CA_CSE1_V1e_wo_LOSV2b_P.Kd_scale_Value;

        /* Gain: '<S14>/Ki' */
        CA_CSE1_V1e_wo_LOSV2b_B.Ki[i] = 0.0;
        CA_CSE1_V1e_wo_LOSV2b_B.Ki[i] = CA_CSE1_V1e_wo_LOSV2b_P.Ki_Gain[i] *
          CA_CSE1_V1e_wo_LOSV2b_B.Integrator_oe[0] +
          CA_CSE1_V1e_wo_LOSV2b_B.Ki[i];
        CA_CSE1_V1e_wo_LOSV2b_B.Ki[i] = CA_CSE1_V1e_wo_LOSV2b_P.Ki_Gain[i + 3] *
          CA_CSE1_V1e_wo_LOSV2b_B.Integrator_oe[1] +
          CA_CSE1_V1e_wo_LOSV2b_B.Ki[i];
        CA_CSE1_V1e_wo_LOSV2b_B.Ki[i] = CA_CSE1_V1e_wo_LOSV2b_P.Ki_Gain[i + 6] *
          CA_CSE1_V1e_wo_LOSV2b_B.Integrator_oe[2] +
          CA_CSE1_V1e_wo_LOSV2b_B.Ki[i];

        /* Product: '<S14>/Product1' incorporates:
         *  Constant: '<S14>/Ki_scale'
         */
        CA_CSE1_V1e_wo_LOSV2b_B.Product1_lu[i] = CA_CSE1_V1e_wo_LOSV2b_B.Ki[i] *
          CA_CSE1_V1e_wo_LOSV2b_P.Ki_scale_Value;
      }

      CA_CSE1_V1e_wo_LOSV2b_B.K_d1 = CA_CSE1_V1e_wo_LOSV2b_P.K_d1_Gain *
        CA_CSE1_V1e_wo_LOSV2b_B.Product_f[0];

      /* Gain: '<S14>/K_d 2' */
      CA_CSE1_V1e_wo_LOSV2b_B.K_d2 = CA_CSE1_V1e_wo_LOSV2b_P.K_d2_Gain *
        CA_CSE1_V1e_wo_LOSV2b_B.Product_f[1];

      /* Gain: '<S14>/K_d 3' */
      CA_CSE1_V1e_wo_LOSV2b_B.K_d3 = CA_CSE1_V1e_wo_LOSV2b_P.K_d3_Gain *
        CA_CSE1_V1e_wo_LOSV2b_B.Product_f[2];

      /* Gain: '<S14>/K_d 3 deg' */
      CA_CSE1_V1e_wo_LOSV2b_B.K_d3deg = CA_CSE1_V1e_wo_LOSV2b_P.K_d3deg_Gain *
        CA_CSE1_V1e_wo_LOSV2b_B.Product_f[2];

      /* Gain: '<S14>/K_i 1' */
      CA_CSE1_V1e_wo_LOSV2b_B.K_i1 = CA_CSE1_V1e_wo_LOSV2b_P.K_i1_Gain *
        CA_CSE1_V1e_wo_LOSV2b_B.Product1_lu[0];

      /* Gain: '<S14>/K_i 2' */
      CA_CSE1_V1e_wo_LOSV2b_B.K_i2 = CA_CSE1_V1e_wo_LOSV2b_P.K_i2_Gain *
        CA_CSE1_V1e_wo_LOSV2b_B.Product1_lu[1];

      /* Gain: '<S14>/K_i 3' */
      CA_CSE1_V1e_wo_LOSV2b_B.K_i3 = CA_CSE1_V1e_wo_LOSV2b_P.K_i3_Gain *
        CA_CSE1_V1e_wo_LOSV2b_B.Product1_lu[2];

      /* Gain: '<S14>/K_i 3 deg' */
      CA_CSE1_V1e_wo_LOSV2b_B.K_i3deg = CA_CSE1_V1e_wo_LOSV2b_P.K_i3deg_Gain *
        CA_CSE1_V1e_wo_LOSV2b_B.Product1_lu[2];

      /* Fcn: '<S14>/yaw angle' */
      CA_CSE1_V1e_wo_LOSV2b_B.psi = CA_CSE1_V1e_wo_LOSV2b_B.MultiportSwitch_j[2];

      /* Saturate: '<S20>/Saturation' */
      currentTime = CA_CSE1_V1e_wo_LOSV2b_B.psi;
      CA_CSE1_V1e_wo_LOSV2b_B.Saturation_h = rt_SATURATE(currentTime,
        CA_CSE1_V1e_wo_LOSV2b_P.Saturation_LowerSat_n,
        CA_CSE1_V1e_wo_LOSV2b_P.Saturation_UpperSat_o);

      /* Signum: '<S20>/Sign' */
      CA_CSE1_V1e_wo_LOSV2b_B.Sign_i = rt_SIGNd_snf
        (CA_CSE1_V1e_wo_LOSV2b_B.Saturation_h);

      /* Gain: '<S20>/Gain' */
      CA_CSE1_V1e_wo_LOSV2b_B.Gain_hg = CA_CSE1_V1e_wo_LOSV2b_P.Gain_Gain_d *
        CA_CSE1_V1e_wo_LOSV2b_B.Sign_i;

      /* Sum: '<S20>/Sum1' */
      CA_CSE1_V1e_wo_LOSV2b_B.Sum1_hs = CA_CSE1_V1e_wo_LOSV2b_B.Saturation_h +
        CA_CSE1_V1e_wo_LOSV2b_B.Gain_hg;

      /* Math: '<S20>/Math Function' incorporates:
       *  Constant: '<S20>/Constant'
       */
      CA_CSE1_V1e_wo_LOSV2b_B.MathFunction_a = rt_rem_snf
        (CA_CSE1_V1e_wo_LOSV2b_B.Sum1_hs,
         CA_CSE1_V1e_wo_LOSV2b_P.Constant_Value_g);

      /* Sum: '<S20>/Sum' */
      CA_CSE1_V1e_wo_LOSV2b_B.Sum_kg = CA_CSE1_V1e_wo_LOSV2b_B.MathFunction_a -
        CA_CSE1_V1e_wo_LOSV2b_B.Gain_hg;

      /* Saturate: '<S19>/Saturation' */
      currentTime = CA_CSE1_V1e_wo_LOSV2b_B.Reg_e_Psi_hil;
      CA_CSE1_V1e_wo_LOSV2b_B.Saturation_m4 = rt_SATURATE(currentTime,
        CA_CSE1_V1e_wo_LOSV2b_P.Saturation_LowerSat_h,
        CA_CSE1_V1e_wo_LOSV2b_P.Saturation_UpperSat_d);

      /* Signum: '<S19>/Sign' */
      CA_CSE1_V1e_wo_LOSV2b_B.Sign_b = rt_SIGNd_snf
        (CA_CSE1_V1e_wo_LOSV2b_B.Saturation_m4);

      /* Gain: '<S19>/Gain' */
      CA_CSE1_V1e_wo_LOSV2b_B.Gain_ki = CA_CSE1_V1e_wo_LOSV2b_P.Gain_Gain_e *
        CA_CSE1_V1e_wo_LOSV2b_B.Sign_b;

      /* Sum: '<S19>/Sum1' */
      CA_CSE1_V1e_wo_LOSV2b_B.Sum1_o = CA_CSE1_V1e_wo_LOSV2b_B.Saturation_m4 +
        CA_CSE1_V1e_wo_LOSV2b_B.Gain_ki;

      /* Math: '<S19>/Math Function' incorporates:
       *  Constant: '<S19>/Constant'
       */
      CA_CSE1_V1e_wo_LOSV2b_B.MathFunction_d = rt_rem_snf
        (CA_CSE1_V1e_wo_LOSV2b_B.Sum1_o,
         CA_CSE1_V1e_wo_LOSV2b_P.Constant_Value_i);

      /* Sum: '<S19>/Sum' */
      CA_CSE1_V1e_wo_LOSV2b_B.Sum_oq = CA_CSE1_V1e_wo_LOSV2b_B.MathFunction_d -
        CA_CSE1_V1e_wo_LOSV2b_B.Gain_ki;

      /* Fcn: '<S18>/Row1' */
      CA_CSE1_V1e_wo_LOSV2b_B.Row1_h = cos(CA_CSE1_V1e_wo_LOSV2b_B.Sum_kg) *
        CA_CSE1_V1e_wo_LOSV2b_B.Reg_e_N_hil + sin(CA_CSE1_V1e_wo_LOSV2b_B.Sum_kg)
        * CA_CSE1_V1e_wo_LOSV2b_B.Reg_e_E_hil;

      /* Fcn: '<S18>/Row2' */
      CA_CSE1_V1e_wo_LOSV2b_B.Row2_h4 = (-sin(CA_CSE1_V1e_wo_LOSV2b_B.Sum_kg)) *
        CA_CSE1_V1e_wo_LOSV2b_B.Reg_e_N_hil + cos(CA_CSE1_V1e_wo_LOSV2b_B.Sum_kg)
        * CA_CSE1_V1e_wo_LOSV2b_B.Reg_e_E_hil;

      /* Fcn: '<S18>/Row3' */
      CA_CSE1_V1e_wo_LOSV2b_B.Row3_a = CA_CSE1_V1e_wo_LOSV2b_B.Sum_oq;

      /* SignalConversion: '<S14>/TmpHiddenBufferAtKpInport1' */
      CA_CSE1_V1e_wo_LOSV2b_B.TmpHiddenBufferAtKpInport1[0] =
        CA_CSE1_V1e_wo_LOSV2b_B.Row1_h;
      CA_CSE1_V1e_wo_LOSV2b_B.TmpHiddenBufferAtKpInport1[1] =
        CA_CSE1_V1e_wo_LOSV2b_B.Row2_h4;
      CA_CSE1_V1e_wo_LOSV2b_B.TmpHiddenBufferAtKpInport1[2] =
        CA_CSE1_V1e_wo_LOSV2b_B.Row3_a;
      for (i = 0; i < 3; i++) {
        /* Gain: '<S14>/Kp' */
        CA_CSE1_V1e_wo_LOSV2b_B.Kp[i] = 0.0;
        CA_CSE1_V1e_wo_LOSV2b_B.Kp[i] = CA_CSE1_V1e_wo_LOSV2b_P.Kp_Gain[i] *
          CA_CSE1_V1e_wo_LOSV2b_B.TmpHiddenBufferAtKpInport1[0] +
          CA_CSE1_V1e_wo_LOSV2b_B.Kp[i];
        CA_CSE1_V1e_wo_LOSV2b_B.Kp[i] = CA_CSE1_V1e_wo_LOSV2b_P.Kp_Gain[i + 3] *
          CA_CSE1_V1e_wo_LOSV2b_B.TmpHiddenBufferAtKpInport1[1] +
          CA_CSE1_V1e_wo_LOSV2b_B.Kp[i];
        CA_CSE1_V1e_wo_LOSV2b_B.Kp[i] = CA_CSE1_V1e_wo_LOSV2b_P.Kp_Gain[i + 6] *
          CA_CSE1_V1e_wo_LOSV2b_B.TmpHiddenBufferAtKpInport1[2] +
          CA_CSE1_V1e_wo_LOSV2b_B.Kp[i];

        /* Product: '<S14>/Product2' incorporates:
         *  Constant: '<S14>/Kp_scale'
         */
        CA_CSE1_V1e_wo_LOSV2b_B.Product2_d[i] =
          CA_CSE1_V1e_wo_LOSV2b_P.Kp_scale_Value * CA_CSE1_V1e_wo_LOSV2b_B.Kp[i];
      }

      /* Gain: '<S14>/K_p 1' */
      CA_CSE1_V1e_wo_LOSV2b_B.K_p1 = CA_CSE1_V1e_wo_LOSV2b_P.K_p1_Gain *
        CA_CSE1_V1e_wo_LOSV2b_B.Product2_d[0];

      /* Gain: '<S14>/K_p 2' */
      CA_CSE1_V1e_wo_LOSV2b_B.K_p2 = CA_CSE1_V1e_wo_LOSV2b_P.K_p2_Gain *
        CA_CSE1_V1e_wo_LOSV2b_B.Product2_d[1];

      /* Gain: '<S14>/K_p 3' */
      CA_CSE1_V1e_wo_LOSV2b_B.K_p3 = CA_CSE1_V1e_wo_LOSV2b_P.K_p3_Gain *
        CA_CSE1_V1e_wo_LOSV2b_B.Product2_d[2];

      /* Gain: '<S14>/K_p 3 deg' */
      CA_CSE1_V1e_wo_LOSV2b_B.K_p3deg = CA_CSE1_V1e_wo_LOSV2b_P.K_p3deg_Gain *
        CA_CSE1_V1e_wo_LOSV2b_B.Product2_d[2];

      /* Gain: '<S14>/Reg_e_Psi_deg' */
      CA_CSE1_V1e_wo_LOSV2b_B.Reg_e_Psi_deg =
        CA_CSE1_V1e_wo_LOSV2b_P.Reg_e_Psi_deg_Gain *
        CA_CSE1_V1e_wo_LOSV2b_B.regulationerror[2];

      /* Sum: '<S14>/Sum3' */
      CA_CSE1_V1e_wo_LOSV2b_B.Sum3_l[0] = CA_CSE1_V1e_wo_LOSV2b_B.K_p1 +
        CA_CSE1_V1e_wo_LOSV2b_B.K_i1;
      CA_CSE1_V1e_wo_LOSV2b_B.Sum3_l[1] = CA_CSE1_V1e_wo_LOSV2b_B.K_p2 +
        CA_CSE1_V1e_wo_LOSV2b_B.K_i2;
      CA_CSE1_V1e_wo_LOSV2b_B.Sum3_l[2] = CA_CSE1_V1e_wo_LOSV2b_B.K_p3 +
        CA_CSE1_V1e_wo_LOSV2b_B.K_i3;

      /* Sum: '<S14>/Sum1' */
      CA_CSE1_V1e_wo_LOSV2b_B.Sum1_g[0] = CA_CSE1_V1e_wo_LOSV2b_B.Sum3_l[0] -
        CA_CSE1_V1e_wo_LOSV2b_B.K_d1;
      CA_CSE1_V1e_wo_LOSV2b_B.Sum1_g[1] = CA_CSE1_V1e_wo_LOSV2b_B.Sum3_l[1] -
        CA_CSE1_V1e_wo_LOSV2b_B.K_d2;
      CA_CSE1_V1e_wo_LOSV2b_B.Sum1_g[2] = CA_CSE1_V1e_wo_LOSV2b_B.Sum3_l[2] -
        CA_CSE1_V1e_wo_LOSV2b_B.K_d3;

      /* Gain: '<S14>/eta Psi deg' */
      CA_CSE1_V1e_wo_LOSV2b_B.etaPsideg = CA_CSE1_V1e_wo_LOSV2b_P.etaPsideg_Gain
        * CA_CSE1_V1e_wo_LOSV2b_B.MultiportSwitch_j[2];

      /* Gain: '<S6>/DP tau_surge' */
      CA_CSE1_V1e_wo_LOSV2b_B.DPtau_surge =
        CA_CSE1_V1e_wo_LOSV2b_P.DPtau_surge_Gain *
        CA_CSE1_V1e_wo_LOSV2b_B.Sum1_g[0];

      /* Gain: '<S6>/DP tau_sway' */
      CA_CSE1_V1e_wo_LOSV2b_B.DPtau_sway =
        CA_CSE1_V1e_wo_LOSV2b_P.DPtau_sway_Gain *
        CA_CSE1_V1e_wo_LOSV2b_B.Sum1_g[1];

      /* Gain: '<S6>/DP tau_yaw' */
      CA_CSE1_V1e_wo_LOSV2b_B.DPtau_yaw = CA_CSE1_V1e_wo_LOSV2b_P.DPtau_yaw_Gain
        * CA_CSE1_V1e_wo_LOSV2b_B.Sum1_g[2];
      if (rtmIsMajorTimeStep(CA_CSE1_V1e_wo_LOSV2b_M)) {
        /* Gain: '<S15>/Gain K_e1_DP' incorporates:
         *  Constant: '<S15>/K_e1_DP'
         */
        CA_CSE1_V1e_wo_LOSV2b_B.GainK_e1_DP_d =
          CA_CSE1_V1e_wo_LOSV2b_P.GainK_e1_DP_Gain_p *
          CA_CSE1_V1e_wo_LOSV2b_P.K_e1_DP_Value_k;

        /* Gain: '<S15>/Gain K_e2_DP' incorporates:
         *  Constant: '<S15>/K_e2_DP'
         */
        CA_CSE1_V1e_wo_LOSV2b_B.GainK_e2_DP_b =
          CA_CSE1_V1e_wo_LOSV2b_P.GainK_e2_DP_Gain_c *
          CA_CSE1_V1e_wo_LOSV2b_P.K_e2_DP_Value_i;

        /* Gain: '<S15>/Gain K_e3_DP' incorporates:
         *  Constant: '<S15>/K_e3_DP'
         */
        CA_CSE1_V1e_wo_LOSV2b_B.GainK_e3_DP_g =
          CA_CSE1_V1e_wo_LOSV2b_P.GainK_e3_DP_Gain_j *
          CA_CSE1_V1e_wo_LOSV2b_P.K_e3_DP_Value_g;

        /* Gain: '<S15>/Gain K_e4_DP' incorporates:
         *  Constant: '<S15>/K_e4_DP'
         */
        CA_CSE1_V1e_wo_LOSV2b_B.GainK_e4_DP_k =
          CA_CSE1_V1e_wo_LOSV2b_P.GainK_e4_DP_Gain_n *
          CA_CSE1_V1e_wo_LOSV2b_P.K_e4_DP_Value_f;

        /* Gain: '<S15>/Gain K_e5_DP' incorporates:
         *  Constant: '<S15>/K_e5_DP'
         */
        CA_CSE1_V1e_wo_LOSV2b_B.GainK_e5_DP_p =
          CA_CSE1_V1e_wo_LOSV2b_P.GainK_e5_DP_Gain_c *
          CA_CSE1_V1e_wo_LOSV2b_P.K_e5_DP_Value_e;

        /* Reshape: '<S15>/Thruster Gain matrix' incorporates:
         *  Constant: '<S15>/Constant'
         */
        CA_CSE1_V1e_wo_LOSV2b_B.ThrusterGainmatrix_f[0] =
          CA_CSE1_V1e_wo_LOSV2b_B.GainK_e1_DP_d;
        CA_CSE1_V1e_wo_LOSV2b_B.ThrusterGainmatrix_f[1] =
          CA_CSE1_V1e_wo_LOSV2b_P.Constant_Value_cb;
        CA_CSE1_V1e_wo_LOSV2b_B.ThrusterGainmatrix_f[2] =
          CA_CSE1_V1e_wo_LOSV2b_P.Constant_Value_cb;
        CA_CSE1_V1e_wo_LOSV2b_B.ThrusterGainmatrix_f[3] =
          CA_CSE1_V1e_wo_LOSV2b_P.Constant_Value_cb;
        CA_CSE1_V1e_wo_LOSV2b_B.ThrusterGainmatrix_f[4] =
          CA_CSE1_V1e_wo_LOSV2b_P.Constant_Value_cb;
        CA_CSE1_V1e_wo_LOSV2b_B.ThrusterGainmatrix_f[5] =
          CA_CSE1_V1e_wo_LOSV2b_P.Constant_Value_cb;
        CA_CSE1_V1e_wo_LOSV2b_B.ThrusterGainmatrix_f[6] =
          CA_CSE1_V1e_wo_LOSV2b_B.GainK_e2_DP_b;
        CA_CSE1_V1e_wo_LOSV2b_B.ThrusterGainmatrix_f[7] =
          CA_CSE1_V1e_wo_LOSV2b_P.Constant_Value_cb;
        CA_CSE1_V1e_wo_LOSV2b_B.ThrusterGainmatrix_f[8] =
          CA_CSE1_V1e_wo_LOSV2b_P.Constant_Value_cb;
        CA_CSE1_V1e_wo_LOSV2b_B.ThrusterGainmatrix_f[9] =
          CA_CSE1_V1e_wo_LOSV2b_P.Constant_Value_cb;
        CA_CSE1_V1e_wo_LOSV2b_B.ThrusterGainmatrix_f[10] =
          CA_CSE1_V1e_wo_LOSV2b_P.Constant_Value_cb;
        CA_CSE1_V1e_wo_LOSV2b_B.ThrusterGainmatrix_f[11] =
          CA_CSE1_V1e_wo_LOSV2b_P.Constant_Value_cb;
        CA_CSE1_V1e_wo_LOSV2b_B.ThrusterGainmatrix_f[12] =
          CA_CSE1_V1e_wo_LOSV2b_B.GainK_e3_DP_g;
        CA_CSE1_V1e_wo_LOSV2b_B.ThrusterGainmatrix_f[13] =
          CA_CSE1_V1e_wo_LOSV2b_P.Constant_Value_cb;
        CA_CSE1_V1e_wo_LOSV2b_B.ThrusterGainmatrix_f[14] =
          CA_CSE1_V1e_wo_LOSV2b_P.Constant_Value_cb;
        CA_CSE1_V1e_wo_LOSV2b_B.ThrusterGainmatrix_f[15] =
          CA_CSE1_V1e_wo_LOSV2b_P.Constant_Value_cb;
        CA_CSE1_V1e_wo_LOSV2b_B.ThrusterGainmatrix_f[16] =
          CA_CSE1_V1e_wo_LOSV2b_P.Constant_Value_cb;
        CA_CSE1_V1e_wo_LOSV2b_B.ThrusterGainmatrix_f[17] =
          CA_CSE1_V1e_wo_LOSV2b_P.Constant_Value_cb;
        CA_CSE1_V1e_wo_LOSV2b_B.ThrusterGainmatrix_f[18] =
          CA_CSE1_V1e_wo_LOSV2b_B.GainK_e4_DP_k;
        CA_CSE1_V1e_wo_LOSV2b_B.ThrusterGainmatrix_f[19] =
          CA_CSE1_V1e_wo_LOSV2b_P.Constant_Value_cb;
        CA_CSE1_V1e_wo_LOSV2b_B.ThrusterGainmatrix_f[20] =
          CA_CSE1_V1e_wo_LOSV2b_P.Constant_Value_cb;
        CA_CSE1_V1e_wo_LOSV2b_B.ThrusterGainmatrix_f[21] =
          CA_CSE1_V1e_wo_LOSV2b_P.Constant_Value_cb;
        CA_CSE1_V1e_wo_LOSV2b_B.ThrusterGainmatrix_f[22] =
          CA_CSE1_V1e_wo_LOSV2b_P.Constant_Value_cb;
        CA_CSE1_V1e_wo_LOSV2b_B.ThrusterGainmatrix_f[23] =
          CA_CSE1_V1e_wo_LOSV2b_P.Constant_Value_cb;
        CA_CSE1_V1e_wo_LOSV2b_B.ThrusterGainmatrix_f[24] =
          CA_CSE1_V1e_wo_LOSV2b_B.GainK_e5_DP_p;

        /* Product Block: '<S6>/K_e^-1' */
        {
          static const int_T dims[3] = { 5, 5, 5 };

          rt_MatDivRR_Dbl(CA_CSE1_V1e_wo_LOSV2b_B.K_e1_b,
                          CA_CSE1_V1e_wo_LOSV2b_B.ThrusterGainmatrix_f,
                          &CA_CSE1_V1e_wo_LOSV2b_DWork.K_e1_DWORK4_m[0], (real_T*)
                          &CA_CSE1_V1e_wo_LOSV2b_DWork.K_e1_DWORK1[0],
                          &CA_CSE1_V1e_wo_LOSV2b_DWork.K_e1_DWORK2[0], (real_T*)
                          &CA_CSE1_V1e_wo_LOSV2b_DWork.K_e1_DWORK3[0],
                          &dims[0]);
        }

        /* Gain: '<S17>/-l_x1' incorporates:
         *  Constant: '<S17>/l_x1'
         */
        CA_CSE1_V1e_wo_LOSV2b_B.l_x1_jy = CA_CSE1_V1e_wo_LOSV2b_P.l_x1_Gain_a *
          CA_CSE1_V1e_wo_LOSV2b_P.l_x1_Value_l;

        /* Gain: '<S17>/-l_y2' incorporates:
         *  Constant: '<S17>/l_y2'
         */
        CA_CSE1_V1e_wo_LOSV2b_B.l_y2_n = CA_CSE1_V1e_wo_LOSV2b_P.l_y2_Gain_j *
          CA_CSE1_V1e_wo_LOSV2b_P.l_y2_Value_o;

        /* Gain: '<S17>/-l_x2' incorporates:
         *  Constant: '<S17>/l_x2'
         */
        CA_CSE1_V1e_wo_LOSV2b_B.l_x2_jn = CA_CSE1_V1e_wo_LOSV2b_P.l_x2_Gain_b *
          CA_CSE1_V1e_wo_LOSV2b_P.l_x2_Value_o;

        /* Reshape: '<S17>/3x5' incorporates:
         *  Constant: '<S17>/T_e11'
         *  Constant: '<S17>/T_e12'
         *  Constant: '<S17>/T_e13'
         *  Constant: '<S17>/T_e14'
         *  Constant: '<S17>/T_e15'
         *  Constant: '<S17>/T_e21'
         *  Constant: '<S17>/T_e22'
         *  Constant: '<S17>/T_e23'
         *  Constant: '<S17>/T_e24'
         *  Constant: '<S17>/T_e25'
         *  Constant: '<S17>/l_x3'
         *  Constant: '<S17>/l_y1'
         */
        CA_CSE1_V1e_wo_LOSV2b_B.x5_o[0] = CA_CSE1_V1e_wo_LOSV2b_P.T_e11_Value_p;
        CA_CSE1_V1e_wo_LOSV2b_B.x5_o[1] = CA_CSE1_V1e_wo_LOSV2b_P.T_e21_Value_c;
        CA_CSE1_V1e_wo_LOSV2b_B.x5_o[2] = CA_CSE1_V1e_wo_LOSV2b_P.l_y1_Value_b;
        CA_CSE1_V1e_wo_LOSV2b_B.x5_o[3] = CA_CSE1_V1e_wo_LOSV2b_P.T_e12_Value_i;
        CA_CSE1_V1e_wo_LOSV2b_B.x5_o[4] = CA_CSE1_V1e_wo_LOSV2b_P.T_e22_Value_o;
        CA_CSE1_V1e_wo_LOSV2b_B.x5_o[5] = CA_CSE1_V1e_wo_LOSV2b_B.l_x1_jy;
        CA_CSE1_V1e_wo_LOSV2b_B.x5_o[6] = CA_CSE1_V1e_wo_LOSV2b_P.T_e13_Value_dc;
        CA_CSE1_V1e_wo_LOSV2b_B.x5_o[7] = CA_CSE1_V1e_wo_LOSV2b_P.T_e23_Value_i;
        CA_CSE1_V1e_wo_LOSV2b_B.x5_o[8] = CA_CSE1_V1e_wo_LOSV2b_B.l_y2_n;
        CA_CSE1_V1e_wo_LOSV2b_B.x5_o[9] = CA_CSE1_V1e_wo_LOSV2b_P.T_e14_Value_oq;
        CA_CSE1_V1e_wo_LOSV2b_B.x5_o[10] = CA_CSE1_V1e_wo_LOSV2b_P.T_e24_Value_h;
        CA_CSE1_V1e_wo_LOSV2b_B.x5_o[11] = CA_CSE1_V1e_wo_LOSV2b_B.l_x2_jn;
        CA_CSE1_V1e_wo_LOSV2b_B.x5_o[12] = CA_CSE1_V1e_wo_LOSV2b_P.T_e15_Value_g;
        CA_CSE1_V1e_wo_LOSV2b_B.x5_o[13] = CA_CSE1_V1e_wo_LOSV2b_P.T_e25_Value_f;
        CA_CSE1_V1e_wo_LOSV2b_B.x5_o[14] = CA_CSE1_V1e_wo_LOSV2b_P.l_x3_Value_h;

        /* S-Function (sdsppinv): '<S6>/T_e^+' */
        /* Copy input to temporary space */
        memcpy((void *)(&CA_CSE1_V1e_wo_LOSV2b_DWork.K_e1_DWORK1[0]), (void *)
               (&CA_CSE1_V1e_wo_LOSV2b_B.x5_o[0]), 15U * sizeof(real_T));

        /* Call SVD */
        i = MWDSP_SVD_D(&CA_CSE1_V1e_wo_LOSV2b_DWork.K_e1_DWORK1[0], 3, 5,
                        &CA_CSE1_V1e_wo_LOSV2b_DWork.T_e_S[0],
                        &CA_CSE1_V1e_wo_LOSV2b_DWork.K_e1_DWORK3[0],
                        &CA_CSE1_V1e_wo_LOSV2b_DWork.T_e_WORK[0],
                        &CA_CSE1_V1e_wo_LOSV2b_DWork.T_e_U[0],
                        &CA_CSE1_V1e_wo_LOSV2b_DWork.T_e_V[0], 1);

        /* Only call 'pinv' function if SVD succeeded */
        if (i == 0) {
          MWDSPCG_Pseudoinverse_D(&CA_CSE1_V1e_wo_LOSV2b_DWork.T_e_S[0],
            &CA_CSE1_V1e_wo_LOSV2b_DWork.T_e_U[0],
            &CA_CSE1_V1e_wo_LOSV2b_DWork.T_e_V[0],
            &CA_CSE1_V1e_wo_LOSV2b_B.T_e_a[0], (const int32_T)3, (const int32_T)
            5);
        }

        /* Product: '<S6>/Product' */
        for (i = 0; i < 5; i++) {
          for (tmp_4 = 0; tmp_4 < 3; tmp_4++) {
            CA_CSE1_V1e_wo_LOSV2b_B.Product_b[i + 5 * tmp_4] = 0.0;
            for (tmp_3 = 0; tmp_3 < 5; tmp_3++) {
              CA_CSE1_V1e_wo_LOSV2b_B.Product_b[i + 5 * tmp_4] =
                CA_CSE1_V1e_wo_LOSV2b_B.K_e1_b[5 * tmp_3 + i] *
                CA_CSE1_V1e_wo_LOSV2b_B.T_e_a[5 * tmp_4 + tmp_3] +
                CA_CSE1_V1e_wo_LOSV2b_B.Product_b[5 * tmp_4 + i];
            }
          }
        }
      }

      /* SignalConversion: '<S6>/TmpHiddenBufferAtProduct1Inport2' */
      CA_CSE1_V1e_wo_LOSV2b_B.TmpHiddenBufferAtProduct1Inpo_d[0] =
        CA_CSE1_V1e_wo_LOSV2b_B.DPtau_surge;
      CA_CSE1_V1e_wo_LOSV2b_B.TmpHiddenBufferAtProduct1Inpo_d[1] =
        CA_CSE1_V1e_wo_LOSV2b_B.DPtau_sway;
      CA_CSE1_V1e_wo_LOSV2b_B.TmpHiddenBufferAtProduct1Inpo_d[2] =
        CA_CSE1_V1e_wo_LOSV2b_B.DPtau_yaw;

      /* Product: '<S6>/Product1' */
      for (i = 0; i < 5; i++) {
        CA_CSE1_V1e_wo_LOSV2b_B.Product1_be[i] = 0.0;
        CA_CSE1_V1e_wo_LOSV2b_B.Product1_be[i] =
          CA_CSE1_V1e_wo_LOSV2b_B.Product_b[i] *
          CA_CSE1_V1e_wo_LOSV2b_B.TmpHiddenBufferAtProduct1Inpo_d[0] +
          CA_CSE1_V1e_wo_LOSV2b_B.Product1_be[i];
        CA_CSE1_V1e_wo_LOSV2b_B.Product1_be[i] =
          CA_CSE1_V1e_wo_LOSV2b_B.Product_b[i + 5] *
          CA_CSE1_V1e_wo_LOSV2b_B.TmpHiddenBufferAtProduct1Inpo_d[1] +
          CA_CSE1_V1e_wo_LOSV2b_B.Product1_be[i];
        CA_CSE1_V1e_wo_LOSV2b_B.Product1_be[i] =
          CA_CSE1_V1e_wo_LOSV2b_B.Product_b[i + 10] *
          CA_CSE1_V1e_wo_LOSV2b_B.TmpHiddenBufferAtProduct1Inpo_d[2] +
          CA_CSE1_V1e_wo_LOSV2b_B.Product1_be[i];
      }

      /* Gain: '<S6>/DP u_1' */
      CA_CSE1_V1e_wo_LOSV2b_B.DPu_1_d = CA_CSE1_V1e_wo_LOSV2b_P.DPu_1_Gain_e *
        CA_CSE1_V1e_wo_LOSV2b_B.Product1_be[0];

      /* Gain: '<S6>/DP u_2' */
      CA_CSE1_V1e_wo_LOSV2b_B.DPu_2_b = CA_CSE1_V1e_wo_LOSV2b_P.DPu_2_Gain_b *
        CA_CSE1_V1e_wo_LOSV2b_B.Product1_be[1];

      /* Gain: '<S6>/DP u_3' */
      CA_CSE1_V1e_wo_LOSV2b_B.DPu_3_g = CA_CSE1_V1e_wo_LOSV2b_P.DPu_3_Gain_f *
        CA_CSE1_V1e_wo_LOSV2b_B.Product1_be[2];

      /* Gain: '<S6>/DP u_4' */
      CA_CSE1_V1e_wo_LOSV2b_B.DPu_4_l = CA_CSE1_V1e_wo_LOSV2b_P.DPu_4_Gain_h *
        CA_CSE1_V1e_wo_LOSV2b_B.Product1_be[3];

      /* Gain: '<S6>/DP u_5' */
      CA_CSE1_V1e_wo_LOSV2b_B.DPu_5_l = CA_CSE1_V1e_wo_LOSV2b_P.DPu_5_Gain_d *
        CA_CSE1_V1e_wo_LOSV2b_B.Product1_be[4];
      for (i = 0; i < 3; i++) {
        /* Gain: '<S16>/Gain1' */
        CA_CSE1_V1e_wo_LOSV2b_B.Gain1_o[i] = 0.0;
        CA_CSE1_V1e_wo_LOSV2b_B.Gain1_o[i] =
          CA_CSE1_V1e_wo_LOSV2b_P.Gain1_Gain_m[i] *
          CA_CSE1_V1e_wo_LOSV2b_B.eta_w[0] + CA_CSE1_V1e_wo_LOSV2b_B.Gain1_o[i];
        CA_CSE1_V1e_wo_LOSV2b_B.Gain1_o[i] =
          CA_CSE1_V1e_wo_LOSV2b_P.Gain1_Gain_m[i + 3] *
          CA_CSE1_V1e_wo_LOSV2b_B.eta_w[1] + CA_CSE1_V1e_wo_LOSV2b_B.Gain1_o[i];
        CA_CSE1_V1e_wo_LOSV2b_B.Gain1_o[i] =
          CA_CSE1_V1e_wo_LOSV2b_P.Gain1_Gain_m[i + 6] *
          CA_CSE1_V1e_wo_LOSV2b_B.eta_w[2] + CA_CSE1_V1e_wo_LOSV2b_B.Gain1_o[i];

        /* Integrator: '<S16>/Integrator2' */
        CA_CSE1_V1e_wo_LOSV2b_B.xi_w[i] =
          CA_CSE1_V1e_wo_LOSV2b_X.Integrator2_CSTATE[i];
      }

      /* Sum: '<S16>/Sum4' */
      CA_CSE1_V1e_wo_LOSV2b_B.Sum4[0] = CA_CSE1_V1e_wo_LOSV2b_B.eta_w[0] +
        CA_CSE1_V1e_wo_LOSV2b_B.eta[0];
      CA_CSE1_V1e_wo_LOSV2b_B.Sum4[1] = CA_CSE1_V1e_wo_LOSV2b_B.eta_w[1] +
        CA_CSE1_V1e_wo_LOSV2b_B.eta[1];
      CA_CSE1_V1e_wo_LOSV2b_B.Sum4[2] = CA_CSE1_V1e_wo_LOSV2b_B.eta_w[2] +
        CA_CSE1_V1e_wo_LOSV2b_B.Sum_jb;

      /* Sum: '<S16>/Sum2' */
      CA_CSE1_V1e_wo_LOSV2b_B.Sum2_d[0] = CA_CSE1_V1e_wo_LOSV2b_B.eta_surge -
        CA_CSE1_V1e_wo_LOSV2b_B.Sum4[0];
      CA_CSE1_V1e_wo_LOSV2b_B.Sum2_d[1] = CA_CSE1_V1e_wo_LOSV2b_B.eta_sway -
        CA_CSE1_V1e_wo_LOSV2b_B.Sum4[1];
      CA_CSE1_V1e_wo_LOSV2b_B.Sum2_d[2] = CA_CSE1_V1e_wo_LOSV2b_B.eta_yaw -
        CA_CSE1_V1e_wo_LOSV2b_B.Sum4[2];

      /* Saturate: '<S25>/Saturation' */
      currentTime = CA_CSE1_V1e_wo_LOSV2b_B.Sum2_d[2];
      CA_CSE1_V1e_wo_LOSV2b_B.Saturation_n = rt_SATURATE(currentTime,
        CA_CSE1_V1e_wo_LOSV2b_P.Saturation_LowerSat_fw,
        CA_CSE1_V1e_wo_LOSV2b_P.Saturation_UpperSat_a);

      /* Signum: '<S25>/Sign' */
      CA_CSE1_V1e_wo_LOSV2b_B.Sign_h = rt_SIGNd_snf
        (CA_CSE1_V1e_wo_LOSV2b_B.Saturation_n);

      /* Gain: '<S25>/Gain' */
      CA_CSE1_V1e_wo_LOSV2b_B.Gain_f = CA_CSE1_V1e_wo_LOSV2b_P.Gain_Gain_g *
        CA_CSE1_V1e_wo_LOSV2b_B.Sign_h;

      /* Sum: '<S25>/Sum1' */
      CA_CSE1_V1e_wo_LOSV2b_B.Sum1_cq = CA_CSE1_V1e_wo_LOSV2b_B.Saturation_n +
        CA_CSE1_V1e_wo_LOSV2b_B.Gain_f;

      /* Math: '<S25>/Math Function' incorporates:
       *  Constant: '<S25>/Constant'
       */
      CA_CSE1_V1e_wo_LOSV2b_B.MathFunction_j = rt_rem_snf
        (CA_CSE1_V1e_wo_LOSV2b_B.Sum1_cq,
         CA_CSE1_V1e_wo_LOSV2b_P.Constant_Value_h);

      /* Sum: '<S25>/Sum' */
      CA_CSE1_V1e_wo_LOSV2b_B.Sum_i = CA_CSE1_V1e_wo_LOSV2b_B.MathFunction_j -
        CA_CSE1_V1e_wo_LOSV2b_B.Gain_f;

      /* SignalConversion: '<S16>/TmpHiddenBufferAtK11Inport1' */
      CA_CSE1_V1e_wo_LOSV2b_B.TmpHiddenBufferAtK11Inport1[0] =
        CA_CSE1_V1e_wo_LOSV2b_B.Sum2_d[0];
      CA_CSE1_V1e_wo_LOSV2b_B.TmpHiddenBufferAtK11Inport1[1] =
        CA_CSE1_V1e_wo_LOSV2b_B.Sum2_d[1];
      CA_CSE1_V1e_wo_LOSV2b_B.TmpHiddenBufferAtK11Inport1[2] =
        CA_CSE1_V1e_wo_LOSV2b_B.Sum_i;

      /* Fcn: '<S22>/Row1' */
      for (i = 0; i < 3; i++) {
        /* Gain: '<S16>/Gain2' */
        CA_CSE1_V1e_wo_LOSV2b_B.Gain2[i] = 0.0;
        CA_CSE1_V1e_wo_LOSV2b_B.Gain2[i] = CA_CSE1_V1e_wo_LOSV2b_P.Gain2_Gain[i]
          * CA_CSE1_V1e_wo_LOSV2b_B.xi_w[0] + CA_CSE1_V1e_wo_LOSV2b_B.Gain2[i];
        CA_CSE1_V1e_wo_LOSV2b_B.Gain2[i] = CA_CSE1_V1e_wo_LOSV2b_P.Gain2_Gain[i
          + 3] * CA_CSE1_V1e_wo_LOSV2b_B.xi_w[1] +
          CA_CSE1_V1e_wo_LOSV2b_B.Gain2[i];
        CA_CSE1_V1e_wo_LOSV2b_B.Gain2[i] = CA_CSE1_V1e_wo_LOSV2b_P.Gain2_Gain[i
          + 6] * CA_CSE1_V1e_wo_LOSV2b_B.xi_w[2] +
          CA_CSE1_V1e_wo_LOSV2b_B.Gain2[i];

        /* Gain: '<S16>/K4' */
        CA_CSE1_V1e_wo_LOSV2b_B.K4[i] = 0.0;
        CA_CSE1_V1e_wo_LOSV2b_B.K4[i] = CA_CSE1_V1e_wo_LOSV2b_P.K4_Gain[i] *
          CA_CSE1_V1e_wo_LOSV2b_B.TmpHiddenBufferAtK11Inport1[0] +
          CA_CSE1_V1e_wo_LOSV2b_B.K4[i];
        CA_CSE1_V1e_wo_LOSV2b_B.K4[i] = CA_CSE1_V1e_wo_LOSV2b_P.K4_Gain[i + 3] *
          CA_CSE1_V1e_wo_LOSV2b_B.TmpHiddenBufferAtK11Inport1[1] +
          CA_CSE1_V1e_wo_LOSV2b_B.K4[i];
        CA_CSE1_V1e_wo_LOSV2b_B.K4[i] = CA_CSE1_V1e_wo_LOSV2b_P.K4_Gain[i + 6] *
          CA_CSE1_V1e_wo_LOSV2b_B.TmpHiddenBufferAtK11Inport1[2] +
          CA_CSE1_V1e_wo_LOSV2b_B.K4[i];

        /* Integrator: '<S16>/Integrator3' */
        CA_CSE1_V1e_wo_LOSV2b_B.bias[i] =
          CA_CSE1_V1e_wo_LOSV2b_X.Integrator3_CSTATE[i];

        /* Gain: '<S16>/Gain6' */
        CA_CSE1_V1e_wo_LOSV2b_B.Gain6[i] = 0.0;
        CA_CSE1_V1e_wo_LOSV2b_B.Gain6[i] = CA_CSE1_V1e_wo_LOSV2b_P.Gain6_Gain[i]
          * CA_CSE1_V1e_wo_LOSV2b_B.nu[0] + CA_CSE1_V1e_wo_LOSV2b_B.Gain6[i];
        CA_CSE1_V1e_wo_LOSV2b_B.Gain6[i] = CA_CSE1_V1e_wo_LOSV2b_P.Gain6_Gain[i
          + 3] * CA_CSE1_V1e_wo_LOSV2b_B.nu[1] + CA_CSE1_V1e_wo_LOSV2b_B.Gain6[i];
        CA_CSE1_V1e_wo_LOSV2b_B.Gain6[i] = CA_CSE1_V1e_wo_LOSV2b_P.Gain6_Gain[i
          + 6] * CA_CSE1_V1e_wo_LOSV2b_B.nu[2] + CA_CSE1_V1e_wo_LOSV2b_B.Gain6[i];
      }

      CA_CSE1_V1e_wo_LOSV2b_B.Row1_c = cos(CA_CSE1_V1e_wo_LOSV2b_B.eta_yaw) *
        CA_CSE1_V1e_wo_LOSV2b_B.K4[0] + sin(CA_CSE1_V1e_wo_LOSV2b_B.eta_yaw) *
        CA_CSE1_V1e_wo_LOSV2b_B.K4[1];

      /* Fcn: '<S22>/Row2' */
      CA_CSE1_V1e_wo_LOSV2b_B.Row2_bf = (-sin(CA_CSE1_V1e_wo_LOSV2b_B.eta_yaw)) *
        CA_CSE1_V1e_wo_LOSV2b_B.K4[0] + cos(CA_CSE1_V1e_wo_LOSV2b_B.eta_yaw) *
        CA_CSE1_V1e_wo_LOSV2b_B.K4[1];

      /* Fcn: '<S22>/Row3' */
      CA_CSE1_V1e_wo_LOSV2b_B.Row3_nq = CA_CSE1_V1e_wo_LOSV2b_B.K4[2];

      /* Fcn: '<S23>/Row1' */
      CA_CSE1_V1e_wo_LOSV2b_B.Row1_kz = cos(CA_CSE1_V1e_wo_LOSV2b_B.eta_yaw) *
        CA_CSE1_V1e_wo_LOSV2b_B.bias[0] + sin(CA_CSE1_V1e_wo_LOSV2b_B.eta_yaw) *
        CA_CSE1_V1e_wo_LOSV2b_B.bias[1];

      /* Fcn: '<S23>/Row2' */
      CA_CSE1_V1e_wo_LOSV2b_B.Row2_bv = (-sin(CA_CSE1_V1e_wo_LOSV2b_B.eta_yaw)) *
        CA_CSE1_V1e_wo_LOSV2b_B.bias[0] + cos(CA_CSE1_V1e_wo_LOSV2b_B.eta_yaw) *
        CA_CSE1_V1e_wo_LOSV2b_B.bias[1];

      /* Fcn: '<S23>/Row3' */
      CA_CSE1_V1e_wo_LOSV2b_B.Row3_l = CA_CSE1_V1e_wo_LOSV2b_B.bias[2];

      /* Sum: '<S16>/Sum1' */
      CA_CSE1_V1e_wo_LOSV2b_B.Sum1_az[0] = CA_CSE1_V1e_wo_LOSV2b_B.Row1_kz +
        CA_CSE1_V1e_wo_LOSV2b_B.TmpHiddenBufferAtProduct1Inpo_d[0];
      CA_CSE1_V1e_wo_LOSV2b_B.Sum1_az[1] = CA_CSE1_V1e_wo_LOSV2b_B.Row2_bv +
        CA_CSE1_V1e_wo_LOSV2b_B.TmpHiddenBufferAtProduct1Inpo_d[1];
      CA_CSE1_V1e_wo_LOSV2b_B.Sum1_az[2] = CA_CSE1_V1e_wo_LOSV2b_B.Row3_l +
        CA_CSE1_V1e_wo_LOSV2b_B.TmpHiddenBufferAtProduct1Inpo_d[2];

      /* Sum: '<S16>/Sum8' */
      CA_CSE1_V1e_wo_LOSV2b_B.Sum8[0] = (CA_CSE1_V1e_wo_LOSV2b_B.Row1_c +
        CA_CSE1_V1e_wo_LOSV2b_B.Sum1_az[0]) - CA_CSE1_V1e_wo_LOSV2b_B.Gain6[0];
      CA_CSE1_V1e_wo_LOSV2b_B.Sum8[1] = (CA_CSE1_V1e_wo_LOSV2b_B.Row2_bf +
        CA_CSE1_V1e_wo_LOSV2b_B.Sum1_az[1]) - CA_CSE1_V1e_wo_LOSV2b_B.Gain6[1];
      CA_CSE1_V1e_wo_LOSV2b_B.Sum8[2] = (CA_CSE1_V1e_wo_LOSV2b_B.Row3_nq +
        CA_CSE1_V1e_wo_LOSV2b_B.Sum1_az[2]) - CA_CSE1_V1e_wo_LOSV2b_B.Gain6[2];

      /* Fcn: '<S21>/Fcn' */
      CA_CSE1_V1e_wo_LOSV2b_B.x_dot = cos(CA_CSE1_V1e_wo_LOSV2b_B.eta_yaw) *
        CA_CSE1_V1e_wo_LOSV2b_B.nu[0] - sin(CA_CSE1_V1e_wo_LOSV2b_B.eta_yaw) *
        CA_CSE1_V1e_wo_LOSV2b_B.nu[1];

      /* Fcn: '<S21>/Fcn1' */
      CA_CSE1_V1e_wo_LOSV2b_B.y_dot = sin(CA_CSE1_V1e_wo_LOSV2b_B.eta_yaw) *
        CA_CSE1_V1e_wo_LOSV2b_B.nu[0] + cos(CA_CSE1_V1e_wo_LOSV2b_B.eta_yaw) *
        CA_CSE1_V1e_wo_LOSV2b_B.nu[1];

      /* Fcn: '<S21>/Fcn2' */
      CA_CSE1_V1e_wo_LOSV2b_B.psi_dot = CA_CSE1_V1e_wo_LOSV2b_B.nu[2];

      /* Sum: '<S16>/Sum3' */
      for (i = 0; i < 3; i++) {
        /* Gain: '<S16>/Gain3' */
        CA_CSE1_V1e_wo_LOSV2b_B.Gain3[i] = 0.0;
        CA_CSE1_V1e_wo_LOSV2b_B.Gain3[i] = CA_CSE1_V1e_wo_LOSV2b_P.Gain3_Gain[i]
          * CA_CSE1_V1e_wo_LOSV2b_B.Sum8[0] + CA_CSE1_V1e_wo_LOSV2b_B.Gain3[i];
        CA_CSE1_V1e_wo_LOSV2b_B.Gain3[i] = CA_CSE1_V1e_wo_LOSV2b_P.Gain3_Gain[i
          + 3] * CA_CSE1_V1e_wo_LOSV2b_B.Sum8[1] +
          CA_CSE1_V1e_wo_LOSV2b_B.Gain3[i];
        CA_CSE1_V1e_wo_LOSV2b_B.Gain3[i] = CA_CSE1_V1e_wo_LOSV2b_P.Gain3_Gain[i
          + 6] * CA_CSE1_V1e_wo_LOSV2b_B.Sum8[2] +
          CA_CSE1_V1e_wo_LOSV2b_B.Gain3[i];

        /* Gain: '<S16>/K11' */
        CA_CSE1_V1e_wo_LOSV2b_B.K11[i] = 0.0;
        CA_CSE1_V1e_wo_LOSV2b_B.K11[i] = CA_CSE1_V1e_wo_LOSV2b_P.K11_Gain[i] *
          CA_CSE1_V1e_wo_LOSV2b_B.TmpHiddenBufferAtK11Inport1[0] +
          CA_CSE1_V1e_wo_LOSV2b_B.K11[i];
        CA_CSE1_V1e_wo_LOSV2b_B.K11[i] = CA_CSE1_V1e_wo_LOSV2b_P.K11_Gain[i + 3]
          * CA_CSE1_V1e_wo_LOSV2b_B.TmpHiddenBufferAtK11Inport1[1] +
          CA_CSE1_V1e_wo_LOSV2b_B.K11[i];
        CA_CSE1_V1e_wo_LOSV2b_B.K11[i] = CA_CSE1_V1e_wo_LOSV2b_P.K11_Gain[i + 6]
          * CA_CSE1_V1e_wo_LOSV2b_B.TmpHiddenBufferAtK11Inport1[2] +
          CA_CSE1_V1e_wo_LOSV2b_B.K11[i];

        /* Gain: '<S16>/K12' */
        CA_CSE1_V1e_wo_LOSV2b_B.K12[i] = 0.0;
        CA_CSE1_V1e_wo_LOSV2b_B.K12[i] = CA_CSE1_V1e_wo_LOSV2b_P.K12_Gain[i] *
          CA_CSE1_V1e_wo_LOSV2b_B.TmpHiddenBufferAtK11Inport1[0] +
          CA_CSE1_V1e_wo_LOSV2b_B.K12[i];
        CA_CSE1_V1e_wo_LOSV2b_B.K12[i] = CA_CSE1_V1e_wo_LOSV2b_P.K12_Gain[i + 3]
          * CA_CSE1_V1e_wo_LOSV2b_B.TmpHiddenBufferAtK11Inport1[1] +
          CA_CSE1_V1e_wo_LOSV2b_B.K12[i];
        CA_CSE1_V1e_wo_LOSV2b_B.K12[i] = CA_CSE1_V1e_wo_LOSV2b_P.K12_Gain[i + 6]
          * CA_CSE1_V1e_wo_LOSV2b_B.TmpHiddenBufferAtK11Inport1[2] +
          CA_CSE1_V1e_wo_LOSV2b_B.K12[i];

        /* Gain: '<S16>/K2' */
        CA_CSE1_V1e_wo_LOSV2b_B.K2[i] = 0.0;
        CA_CSE1_V1e_wo_LOSV2b_B.K2[i] = CA_CSE1_V1e_wo_LOSV2b_P.K2_Gain[i] *
          CA_CSE1_V1e_wo_LOSV2b_B.TmpHiddenBufferAtK11Inport1[0] +
          CA_CSE1_V1e_wo_LOSV2b_B.K2[i];
        CA_CSE1_V1e_wo_LOSV2b_B.K2[i] = CA_CSE1_V1e_wo_LOSV2b_P.K2_Gain[i + 3] *
          CA_CSE1_V1e_wo_LOSV2b_B.TmpHiddenBufferAtK11Inport1[1] +
          CA_CSE1_V1e_wo_LOSV2b_B.K2[i];
        CA_CSE1_V1e_wo_LOSV2b_B.K2[i] = CA_CSE1_V1e_wo_LOSV2b_P.K2_Gain[i + 6] *
          CA_CSE1_V1e_wo_LOSV2b_B.TmpHiddenBufferAtK11Inport1[2] +
          CA_CSE1_V1e_wo_LOSV2b_B.K2[i];

        /* Gain: '<S16>/K3' */
        CA_CSE1_V1e_wo_LOSV2b_B.K3[i] = 0.0;
        CA_CSE1_V1e_wo_LOSV2b_B.K3[i] = CA_CSE1_V1e_wo_LOSV2b_P.K3_Gain[i] *
          CA_CSE1_V1e_wo_LOSV2b_B.TmpHiddenBufferAtK11Inport1[0] +
          CA_CSE1_V1e_wo_LOSV2b_B.K3[i];
        CA_CSE1_V1e_wo_LOSV2b_B.K3[i] = CA_CSE1_V1e_wo_LOSV2b_P.K3_Gain[i + 3] *
          CA_CSE1_V1e_wo_LOSV2b_B.TmpHiddenBufferAtK11Inport1[1] +
          CA_CSE1_V1e_wo_LOSV2b_B.K3[i];
        CA_CSE1_V1e_wo_LOSV2b_B.K3[i] = CA_CSE1_V1e_wo_LOSV2b_P.K3_Gain[i + 6] *
          CA_CSE1_V1e_wo_LOSV2b_B.TmpHiddenBufferAtK11Inport1[2] +
          CA_CSE1_V1e_wo_LOSV2b_B.K3[i];

        /* Sum: '<S16>/Sum5' */
        CA_CSE1_V1e_wo_LOSV2b_B.psi_WF[i] = CA_CSE1_V1e_wo_LOSV2b_B.K11[i] +
          CA_CSE1_V1e_wo_LOSV2b_B.eta_w[i];

        /* Sum: '<S16>/Sum6' */
        CA_CSE1_V1e_wo_LOSV2b_B.Sum6[i] = (CA_CSE1_V1e_wo_LOSV2b_B.K12[i] -
          CA_CSE1_V1e_wo_LOSV2b_B.Gain2[i]) - CA_CSE1_V1e_wo_LOSV2b_B.Gain1_o[i];

        /* Gain: '<S16>/inv(T_b)' */
        CA_CSE1_V1e_wo_LOSV2b_B.invT_b[i] = 0.0;
        CA_CSE1_V1e_wo_LOSV2b_B.invT_b[i] =
          CA_CSE1_V1e_wo_LOSV2b_P.invT_b_Gain[i] * CA_CSE1_V1e_wo_LOSV2b_B.bias
          [0] + CA_CSE1_V1e_wo_LOSV2b_B.invT_b[i];
        CA_CSE1_V1e_wo_LOSV2b_B.invT_b[i] =
          CA_CSE1_V1e_wo_LOSV2b_P.invT_b_Gain[i + 3] *
          CA_CSE1_V1e_wo_LOSV2b_B.bias[1] + CA_CSE1_V1e_wo_LOSV2b_B.invT_b[i];
        CA_CSE1_V1e_wo_LOSV2b_B.invT_b[i] =
          CA_CSE1_V1e_wo_LOSV2b_P.invT_b_Gain[i + 6] *
          CA_CSE1_V1e_wo_LOSV2b_B.bias[2] + CA_CSE1_V1e_wo_LOSV2b_B.invT_b[i];

        /* Sum: '<S16>/Sum7' */
        CA_CSE1_V1e_wo_LOSV2b_B.Sum7[i] = CA_CSE1_V1e_wo_LOSV2b_B.K3[i] -
          CA_CSE1_V1e_wo_LOSV2b_B.invT_b[i];
      }

      CA_CSE1_V1e_wo_LOSV2b_B.Sum3_k[0] = CA_CSE1_V1e_wo_LOSV2b_B.K2[0] +
        CA_CSE1_V1e_wo_LOSV2b_B.x_dot;
      CA_CSE1_V1e_wo_LOSV2b_B.Sum3_k[1] = CA_CSE1_V1e_wo_LOSV2b_B.K2[1] +
        CA_CSE1_V1e_wo_LOSV2b_B.y_dot;
      CA_CSE1_V1e_wo_LOSV2b_B.Sum3_k[2] = CA_CSE1_V1e_wo_LOSV2b_B.K2[2] +
        CA_CSE1_V1e_wo_LOSV2b_B.psi_dot;

      /* Saturate: '<S6>/Saturation' */
      tmp[0] = CA_CSE1_V1e_wo_LOSV2b_B.DPu_1_d;
      tmp[1] = CA_CSE1_V1e_wo_LOSV2b_B.DPu_2_b;
      tmp[2] = CA_CSE1_V1e_wo_LOSV2b_B.DPu_3_g;
      tmp[3] = CA_CSE1_V1e_wo_LOSV2b_B.DPu_4_l;
      tmp[4] = CA_CSE1_V1e_wo_LOSV2b_B.DPu_5_l;
      for (i = 0; i < 5; i++) {
        CA_CSE1_V1e_wo_LOSV2b_B.Saturation_f[i] = rt_SATURATE(tmp[i],
          CA_CSE1_V1e_wo_LOSV2b_P.Saturation_LowerSat_o,
          CA_CSE1_V1e_wo_LOSV2b_P.Saturation_UpperSat_ga);
      }

      if (rtmIsMajorTimeStep(CA_CSE1_V1e_wo_LOSV2b_M)) {
        /* Constant: '<S6>/VSP_speeds' */
        CA_CSE1_V1e_wo_LOSV2b_B.VSP_speeds =
          CA_CSE1_V1e_wo_LOSV2b_P.VSP_speeds_Value_a;
      }
    }

    /* end of Outputs for SubSystem: '<S1>/DP control' */
    if (rtmIsMajorTimeStep(CA_CSE1_V1e_wo_LOSV2b_M)) {
      /* Gain: '<S28>/Gain K_e1_DP' incorporates:
       *  Constant: '<S28>/K_e1_DP'
       */
      CA_CSE1_V1e_wo_LOSV2b_B.GainK_e1_DP =
        CA_CSE1_V1e_wo_LOSV2b_P.GainK_e1_DP_Gain *
        CA_CSE1_V1e_wo_LOSV2b_P.K_e1_DP_Value;

      /* Gain: '<S28>/Gain K_e2_DP' incorporates:
       *  Constant: '<S28>/K_e2_DP'
       */
      CA_CSE1_V1e_wo_LOSV2b_B.GainK_e2_DP =
        CA_CSE1_V1e_wo_LOSV2b_P.GainK_e2_DP_Gain *
        CA_CSE1_V1e_wo_LOSV2b_P.K_e2_DP_Value;

      /* Gain: '<S28>/Gain K_e3_DP' incorporates:
       *  Constant: '<S28>/K_e3_DP'
       */
      CA_CSE1_V1e_wo_LOSV2b_B.GainK_e3_DP =
        CA_CSE1_V1e_wo_LOSV2b_P.GainK_e3_DP_Gain *
        CA_CSE1_V1e_wo_LOSV2b_P.K_e3_DP_Value;

      /* Gain: '<S28>/Gain K_e4_DP' incorporates:
       *  Constant: '<S28>/K_e4_DP'
       */
      CA_CSE1_V1e_wo_LOSV2b_B.GainK_e4_DP =
        CA_CSE1_V1e_wo_LOSV2b_P.GainK_e4_DP_Gain *
        CA_CSE1_V1e_wo_LOSV2b_P.K_e4_DP_Value;

      /* Gain: '<S28>/Gain K_e5_DP' incorporates:
       *  Constant: '<S28>/K_e5_DP'
       */
      CA_CSE1_V1e_wo_LOSV2b_B.GainK_e5_DP =
        CA_CSE1_V1e_wo_LOSV2b_P.GainK_e5_DP_Gain *
        CA_CSE1_V1e_wo_LOSV2b_P.K_e5_DP_Value;

      /* Reshape: '<S28>/Thruster Gain matrix' incorporates:
       *  Constant: '<S28>/Constant'
       */
      CA_CSE1_V1e_wo_LOSV2b_B.ThrusterGainmatrix_c[0] =
        CA_CSE1_V1e_wo_LOSV2b_B.GainK_e1_DP;
      CA_CSE1_V1e_wo_LOSV2b_B.ThrusterGainmatrix_c[1] =
        CA_CSE1_V1e_wo_LOSV2b_P.Constant_Value_cz;
      CA_CSE1_V1e_wo_LOSV2b_B.ThrusterGainmatrix_c[2] =
        CA_CSE1_V1e_wo_LOSV2b_P.Constant_Value_cz;
      CA_CSE1_V1e_wo_LOSV2b_B.ThrusterGainmatrix_c[3] =
        CA_CSE1_V1e_wo_LOSV2b_P.Constant_Value_cz;
      CA_CSE1_V1e_wo_LOSV2b_B.ThrusterGainmatrix_c[4] =
        CA_CSE1_V1e_wo_LOSV2b_P.Constant_Value_cz;
      CA_CSE1_V1e_wo_LOSV2b_B.ThrusterGainmatrix_c[5] =
        CA_CSE1_V1e_wo_LOSV2b_P.Constant_Value_cz;
      CA_CSE1_V1e_wo_LOSV2b_B.ThrusterGainmatrix_c[6] =
        CA_CSE1_V1e_wo_LOSV2b_B.GainK_e2_DP;
      CA_CSE1_V1e_wo_LOSV2b_B.ThrusterGainmatrix_c[7] =
        CA_CSE1_V1e_wo_LOSV2b_P.Constant_Value_cz;
      CA_CSE1_V1e_wo_LOSV2b_B.ThrusterGainmatrix_c[8] =
        CA_CSE1_V1e_wo_LOSV2b_P.Constant_Value_cz;
      CA_CSE1_V1e_wo_LOSV2b_B.ThrusterGainmatrix_c[9] =
        CA_CSE1_V1e_wo_LOSV2b_P.Constant_Value_cz;
      CA_CSE1_V1e_wo_LOSV2b_B.ThrusterGainmatrix_c[10] =
        CA_CSE1_V1e_wo_LOSV2b_P.Constant_Value_cz;
      CA_CSE1_V1e_wo_LOSV2b_B.ThrusterGainmatrix_c[11] =
        CA_CSE1_V1e_wo_LOSV2b_P.Constant_Value_cz;
      CA_CSE1_V1e_wo_LOSV2b_B.ThrusterGainmatrix_c[12] =
        CA_CSE1_V1e_wo_LOSV2b_B.GainK_e3_DP;
      CA_CSE1_V1e_wo_LOSV2b_B.ThrusterGainmatrix_c[13] =
        CA_CSE1_V1e_wo_LOSV2b_P.Constant_Value_cz;
      CA_CSE1_V1e_wo_LOSV2b_B.ThrusterGainmatrix_c[14] =
        CA_CSE1_V1e_wo_LOSV2b_P.Constant_Value_cz;
      CA_CSE1_V1e_wo_LOSV2b_B.ThrusterGainmatrix_c[15] =
        CA_CSE1_V1e_wo_LOSV2b_P.Constant_Value_cz;
      CA_CSE1_V1e_wo_LOSV2b_B.ThrusterGainmatrix_c[16] =
        CA_CSE1_V1e_wo_LOSV2b_P.Constant_Value_cz;
      CA_CSE1_V1e_wo_LOSV2b_B.ThrusterGainmatrix_c[17] =
        CA_CSE1_V1e_wo_LOSV2b_P.Constant_Value_cz;
      CA_CSE1_V1e_wo_LOSV2b_B.ThrusterGainmatrix_c[18] =
        CA_CSE1_V1e_wo_LOSV2b_B.GainK_e4_DP;
      CA_CSE1_V1e_wo_LOSV2b_B.ThrusterGainmatrix_c[19] =
        CA_CSE1_V1e_wo_LOSV2b_P.Constant_Value_cz;
      CA_CSE1_V1e_wo_LOSV2b_B.ThrusterGainmatrix_c[20] =
        CA_CSE1_V1e_wo_LOSV2b_P.Constant_Value_cz;
      CA_CSE1_V1e_wo_LOSV2b_B.ThrusterGainmatrix_c[21] =
        CA_CSE1_V1e_wo_LOSV2b_P.Constant_Value_cz;
      CA_CSE1_V1e_wo_LOSV2b_B.ThrusterGainmatrix_c[22] =
        CA_CSE1_V1e_wo_LOSV2b_P.Constant_Value_cz;
      CA_CSE1_V1e_wo_LOSV2b_B.ThrusterGainmatrix_c[23] =
        CA_CSE1_V1e_wo_LOSV2b_P.Constant_Value_cz;
      CA_CSE1_V1e_wo_LOSV2b_B.ThrusterGainmatrix_c[24] =
        CA_CSE1_V1e_wo_LOSV2b_B.GainK_e5_DP;

      /* Product Block: '<S8>/K_e^-1' */
      {
        static const int_T dims[3] = { 5, 5, 5 };

        rt_MatDivRR_Dbl(CA_CSE1_V1e_wo_LOSV2b_B.K_e1_h,
                        CA_CSE1_V1e_wo_LOSV2b_B.ThrusterGainmatrix_c,
                        &CA_CSE1_V1e_wo_LOSV2b_DWork.K_e1_DWORK4_d[0], (real_T*)
                        &CA_CSE1_V1e_wo_LOSV2b_DWork.K_e1_DWORK1[0],
                        &CA_CSE1_V1e_wo_LOSV2b_DWork.K_e1_DWORK2[0], (real_T*)
                        &CA_CSE1_V1e_wo_LOSV2b_DWork.K_e1_DWORK3[0],
                        &dims[0]);
      }

      /* Gain: '<S30>/-l_x1' incorporates:
       *  Constant: '<S30>/l_x1'
       */
      CA_CSE1_V1e_wo_LOSV2b_B.l_x1_o = CA_CSE1_V1e_wo_LOSV2b_P.l_x1_Gain_h *
        CA_CSE1_V1e_wo_LOSV2b_P.l_x1_Value_h;

      /* Gain: '<S30>/-l_y2' incorporates:
       *  Constant: '<S30>/l_y2'
       */
      CA_CSE1_V1e_wo_LOSV2b_B.l_y2_g = CA_CSE1_V1e_wo_LOSV2b_P.l_y2_Gain_g *
        CA_CSE1_V1e_wo_LOSV2b_P.l_y2_Value_b;

      /* Gain: '<S30>/-l_x2' incorporates:
       *  Constant: '<S30>/l_x2'
       */
      CA_CSE1_V1e_wo_LOSV2b_B.l_x2_i = CA_CSE1_V1e_wo_LOSV2b_P.l_x2_Gain_i *
        CA_CSE1_V1e_wo_LOSV2b_P.l_x2_Value_p;

      /* Reshape: '<S30>/3x5' incorporates:
       *  Constant: '<S30>/T_e11'
       *  Constant: '<S30>/T_e12'
       *  Constant: '<S30>/T_e13'
       *  Constant: '<S30>/T_e14'
       *  Constant: '<S30>/T_e15'
       *  Constant: '<S30>/T_e21'
       *  Constant: '<S30>/T_e22'
       *  Constant: '<S30>/T_e23'
       *  Constant: '<S30>/T_e24'
       *  Constant: '<S30>/T_e25'
       *  Constant: '<S30>/l_x3'
       *  Constant: '<S30>/l_y1'
       */
      CA_CSE1_V1e_wo_LOSV2b_B.x5_p[0] = CA_CSE1_V1e_wo_LOSV2b_P.T_e11_Value_f;
      CA_CSE1_V1e_wo_LOSV2b_B.x5_p[1] = CA_CSE1_V1e_wo_LOSV2b_P.T_e21_Value_m;
      CA_CSE1_V1e_wo_LOSV2b_B.x5_p[2] = CA_CSE1_V1e_wo_LOSV2b_P.l_y1_Value_m;
      CA_CSE1_V1e_wo_LOSV2b_B.x5_p[3] = CA_CSE1_V1e_wo_LOSV2b_P.T_e12_Value_a;
      CA_CSE1_V1e_wo_LOSV2b_B.x5_p[4] = CA_CSE1_V1e_wo_LOSV2b_P.T_e22_Value_p;
      CA_CSE1_V1e_wo_LOSV2b_B.x5_p[5] = CA_CSE1_V1e_wo_LOSV2b_B.l_x1_o;
      CA_CSE1_V1e_wo_LOSV2b_B.x5_p[6] = CA_CSE1_V1e_wo_LOSV2b_P.T_e13_Value_d;
      CA_CSE1_V1e_wo_LOSV2b_B.x5_p[7] = CA_CSE1_V1e_wo_LOSV2b_P.T_e23_Value_h;
      CA_CSE1_V1e_wo_LOSV2b_B.x5_p[8] = CA_CSE1_V1e_wo_LOSV2b_B.l_y2_g;
      CA_CSE1_V1e_wo_LOSV2b_B.x5_p[9] = CA_CSE1_V1e_wo_LOSV2b_P.T_e14_Value_o;
      CA_CSE1_V1e_wo_LOSV2b_B.x5_p[10] = CA_CSE1_V1e_wo_LOSV2b_P.T_e24_Value_m;
      CA_CSE1_V1e_wo_LOSV2b_B.x5_p[11] = CA_CSE1_V1e_wo_LOSV2b_B.l_x2_i;
      CA_CSE1_V1e_wo_LOSV2b_B.x5_p[12] = CA_CSE1_V1e_wo_LOSV2b_P.T_e15_Value_j;
      CA_CSE1_V1e_wo_LOSV2b_B.x5_p[13] = CA_CSE1_V1e_wo_LOSV2b_P.T_e25_Value_j;
      CA_CSE1_V1e_wo_LOSV2b_B.x5_p[14] = CA_CSE1_V1e_wo_LOSV2b_P.l_x3_Value_o;

      /* S-Function (sdsppinv): '<S8>/T_e^+' */
      /* Copy input to temporary space */
      memcpy((void *)(&CA_CSE1_V1e_wo_LOSV2b_DWork.K_e1_DWORK1[0]), (void *)
             (&CA_CSE1_V1e_wo_LOSV2b_B.x5_p[0]), 15U * sizeof(real_T));

      /* Call SVD */
      i = MWDSP_SVD_D(&CA_CSE1_V1e_wo_LOSV2b_DWork.K_e1_DWORK1[0], 3, 5,
                      &CA_CSE1_V1e_wo_LOSV2b_DWork.T_e_S[0],
                      &CA_CSE1_V1e_wo_LOSV2b_DWork.K_e1_DWORK3[0],
                      &CA_CSE1_V1e_wo_LOSV2b_DWork.T_e_WORK[0],
                      &CA_CSE1_V1e_wo_LOSV2b_DWork.T_e_U[0],
                      &CA_CSE1_V1e_wo_LOSV2b_DWork.T_e_V[0], 1);

      /* Only call 'pinv' function if SVD succeeded */
      if (i == 0) {
        MWDSPCG_Pseudoinverse_D(&CA_CSE1_V1e_wo_LOSV2b_DWork.T_e_S[0],
          &CA_CSE1_V1e_wo_LOSV2b_DWork.T_e_U[0],
          &CA_CSE1_V1e_wo_LOSV2b_DWork.T_e_V[0], &CA_CSE1_V1e_wo_LOSV2b_B.T_e_j
          [0], (const int32_T)3, (const int32_T)5);
      }

      /* Product: '<S8>/Product' */
      for (i = 0; i < 5; i++) {
        for (tmp_4 = 0; tmp_4 < 3; tmp_4++) {
          CA_CSE1_V1e_wo_LOSV2b_B.Product_h[i + 5 * tmp_4] = 0.0;
          for (tmp_3 = 0; tmp_3 < 5; tmp_3++) {
            CA_CSE1_V1e_wo_LOSV2b_B.Product_h[i + 5 * tmp_4] =
              CA_CSE1_V1e_wo_LOSV2b_B.K_e1_h[5 * tmp_3 + i] *
              CA_CSE1_V1e_wo_LOSV2b_B.T_e_j[5 * tmp_4 + tmp_3] +
              CA_CSE1_V1e_wo_LOSV2b_B.Product_h[5 * tmp_4 + i];
          }
        }
      }
    }

    /* Step: '<S51>/Step' */
    currentTime = CA_CSE1_V1e_wo_LOSV2b_M->Timing.t[0];
    if (currentTime < CA_CSE1_V1e_wo_LOSV2b_P.Step_Time) {
      CA_CSE1_V1e_wo_LOSV2b_B.Step = CA_CSE1_V1e_wo_LOSV2b_P.Step_Y0;
    } else {
      CA_CSE1_V1e_wo_LOSV2b_B.Step = CA_CSE1_V1e_wo_LOSV2b_P.Step_YFinal;
    }

    /* Clock Block: '<S51>/Clock'
     */
    CA_CSE1_V1e_wo_LOSV2b_B.Clock = CA_CSE1_V1e_wo_LOSV2b_M->Timing.t[0];

    /* Sum: '<S51>/Sum' incorporates:
     *  Constant: '<S51>/Constant'
     */
    CA_CSE1_V1e_wo_LOSV2b_B.Sum_m = CA_CSE1_V1e_wo_LOSV2b_B.Clock -
      CA_CSE1_V1e_wo_LOSV2b_P.Constant_Value_j;

    /* Product: '<S51>/Product' */
    CA_CSE1_V1e_wo_LOSV2b_B.Product_c = CA_CSE1_V1e_wo_LOSV2b_B.Step *
      CA_CSE1_V1e_wo_LOSV2b_B.Sum_m;

    /* Sum: '<S51>/Output' incorporates:
     *  Constant: '<S51>/Constant1'
     */
    CA_CSE1_V1e_wo_LOSV2b_B.Output = CA_CSE1_V1e_wo_LOSV2b_B.Product_c +
      CA_CSE1_V1e_wo_LOSV2b_P.Constant1_Value_i;

    /* Step: '<S50>/Step' */
    currentTime = CA_CSE1_V1e_wo_LOSV2b_M->Timing.t[0];
    if (currentTime < CA_CSE1_V1e_wo_LOSV2b_P.Step_Time_l) {
      CA_CSE1_V1e_wo_LOSV2b_B.Step_f = CA_CSE1_V1e_wo_LOSV2b_P.Step_Y0_k;
    } else {
      CA_CSE1_V1e_wo_LOSV2b_B.Step_f = CA_CSE1_V1e_wo_LOSV2b_P.Step_YFinal_l;
    }

    /* Clock Block: '<S50>/Clock'
     */
    CA_CSE1_V1e_wo_LOSV2b_B.Clock_o = CA_CSE1_V1e_wo_LOSV2b_M->Timing.t[0];

    /* Sum: '<S50>/Sum' incorporates:
     *  Constant: '<S50>/Constant'
     */
    CA_CSE1_V1e_wo_LOSV2b_B.Sum_o = CA_CSE1_V1e_wo_LOSV2b_B.Clock_o -
      CA_CSE1_V1e_wo_LOSV2b_P.Constant_Value_k;

    /* Product: '<S50>/Product' */
    CA_CSE1_V1e_wo_LOSV2b_B.Product_d = CA_CSE1_V1e_wo_LOSV2b_B.Step_f *
      CA_CSE1_V1e_wo_LOSV2b_B.Sum_o;

    /* Sum: '<S50>/Output' incorporates:
     *  Constant: '<S50>/Constant1'
     */
    CA_CSE1_V1e_wo_LOSV2b_B.Output_m = CA_CSE1_V1e_wo_LOSV2b_B.Product_d +
      CA_CSE1_V1e_wo_LOSV2b_P.Constant1_Value_d;
    if (rtmIsMajorTimeStep(CA_CSE1_V1e_wo_LOSV2b_M)) {
      /* Memory: '<S52>/Memory2' */
      CA_CSE1_V1e_wo_LOSV2b_B.Memory2 =
        CA_CSE1_V1e_wo_LOSV2b_DWork.Memory2_PreviousInput;
    }

    /* Sum: '<S52>/Sum2' */
    CA_CSE1_V1e_wo_LOSV2b_B.Sum2_f = CA_CSE1_V1e_wo_LOSV2b_B.Output_m -
      CA_CSE1_V1e_wo_LOSV2b_B.Memory2;
    if (rtmIsMajorTimeStep(CA_CSE1_V1e_wo_LOSV2b_M)) {
      /* Memory: '<S52>/Memory1' */
      CA_CSE1_V1e_wo_LOSV2b_B.Memory1 =
        CA_CSE1_V1e_wo_LOSV2b_DWork.Memory1_PreviousInput;
    }

    /* Integrator: '<S35>/Integrator' */
    CA_CSE1_V1e_wo_LOSV2b_B.Integrator =
      CA_CSE1_V1e_wo_LOSV2b_X.Integrator_CSTATE;

    /* Sum: '<S52>/Sum1' */
    CA_CSE1_V1e_wo_LOSV2b_B.Sum1_h = CA_CSE1_V1e_wo_LOSV2b_B.Integrator -
      CA_CSE1_V1e_wo_LOSV2b_B.Memory1;

    /* Product: '<S52>/Divide1' */
    CA_CSE1_V1e_wo_LOSV2b_B.Divide1 = CA_CSE1_V1e_wo_LOSV2b_B.Sum2_f /
      CA_CSE1_V1e_wo_LOSV2b_B.Sum1_h;
    if (rtmIsMajorTimeStep(CA_CSE1_V1e_wo_LOSV2b_M)) {
      /* Memory: '<S52>/Memory' */
      CA_CSE1_V1e_wo_LOSV2b_B.Memory =
        CA_CSE1_V1e_wo_LOSV2b_DWork.Memory_PreviousInput;
    }

    /* Sum: '<S52>/Sum' */
    CA_CSE1_V1e_wo_LOSV2b_B.Sum_g = CA_CSE1_V1e_wo_LOSV2b_B.Output -
      CA_CSE1_V1e_wo_LOSV2b_B.Memory;

    /* Product: '<S52>/Divide' */
    CA_CSE1_V1e_wo_LOSV2b_B.Divide = CA_CSE1_V1e_wo_LOSV2b_B.Sum_g /
      CA_CSE1_V1e_wo_LOSV2b_B.Sum1_h;

    /* Trigonometry: '<S52>/trigfun1' */
    CA_CSE1_V1e_wo_LOSV2b_B.trigfun1 = rt_atan2_snf
      (CA_CSE1_V1e_wo_LOSV2b_B.Divide1, CA_CSE1_V1e_wo_LOSV2b_B.Divide);

    /* Sum: '<S36>/Sum' */
    CA_CSE1_V1e_wo_LOSV2b_B.Sum_b[0] = CA_CSE1_V1e_wo_LOSV2b_B.eta_surge -
      CA_CSE1_V1e_wo_LOSV2b_B.Output;
    CA_CSE1_V1e_wo_LOSV2b_B.Sum_b[1] = CA_CSE1_V1e_wo_LOSV2b_B.eta_sway -
      CA_CSE1_V1e_wo_LOSV2b_B.Output_m;
    CA_CSE1_V1e_wo_LOSV2b_B.Sum_b[2] = CA_CSE1_V1e_wo_LOSV2b_B.eta_yaw -
      CA_CSE1_V1e_wo_LOSV2b_B.trigfun1;

    /* Fcn: '<S47>/Row1' */
    CA_CSE1_V1e_wo_LOSV2b_B.Row1 = cos(CA_CSE1_V1e_wo_LOSV2b_B.eta_yaw) *
      CA_CSE1_V1e_wo_LOSV2b_B.Sum_b[0] + sin(CA_CSE1_V1e_wo_LOSV2b_B.eta_yaw) *
      CA_CSE1_V1e_wo_LOSV2b_B.Sum_b[1];

    /* Fcn: '<S47>/Row2' */
    CA_CSE1_V1e_wo_LOSV2b_B.Row2 = (-sin(CA_CSE1_V1e_wo_LOSV2b_B.eta_yaw)) *
      CA_CSE1_V1e_wo_LOSV2b_B.Sum_b[0] + cos(CA_CSE1_V1e_wo_LOSV2b_B.eta_yaw) *
      CA_CSE1_V1e_wo_LOSV2b_B.Sum_b[1];

    /* Fcn: '<S47>/Row3' */
    CA_CSE1_V1e_wo_LOSV2b_B.Row3 = CA_CSE1_V1e_wo_LOSV2b_B.Sum_b[2];

    /* SignalConversion: '<S31>/TmpHiddenBufferAtK_pInport1' */
    CA_CSE1_V1e_wo_LOSV2b_B.TmpHiddenBufferAtK_pInport1[0] =
      CA_CSE1_V1e_wo_LOSV2b_B.Row1;
    CA_CSE1_V1e_wo_LOSV2b_B.TmpHiddenBufferAtK_pInport1[1] =
      CA_CSE1_V1e_wo_LOSV2b_B.Row2;
    CA_CSE1_V1e_wo_LOSV2b_B.TmpHiddenBufferAtK_pInport1[2] =
      CA_CSE1_V1e_wo_LOSV2b_B.Row3;

    /* SignalConversion: '<S34>/TmpHiddenBufferAtD_sInport1' */
    CA_CSE1_V1e_wo_LOSV2b_B.TmpHiddenBufferAtD_sInport1[0] =
      CA_CSE1_V1e_wo_LOSV2b_B.nu_surge;
    CA_CSE1_V1e_wo_LOSV2b_B.TmpHiddenBufferAtD_sInport1[1] =
      CA_CSE1_V1e_wo_LOSV2b_B.nu_sway;
    CA_CSE1_V1e_wo_LOSV2b_B.TmpHiddenBufferAtD_sInport1[2] =
      CA_CSE1_V1e_wo_LOSV2b_B.nu_yaw;

    /* Gain: '<S31>/K_p' */
    for (i = 0; i < 3; i++) {
      CA_CSE1_V1e_wo_LOSV2b_B.K_p[i] = 0.0;
      CA_CSE1_V1e_wo_LOSV2b_B.K_p[i] = CA_CSE1_V1e_wo_LOSV2b_P.K_p_Gain[i] *
        CA_CSE1_V1e_wo_LOSV2b_B.TmpHiddenBufferAtK_pInport1[0] +
        CA_CSE1_V1e_wo_LOSV2b_B.K_p[i];
      CA_CSE1_V1e_wo_LOSV2b_B.K_p[i] = CA_CSE1_V1e_wo_LOSV2b_P.K_p_Gain[i + 3] *
        CA_CSE1_V1e_wo_LOSV2b_B.TmpHiddenBufferAtK_pInport1[1] +
        CA_CSE1_V1e_wo_LOSV2b_B.K_p[i];
      CA_CSE1_V1e_wo_LOSV2b_B.K_p[i] = CA_CSE1_V1e_wo_LOSV2b_P.K_p_Gain[i + 6] *
        CA_CSE1_V1e_wo_LOSV2b_B.TmpHiddenBufferAtK_pInport1[2] +
        CA_CSE1_V1e_wo_LOSV2b_B.K_p[i];
    }

    if (rtmIsMajorTimeStep(CA_CSE1_V1e_wo_LOSV2b_M)) {
      /* Memory: '<S52>/Memory3' */
      CA_CSE1_V1e_wo_LOSV2b_B.Memory3 =
        CA_CSE1_V1e_wo_LOSV2b_DWork.Memory3_PreviousInput;
    }

    /* Sum: '<S52>/Sum3' */
    CA_CSE1_V1e_wo_LOSV2b_B.Sum3 = CA_CSE1_V1e_wo_LOSV2b_B.trigfun1 -
      CA_CSE1_V1e_wo_LOSV2b_B.Memory3;

    /* Product: '<S52>/Divide2' */
    CA_CSE1_V1e_wo_LOSV2b_B.Divide2 = CA_CSE1_V1e_wo_LOSV2b_B.Sum3 /
      CA_CSE1_V1e_wo_LOSV2b_B.Sum1_h;

    /* Fcn: '<S38>/Row1' */
    CA_CSE1_V1e_wo_LOSV2b_B.Row1_f = cos(CA_CSE1_V1e_wo_LOSV2b_B.eta_yaw) *
      CA_CSE1_V1e_wo_LOSV2b_B.Divide + sin(CA_CSE1_V1e_wo_LOSV2b_B.eta_yaw) *
      CA_CSE1_V1e_wo_LOSV2b_B.Divide1;

    /* Fcn: '<S38>/Row2' */
    CA_CSE1_V1e_wo_LOSV2b_B.Row2_o = (-sin(CA_CSE1_V1e_wo_LOSV2b_B.eta_yaw)) *
      CA_CSE1_V1e_wo_LOSV2b_B.Divide + cos(CA_CSE1_V1e_wo_LOSV2b_B.eta_yaw) *
      CA_CSE1_V1e_wo_LOSV2b_B.Divide1;

    /* Fcn: '<S38>/Row3' */
    CA_CSE1_V1e_wo_LOSV2b_B.Row3_n = CA_CSE1_V1e_wo_LOSV2b_B.Divide2;

    /* Math: '<S54>/mf1' */
    currentTime = CA_CSE1_V1e_wo_LOSV2b_B.Divide;
    CA_CSE1_V1e_wo_LOSV2b_B.mf1 = currentTime * currentTime;

    /* Math: '<S54>/mf2' */
    currentTime = CA_CSE1_V1e_wo_LOSV2b_B.Divide1;
    CA_CSE1_V1e_wo_LOSV2b_B.mf2 = currentTime * currentTime;

    /* Sum: '<S54>/Sum' */
    CA_CSE1_V1e_wo_LOSV2b_B.Sum_j = CA_CSE1_V1e_wo_LOSV2b_B.mf1 +
      CA_CSE1_V1e_wo_LOSV2b_B.mf2;

    /* Math: '<S54>/Sqrt' */
    currentTime = CA_CSE1_V1e_wo_LOSV2b_B.Sum_j;
    if (currentTime < 0.0) {
      CA_CSE1_V1e_wo_LOSV2b_B.Sqrt = -sqrt(-currentTime);
    } else {
      CA_CSE1_V1e_wo_LOSV2b_B.Sqrt = sqrt(currentTime);
    }

    /* Embedded MATLAB: '<S54>/null checker' */
    CA_CSE1_V1e_wo_LOSV_nullchecker(CA_CSE1_V1e_wo_LOSV2b_B.Sqrt,
      &CA_CSE1_V1e_wo_LOSV2b_B.sf_nullchecker);

    /* Product: '<S54>/Divide1' incorporates:
     *  Constant: '<S49>/U_d'
     */
    CA_CSE1_V1e_wo_LOSV2b_B.Divide1_o = CA_CSE1_V1e_wo_LOSV2b_P.U_d_Value /
      CA_CSE1_V1e_wo_LOSV2b_B.sf_nullchecker.y;

    /* Product: '<S31>/Product1' */
    CA_CSE1_V1e_wo_LOSV2b_B.Product1_o[0] = CA_CSE1_V1e_wo_LOSV2b_B.Row1_f *
      CA_CSE1_V1e_wo_LOSV2b_B.Divide1_o;
    CA_CSE1_V1e_wo_LOSV2b_B.Product1_o[1] = CA_CSE1_V1e_wo_LOSV2b_B.Row2_o *
      CA_CSE1_V1e_wo_LOSV2b_B.Divide1_o;
    CA_CSE1_V1e_wo_LOSV2b_B.Product1_o[2] = CA_CSE1_V1e_wo_LOSV2b_B.Row3_n *
      CA_CSE1_V1e_wo_LOSV2b_B.Divide1_o;

    /* Sum: '<S31>/Sum' */
    CA_CSE1_V1e_wo_LOSV2b_B.Sum_e[0] = CA_CSE1_V1e_wo_LOSV2b_B.Product1_o[0] -
      CA_CSE1_V1e_wo_LOSV2b_B.K_p[0];

    /* Sum: '<S37>/Sum' */
    CA_CSE1_V1e_wo_LOSV2b_B.Sum_ei[0] =
      CA_CSE1_V1e_wo_LOSV2b_B.TmpHiddenBufferAtD_sInport1[0] -
      CA_CSE1_V1e_wo_LOSV2b_B.Sum_e[0];

    /* Sum: '<S31>/Sum' */
    CA_CSE1_V1e_wo_LOSV2b_B.Sum_e[1] = CA_CSE1_V1e_wo_LOSV2b_B.Product1_o[1] -
      CA_CSE1_V1e_wo_LOSV2b_B.K_p[1];

    /* Sum: '<S37>/Sum' */
    CA_CSE1_V1e_wo_LOSV2b_B.Sum_ei[1] =
      CA_CSE1_V1e_wo_LOSV2b_B.TmpHiddenBufferAtD_sInport1[1] -
      CA_CSE1_V1e_wo_LOSV2b_B.Sum_e[1];

    /* Sum: '<S31>/Sum' */
    CA_CSE1_V1e_wo_LOSV2b_B.Sum_e[2] = CA_CSE1_V1e_wo_LOSV2b_B.Product1_o[2] -
      CA_CSE1_V1e_wo_LOSV2b_B.K_p[2];

    /* Sum: '<S37>/Sum' */
    CA_CSE1_V1e_wo_LOSV2b_B.Sum_ei[2] =
      CA_CSE1_V1e_wo_LOSV2b_B.TmpHiddenBufferAtD_sInport1[2] -
      CA_CSE1_V1e_wo_LOSV2b_B.Sum_e[2];
    for (i = 0; i < 3; i++) {
      /* Gain: '<S34>/K_d' */
      CA_CSE1_V1e_wo_LOSV2b_B.K_d[i] = 0.0;
      CA_CSE1_V1e_wo_LOSV2b_B.K_d[i] = CA_CSE1_V1e_wo_LOSV2b_P.K_d_Gain[i] *
        CA_CSE1_V1e_wo_LOSV2b_B.Sum_ei[0] + CA_CSE1_V1e_wo_LOSV2b_B.K_d[i];
      CA_CSE1_V1e_wo_LOSV2b_B.K_d[i] = CA_CSE1_V1e_wo_LOSV2b_P.K_d_Gain[i + 3] *
        CA_CSE1_V1e_wo_LOSV2b_B.Sum_ei[1] + CA_CSE1_V1e_wo_LOSV2b_B.K_d[i];
      CA_CSE1_V1e_wo_LOSV2b_B.K_d[i] = CA_CSE1_V1e_wo_LOSV2b_P.K_d_Gain[i + 6] *
        CA_CSE1_V1e_wo_LOSV2b_B.Sum_ei[2] + CA_CSE1_V1e_wo_LOSV2b_B.K_d[i];

      /* Gain: '<S34>/D_s' */
      CA_CSE1_V1e_wo_LOSV2b_B.D_s[i] = 0.0;
      CA_CSE1_V1e_wo_LOSV2b_B.D_s[i] = CA_CSE1_V1e_wo_LOSV2b_P.D_s_Gain[i] *
        CA_CSE1_V1e_wo_LOSV2b_B.TmpHiddenBufferAtD_sInport1[0] +
        CA_CSE1_V1e_wo_LOSV2b_B.D_s[i];
      CA_CSE1_V1e_wo_LOSV2b_B.D_s[i] = CA_CSE1_V1e_wo_LOSV2b_P.D_s_Gain[i + 3] *
        CA_CSE1_V1e_wo_LOSV2b_B.TmpHiddenBufferAtD_sInport1[1] +
        CA_CSE1_V1e_wo_LOSV2b_B.D_s[i];
      CA_CSE1_V1e_wo_LOSV2b_B.D_s[i] = CA_CSE1_V1e_wo_LOSV2b_P.D_s_Gain[i + 6] *
        CA_CSE1_V1e_wo_LOSV2b_B.TmpHiddenBufferAtD_sInport1[2] +
        CA_CSE1_V1e_wo_LOSV2b_B.D_s[i];

      /* Gain: '<S33>/S' */
      CA_CSE1_V1e_wo_LOSV2b_B.S[i] = 0.0;
      CA_CSE1_V1e_wo_LOSV2b_B.S[i] = CA_CSE1_V1e_wo_LOSV2b_P.S_Gain[i] *
        CA_CSE1_V1e_wo_LOSV2b_B.TmpHiddenBufferAtK_pInport1[0] +
        CA_CSE1_V1e_wo_LOSV2b_B.S[i];
      CA_CSE1_V1e_wo_LOSV2b_B.S[i] = CA_CSE1_V1e_wo_LOSV2b_P.S_Gain[i + 3] *
        CA_CSE1_V1e_wo_LOSV2b_B.TmpHiddenBufferAtK_pInport1[1] +
        CA_CSE1_V1e_wo_LOSV2b_B.S[i];
      CA_CSE1_V1e_wo_LOSV2b_B.S[i] = CA_CSE1_V1e_wo_LOSV2b_P.S_Gain[i + 6] *
        CA_CSE1_V1e_wo_LOSV2b_B.TmpHiddenBufferAtK_pInport1[2] +
        CA_CSE1_V1e_wo_LOSV2b_B.S[i];

      /* Product: '<S33>/Product1' */
      CA_CSE1_V1e_wo_LOSV2b_B.Product1_o0[i] = CA_CSE1_V1e_wo_LOSV2b_B.nu_yaw *
        CA_CSE1_V1e_wo_LOSV2b_B.S[i];

      /* Sum: '<S33>/Sum1' */
      CA_CSE1_V1e_wo_LOSV2b_B.Sum1_b[i] =
        CA_CSE1_V1e_wo_LOSV2b_B.TmpHiddenBufferAtD_sInport1[i] -
        CA_CSE1_V1e_wo_LOSV2b_B.Product1_o0[i];
    }

    /* Fcn: '<S41>/Row1' */
    CA_CSE1_V1e_wo_LOSV2b_B.Row1_g = cos(CA_CSE1_V1e_wo_LOSV2b_B.eta_yaw) *
      CA_CSE1_V1e_wo_LOSV2b_B.Divide + sin(CA_CSE1_V1e_wo_LOSV2b_B.eta_yaw) *
      CA_CSE1_V1e_wo_LOSV2b_B.Divide1;

    /* Fcn: '<S41>/Row2' */
    CA_CSE1_V1e_wo_LOSV2b_B.Row2_m = (-sin(CA_CSE1_V1e_wo_LOSV2b_B.eta_yaw)) *
      CA_CSE1_V1e_wo_LOSV2b_B.Divide + cos(CA_CSE1_V1e_wo_LOSV2b_B.eta_yaw) *
      CA_CSE1_V1e_wo_LOSV2b_B.Divide1;

    /* Fcn: '<S41>/Row3' */
    CA_CSE1_V1e_wo_LOSV2b_B.Row3_p = CA_CSE1_V1e_wo_LOSV2b_B.Divide2;

    /* SignalConversion: '<S33>/TmpHiddenBufferAtProduct6Inport2' */
    CA_CSE1_V1e_wo_LOSV2b_B.TmpHiddenBufferAtProduct6Inport[0] =
      CA_CSE1_V1e_wo_LOSV2b_B.Row1_g;
    CA_CSE1_V1e_wo_LOSV2b_B.TmpHiddenBufferAtProduct6Inport[1] =
      CA_CSE1_V1e_wo_LOSV2b_B.Row2_m;
    CA_CSE1_V1e_wo_LOSV2b_B.TmpHiddenBufferAtProduct6Inport[2] =
      CA_CSE1_V1e_wo_LOSV2b_B.Row3_p;
    for (i = 0; i < 3; i++) {
      /* Gain: '<S33>/K_p' */
      CA_CSE1_V1e_wo_LOSV2b_B.K_p_n[i] = 0.0;
      CA_CSE1_V1e_wo_LOSV2b_B.K_p_n[i] = CA_CSE1_V1e_wo_LOSV2b_P.K_p_Gain_k[i] *
        CA_CSE1_V1e_wo_LOSV2b_B.Sum1_b[0] + CA_CSE1_V1e_wo_LOSV2b_B.K_p_n[i];
      CA_CSE1_V1e_wo_LOSV2b_B.K_p_n[i] = CA_CSE1_V1e_wo_LOSV2b_P.K_p_Gain_k[i +
        3] * CA_CSE1_V1e_wo_LOSV2b_B.Sum1_b[1] + CA_CSE1_V1e_wo_LOSV2b_B.K_p_n[i];
      CA_CSE1_V1e_wo_LOSV2b_B.K_p_n[i] = CA_CSE1_V1e_wo_LOSV2b_P.K_p_Gain_k[i +
        6] * CA_CSE1_V1e_wo_LOSV2b_B.Sum1_b[2] + CA_CSE1_V1e_wo_LOSV2b_B.K_p_n[i];
      tmp_1[i] = 0.0;
      currentTime = tmp_1[i];
      currentTime += CA_CSE1_V1e_wo_LOSV2b_P.S1_Value[i] *
        CA_CSE1_V1e_wo_LOSV2b_B.TmpHiddenBufferAtProduct6Inport[0];
      tmp_1[i] = currentTime;
      currentTime = tmp_1[i];
      currentTime += CA_CSE1_V1e_wo_LOSV2b_P.S1_Value[i + 3] *
        CA_CSE1_V1e_wo_LOSV2b_B.TmpHiddenBufferAtProduct6Inport[1];
      tmp_1[i] = currentTime;
      currentTime = tmp_1[i];
      currentTime += CA_CSE1_V1e_wo_LOSV2b_P.S1_Value[i + 6] *
        CA_CSE1_V1e_wo_LOSV2b_B.TmpHiddenBufferAtProduct6Inport[2];
      tmp_1[i] = currentTime;
      CA_CSE1_V1e_wo_LOSV2b_B.Product6[i] = tmp_1[i] *
        CA_CSE1_V1e_wo_LOSV2b_B.Divide1_o;

      /* Product: '<S33>/Product5' */
      CA_CSE1_V1e_wo_LOSV2b_B.Product5[i] = CA_CSE1_V1e_wo_LOSV2b_B.nu_yaw *
        CA_CSE1_V1e_wo_LOSV2b_B.Product6[i];
    }

    /* Derivative Block: '<S54>/Derivative' */
    {
      real_T t = CA_CSE1_V1e_wo_LOSV2b_M->Timing.t[0];
      real_T timeStampA =
        CA_CSE1_V1e_wo_LOSV2b_DWork.Derivative_RWORK_m.TimeStampA;
      real_T timeStampB =
        CA_CSE1_V1e_wo_LOSV2b_DWork.Derivative_RWORK_m.TimeStampB;
      if (timeStampA >= t && timeStampB >= t) {
        CA_CSE1_V1e_wo_LOSV2b_B.Derivative_o = 0.0;
      } else {
        real_T deltaT;
        real_T *lastBank =
          &CA_CSE1_V1e_wo_LOSV2b_DWork.Derivative_RWORK_m.TimeStampA;
        if (timeStampA < timeStampB) {
          if (timeStampB < t) {
            lastBank += 2;
          }
        } else if (timeStampA >= t) {
          lastBank += 2;
        }

        deltaT = t - *lastBank++;
        CA_CSE1_V1e_wo_LOSV2b_B.Derivative_o =
          (CA_CSE1_V1e_wo_LOSV2b_P.U_d_Value - *lastBank++) / deltaT;
      }
    }

    /* Embedded MATLAB: '<S54>/null checker1' */
    CA_CSE1_V1e_wo_LOSV_nullchecker(CA_CSE1_V1e_wo_LOSV2b_B.Sqrt,
      &CA_CSE1_V1e_wo_LOSV2b_B.sf_nullchecker1);

    /* Product: '<S54>/Divide' */
    CA_CSE1_V1e_wo_LOSV2b_B.Divide_g = CA_CSE1_V1e_wo_LOSV2b_B.Derivative_o /
      CA_CSE1_V1e_wo_LOSV2b_B.sf_nullchecker1.y;

    /* Product: '<S33>/Product3' */
    CA_CSE1_V1e_wo_LOSV2b_B.Product3[0] =
      CA_CSE1_V1e_wo_LOSV2b_B.TmpHiddenBufferAtProduct6Inport[0] *
      CA_CSE1_V1e_wo_LOSV2b_B.Divide_g;

    /* Sum: '<S33>/Sum' */
    CA_CSE1_V1e_wo_LOSV2b_B.Sum_jh[0] = (CA_CSE1_V1e_wo_LOSV2b_B.Product3[0] -
      CA_CSE1_V1e_wo_LOSV2b_B.K_p_n[0]) - CA_CSE1_V1e_wo_LOSV2b_B.Product5[0];

    /* Product: '<S33>/Product3' */
    CA_CSE1_V1e_wo_LOSV2b_B.Product3[1] =
      CA_CSE1_V1e_wo_LOSV2b_B.TmpHiddenBufferAtProduct6Inport[1] *
      CA_CSE1_V1e_wo_LOSV2b_B.Divide_g;

    /* Sum: '<S33>/Sum' */
    CA_CSE1_V1e_wo_LOSV2b_B.Sum_jh[1] = (CA_CSE1_V1e_wo_LOSV2b_B.Product3[1] -
      CA_CSE1_V1e_wo_LOSV2b_B.K_p_n[1]) - CA_CSE1_V1e_wo_LOSV2b_B.Product5[1];

    /* Product: '<S33>/Product3' */
    CA_CSE1_V1e_wo_LOSV2b_B.Product3[2] =
      CA_CSE1_V1e_wo_LOSV2b_B.TmpHiddenBufferAtProduct6Inport[2] *
      CA_CSE1_V1e_wo_LOSV2b_B.Divide_g;

    /* Sum: '<S33>/Sum' */
    CA_CSE1_V1e_wo_LOSV2b_B.Sum_jh[2] = (CA_CSE1_V1e_wo_LOSV2b_B.Product3[2] -
      CA_CSE1_V1e_wo_LOSV2b_B.K_p_n[2]) - CA_CSE1_V1e_wo_LOSV2b_B.Product5[2];

    /* Fcn: '<S39>/Row1' */
    CA_CSE1_V1e_wo_LOSV2b_B.Row1_n = cos(CA_CSE1_V1e_wo_LOSV2b_B.eta_yaw) *
      CA_CSE1_V1e_wo_LOSV2b_B.Divide + sin(CA_CSE1_V1e_wo_LOSV2b_B.eta_yaw) *
      CA_CSE1_V1e_wo_LOSV2b_B.Divide1;

    /* Fcn: '<S39>/Row2' */
    CA_CSE1_V1e_wo_LOSV2b_B.Row2_i = (-sin(CA_CSE1_V1e_wo_LOSV2b_B.eta_yaw)) *
      CA_CSE1_V1e_wo_LOSV2b_B.Divide + cos(CA_CSE1_V1e_wo_LOSV2b_B.eta_yaw) *
      CA_CSE1_V1e_wo_LOSV2b_B.Divide1;

    /* Fcn: '<S39>/Row3' */
    CA_CSE1_V1e_wo_LOSV2b_B.Row3_d = CA_CSE1_V1e_wo_LOSV2b_B.Divide2;

    /* SignalConversion: '<S32>/TmpHiddenBufferAtK_pInport1' */
    CA_CSE1_V1e_wo_LOSV2b_B.TmpHiddenBufferAtK_pInport1_a[0] =
      CA_CSE1_V1e_wo_LOSV2b_B.Row1_n;
    CA_CSE1_V1e_wo_LOSV2b_B.TmpHiddenBufferAtK_pInport1_a[1] =
      CA_CSE1_V1e_wo_LOSV2b_B.Row2_i;
    CA_CSE1_V1e_wo_LOSV2b_B.TmpHiddenBufferAtK_pInport1_a[2] =
      CA_CSE1_V1e_wo_LOSV2b_B.Row3_d;
    for (i = 0; i < 3; i++) {
      /* Gain: '<S34>/M_s' */
      CA_CSE1_V1e_wo_LOSV2b_B.M_s[i] = 0.0;
      CA_CSE1_V1e_wo_LOSV2b_B.M_s[i] = CA_CSE1_V1e_wo_LOSV2b_P.M_s_Gain[i] *
        CA_CSE1_V1e_wo_LOSV2b_B.Sum_jh[0] + CA_CSE1_V1e_wo_LOSV2b_B.M_s[i];
      CA_CSE1_V1e_wo_LOSV2b_B.M_s[i] = CA_CSE1_V1e_wo_LOSV2b_P.M_s_Gain[i + 3] *
        CA_CSE1_V1e_wo_LOSV2b_B.Sum_jh[1] + CA_CSE1_V1e_wo_LOSV2b_B.M_s[i];
      CA_CSE1_V1e_wo_LOSV2b_B.M_s[i] = CA_CSE1_V1e_wo_LOSV2b_P.M_s_Gain[i + 6] *
        CA_CSE1_V1e_wo_LOSV2b_B.Sum_jh[2] + CA_CSE1_V1e_wo_LOSV2b_B.M_s[i];

      /* Gain: '<S32>/K_p' */
      CA_CSE1_V1e_wo_LOSV2b_B.K_p_f[i] = 0.0;
      CA_CSE1_V1e_wo_LOSV2b_B.K_p_f[i] = CA_CSE1_V1e_wo_LOSV2b_P.K_p_Gain_p[i] *
        CA_CSE1_V1e_wo_LOSV2b_B.TmpHiddenBufferAtK_pInport1_a[0] +
        CA_CSE1_V1e_wo_LOSV2b_B.K_p_f[i];
      CA_CSE1_V1e_wo_LOSV2b_B.K_p_f[i] = CA_CSE1_V1e_wo_LOSV2b_P.K_p_Gain_p[i +
        3] * CA_CSE1_V1e_wo_LOSV2b_B.TmpHiddenBufferAtK_pInport1_a[1] +
        CA_CSE1_V1e_wo_LOSV2b_B.K_p_f[i];
      CA_CSE1_V1e_wo_LOSV2b_B.K_p_f[i] = CA_CSE1_V1e_wo_LOSV2b_P.K_p_Gain_p[i +
        6] * CA_CSE1_V1e_wo_LOSV2b_B.TmpHiddenBufferAtK_pInport1_a[2] +
        CA_CSE1_V1e_wo_LOSV2b_B.K_p_f[i];
    }

    if (rtmIsMajorTimeStep(CA_CSE1_V1e_wo_LOSV2b_M)) {
      /* Memory: '<S53>/Memory' */
      CA_CSE1_V1e_wo_LOSV2b_B.Memory_n =
        CA_CSE1_V1e_wo_LOSV2b_DWork.Memory_PreviousInput_d;
    }

    /* Sum: '<S53>/Sum' */
    CA_CSE1_V1e_wo_LOSV2b_B.Sum_n = CA_CSE1_V1e_wo_LOSV2b_B.Divide -
      CA_CSE1_V1e_wo_LOSV2b_B.Memory_n;
    if (rtmIsMajorTimeStep(CA_CSE1_V1e_wo_LOSV2b_M)) {
      /* Memory: '<S53>/Memory1' */
      CA_CSE1_V1e_wo_LOSV2b_B.Memory1_o =
        CA_CSE1_V1e_wo_LOSV2b_DWork.Memory1_PreviousInput_g;
    }

    /* Sum: '<S53>/Sum1' */
    CA_CSE1_V1e_wo_LOSV2b_B.Sum1_c = CA_CSE1_V1e_wo_LOSV2b_B.Integrator -
      CA_CSE1_V1e_wo_LOSV2b_B.Memory1_o;

    /* Product: '<S53>/Divide' */
    CA_CSE1_V1e_wo_LOSV2b_B.Divide_d = CA_CSE1_V1e_wo_LOSV2b_B.Sum_n /
      CA_CSE1_V1e_wo_LOSV2b_B.Sum1_c;

    /* Product: '<S55>/Product' */
    CA_CSE1_V1e_wo_LOSV2b_B.Product_p = CA_CSE1_V1e_wo_LOSV2b_B.Divide *
      CA_CSE1_V1e_wo_LOSV2b_B.Divide_d;
    if (rtmIsMajorTimeStep(CA_CSE1_V1e_wo_LOSV2b_M)) {
      /* Memory: '<S53>/Memory2' */
      CA_CSE1_V1e_wo_LOSV2b_B.Memory2_k =
        CA_CSE1_V1e_wo_LOSV2b_DWork.Memory2_PreviousInput_e;
    }

    /* Sum: '<S53>/Sum2' */
    CA_CSE1_V1e_wo_LOSV2b_B.Sum2_m = CA_CSE1_V1e_wo_LOSV2b_B.Divide1 -
      CA_CSE1_V1e_wo_LOSV2b_B.Memory2_k;

    /* Product: '<S53>/Divide1' */
    CA_CSE1_V1e_wo_LOSV2b_B.Divide1_m = CA_CSE1_V1e_wo_LOSV2b_B.Sum2_m /
      CA_CSE1_V1e_wo_LOSV2b_B.Sum1_c;

    /* Product: '<S55>/Product1' */
    CA_CSE1_V1e_wo_LOSV2b_B.Product1_g = CA_CSE1_V1e_wo_LOSV2b_B.Divide1 *
      CA_CSE1_V1e_wo_LOSV2b_B.Divide1_m;

    /* Sum: '<S55>/Sum' */
    CA_CSE1_V1e_wo_LOSV2b_B.Sum_k = CA_CSE1_V1e_wo_LOSV2b_B.Product_p +
      CA_CSE1_V1e_wo_LOSV2b_B.Product1_g;

    /* Gain: '<S55>/Gain' */
    CA_CSE1_V1e_wo_LOSV2b_B.Gain = CA_CSE1_V1e_wo_LOSV2b_P.Gain_Gain *
      CA_CSE1_V1e_wo_LOSV2b_B.Sum_k;

    /* Math: '<S55>/mf1' */
    currentTime = CA_CSE1_V1e_wo_LOSV2b_B.Divide;
    CA_CSE1_V1e_wo_LOSV2b_B.mf1_f = currentTime * currentTime;

    /* Math: '<S55>/mf2' */
    currentTime = CA_CSE1_V1e_wo_LOSV2b_B.Divide1;
    CA_CSE1_V1e_wo_LOSV2b_B.mf2_b = currentTime * currentTime;

    /* Sum: '<S55>/Sum1' */
    CA_CSE1_V1e_wo_LOSV2b_B.Sum1_p = CA_CSE1_V1e_wo_LOSV2b_B.mf1_f +
      CA_CSE1_V1e_wo_LOSV2b_B.mf2_b;

    /* Math: '<S55>/mf3' incorporates:
     *  Constant: '<S55>/power'
     */
    if ((CA_CSE1_V1e_wo_LOSV2b_B.Sum1_p < 0.0) &&
        (CA_CSE1_V1e_wo_LOSV2b_P.power_Value > floor
         (CA_CSE1_V1e_wo_LOSV2b_P.power_Value))) {
      CA_CSE1_V1e_wo_LOSV2b_B.mf3 = -rt_pow_snf(-CA_CSE1_V1e_wo_LOSV2b_B.Sum1_p,
        CA_CSE1_V1e_wo_LOSV2b_P.power_Value);
    } else {
      CA_CSE1_V1e_wo_LOSV2b_B.mf3 = rt_pow_snf(CA_CSE1_V1e_wo_LOSV2b_B.Sum1_p,
        CA_CSE1_V1e_wo_LOSV2b_P.power_Value);
    }

    /* InitialCondition: '<S55>/IC' */
    if ((CA_CSE1_V1e_wo_LOSV2b_DWork.IC_FirstOutputTime == (rtMinusInf)) ||
        (CA_CSE1_V1e_wo_LOSV2b_DWork.IC_FirstOutputTime ==
         CA_CSE1_V1e_wo_LOSV2b_M->Timing.t[0])) {
      CA_CSE1_V1e_wo_LOSV2b_DWork.IC_FirstOutputTime =
        CA_CSE1_V1e_wo_LOSV2b_M->Timing.t[0];
      CA_CSE1_V1e_wo_LOSV2b_B.IC = CA_CSE1_V1e_wo_LOSV2b_P.IC_Value;
    } else {
      CA_CSE1_V1e_wo_LOSV2b_B.IC = CA_CSE1_V1e_wo_LOSV2b_B.mf3;
    }

    /* Product: '<S55>/Divide' */
    CA_CSE1_V1e_wo_LOSV2b_B.Divide_a = CA_CSE1_V1e_wo_LOSV2b_B.Gain /
      CA_CSE1_V1e_wo_LOSV2b_B.IC;

    /* Product: '<S55>/Product2' incorporates:
     *  Constant: '<S49>/U_d'
     */
    CA_CSE1_V1e_wo_LOSV2b_B.Product2 = CA_CSE1_V1e_wo_LOSV2b_B.Divide_a *
      CA_CSE1_V1e_wo_LOSV2b_P.U_d_Value;

    /* Product: '<S32>/Product2' */
    CA_CSE1_V1e_wo_LOSV2b_B.Product2_e[0] = CA_CSE1_V1e_wo_LOSV2b_B.Divide *
      CA_CSE1_V1e_wo_LOSV2b_B.Product2;
    CA_CSE1_V1e_wo_LOSV2b_B.Product2_e[1] = CA_CSE1_V1e_wo_LOSV2b_B.Divide1 *
      CA_CSE1_V1e_wo_LOSV2b_B.Product2;
    CA_CSE1_V1e_wo_LOSV2b_B.Product2_e[2] = CA_CSE1_V1e_wo_LOSV2b_B.Divide2 *
      CA_CSE1_V1e_wo_LOSV2b_B.Product2;
    if (rtmIsMajorTimeStep(CA_CSE1_V1e_wo_LOSV2b_M)) {
      /* Memory: '<S53>/Memory3' */
      CA_CSE1_V1e_wo_LOSV2b_B.Memory3_c =
        CA_CSE1_V1e_wo_LOSV2b_DWork.Memory3_PreviousInput_n;
    }

    /* Sum: '<S53>/Sum3' */
    CA_CSE1_V1e_wo_LOSV2b_B.Sum3_g = CA_CSE1_V1e_wo_LOSV2b_B.Divide2 -
      CA_CSE1_V1e_wo_LOSV2b_B.Memory3_c;

    /* Product: '<S53>/Divide2' */
    CA_CSE1_V1e_wo_LOSV2b_B.Divide2_o = CA_CSE1_V1e_wo_LOSV2b_B.Sum3_g /
      CA_CSE1_V1e_wo_LOSV2b_B.Sum1_c;

    /* Product: '<S32>/Product1' */
    CA_CSE1_V1e_wo_LOSV2b_B.Product1_o3[0] = CA_CSE1_V1e_wo_LOSV2b_B.Divide_d *
      CA_CSE1_V1e_wo_LOSV2b_B.Divide1_o;
    CA_CSE1_V1e_wo_LOSV2b_B.Product1_o3[1] = CA_CSE1_V1e_wo_LOSV2b_B.Divide1_m *
      CA_CSE1_V1e_wo_LOSV2b_B.Divide1_o;
    CA_CSE1_V1e_wo_LOSV2b_B.Product1_o3[2] = CA_CSE1_V1e_wo_LOSV2b_B.Divide2_o *
      CA_CSE1_V1e_wo_LOSV2b_B.Divide1_o;

    /* Fcn: '<S40>/Row1' */

    /* Sum: '<S32>/Sum1' */
    CA_CSE1_V1e_wo_LOSV2b_B.Sum1_a[0] = CA_CSE1_V1e_wo_LOSV2b_B.Product2_e[0] +
      CA_CSE1_V1e_wo_LOSV2b_B.Product1_o3[0];

    /* Math: '<S45>/Math Function' */
    CA_CSE1_V1e_wo_LOSV2b_B.MathFunction[0] =
      CA_CSE1_V1e_wo_LOSV2b_B.TmpHiddenBufferAtK_pInport1[0];

    /* Sum: '<S32>/Sum1' */
    CA_CSE1_V1e_wo_LOSV2b_B.Sum1_a[1] = CA_CSE1_V1e_wo_LOSV2b_B.Product2_e[1] +
      CA_CSE1_V1e_wo_LOSV2b_B.Product1_o3[1];

    /* Math: '<S45>/Math Function' */
    CA_CSE1_V1e_wo_LOSV2b_B.MathFunction[1] =
      CA_CSE1_V1e_wo_LOSV2b_B.TmpHiddenBufferAtK_pInport1[1];

    /* Sum: '<S32>/Sum1' */
    CA_CSE1_V1e_wo_LOSV2b_B.Sum1_a[2] = CA_CSE1_V1e_wo_LOSV2b_B.Product2_e[2] +
      CA_CSE1_V1e_wo_LOSV2b_B.Product1_o3[2];

    /* Math: '<S45>/Math Function' */
    CA_CSE1_V1e_wo_LOSV2b_B.MathFunction[2] =
      CA_CSE1_V1e_wo_LOSV2b_B.TmpHiddenBufferAtK_pInport1[2];
    CA_CSE1_V1e_wo_LOSV2b_B.Row1_k = cos(CA_CSE1_V1e_wo_LOSV2b_B.eta_yaw) *
      CA_CSE1_V1e_wo_LOSV2b_B.Sum1_a[0] + sin(CA_CSE1_V1e_wo_LOSV2b_B.eta_yaw) *
      CA_CSE1_V1e_wo_LOSV2b_B.Sum1_a[1];

    /* Fcn: '<S40>/Row2' */
    CA_CSE1_V1e_wo_LOSV2b_B.Row2_iy = (-sin(CA_CSE1_V1e_wo_LOSV2b_B.eta_yaw)) *
      CA_CSE1_V1e_wo_LOSV2b_B.Sum1_a[0] + cos(CA_CSE1_V1e_wo_LOSV2b_B.eta_yaw) *
      CA_CSE1_V1e_wo_LOSV2b_B.Sum1_a[1];

    /* Fcn: '<S40>/Row3' */
    CA_CSE1_V1e_wo_LOSV2b_B.Row3_k = CA_CSE1_V1e_wo_LOSV2b_B.Sum1_a[2];

    /* Sum: '<S32>/Sum' */
    CA_CSE1_V1e_wo_LOSV2b_B.Sum_mm[0] = CA_CSE1_V1e_wo_LOSV2b_B.K_p_f[0] +
      CA_CSE1_V1e_wo_LOSV2b_B.Row1_k;
    CA_CSE1_V1e_wo_LOSV2b_B.Sum_mm[1] = CA_CSE1_V1e_wo_LOSV2b_B.K_p_f[1] +
      CA_CSE1_V1e_wo_LOSV2b_B.Row2_iy;
    CA_CSE1_V1e_wo_LOSV2b_B.Sum_mm[2] = CA_CSE1_V1e_wo_LOSV2b_B.K_p_f[2] +
      CA_CSE1_V1e_wo_LOSV2b_B.Row3_k;

    /* Fcn: '<S44>/Row1' */
    CA_CSE1_V1e_wo_LOSV2b_B.Row1_j = cos(CA_CSE1_V1e_wo_LOSV2b_B.eta_yaw) *
      CA_CSE1_V1e_wo_LOSV2b_B.Divide + sin(CA_CSE1_V1e_wo_LOSV2b_B.eta_yaw) *
      CA_CSE1_V1e_wo_LOSV2b_B.Divide1;

    /* Fcn: '<S44>/Row2' */
    CA_CSE1_V1e_wo_LOSV2b_B.Row2_my = (-sin(CA_CSE1_V1e_wo_LOSV2b_B.eta_yaw)) *
      CA_CSE1_V1e_wo_LOSV2b_B.Divide + cos(CA_CSE1_V1e_wo_LOSV2b_B.eta_yaw) *
      CA_CSE1_V1e_wo_LOSV2b_B.Divide1;

    /* Fcn: '<S44>/Row3' */
    CA_CSE1_V1e_wo_LOSV2b_B.Row3_e = CA_CSE1_V1e_wo_LOSV2b_B.Divide2;

    /* SignalConversion: '<S35>/TmpHiddenBufferAtProduct1Inport2' */
    CA_CSE1_V1e_wo_LOSV2b_B.TmpHiddenBufferAtProduct1Inpo_g[0] =
      CA_CSE1_V1e_wo_LOSV2b_B.Row1_j;
    CA_CSE1_V1e_wo_LOSV2b_B.TmpHiddenBufferAtProduct1Inpo_g[1] =
      CA_CSE1_V1e_wo_LOSV2b_B.Row2_my;
    CA_CSE1_V1e_wo_LOSV2b_B.TmpHiddenBufferAtProduct1Inpo_g[2] =
      CA_CSE1_V1e_wo_LOSV2b_B.Row3_e;

    /* Product: '<S35>/Product1' */
    currentTime = CA_CSE1_V1e_wo_LOSV2b_B.MathFunction[0] *
      CA_CSE1_V1e_wo_LOSV2b_B.TmpHiddenBufferAtProduct1Inpo_g[0];
    currentTime += CA_CSE1_V1e_wo_LOSV2b_B.MathFunction[1] *
      CA_CSE1_V1e_wo_LOSV2b_B.TmpHiddenBufferAtProduct1Inpo_g[1];
    currentTime += CA_CSE1_V1e_wo_LOSV2b_B.MathFunction[2] *
      CA_CSE1_V1e_wo_LOSV2b_B.TmpHiddenBufferAtProduct1Inpo_g[2];
    CA_CSE1_V1e_wo_LOSV2b_B.Product1_p = currentTime;
    for (i = 0; i < 3; i++) {
      /* Math: '<S46>/Math Function' */
      CA_CSE1_V1e_wo_LOSV2b_B.MathFunction_o[i] =
        CA_CSE1_V1e_wo_LOSV2b_B.Sum_ei[i];

      /* Gain: '<S35>/M_s' */
      CA_CSE1_V1e_wo_LOSV2b_B.M_s_a[i] = 0.0;
      CA_CSE1_V1e_wo_LOSV2b_B.M_s_a[i] = CA_CSE1_V1e_wo_LOSV2b_P.M_s_Gain_f[i] *
        CA_CSE1_V1e_wo_LOSV2b_B.Sum_mm[0] + CA_CSE1_V1e_wo_LOSV2b_B.M_s_a[i];
      CA_CSE1_V1e_wo_LOSV2b_B.M_s_a[i] = CA_CSE1_V1e_wo_LOSV2b_P.M_s_Gain_f[i +
        3] * CA_CSE1_V1e_wo_LOSV2b_B.Sum_mm[1] + CA_CSE1_V1e_wo_LOSV2b_B.M_s_a[i];
      CA_CSE1_V1e_wo_LOSV2b_B.M_s_a[i] = CA_CSE1_V1e_wo_LOSV2b_P.M_s_Gain_f[i +
        6] * CA_CSE1_V1e_wo_LOSV2b_B.Sum_mm[2] + CA_CSE1_V1e_wo_LOSV2b_B.M_s_a[i];
    }

    /* Product: '<S35>/Product' */
    currentTime = CA_CSE1_V1e_wo_LOSV2b_B.MathFunction_o[0] *
      CA_CSE1_V1e_wo_LOSV2b_B.M_s_a[0];
    currentTime += CA_CSE1_V1e_wo_LOSV2b_B.MathFunction_o[1] *
      CA_CSE1_V1e_wo_LOSV2b_B.M_s_a[1];
    currentTime += CA_CSE1_V1e_wo_LOSV2b_B.MathFunction_o[2] *
      CA_CSE1_V1e_wo_LOSV2b_B.M_s_a[2];
    CA_CSE1_V1e_wo_LOSV2b_B.Product_h2 = currentTime;

    /* Sum: '<S35>/Sum1' */
    CA_CSE1_V1e_wo_LOSV2b_B.Sum1_be = CA_CSE1_V1e_wo_LOSV2b_B.Product1_p +
      CA_CSE1_V1e_wo_LOSV2b_B.Product_h2;

    /* Gain: '<S35>/mu' */
    CA_CSE1_V1e_wo_LOSV2b_B.mu = CA_CSE1_V1e_wo_LOSV2b_P.mu_Gain *
      CA_CSE1_V1e_wo_LOSV2b_B.Sum1_be;

    /* Sum: '<S35>/Sum' */
    CA_CSE1_V1e_wo_LOSV2b_B.Sum_d = CA_CSE1_V1e_wo_LOSV2b_B.Divide1_o -
      CA_CSE1_V1e_wo_LOSV2b_B.mu;

    /* Product: '<S34>/Product' */
    CA_CSE1_V1e_wo_LOSV2b_B.Product_cb[0] = CA_CSE1_V1e_wo_LOSV2b_B.Sum_mm[0] *
      CA_CSE1_V1e_wo_LOSV2b_B.Sum_d;
    CA_CSE1_V1e_wo_LOSV2b_B.Product_cb[1] = CA_CSE1_V1e_wo_LOSV2b_B.Sum_mm[1] *
      CA_CSE1_V1e_wo_LOSV2b_B.Sum_d;
    CA_CSE1_V1e_wo_LOSV2b_B.Product_cb[2] = CA_CSE1_V1e_wo_LOSV2b_B.Sum_mm[2] *
      CA_CSE1_V1e_wo_LOSV2b_B.Sum_d;

    /* Gain: '<S63>/QTM In10' */
    CA_CSE1_V1e_wo_LOSV2b_B.QTMIn10 = CA_CSE1_V1e_wo_LOSV2b_P.QTMIn10_Gain *
      CA_CSE1_V1e_wo_LOSV2b_B.QTMIn[9];

    /* Gain: '<S63>/mm2m x1' */
    CA_CSE1_V1e_wo_LOSV2b_B.mm2mx1 = CA_CSE1_V1e_wo_LOSV2b_P.mm2mx1_Gain *
      CA_CSE1_V1e_wo_LOSV2b_B.QTMIn10;

    /* Gain: '<S4>/eta_i_surge' */
    CA_CSE1_V1e_wo_LOSV2b_B.eta_i_surge =
      CA_CSE1_V1e_wo_LOSV2b_P.eta_i_surge_Gain * CA_CSE1_V1e_wo_LOSV2b_B.mm2mx1;

    /* Gain: '<S63>/QTM In11' */
    CA_CSE1_V1e_wo_LOSV2b_B.QTMIn11 = CA_CSE1_V1e_wo_LOSV2b_P.QTMIn11_Gain *
      CA_CSE1_V1e_wo_LOSV2b_B.QTMIn[10];

    /* Gain: '<S63>/mm2m y1' */
    CA_CSE1_V1e_wo_LOSV2b_B.mm2my1 = CA_CSE1_V1e_wo_LOSV2b_P.mm2my1_Gain *
      CA_CSE1_V1e_wo_LOSV2b_B.QTMIn11;

    /* Gain: '<S4>/eta_i_sway' */
    CA_CSE1_V1e_wo_LOSV2b_B.eta_i_sway = CA_CSE1_V1e_wo_LOSV2b_P.eta_i_sway_Gain
      * CA_CSE1_V1e_wo_LOSV2b_B.mm2my1;

    /* Gain: '<S63>/QTM In13' */
    CA_CSE1_V1e_wo_LOSV2b_B.QTMIn13 = CA_CSE1_V1e_wo_LOSV2b_P.QTMIn13_Gain *
      CA_CSE1_V1e_wo_LOSV2b_B.QTMIn[12];

    /* Gain: '<S63>/d2r yaw1' */
    CA_CSE1_V1e_wo_LOSV2b_B.d2ryaw1 = CA_CSE1_V1e_wo_LOSV2b_P.d2ryaw1_Gain *
      CA_CSE1_V1e_wo_LOSV2b_B.QTMIn13;

    /* Gain: '<S4>/eta_i_yaw' */
    CA_CSE1_V1e_wo_LOSV2b_B.eta_i_yaw = CA_CSE1_V1e_wo_LOSV2b_P.eta_i_yaw_Gain *
      CA_CSE1_V1e_wo_LOSV2b_B.d2ryaw1;

    /* Sum: '<S11>/Sum' */
    CA_CSE1_V1e_wo_LOSV2b_B.Sum_c[0] = CA_CSE1_V1e_wo_LOSV2b_B.eta_surge -
      CA_CSE1_V1e_wo_LOSV2b_B.eta_i_surge;
    CA_CSE1_V1e_wo_LOSV2b_B.Sum_c[1] = CA_CSE1_V1e_wo_LOSV2b_B.eta_sway -
      CA_CSE1_V1e_wo_LOSV2b_B.eta_i_sway;
    CA_CSE1_V1e_wo_LOSV2b_B.Sum_c[2] = CA_CSE1_V1e_wo_LOSV2b_B.eta_yaw -
      CA_CSE1_V1e_wo_LOSV2b_B.eta_i_yaw;
    for (i = 0; i < 3; i++) {
      /* Gain: '<S34>/M_s1' */
      CA_CSE1_V1e_wo_LOSV2b_B.M_s1[i] = 0.0;
      CA_CSE1_V1e_wo_LOSV2b_B.M_s1[i] = CA_CSE1_V1e_wo_LOSV2b_P.M_s1_Gain[i] *
        CA_CSE1_V1e_wo_LOSV2b_B.Product_cb[0] + CA_CSE1_V1e_wo_LOSV2b_B.M_s1[i];
      CA_CSE1_V1e_wo_LOSV2b_B.M_s1[i] = CA_CSE1_V1e_wo_LOSV2b_P.M_s1_Gain[i + 3]
        * CA_CSE1_V1e_wo_LOSV2b_B.Product_cb[1] + CA_CSE1_V1e_wo_LOSV2b_B.M_s1[i];
      CA_CSE1_V1e_wo_LOSV2b_B.M_s1[i] = CA_CSE1_V1e_wo_LOSV2b_P.M_s1_Gain[i + 6]
        * CA_CSE1_V1e_wo_LOSV2b_B.Product_cb[2] + CA_CSE1_V1e_wo_LOSV2b_B.M_s1[i];

      /* Gain: '<S11>/K_tow' */
      CA_CSE1_V1e_wo_LOSV2b_B.K_tow[i] = 0.0;
      CA_CSE1_V1e_wo_LOSV2b_B.K_tow[i] = CA_CSE1_V1e_wo_LOSV2b_P.K_tow_Gain[i] *
        CA_CSE1_V1e_wo_LOSV2b_B.Sum_c[0] + CA_CSE1_V1e_wo_LOSV2b_B.K_tow[i];
      CA_CSE1_V1e_wo_LOSV2b_B.K_tow[i] = CA_CSE1_V1e_wo_LOSV2b_P.K_tow_Gain[i +
        3] * CA_CSE1_V1e_wo_LOSV2b_B.Sum_c[1] + CA_CSE1_V1e_wo_LOSV2b_B.K_tow[i];
      CA_CSE1_V1e_wo_LOSV2b_B.K_tow[i] = CA_CSE1_V1e_wo_LOSV2b_P.K_tow_Gain[i +
        6] * CA_CSE1_V1e_wo_LOSV2b_B.Sum_c[2] + CA_CSE1_V1e_wo_LOSV2b_B.K_tow[i];
    }

    /* Fcn: '<S42>/Row1' */
    CA_CSE1_V1e_wo_LOSV2b_B.Row1_o = cos(CA_CSE1_V1e_wo_LOSV2b_B.eta_yaw) *
      CA_CSE1_V1e_wo_LOSV2b_B.K_tow[0] + sin(CA_CSE1_V1e_wo_LOSV2b_B.eta_yaw) *
      CA_CSE1_V1e_wo_LOSV2b_B.K_tow[1];

    /* Fcn: '<S42>/Row2' */
    CA_CSE1_V1e_wo_LOSV2b_B.Row2_b = (-sin(CA_CSE1_V1e_wo_LOSV2b_B.eta_yaw)) *
      CA_CSE1_V1e_wo_LOSV2b_B.K_tow[0] + cos(CA_CSE1_V1e_wo_LOSV2b_B.eta_yaw) *
      CA_CSE1_V1e_wo_LOSV2b_B.K_tow[1];

    /* Fcn: '<S42>/Row3' */
    CA_CSE1_V1e_wo_LOSV2b_B.Row3_m = CA_CSE1_V1e_wo_LOSV2b_B.K_tow[2];

    /* Fcn: '<S43>/Row1' incorporates:
     *  Constant: '<S8>/DEBUG'
     */
    CA_CSE1_V1e_wo_LOSV2b_B.Row1_i = cos(CA_CSE1_V1e_wo_LOSV2b_B.eta_yaw) *
      CA_CSE1_V1e_wo_LOSV2b_P.DEBUG_Value[0] + sin
      (CA_CSE1_V1e_wo_LOSV2b_B.eta_yaw) * CA_CSE1_V1e_wo_LOSV2b_P.DEBUG_Value[1];

    /* Fcn: '<S43>/Row2' incorporates:
     *  Constant: '<S8>/DEBUG'
     */
    CA_CSE1_V1e_wo_LOSV2b_B.Row2_h = (-sin(CA_CSE1_V1e_wo_LOSV2b_B.eta_yaw)) *
      CA_CSE1_V1e_wo_LOSV2b_P.DEBUG_Value[0] + cos
      (CA_CSE1_V1e_wo_LOSV2b_B.eta_yaw) * CA_CSE1_V1e_wo_LOSV2b_P.DEBUG_Value[1];

    /* Fcn: '<S43>/Row3' incorporates:
     *  Constant: '<S8>/DEBUG'
     */
    CA_CSE1_V1e_wo_LOSV2b_B.Row3_pl = CA_CSE1_V1e_wo_LOSV2b_P.DEBUG_Value[2];

    /* Sum: '<S34>/Sum' */
    CA_CSE1_V1e_wo_LOSV2b_B.Sum_g1[0] = (((((CA_CSE1_V1e_wo_LOSV2b_B.D_s[0] -
      CA_CSE1_V1e_wo_LOSV2b_B.TmpHiddenBufferAtK_pInport1[0]) -
      CA_CSE1_V1e_wo_LOSV2b_B.K_d[0]) + CA_CSE1_V1e_wo_LOSV2b_B.M_s[0]) +
      CA_CSE1_V1e_wo_LOSV2b_B.M_s1[0]) + CA_CSE1_V1e_wo_LOSV2b_B.Row1_o) -
      CA_CSE1_V1e_wo_LOSV2b_B.Row1_i;
    CA_CSE1_V1e_wo_LOSV2b_B.Sum_g1[1] = (((((CA_CSE1_V1e_wo_LOSV2b_B.D_s[1] -
      CA_CSE1_V1e_wo_LOSV2b_B.TmpHiddenBufferAtK_pInport1[1]) -
      CA_CSE1_V1e_wo_LOSV2b_B.K_d[1]) + CA_CSE1_V1e_wo_LOSV2b_B.M_s[1]) +
      CA_CSE1_V1e_wo_LOSV2b_B.M_s1[1]) + CA_CSE1_V1e_wo_LOSV2b_B.Row2_b) -
      CA_CSE1_V1e_wo_LOSV2b_B.Row2_h;
    CA_CSE1_V1e_wo_LOSV2b_B.Sum_g1[2] = (((((CA_CSE1_V1e_wo_LOSV2b_B.D_s[2] -
      CA_CSE1_V1e_wo_LOSV2b_B.TmpHiddenBufferAtK_pInport1[2]) -
      CA_CSE1_V1e_wo_LOSV2b_B.K_d[2]) + CA_CSE1_V1e_wo_LOSV2b_B.M_s[2]) +
      CA_CSE1_V1e_wo_LOSV2b_B.M_s1[2]) + CA_CSE1_V1e_wo_LOSV2b_B.Row3_m) -
      CA_CSE1_V1e_wo_LOSV2b_B.Row3_pl;

    /* Product: '<S8>/Product1' */
    for (i = 0; i < 5; i++) {
      CA_CSE1_V1e_wo_LOSV2b_B.Product1_pj[i] = 0.0;
      CA_CSE1_V1e_wo_LOSV2b_B.Product1_pj[i] =
        CA_CSE1_V1e_wo_LOSV2b_B.Product_h[i] * CA_CSE1_V1e_wo_LOSV2b_B.Sum_g1[0]
        + CA_CSE1_V1e_wo_LOSV2b_B.Product1_pj[i];
      CA_CSE1_V1e_wo_LOSV2b_B.Product1_pj[i] =
        CA_CSE1_V1e_wo_LOSV2b_B.Product_h[i + 5] *
        CA_CSE1_V1e_wo_LOSV2b_B.Sum_g1[1] +
        CA_CSE1_V1e_wo_LOSV2b_B.Product1_pj[i];
      CA_CSE1_V1e_wo_LOSV2b_B.Product1_pj[i] =
        CA_CSE1_V1e_wo_LOSV2b_B.Product_h[i + 10] *
        CA_CSE1_V1e_wo_LOSV2b_B.Sum_g1[2] +
        CA_CSE1_V1e_wo_LOSV2b_B.Product1_pj[i];
    }

    /* Gain: '<S8>/DP u_1' */
    CA_CSE1_V1e_wo_LOSV2b_B.DPu_1 = CA_CSE1_V1e_wo_LOSV2b_P.DPu_1_Gain *
      CA_CSE1_V1e_wo_LOSV2b_B.Product1_pj[0];

    /* Gain: '<S8>/DP u_2' */
    CA_CSE1_V1e_wo_LOSV2b_B.DPu_2 = CA_CSE1_V1e_wo_LOSV2b_P.DPu_2_Gain *
      CA_CSE1_V1e_wo_LOSV2b_B.Product1_pj[1];

    /* Gain: '<S8>/DP u_3' */
    CA_CSE1_V1e_wo_LOSV2b_B.DPu_3 = CA_CSE1_V1e_wo_LOSV2b_P.DPu_3_Gain *
      CA_CSE1_V1e_wo_LOSV2b_B.Product1_pj[2];

    /* Gain: '<S8>/DP u_4' */
    CA_CSE1_V1e_wo_LOSV2b_B.DPu_4 = CA_CSE1_V1e_wo_LOSV2b_P.DPu_4_Gain *
      CA_CSE1_V1e_wo_LOSV2b_B.Product1_pj[3];

    /* Gain: '<S8>/DP u_5' */
    CA_CSE1_V1e_wo_LOSV2b_B.DPu_5 = CA_CSE1_V1e_wo_LOSV2b_P.DPu_5_Gain *
      CA_CSE1_V1e_wo_LOSV2b_B.Product1_pj[4];

    /* Saturate: '<S8>/Saturation' */
    tmp[0] = CA_CSE1_V1e_wo_LOSV2b_B.DPu_1;
    tmp[1] = CA_CSE1_V1e_wo_LOSV2b_B.DPu_2;
    tmp[2] = CA_CSE1_V1e_wo_LOSV2b_B.DPu_3;
    tmp[3] = CA_CSE1_V1e_wo_LOSV2b_B.DPu_4;
    tmp[4] = CA_CSE1_V1e_wo_LOSV2b_B.DPu_5;
    for (i = 0; i < 5; i++) {
      CA_CSE1_V1e_wo_LOSV2b_B.Saturation_o[i] = rt_SATURATE(tmp[i],
        CA_CSE1_V1e_wo_LOSV2b_P.Saturation_LowerSat_f,
        CA_CSE1_V1e_wo_LOSV2b_P.Saturation_UpperSat_g);
    }

    /* MultiPortSwitch: '<S1>/Control Switch' incorporates:
     *  Constant: '<S1>/Control Mode'
     *  Constant: '<S59>/LabVIEW_BT_Power'
     *  Constant: '<S59>/LabVIEW_VSP_Speed'
     *  Constant: '<S8>/BT_power_limit'
     *  Constant: '<S8>/VSP_speeds'
     */
    switch ((int32_T)CA_CSE1_V1e_wo_LOSV2b_P.ControlMode_Value) {
     case 0:
      CA_CSE1_V1e_wo_LOSV2b_B.ControlSwitch[0] =
        CA_CSE1_V1e_wo_LOSV2b_B.Panelu_1;
      CA_CSE1_V1e_wo_LOSV2b_B.ControlSwitch[1] =
        CA_CSE1_V1e_wo_LOSV2b_B.Panelu_2;
      CA_CSE1_V1e_wo_LOSV2b_B.ControlSwitch[2] =
        CA_CSE1_V1e_wo_LOSV2b_B.Panelu_3;
      CA_CSE1_V1e_wo_LOSV2b_B.ControlSwitch[3] =
        CA_CSE1_V1e_wo_LOSV2b_B.Panelu_4;
      CA_CSE1_V1e_wo_LOSV2b_B.ControlSwitch[4] =
        CA_CSE1_V1e_wo_LOSV2b_B.Panelu_5;
      CA_CSE1_V1e_wo_LOSV2b_B.ControlSwitch[5] =
        CA_CSE1_V1e_wo_LOSV2b_P.LabVIEW_BT_Power_Value;
      CA_CSE1_V1e_wo_LOSV2b_B.ControlSwitch[6] =
        CA_CSE1_V1e_wo_LOSV2b_P.LabVIEW_VSP_Speed_Value;
      break;

     case 1:
      CA_CSE1_V1e_wo_LOSV2b_B.ControlSwitch[0] = CA_CSE1_V1e_wo_LOSV2b_B.PS3u_1;
      CA_CSE1_V1e_wo_LOSV2b_B.ControlSwitch[1] = CA_CSE1_V1e_wo_LOSV2b_B.PS3u_2;
      CA_CSE1_V1e_wo_LOSV2b_B.ControlSwitch[2] = CA_CSE1_V1e_wo_LOSV2b_B.PS3u_3;
      CA_CSE1_V1e_wo_LOSV2b_B.ControlSwitch[3] = CA_CSE1_V1e_wo_LOSV2b_B.PS3u_4;
      CA_CSE1_V1e_wo_LOSV2b_B.ControlSwitch[4] = CA_CSE1_V1e_wo_LOSV2b_B.PS3u_5;
      CA_CSE1_V1e_wo_LOSV2b_B.ControlSwitch[5] =
        CA_CSE1_V1e_wo_LOSV2b_P.LabVIEW_BT_Power_Value;
      CA_CSE1_V1e_wo_LOSV2b_B.ControlSwitch[6] =
        CA_CSE1_V1e_wo_LOSV2b_P.LabVIEW_VSP_Speed_Value;
      break;

     case 2:
      CA_CSE1_V1e_wo_LOSV2b_B.ControlSwitch[0] =
        CA_CSE1_V1e_wo_LOSV2b_B.Joysticku_1;
      CA_CSE1_V1e_wo_LOSV2b_B.ControlSwitch[1] =
        CA_CSE1_V1e_wo_LOSV2b_B.Joysticku_2;
      CA_CSE1_V1e_wo_LOSV2b_B.ControlSwitch[2] =
        CA_CSE1_V1e_wo_LOSV2b_B.Joysticku_3;
      CA_CSE1_V1e_wo_LOSV2b_B.ControlSwitch[3] =
        CA_CSE1_V1e_wo_LOSV2b_B.Joysticku_4;
      CA_CSE1_V1e_wo_LOSV2b_B.ControlSwitch[4] =
        CA_CSE1_V1e_wo_LOSV2b_B.Joysticku_5;
      CA_CSE1_V1e_wo_LOSV2b_B.ControlSwitch[5] =
        CA_CSE1_V1e_wo_LOSV2b_P.LabVIEW_BT_Power_Value;
      CA_CSE1_V1e_wo_LOSV2b_B.ControlSwitch[6] =
        CA_CSE1_V1e_wo_LOSV2b_P.LabVIEW_VSP_Speed_Value;
      break;

     case 3:
      for (i = 0; i < 5; i++) {
        CA_CSE1_V1e_wo_LOSV2b_B.ControlSwitch[i] =
          CA_CSE1_V1e_wo_LOSV2b_B.Saturation_f[i];
      }

      CA_CSE1_V1e_wo_LOSV2b_B.ControlSwitch[5] =
        CA_CSE1_V1e_wo_LOSV2b_B.BT_power_limit;
      CA_CSE1_V1e_wo_LOSV2b_B.ControlSwitch[6] =
        CA_CSE1_V1e_wo_LOSV2b_B.VSP_speeds;
      break;

     default:
      for (i = 0; i < 5; i++) {
        CA_CSE1_V1e_wo_LOSV2b_B.ControlSwitch[i] =
          CA_CSE1_V1e_wo_LOSV2b_B.Saturation_o[i];
      }

      CA_CSE1_V1e_wo_LOSV2b_B.ControlSwitch[5] =
        CA_CSE1_V1e_wo_LOSV2b_P.BT_power_limit_Value;
      CA_CSE1_V1e_wo_LOSV2b_B.ControlSwitch[6] =
        CA_CSE1_V1e_wo_LOSV2b_P.VSP_speeds_Value;
      break;
    }

    /* Saturate: '<S1>/Saturation' */
    for (i = 0; i < 7; i++) {
      currentTime = CA_CSE1_V1e_wo_LOSV2b_B.ControlSwitch[i];
      CA_CSE1_V1e_wo_LOSV2b_B.Saturation_c[i] = rt_SATURATE(currentTime,
        CA_CSE1_V1e_wo_LOSV2b_P.Saturation_LowerSat_fh,
        CA_CSE1_V1e_wo_LOSV2b_P.Saturation_UpperSat_m);
    }

    if (rtmIsMajorTimeStep(CA_CSE1_V1e_wo_LOSV2b_M)) {
      /* SignalConversion: '<Root>/TmpHiddenBufferAtTo FileInport1' incorporates:
       *  Constant: '<S58>/x_d'
       *  Constant: '<S58>/y_d'
       */
      CA_CSE1_V1e_wo_LOSV2b_B.TmpHiddenBufferAtToFileInport1[0] =
        CA_CSE1_V1e_wo_LOSV2b_B.mm2mx;
      CA_CSE1_V1e_wo_LOSV2b_B.TmpHiddenBufferAtToFileInport1[1] =
        CA_CSE1_V1e_wo_LOSV2b_B.mm2my;
      CA_CSE1_V1e_wo_LOSV2b_B.TmpHiddenBufferAtToFileInport1[2] =
        CA_CSE1_V1e_wo_LOSV2b_B.mm2mz;
      CA_CSE1_V1e_wo_LOSV2b_B.TmpHiddenBufferAtToFileInport1[3] =
        CA_CSE1_V1e_wo_LOSV2b_B.d2rroll;
      CA_CSE1_V1e_wo_LOSV2b_B.TmpHiddenBufferAtToFileInport1[4] =
        CA_CSE1_V1e_wo_LOSV2b_B.d2rpitch;
      CA_CSE1_V1e_wo_LOSV2b_B.TmpHiddenBufferAtToFileInport1[5] =
        CA_CSE1_V1e_wo_LOSV2b_B.d2ryaw;
      for (i = 0; i < 7; i++) {
        CA_CSE1_V1e_wo_LOSV2b_B.TmpHiddenBufferAtToFileInport1[i + 6] =
          CA_CSE1_V1e_wo_LOSV2b_B.Saturation_c[i];
      }

      for (i = 0; i < 6; i++) {
        CA_CSE1_V1e_wo_LOSV2b_B.TmpHiddenBufferAtToFileInport1[i + 13] =
          CA_CSE1_V1e_wo_LOSV2b_B.Product[i];
      }

      CA_CSE1_V1e_wo_LOSV2b_B.TmpHiddenBufferAtToFileInport1[19] =
        CA_CSE1_V1e_wo_LOSV2b_P.x_d_Value;
      CA_CSE1_V1e_wo_LOSV2b_B.TmpHiddenBufferAtToFileInport1[20] =
        CA_CSE1_V1e_wo_LOSV2b_P.y_d_Value;
      CA_CSE1_V1e_wo_LOSV2b_B.TmpHiddenBufferAtToFileInport1[21] =
        CA_CSE1_V1e_wo_LOSV2b_B.Gain1;

      /* ToFile Block: '<Root>/To File'
       */
      if (rtmIsMajorTimeStep(CA_CSE1_V1e_wo_LOSV2b_M)) {
        if (!(++CA_CSE1_V1e_wo_LOSV2b_DWork.ToFile_IWORK.Decimation % 1) &&
            (CA_CSE1_V1e_wo_LOSV2b_DWork.ToFile_IWORK.Count*23)+1 < 100000000 )
        {
          real_T u[23];
          FILE *fp = (FILE *) CA_CSE1_V1e_wo_LOSV2b_DWork.ToFile_PWORK.FilePtr;
          if (fp != (NULL)) {
            CA_CSE1_V1e_wo_LOSV2b_DWork.ToFile_IWORK.Decimation = 0;
            u[0] = CA_CSE1_V1e_wo_LOSV2b_M->Timing.t[1];
            u[1] = CA_CSE1_V1e_wo_LOSV2b_B.TmpHiddenBufferAtToFileInport1[0];
            u[2] = CA_CSE1_V1e_wo_LOSV2b_B.TmpHiddenBufferAtToFileInport1[1];
            u[3] = CA_CSE1_V1e_wo_LOSV2b_B.TmpHiddenBufferAtToFileInport1[2];
            u[4] = CA_CSE1_V1e_wo_LOSV2b_B.TmpHiddenBufferAtToFileInport1[3];
            u[5] = CA_CSE1_V1e_wo_LOSV2b_B.TmpHiddenBufferAtToFileInport1[4];
            u[6] = CA_CSE1_V1e_wo_LOSV2b_B.TmpHiddenBufferAtToFileInport1[5];
            u[7] = CA_CSE1_V1e_wo_LOSV2b_B.TmpHiddenBufferAtToFileInport1[6];
            u[8] = CA_CSE1_V1e_wo_LOSV2b_B.TmpHiddenBufferAtToFileInport1[7];
            u[9] = CA_CSE1_V1e_wo_LOSV2b_B.TmpHiddenBufferAtToFileInport1[8];
            u[10] = CA_CSE1_V1e_wo_LOSV2b_B.TmpHiddenBufferAtToFileInport1[9];
            u[11] = CA_CSE1_V1e_wo_LOSV2b_B.TmpHiddenBufferAtToFileInport1[10];
            u[12] = CA_CSE1_V1e_wo_LOSV2b_B.TmpHiddenBufferAtToFileInport1[11];
            u[13] = CA_CSE1_V1e_wo_LOSV2b_B.TmpHiddenBufferAtToFileInport1[12];
            u[14] = CA_CSE1_V1e_wo_LOSV2b_B.TmpHiddenBufferAtToFileInport1[13];
            u[15] = CA_CSE1_V1e_wo_LOSV2b_B.TmpHiddenBufferAtToFileInport1[14];
            u[16] = CA_CSE1_V1e_wo_LOSV2b_B.TmpHiddenBufferAtToFileInport1[15];
            u[17] = CA_CSE1_V1e_wo_LOSV2b_B.TmpHiddenBufferAtToFileInport1[16];
            u[18] = CA_CSE1_V1e_wo_LOSV2b_B.TmpHiddenBufferAtToFileInport1[17];
            u[19] = CA_CSE1_V1e_wo_LOSV2b_B.TmpHiddenBufferAtToFileInport1[18];
            u[20] = CA_CSE1_V1e_wo_LOSV2b_B.TmpHiddenBufferAtToFileInport1[19];
            u[21] = CA_CSE1_V1e_wo_LOSV2b_B.TmpHiddenBufferAtToFileInport1[20];
            u[22] = CA_CSE1_V1e_wo_LOSV2b_B.TmpHiddenBufferAtToFileInport1[21];
            if (fwrite(u, sizeof(real_T), 23, fp) != 23) {
              rtmSetErrorStatus(CA_CSE1_V1e_wo_LOSV2b_M,
                                "Error writing to MAT-file CSE1_data.mat");
              return;
            }

            if (((++CA_CSE1_V1e_wo_LOSV2b_DWork.ToFile_IWORK.Count)*23)+1 >=
                100000000) {
              (void)fprintf(stdout,
                            "*** The ToFile block will stop logging data before\n"
                            "    the simulation has ended, because it has reached\n"
                            "    the maximum number of elements (100000000)\n"
                            "    allowed in MAT-file CSE1_data.mat.\n");
            }
          }
        }
      }

      /* ToFile Block: '<Root>/To File1'
       */
      if (rtmIsMajorTimeStep(CA_CSE1_V1e_wo_LOSV2b_M)) {
        if (!(++CA_CSE1_V1e_wo_LOSV2b_DWork.ToFile1_IWORK.Decimation % 1) &&
            (CA_CSE1_V1e_wo_LOSV2b_DWork.ToFile1_IWORK.Count*2)+1 < 100000000 )
        {
          real_T u[2];
          FILE *fp = (FILE *) CA_CSE1_V1e_wo_LOSV2b_DWork.ToFile1_PWORK.FilePtr;
          if (fp != (NULL)) {
            CA_CSE1_V1e_wo_LOSV2b_DWork.ToFile1_IWORK.Decimation = 0;
            u[0] = CA_CSE1_V1e_wo_LOSV2b_M->Timing.t[1];
            u[1] = CA_CSE1_V1e_wo_LOSV2b_B.Integrator;
            if (fwrite(u, sizeof(real_T), 2, fp) != 2) {
              rtmSetErrorStatus(CA_CSE1_V1e_wo_LOSV2b_M,
                                "Error writing to MAT-file theta.mat");
              return;
            }

            if (((++CA_CSE1_V1e_wo_LOSV2b_DWork.ToFile1_IWORK.Count)*2)+1 >=
                100000000) {
              (void)fprintf(stdout,
                            "*** The ToFile block will stop logging data before\n"
                            "    the simulation has ended, because it has reached\n"
                            "    the maximum number of elements (100000000)\n"
                            "    allowed in MAT-file theta.mat.\n");
            }
          }
        }
      }

      /* RelationalOperator: '<S13>/Compare' incorporates:
       *  Constant: '<S13>/Constant'
       *  Constant: '<S1>/Control Mode'
       */
      CA_CSE1_V1e_wo_LOSV2b_B.Compare_f =
        (CA_CSE1_V1e_wo_LOSV2b_P.ControlMode_Value ==
         CA_CSE1_V1e_wo_LOSV2b_P.Constant_Value_a);
    }

    /* Gain: '<S48>/eta_d Psi deg' */
    CA_CSE1_V1e_wo_LOSV2b_B.eta_dPsideg =
      CA_CSE1_V1e_wo_LOSV2b_P.eta_dPsideg_Gain *
      CA_CSE1_V1e_wo_LOSV2b_B.MultiportSwitch[2];
    if (rtmIsMajorTimeStep(CA_CSE1_V1e_wo_LOSV2b_M)) {
      /* SignalConversion: '<S49>/TmpHiddenBufferAtTo File (eta_d)Inport1' */
      CA_CSE1_V1e_wo_LOSV2b_B.TmpHiddenBufferAtToFileeta_dInp[0] =
        CA_CSE1_V1e_wo_LOSV2b_B.Output;
      CA_CSE1_V1e_wo_LOSV2b_B.TmpHiddenBufferAtToFileeta_dInp[1] =
        CA_CSE1_V1e_wo_LOSV2b_B.Output_m;
      CA_CSE1_V1e_wo_LOSV2b_B.TmpHiddenBufferAtToFileeta_dInp[2] =
        CA_CSE1_V1e_wo_LOSV2b_B.trigfun1;
      CA_CSE1_V1e_wo_LOSV2b_B.TmpHiddenBufferAtToFileeta_dInp[3] =
        CA_CSE1_V1e_wo_LOSV2b_B.Divide;
      CA_CSE1_V1e_wo_LOSV2b_B.TmpHiddenBufferAtToFileeta_dInp[4] =
        CA_CSE1_V1e_wo_LOSV2b_B.Divide1;
      CA_CSE1_V1e_wo_LOSV2b_B.TmpHiddenBufferAtToFileeta_dInp[5] =
        CA_CSE1_V1e_wo_LOSV2b_B.Divide2;
      CA_CSE1_V1e_wo_LOSV2b_B.TmpHiddenBufferAtToFileeta_dInp[6] =
        CA_CSE1_V1e_wo_LOSV2b_B.Divide_d;
      CA_CSE1_V1e_wo_LOSV2b_B.TmpHiddenBufferAtToFileeta_dInp[7] =
        CA_CSE1_V1e_wo_LOSV2b_B.Divide1_m;
      CA_CSE1_V1e_wo_LOSV2b_B.TmpHiddenBufferAtToFileeta_dInp[8] =
        CA_CSE1_V1e_wo_LOSV2b_B.Divide2_o;
      CA_CSE1_V1e_wo_LOSV2b_B.TmpHiddenBufferAtToFileeta_dInp[9] =
        CA_CSE1_V1e_wo_LOSV2b_B.Divide1_o;
      CA_CSE1_V1e_wo_LOSV2b_B.TmpHiddenBufferAtToFileeta_dInp[10] =
        CA_CSE1_V1e_wo_LOSV2b_B.Product2;
      CA_CSE1_V1e_wo_LOSV2b_B.TmpHiddenBufferAtToFileeta_dInp[11] =
        CA_CSE1_V1e_wo_LOSV2b_B.Divide_g;

      /* ToFile Block: '<S49>/To File (eta_d)'
       */
      if (rtmIsMajorTimeStep(CA_CSE1_V1e_wo_LOSV2b_M)) {
        if (!(++CA_CSE1_V1e_wo_LOSV2b_DWork.ToFileeta_d_IWORK.Decimation % 1) &&
            (CA_CSE1_V1e_wo_LOSV2b_DWork.ToFileeta_d_IWORK.Count*13)+1 <
            100000000 ) {
          real_T u[13];
          FILE *fp = (FILE *)
            CA_CSE1_V1e_wo_LOSV2b_DWork.ToFileeta_d_PWORK.FilePtr;
          if (fp != (NULL)) {
            CA_CSE1_V1e_wo_LOSV2b_DWork.ToFileeta_d_IWORK.Decimation = 0;
            u[0] = CA_CSE1_V1e_wo_LOSV2b_M->Timing.t[1];
            u[1] = CA_CSE1_V1e_wo_LOSV2b_B.TmpHiddenBufferAtToFileeta_dInp[0];
            u[2] = CA_CSE1_V1e_wo_LOSV2b_B.TmpHiddenBufferAtToFileeta_dInp[1];
            u[3] = CA_CSE1_V1e_wo_LOSV2b_B.TmpHiddenBufferAtToFileeta_dInp[2];
            u[4] = CA_CSE1_V1e_wo_LOSV2b_B.TmpHiddenBufferAtToFileeta_dInp[3];
            u[5] = CA_CSE1_V1e_wo_LOSV2b_B.TmpHiddenBufferAtToFileeta_dInp[4];
            u[6] = CA_CSE1_V1e_wo_LOSV2b_B.TmpHiddenBufferAtToFileeta_dInp[5];
            u[7] = CA_CSE1_V1e_wo_LOSV2b_B.TmpHiddenBufferAtToFileeta_dInp[6];
            u[8] = CA_CSE1_V1e_wo_LOSV2b_B.TmpHiddenBufferAtToFileeta_dInp[7];
            u[9] = CA_CSE1_V1e_wo_LOSV2b_B.TmpHiddenBufferAtToFileeta_dInp[8];
            u[10] = CA_CSE1_V1e_wo_LOSV2b_B.TmpHiddenBufferAtToFileeta_dInp[9];
            u[11] = CA_CSE1_V1e_wo_LOSV2b_B.TmpHiddenBufferAtToFileeta_dInp[10];
            u[12] = CA_CSE1_V1e_wo_LOSV2b_B.TmpHiddenBufferAtToFileeta_dInp[11];
            if (fwrite(u, sizeof(real_T), 13, fp) != 13) {
              rtmSetErrorStatus(CA_CSE1_V1e_wo_LOSV2b_M,
                                "Error writing to MAT-file guidance_saved.mat");
              return;
            }

            if (((++CA_CSE1_V1e_wo_LOSV2b_DWork.ToFileeta_d_IWORK.Count)*13)+1 >=
                100000000) {
              (void)fprintf(stdout,
                            "*** The ToFile block will stop logging data before\n"
                            "    the simulation has ended, because it has reached\n"
                            "    the maximum number of elements (100000000)\n"
                            "    allowed in MAT-file guidance_saved.mat.\n");
            }
          }
        }
      }

      /* Gain: '<S3>/Battery Bow Thruster' */
      CA_CSE1_V1e_wo_LOSV2b_B.BatteryBowThruster =
        CA_CSE1_V1e_wo_LOSV2b_P.BatteryBowThruster_Gain *
        CA_CSE1_V1e_wo_LOSV2b_B.SITzAI0;

      /* Gain: '<S3>/Battery Servo' */
      CA_CSE1_V1e_wo_LOSV2b_B.BatteryServo =
        CA_CSE1_V1e_wo_LOSV2b_P.BatteryServo_Gain *
        CA_CSE1_V1e_wo_LOSV2b_B.SITzAI1;

      /* Gain: '<S3>/Battery Main' */
      CA_CSE1_V1e_wo_LOSV2b_B.BatteryMain =
        CA_CSE1_V1e_wo_LOSV2b_P.BatteryMain_Gain *
        CA_CSE1_V1e_wo_LOSV2b_B.SITzAI2;
    }

    /* Gain: '<S63>/QTM In12' */
    CA_CSE1_V1e_wo_LOSV2b_B.QTMIn12 = CA_CSE1_V1e_wo_LOSV2b_P.QTMIn12_Gain *
      CA_CSE1_V1e_wo_LOSV2b_B.QTMIn[11];

    /* Gain: '<S63>/mm2m z1' */
    CA_CSE1_V1e_wo_LOSV2b_B.mm2mz1 = CA_CSE1_V1e_wo_LOSV2b_P.mm2mz1_Gain *
      CA_CSE1_V1e_wo_LOSV2b_B.QTMIn12;

    /* Gain: '<S63>/QTM In15' */
    CA_CSE1_V1e_wo_LOSV2b_B.QTMIn15 = CA_CSE1_V1e_wo_LOSV2b_P.QTMIn15_Gain *
      CA_CSE1_V1e_wo_LOSV2b_B.QTMIn[14];

    /* Gain: '<S63>/d2r roll1' */
    CA_CSE1_V1e_wo_LOSV2b_B.d2rroll1 = CA_CSE1_V1e_wo_LOSV2b_P.d2rroll1_Gain *
      CA_CSE1_V1e_wo_LOSV2b_B.QTMIn15;

    /* Gain: '<S63>/QTM In14' */
    CA_CSE1_V1e_wo_LOSV2b_B.QTMIn14 = CA_CSE1_V1e_wo_LOSV2b_P.QTMIn14_Gain *
      CA_CSE1_V1e_wo_LOSV2b_B.QTMIn[13];

    /* Gain: '<S63>/d2r pitch1' */
    CA_CSE1_V1e_wo_LOSV2b_B.d2rpitch1 = CA_CSE1_V1e_wo_LOSV2b_P.d2rpitch1_Gain *
      CA_CSE1_V1e_wo_LOSV2b_B.QTMIn14;

    /* Derivative Block: '<S63>/Derivative1' */
    {
      real_T t = CA_CSE1_V1e_wo_LOSV2b_M->Timing.t[0];
      real_T timeStampA =
        CA_CSE1_V1e_wo_LOSV2b_DWork.Derivative1_RWORK.TimeStampA;
      real_T timeStampB =
        CA_CSE1_V1e_wo_LOSV2b_DWork.Derivative1_RWORK.TimeStampB;
      if (timeStampA >= t && timeStampB >= t) {
        {
          int_T i1;
          real_T *y0 = CA_CSE1_V1e_wo_LOSV2b_B.Derivative1;
          for (i1=0; i1 < 6; i1++) {
            y0[i1] = 0.0;
          }
        }
      } else {
        real_T deltaT;
        real_T *lastBank =
          &CA_CSE1_V1e_wo_LOSV2b_DWork.Derivative1_RWORK.TimeStampA;
        if (timeStampA < timeStampB) {
          if (timeStampB < t) {
            lastBank += 7;
          }
        } else if (timeStampA >= t) {
          lastBank += 7;
        }

        deltaT = t - *lastBank++;
        CA_CSE1_V1e_wo_LOSV2b_B.Derivative1[0] = (CA_CSE1_V1e_wo_LOSV2b_B.mm2mx1
          - *lastBank++) / deltaT;
        CA_CSE1_V1e_wo_LOSV2b_B.Derivative1[1] = (CA_CSE1_V1e_wo_LOSV2b_B.mm2my1
          - *lastBank++) / deltaT;
        CA_CSE1_V1e_wo_LOSV2b_B.Derivative1[2] = (CA_CSE1_V1e_wo_LOSV2b_B.mm2mz1
          - *lastBank++) / deltaT;
        CA_CSE1_V1e_wo_LOSV2b_B.Derivative1[3] =
          (CA_CSE1_V1e_wo_LOSV2b_B.d2rroll1 - *lastBank++) / deltaT;
        CA_CSE1_V1e_wo_LOSV2b_B.Derivative1[4] =
          (CA_CSE1_V1e_wo_LOSV2b_B.d2rpitch1 - *lastBank++) / deltaT;
        CA_CSE1_V1e_wo_LOSV2b_B.Derivative1[5] =
          (CA_CSE1_V1e_wo_LOSV2b_B.d2ryaw1 - *lastBank++) / deltaT;
      }
    }

    /* Trigonometry: '<S65>/sin(theta)' */
    CA_CSE1_V1e_wo_LOSV2b_B.sintheta_n[0] = sin(CA_CSE1_V1e_wo_LOSV2b_B.d2rroll1);
    CA_CSE1_V1e_wo_LOSV2b_B.sintheta_n[1] = sin
      (CA_CSE1_V1e_wo_LOSV2b_B.d2rpitch1);
    CA_CSE1_V1e_wo_LOSV2b_B.sintheta_n[2] = sin(CA_CSE1_V1e_wo_LOSV2b_B.d2ryaw1);

    /* Trigonometry: '<S65>/cos(theta)' */
    CA_CSE1_V1e_wo_LOSV2b_B.costheta_l[0] = cos(CA_CSE1_V1e_wo_LOSV2b_B.d2rroll1);
    CA_CSE1_V1e_wo_LOSV2b_B.costheta_l[1] = cos
      (CA_CSE1_V1e_wo_LOSV2b_B.d2rpitch1);
    CA_CSE1_V1e_wo_LOSV2b_B.costheta_l[2] = cos(CA_CSE1_V1e_wo_LOSV2b_B.d2ryaw1);

    /* Fcn: '<S65>/R11' */
    CA_CSE1_V1e_wo_LOSV2b_B.R11_j = CA_CSE1_V1e_wo_LOSV2b_B.costheta_l[1] *
      CA_CSE1_V1e_wo_LOSV2b_B.costheta_l[2];

    /* Fcn: '<S65>/R12' */
    CA_CSE1_V1e_wo_LOSV2b_B.R12_e = CA_CSE1_V1e_wo_LOSV2b_B.costheta_l[1] *
      CA_CSE1_V1e_wo_LOSV2b_B.sintheta_n[2];

    /* Fcn: '<S65>/R13' */
    CA_CSE1_V1e_wo_LOSV2b_B.R13_j = -CA_CSE1_V1e_wo_LOSV2b_B.sintheta_n[1];

    /* Fcn: '<S65>/R21 ' */
    CA_CSE1_V1e_wo_LOSV2b_B.R21_a = CA_CSE1_V1e_wo_LOSV2b_B.sintheta_n[0] *
      CA_CSE1_V1e_wo_LOSV2b_B.sintheta_n[1] *
      CA_CSE1_V1e_wo_LOSV2b_B.costheta_l[2] +
      (-CA_CSE1_V1e_wo_LOSV2b_B.costheta_l[0]) *
      CA_CSE1_V1e_wo_LOSV2b_B.sintheta_n[2];

    /* Fcn: '<S65>/R22' */
    CA_CSE1_V1e_wo_LOSV2b_B.R22_e = CA_CSE1_V1e_wo_LOSV2b_B.sintheta_n[0] *
      CA_CSE1_V1e_wo_LOSV2b_B.sintheta_n[1] *
      CA_CSE1_V1e_wo_LOSV2b_B.sintheta_n[2] +
      CA_CSE1_V1e_wo_LOSV2b_B.costheta_l[0] *
      CA_CSE1_V1e_wo_LOSV2b_B.costheta_l[2];

    /* Fcn: '<S65>/R23' */
    CA_CSE1_V1e_wo_LOSV2b_B.R23_h = CA_CSE1_V1e_wo_LOSV2b_B.sintheta_n[0] *
      CA_CSE1_V1e_wo_LOSV2b_B.costheta_l[1];

    /* Fcn: '<S65>/R31 ' */
    CA_CSE1_V1e_wo_LOSV2b_B.R31_f = CA_CSE1_V1e_wo_LOSV2b_B.costheta_l[0] *
      CA_CSE1_V1e_wo_LOSV2b_B.sintheta_n[1] *
      CA_CSE1_V1e_wo_LOSV2b_B.costheta_l[2] +
      CA_CSE1_V1e_wo_LOSV2b_B.sintheta_n[0] *
      CA_CSE1_V1e_wo_LOSV2b_B.sintheta_n[2];

    /* Fcn: '<S65>/R32' */
    CA_CSE1_V1e_wo_LOSV2b_B.R32_p = CA_CSE1_V1e_wo_LOSV2b_B.costheta_l[0] *
      CA_CSE1_V1e_wo_LOSV2b_B.sintheta_n[1] *
      CA_CSE1_V1e_wo_LOSV2b_B.sintheta_n[2] +
      (-CA_CSE1_V1e_wo_LOSV2b_B.sintheta_n[0]) *
      CA_CSE1_V1e_wo_LOSV2b_B.costheta_l[2];

    /* Fcn: '<S65>/R33' */
    CA_CSE1_V1e_wo_LOSV2b_B.R33_j = CA_CSE1_V1e_wo_LOSV2b_B.costheta_l[0] *
      CA_CSE1_V1e_wo_LOSV2b_B.costheta_l[1];

    /* Reshape: '<S65>/Reshape 9x1->3x3' */
    CA_CSE1_V1e_wo_LOSV2b_B.Reshape9x13x3_m[0] = CA_CSE1_V1e_wo_LOSV2b_B.R11_j;
    CA_CSE1_V1e_wo_LOSV2b_B.Reshape9x13x3_m[1] = CA_CSE1_V1e_wo_LOSV2b_B.R21_a;
    CA_CSE1_V1e_wo_LOSV2b_B.Reshape9x13x3_m[2] = CA_CSE1_V1e_wo_LOSV2b_B.R31_f;
    CA_CSE1_V1e_wo_LOSV2b_B.Reshape9x13x3_m[3] = CA_CSE1_V1e_wo_LOSV2b_B.R12_e;
    CA_CSE1_V1e_wo_LOSV2b_B.Reshape9x13x3_m[4] = CA_CSE1_V1e_wo_LOSV2b_B.R22_e;
    CA_CSE1_V1e_wo_LOSV2b_B.Reshape9x13x3_m[5] = CA_CSE1_V1e_wo_LOSV2b_B.R32_p;
    CA_CSE1_V1e_wo_LOSV2b_B.Reshape9x13x3_m[6] = CA_CSE1_V1e_wo_LOSV2b_B.R13_j;
    CA_CSE1_V1e_wo_LOSV2b_B.Reshape9x13x3_m[7] = CA_CSE1_V1e_wo_LOSV2b_B.R23_h;
    CA_CSE1_V1e_wo_LOSV2b_B.Reshape9x13x3_m[8] = CA_CSE1_V1e_wo_LOSV2b_B.R33_j;

    /* Concatenate: '<S63>/Matrix Concatenate3' incorporates:
     *  Constant: '<S63>/Constant2'
     */
    for (i = 0; i < 3; i++) {
      tmp_0[6 * i] = CA_CSE1_V1e_wo_LOSV2b_B.Reshape9x13x3_m[3 * i];
      tmp_0[1 + 6 * i] = CA_CSE1_V1e_wo_LOSV2b_B.Reshape9x13x3_m[3 * i + 1];
      tmp_0[2 + 6 * i] = CA_CSE1_V1e_wo_LOSV2b_B.Reshape9x13x3_m[3 * i + 2];
    }

    for (i = 0; i < 3; i++) {
      tmp_0[3 + 6 * i] = CA_CSE1_V1e_wo_LOSV2b_P.Constant2_Value[3 * i];
      tmp_0[4 + 6 * i] = CA_CSE1_V1e_wo_LOSV2b_P.Constant2_Value[3 * i + 1];
      tmp_0[5 + 6 * i] = CA_CSE1_V1e_wo_LOSV2b_P.Constant2_Value[3 * i + 2];
    }

    memcpy((void *)(&CA_CSE1_V1e_wo_LOSV2b_B.MatrixConcatenate5[0]), (void *)
           &tmp_0[0], 18U * sizeof(real_T));

    /* Concatenate: '<S63>/Matrix Concatenate4' incorporates:
     *  Constant: '<S63>/Constant2'
     */
    for (i = 0; i < 3; i++) {
      tmp_0[6 * i] = CA_CSE1_V1e_wo_LOSV2b_P.Constant2_Value[3 * i];
      tmp_0[1 + 6 * i] = CA_CSE1_V1e_wo_LOSV2b_P.Constant2_Value[3 * i + 1];
      tmp_0[2 + 6 * i] = CA_CSE1_V1e_wo_LOSV2b_P.Constant2_Value[3 * i + 2];
    }

    for (i = 0; i < 3; i++) {
      tmp_0[3 + 6 * i] = CA_CSE1_V1e_wo_LOSV2b_B.Reshape9x13x3_m[3 * i];
      tmp_0[4 + 6 * i] = CA_CSE1_V1e_wo_LOSV2b_B.Reshape9x13x3_m[3 * i + 1];
      tmp_0[5 + 6 * i] = CA_CSE1_V1e_wo_LOSV2b_B.Reshape9x13x3_m[3 * i + 2];
    }

    memcpy((void *)(&CA_CSE1_V1e_wo_LOSV2b_B.MatrixConcatenate5[18]), (void *)
           &tmp_0[0], 18U * sizeof(real_T));

    /* Product: '<S63>/Product1' */
    for (i = 0; i < 6; i++) {
      CA_CSE1_V1e_wo_LOSV2b_B.Product1_l[i] = 0.0;
      for (tmp_4 = 0; tmp_4 < 6; tmp_4++) {
        CA_CSE1_V1e_wo_LOSV2b_B.Product1_l[i] =
          CA_CSE1_V1e_wo_LOSV2b_B.MatrixConcatenate5[6 * tmp_4 + i] *
          CA_CSE1_V1e_wo_LOSV2b_B.Derivative1[tmp_4] +
          CA_CSE1_V1e_wo_LOSV2b_B.Product1_l[i];
      }
    }

    /* Gain: '<S63>/QTM In1 FPS' */
    CA_CSE1_V1e_wo_LOSV2b_B.QTMIn1FPS = CA_CSE1_V1e_wo_LOSV2b_P.QTMIn1FPS_Gain *
      CA_CSE1_V1e_wo_LOSV2b_B.QTMIn[0];

    /* Gain: '<S63>/QTM In16 Residual' */
    CA_CSE1_V1e_wo_LOSV2b_B.QTMIn16Residual =
      CA_CSE1_V1e_wo_LOSV2b_P.QTMIn16Residual_Gain *
      CA_CSE1_V1e_wo_LOSV2b_B.QTMIn[15];

    /* Gain: '<S63>/QTM In2 Error' */
    CA_CSE1_V1e_wo_LOSV2b_B.QTMIn2Error =
      CA_CSE1_V1e_wo_LOSV2b_P.QTMIn2Error_Gain * CA_CSE1_V1e_wo_LOSV2b_B.QTMIn[1];

    /* Gain: '<S63>/QTM In9 Residual' */
    CA_CSE1_V1e_wo_LOSV2b_B.QTMIn9Residual =
      CA_CSE1_V1e_wo_LOSV2b_P.QTMIn9Residual_Gain *
      CA_CSE1_V1e_wo_LOSV2b_B.QTMIn[8];

    /* Gain: '<S4>/nu_i_surge' */
    CA_CSE1_V1e_wo_LOSV2b_B.nu_i_surge = CA_CSE1_V1e_wo_LOSV2b_P.nu_i_surge_Gain
      * CA_CSE1_V1e_wo_LOSV2b_B.Product1_l[0];

    /* Gain: '<S4>/nu_i_sway' */
    CA_CSE1_V1e_wo_LOSV2b_B.nu_i_sway = CA_CSE1_V1e_wo_LOSV2b_P.nu_i_sway_Gain *
      CA_CSE1_V1e_wo_LOSV2b_B.Product1_l[1];

    /* Gain: '<S4>/nu_i_yaw' */
    CA_CSE1_V1e_wo_LOSV2b_B.nu_i_yaw = CA_CSE1_V1e_wo_LOSV2b_P.nu_i_yaw_Gain *
      CA_CSE1_V1e_wo_LOSV2b_B.Product1_l[5];

    /* Gain: '<S5>/u_1 plant' */
    CA_CSE1_V1e_wo_LOSV2b_B.u_1plant = CA_CSE1_V1e_wo_LOSV2b_P.u_1plant_Gain *
      CA_CSE1_V1e_wo_LOSV2b_B.Saturation_c[0];

    /* Gain: '<S5>/u_2 plant' */
    CA_CSE1_V1e_wo_LOSV2b_B.u_2plant = CA_CSE1_V1e_wo_LOSV2b_P.u_2plant_Gain *
      CA_CSE1_V1e_wo_LOSV2b_B.Saturation_c[1];

    /* Gain: '<S5>/u_3 plant' */
    CA_CSE1_V1e_wo_LOSV2b_B.u_3plant = CA_CSE1_V1e_wo_LOSV2b_P.u_3plant_Gain *
      CA_CSE1_V1e_wo_LOSV2b_B.Saturation_c[2];

    /* Gain: '<S5>/u_4 plant' */
    CA_CSE1_V1e_wo_LOSV2b_B.u_4plant = CA_CSE1_V1e_wo_LOSV2b_P.u_4plant_Gain *
      CA_CSE1_V1e_wo_LOSV2b_B.Saturation_c[3];

    /* Gain: '<S5>/u_5 plant' */
    CA_CSE1_V1e_wo_LOSV2b_B.u_5plant = CA_CSE1_V1e_wo_LOSV2b_P.u_5plant_Gain *
      CA_CSE1_V1e_wo_LOSV2b_B.Saturation_c[4];

    /* Gain: '<S5>/BT power lmit' */
    CA_CSE1_V1e_wo_LOSV2b_B.BTpowerlmit =
      CA_CSE1_V1e_wo_LOSV2b_P.BTpowerlmit_Gain *
      CA_CSE1_V1e_wo_LOSV2b_B.Saturation_c[5];

    /* Gain: '<S5>/VSP speed' */
    CA_CSE1_V1e_wo_LOSV2b_B.VSPspeed = CA_CSE1_V1e_wo_LOSV2b_P.VSPspeed_Gain *
      CA_CSE1_V1e_wo_LOSV2b_B.Saturation_c[6];

    /* Outputs for enable SubSystem: '<S5>/CSE1' incorporates:
     *  Constant: '<S5>/Enable CSE1'
     *  EnablePort: '<S66>/Enable'
     */
    if (rtmIsMajorTimeStep(CA_CSE1_V1e_wo_LOSV2b_M) && rtmIsMajorTimeStep
        (CA_CSE1_V1e_wo_LOSV2b_M)) {
      if (CA_CSE1_V1e_wo_LOSV2b_P.EnableCSE1_Value > 0.0) {
        if (CA_CSE1_V1e_wo_LOSV2b_DWork.CSE1_MODE == SUBSYS_DISABLED) {
          CA_CSE1_V1e_wo_LOSV2b_DWork.CSE1_MODE = SUBSYS_ENABLED;
        }
      } else {
        if (CA_CSE1_V1e_wo_LOSV2b_DWork.CSE1_MODE == SUBSYS_ENABLED) {
          CA_CSE1_V1e_wo_LOSV2b_DWork.CSE1_MODE = SUBSYS_DISABLED;
        }
      }
    }

    if (CA_CSE1_V1e_wo_LOSV2b_DWork.CSE1_MODE == SUBSYS_ENABLED) {
      /* Gain: '<S68>/BT_D_Gain1' */
      CA_CSE1_V1e_wo_LOSV2b_B.BT_D_Gain1 =
        CA_CSE1_V1e_wo_LOSV2b_P.BT_D_Gain1_Gain *
        CA_CSE1_V1e_wo_LOSV2b_B.u_5plant;

      /* Gain: '<S68>/BT_D_Gain2' */
      CA_CSE1_V1e_wo_LOSV2b_B.BT_D_Gain2 =
        CA_CSE1_V1e_wo_LOSV2b_P.BT_D_Gain2_Gain *
        CA_CSE1_V1e_wo_LOSV2b_B.u_5plant;

      /* Sum: '<S68>/Add' incorporates:
       *  Constant: '<S68>/BT_Power_Offset1'
       */
      CA_CSE1_V1e_wo_LOSV2b_B.Add = (CA_CSE1_V1e_wo_LOSV2b_B.BT_D_Gain1 +
        CA_CSE1_V1e_wo_LOSV2b_P.BT_Power_Offset1_Value) +
        CA_CSE1_V1e_wo_LOSV2b_B.BT_D_Gain2;

      /* Gain: '<S68>/BT_L_Gain1' */
      CA_CSE1_V1e_wo_LOSV2b_B.BT_L_Gain1 =
        CA_CSE1_V1e_wo_LOSV2b_P.BT_L_Gain1_Gain *
        CA_CSE1_V1e_wo_LOSV2b_B.BTpowerlmit;

      /* Gain: '<S68>/BT_L_Gain2' */
      CA_CSE1_V1e_wo_LOSV2b_B.BT_L_Gain2 =
        CA_CSE1_V1e_wo_LOSV2b_P.BT_L_Gain2_Gain *
        CA_CSE1_V1e_wo_LOSV2b_B.BTpowerlmit;

      /* Gain: '<S68>/Neg' */
      CA_CSE1_V1e_wo_LOSV2b_B.Neg_d = CA_CSE1_V1e_wo_LOSV2b_P.Neg_Gain *
        CA_CSE1_V1e_wo_LOSV2b_B.BTpowerlmit;
      if (rtmIsMajorTimeStep(CA_CSE1_V1e_wo_LOSV2b_M)) {
      }

      /* Sum: '<S68>/Sum1' incorporates:
       *  Constant: '<S68>/BT_Power_Offset2'
       */
      CA_CSE1_V1e_wo_LOSV2b_B.Sum1_f = CA_CSE1_V1e_wo_LOSV2b_B.BT_L_Gain1 +
        CA_CSE1_V1e_wo_LOSV2b_P.BT_Power_Offset2_Value;

      /* RelationalOperator: '<S72>/LowerRelop1' */
      CA_CSE1_V1e_wo_LOSV2b_B.LowerRelop1_n = (CA_CSE1_V1e_wo_LOSV2b_B.Add >
        CA_CSE1_V1e_wo_LOSV2b_B.Sum1_f);

      /* Sum: '<S68>/Sum2' incorporates:
       *  Constant: '<S68>/BT_Power_Offset3'
       */
      CA_CSE1_V1e_wo_LOSV2b_B.Sum2_mv = CA_CSE1_V1e_wo_LOSV2b_B.BT_L_Gain2 +
        CA_CSE1_V1e_wo_LOSV2b_P.BT_Power_Offset3_Value;

      /* RelationalOperator: '<S72>/UpperRelop' */
      CA_CSE1_V1e_wo_LOSV2b_B.UpperRelop_d = (CA_CSE1_V1e_wo_LOSV2b_B.Add <
        CA_CSE1_V1e_wo_LOSV2b_B.Sum2_mv);

      /* Switch: '<S72>/Switch' */
      if (CA_CSE1_V1e_wo_LOSV2b_B.UpperRelop_d) {
        CA_CSE1_V1e_wo_LOSV2b_B.Switch_n = CA_CSE1_V1e_wo_LOSV2b_B.Sum2_mv;
      } else {
        CA_CSE1_V1e_wo_LOSV2b_B.Switch_n = CA_CSE1_V1e_wo_LOSV2b_B.Add;
      }

      /* Switch: '<S72>/Switch2' */
      if (CA_CSE1_V1e_wo_LOSV2b_B.LowerRelop1_n) {
        CA_CSE1_V1e_wo_LOSV2b_B.Switch2_l = CA_CSE1_V1e_wo_LOSV2b_B.Sum1_f;
      } else {
        CA_CSE1_V1e_wo_LOSV2b_B.Switch2_l = CA_CSE1_V1e_wo_LOSV2b_B.Switch_n;
      }

      if (rtmIsMajorTimeStep(CA_CSE1_V1e_wo_LOSV2b_M)) {
      }

      /* RelationalOperator: '<S73>/LowerRelop1' incorporates:
       *  Constant: '<S68>/Constant'
       */
      CA_CSE1_V1e_wo_LOSV2b_B.LowerRelop1_o = (CA_CSE1_V1e_wo_LOSV2b_B.u_5plant >
        CA_CSE1_V1e_wo_LOSV2b_P.Constant_Value_ef);

      /* RelationalOperator: '<S73>/UpperRelop' */
      CA_CSE1_V1e_wo_LOSV2b_B.UpperRelop_o = (CA_CSE1_V1e_wo_LOSV2b_B.u_5plant <
        CA_CSE1_V1e_wo_LOSV2b_B.Neg_d);

      /* Switch: '<S73>/Switch' */
      if (CA_CSE1_V1e_wo_LOSV2b_B.UpperRelop_o) {
        CA_CSE1_V1e_wo_LOSV2b_B.Switch_nw = CA_CSE1_V1e_wo_LOSV2b_B.Neg_d;
      } else {
        CA_CSE1_V1e_wo_LOSV2b_B.Switch_nw = CA_CSE1_V1e_wo_LOSV2b_B.u_5plant;
      }

      /* Switch: '<S73>/Switch2' incorporates:
       *  Constant: '<S68>/Constant'
       */
      if (CA_CSE1_V1e_wo_LOSV2b_B.LowerRelop1_o) {
        CA_CSE1_V1e_wo_LOSV2b_B.Switch2_f =
          CA_CSE1_V1e_wo_LOSV2b_P.Constant_Value_ef;
      } else {
        CA_CSE1_V1e_wo_LOSV2b_B.Switch2_f = CA_CSE1_V1e_wo_LOSV2b_B.Switch_nw;
      }

      if (rtmIsMajorTimeStep(CA_CSE1_V1e_wo_LOSV2b_M)) {
      }

      /* RelationalOperator: '<S74>/LowerRelop1' */
      CA_CSE1_V1e_wo_LOSV2b_B.LowerRelop1_j = (CA_CSE1_V1e_wo_LOSV2b_B.u_5plant >
        CA_CSE1_V1e_wo_LOSV2b_B.BTpowerlmit);

      /* RelationalOperator: '<S74>/UpperRelop' incorporates:
       *  Constant: '<S68>/Constant1'
       */
      CA_CSE1_V1e_wo_LOSV2b_B.UpperRelop_h = (CA_CSE1_V1e_wo_LOSV2b_B.u_5plant <
        CA_CSE1_V1e_wo_LOSV2b_P.Constant1_Value_n);

      /* Switch: '<S74>/Switch' incorporates:
       *  Constant: '<S68>/Constant1'
       */
      if (CA_CSE1_V1e_wo_LOSV2b_B.UpperRelop_h) {
        CA_CSE1_V1e_wo_LOSV2b_B.Switch_m =
          CA_CSE1_V1e_wo_LOSV2b_P.Constant1_Value_n;
      } else {
        CA_CSE1_V1e_wo_LOSV2b_B.Switch_m = CA_CSE1_V1e_wo_LOSV2b_B.u_5plant;
      }

      /* Switch: '<S74>/Switch2' */
      if (CA_CSE1_V1e_wo_LOSV2b_B.LowerRelop1_j) {
        CA_CSE1_V1e_wo_LOSV2b_B.Switch2_o = CA_CSE1_V1e_wo_LOSV2b_B.BTpowerlmit;
      } else {
        CA_CSE1_V1e_wo_LOSV2b_B.Switch2_o = CA_CSE1_V1e_wo_LOSV2b_B.Switch_m;
      }

      /* Signum: '<S71>/Sign' */
      CA_CSE1_V1e_wo_LOSV2b_B.Sign = rt_SIGNd_snf
        (CA_CSE1_V1e_wo_LOSV2b_B.VSPspeed);

      /* Product: '<S71>/Product1' */
      CA_CSE1_V1e_wo_LOSV2b_B.PortVPS_X = CA_CSE1_V1e_wo_LOSV2b_B.u_2plant *
        CA_CSE1_V1e_wo_LOSV2b_B.Sign;

      /* Gain: '<S71>/-x' */
      CA_CSE1_V1e_wo_LOSV2b_B.PortVPS_X_a = CA_CSE1_V1e_wo_LOSV2b_P.x_Gain *
        CA_CSE1_V1e_wo_LOSV2b_B.PortVPS_X;

      /* Product: '<S71>/Product2' */
      CA_CSE1_V1e_wo_LOSV2b_B.PortVSP_Y = CA_CSE1_V1e_wo_LOSV2b_B.u_1plant *
        CA_CSE1_V1e_wo_LOSV2b_B.Sign;

      /* Gain: '<S71>/-y' */
      CA_CSE1_V1e_wo_LOSV2b_B.PortVSP_Y_a = CA_CSE1_V1e_wo_LOSV2b_P.y_Gain *
        CA_CSE1_V1e_wo_LOSV2b_B.PortVSP_Y;

      /* Fcn: '<S75>/x->r' */
      CA_CSE1_V1e_wo_LOSV2b_B.xr_l = rt_hypot_snf
        (CA_CSE1_V1e_wo_LOSV2b_B.PortVPS_X_a,
         CA_CSE1_V1e_wo_LOSV2b_B.PortVSP_Y_a);

      /* Fcn: '<S75>/x->theta' */
      CA_CSE1_V1e_wo_LOSV2b_B.xtheta_b = rt_atan2_snf
        (CA_CSE1_V1e_wo_LOSV2b_B.PortVSP_Y_a,
         CA_CSE1_V1e_wo_LOSV2b_B.PortVPS_X_a);

      /* Product: '<S71>/Product3' */
      CA_CSE1_V1e_wo_LOSV2b_B.StarboardVSP_X = CA_CSE1_V1e_wo_LOSV2b_B.u_4plant *
        CA_CSE1_V1e_wo_LOSV2b_B.Sign;

      /* Product: '<S71>/Product4' */
      CA_CSE1_V1e_wo_LOSV2b_B.StarboardVSP_Y = CA_CSE1_V1e_wo_LOSV2b_B.u_3plant *
        CA_CSE1_V1e_wo_LOSV2b_B.Sign;

      /* Fcn: '<S76>/x->r' */
      CA_CSE1_V1e_wo_LOSV2b_B.xr_a = rt_hypot_snf
        (CA_CSE1_V1e_wo_LOSV2b_B.StarboardVSP_X,
         CA_CSE1_V1e_wo_LOSV2b_B.StarboardVSP_Y);

      /* Fcn: '<S76>/x->theta' */
      CA_CSE1_V1e_wo_LOSV2b_B.xtheta_al = rt_atan2_snf
        (CA_CSE1_V1e_wo_LOSV2b_B.StarboardVSP_Y,
         CA_CSE1_V1e_wo_LOSV2b_B.StarboardVSP_X);

      /* Gain: '<S77>/Gain' */
      CA_CSE1_V1e_wo_LOSV2b_B.Gain_h = CA_CSE1_V1e_wo_LOSV2b_P.Gain_Gain_k *
        CA_CSE1_V1e_wo_LOSV2b_B.xtheta_b;

      /* Gain: '<S78>/Gain' */
      CA_CSE1_V1e_wo_LOSV2b_B.Gain_i = CA_CSE1_V1e_wo_LOSV2b_P.Gain_Gain_o *
        CA_CSE1_V1e_wo_LOSV2b_B.xtheta_al;

      /* Lookup2D: '<S71>/Servo1' */
      CA_CSE1_V1e_wo_LOSV2b_B.Servo1 = rt_Lookup2D_Normal((const real_T *)
        (&CA_CSE1_V1e_wo_LOSV2b_P.Servo1_RowIdx[0]), 3, (const real_T *)
        (&CA_CSE1_V1e_wo_LOSV2b_P.Servo1_ColIdx[0]), 3, (const real_T *)
        (&CA_CSE1_V1e_wo_LOSV2b_P.Servo1_Table[0]), (const real_T)
        CA_CSE1_V1e_wo_LOSV2b_B.PortVPS_X_a, (const real_T)
        CA_CSE1_V1e_wo_LOSV2b_B.PortVSP_Y_a);

      /* Lookup2D: '<S71>/Servo2' */
      CA_CSE1_V1e_wo_LOSV2b_B.Servo2 = rt_Lookup2D_Normal((const real_T *)
        (&CA_CSE1_V1e_wo_LOSV2b_P.Servo2_RowIdx[0]), 3, (const real_T *)
        (&CA_CSE1_V1e_wo_LOSV2b_P.Servo2_ColIdx[0]), 3, (const real_T *)
        (&CA_CSE1_V1e_wo_LOSV2b_P.Servo2_Table[0]), (const real_T)
        CA_CSE1_V1e_wo_LOSV2b_B.PortVPS_X_a, (const real_T)
        CA_CSE1_V1e_wo_LOSV2b_B.PortVSP_Y_a);

      /* Lookup2D: '<S71>/Servo3' */
      CA_CSE1_V1e_wo_LOSV2b_B.Servo3 = rt_Lookup2D_Normal((const real_T *)
        (&CA_CSE1_V1e_wo_LOSV2b_P.Servo3_RowIdx[0]), 3, (const real_T *)
        (&CA_CSE1_V1e_wo_LOSV2b_P.Servo3_ColIdx[0]), 3, (const real_T *)
        (&CA_CSE1_V1e_wo_LOSV2b_P.Servo3_Table[0]), (const real_T)
        CA_CSE1_V1e_wo_LOSV2b_B.StarboardVSP_X, (const real_T)
        CA_CSE1_V1e_wo_LOSV2b_B.StarboardVSP_Y);

      /* Lookup2D: '<S71>/Servo4' */
      CA_CSE1_V1e_wo_LOSV2b_B.Servo4 = rt_Lookup2D_Normal((const real_T *)
        (&CA_CSE1_V1e_wo_LOSV2b_P.Servo4_RowIdx[0]), 3, (const real_T *)
        (&CA_CSE1_V1e_wo_LOSV2b_P.Servo4_ColIdx[0]), 3, (const real_T *)
        (&CA_CSE1_V1e_wo_LOSV2b_P.Servo4_Table[0]), (const real_T)
        CA_CSE1_V1e_wo_LOSV2b_B.StarboardVSP_X, (const real_T)
        CA_CSE1_V1e_wo_LOSV2b_B.StarboardVSP_Y);

      /* Gain: '<S71>/VPS_Speed_Gain' */
      CA_CSE1_V1e_wo_LOSV2b_B.VPS_Speed_Gain =
        CA_CSE1_V1e_wo_LOSV2b_P.VPS_Speed_Gain_Gain *
        CA_CSE1_V1e_wo_LOSV2b_B.VSPspeed;

      /* Sum: '<S71>/Sum' incorporates:
       *  Constant: '<S71>/VPS_Power_Offset'
       */
      CA_CSE1_V1e_wo_LOSV2b_B.Sum_er = CA_CSE1_V1e_wo_LOSV2b_B.VPS_Speed_Gain +
        CA_CSE1_V1e_wo_LOSV2b_P.VPS_Power_Offset_Value;

      /* Gain: '<S71>/VSPS Port' */
      CA_CSE1_V1e_wo_LOSV2b_B.VSPSPort = CA_CSE1_V1e_wo_LOSV2b_P.VSPSPort_Gain *
        CA_CSE1_V1e_wo_LOSV2b_B.Sum_er;

      /* Gain: '<S71>/VSPS Starboard' */
      CA_CSE1_V1e_wo_LOSV2b_B.VSPSStarboard =
        CA_CSE1_V1e_wo_LOSV2b_P.VSPSStarboard_Gain *
        CA_CSE1_V1e_wo_LOSV2b_B.Sum_er;
      if (rtmIsMajorTimeStep(CA_CSE1_V1e_wo_LOSV2b_M)) {
        /* Gain: '<S70>/-l_x1' incorporates:
         *  Constant: '<S70>/l_x1'
         */
        CA_CSE1_V1e_wo_LOSV2b_B.l_x1_e = CA_CSE1_V1e_wo_LOSV2b_P.l_x1_Gain_f *
          CA_CSE1_V1e_wo_LOSV2b_P.l_x1_Value_j;

        /* Gain: '<S70>/-l_y2' incorporates:
         *  Constant: '<S70>/l_y2'
         */
        CA_CSE1_V1e_wo_LOSV2b_B.l_y2_l = CA_CSE1_V1e_wo_LOSV2b_P.l_y2_Gain_c *
          CA_CSE1_V1e_wo_LOSV2b_P.l_y2_Value_g;

        /* Gain: '<S70>/-l_x2' incorporates:
         *  Constant: '<S70>/l_x2'
         */
        CA_CSE1_V1e_wo_LOSV2b_B.l_x2_j = CA_CSE1_V1e_wo_LOSV2b_P.l_x2_Gain_j *
          CA_CSE1_V1e_wo_LOSV2b_P.l_x2_Value_f;

        /* Reshape: '<S70>/3x5' incorporates:
         *  Constant: '<S70>/T_e11'
         *  Constant: '<S70>/T_e12'
         *  Constant: '<S70>/T_e13'
         *  Constant: '<S70>/T_e14'
         *  Constant: '<S70>/T_e15'
         *  Constant: '<S70>/T_e21'
         *  Constant: '<S70>/T_e22'
         *  Constant: '<S70>/T_e23'
         *  Constant: '<S70>/T_e24'
         *  Constant: '<S70>/T_e25'
         *  Constant: '<S70>/l_x3'
         *  Constant: '<S70>/l_y1'
         */
        CA_CSE1_V1e_wo_LOSV2b_B.x5_df[0] = CA_CSE1_V1e_wo_LOSV2b_P.T_e11_Value_i;
        CA_CSE1_V1e_wo_LOSV2b_B.x5_df[1] = CA_CSE1_V1e_wo_LOSV2b_P.T_e21_Value_p;
        CA_CSE1_V1e_wo_LOSV2b_B.x5_df[2] = CA_CSE1_V1e_wo_LOSV2b_P.l_y1_Value_a;
        CA_CSE1_V1e_wo_LOSV2b_B.x5_df[3] = CA_CSE1_V1e_wo_LOSV2b_P.T_e12_Value_o;
        CA_CSE1_V1e_wo_LOSV2b_B.x5_df[4] =
          CA_CSE1_V1e_wo_LOSV2b_P.T_e22_Value_pn;
        CA_CSE1_V1e_wo_LOSV2b_B.x5_df[5] = CA_CSE1_V1e_wo_LOSV2b_B.l_x1_e;
        CA_CSE1_V1e_wo_LOSV2b_B.x5_df[6] = CA_CSE1_V1e_wo_LOSV2b_P.T_e13_Value_l;
        CA_CSE1_V1e_wo_LOSV2b_B.x5_df[7] = CA_CSE1_V1e_wo_LOSV2b_P.T_e23_Value_c;
        CA_CSE1_V1e_wo_LOSV2b_B.x5_df[8] = CA_CSE1_V1e_wo_LOSV2b_B.l_y2_l;
        CA_CSE1_V1e_wo_LOSV2b_B.x5_df[9] = CA_CSE1_V1e_wo_LOSV2b_P.T_e14_Value_g;
        CA_CSE1_V1e_wo_LOSV2b_B.x5_df[10] =
          CA_CSE1_V1e_wo_LOSV2b_P.T_e24_Value_i;
        CA_CSE1_V1e_wo_LOSV2b_B.x5_df[11] = CA_CSE1_V1e_wo_LOSV2b_B.l_x2_j;
        CA_CSE1_V1e_wo_LOSV2b_B.x5_df[12] =
          CA_CSE1_V1e_wo_LOSV2b_P.T_e15_Value_c;
        CA_CSE1_V1e_wo_LOSV2b_B.x5_df[13] =
          CA_CSE1_V1e_wo_LOSV2b_P.T_e25_Value_jq;
        CA_CSE1_V1e_wo_LOSV2b_B.x5_df[14] = CA_CSE1_V1e_wo_LOSV2b_P.l_x3_Value_m;

        /* Gain: '<S69>/Gain K_e1_CSE1' incorporates:
         *  Constant: '<S69>/K_e1_CSE1'
         */
        CA_CSE1_V1e_wo_LOSV2b_B.GainK_e1_CSE1 =
          CA_CSE1_V1e_wo_LOSV2b_P.GainK_e1_CSE1_Gain *
          CA_CSE1_V1e_wo_LOSV2b_P.K_e1_CSE1_Value;

        /* Gain: '<S69>/Gain K_e2_CSE1' incorporates:
         *  Constant: '<S69>/K_e2_CSE1'
         */
        CA_CSE1_V1e_wo_LOSV2b_B.GainK_e2_CSE1 =
          CA_CSE1_V1e_wo_LOSV2b_P.GainK_e2_CSE1_Gain *
          CA_CSE1_V1e_wo_LOSV2b_P.K_e2_CSE1_Value;

        /* Gain: '<S69>/Gain K_e3_CSE1' incorporates:
         *  Constant: '<S69>/K_e3_CSE1'
         */
        CA_CSE1_V1e_wo_LOSV2b_B.GainK_e3_CSE1 =
          CA_CSE1_V1e_wo_LOSV2b_P.GainK_e3_CSE1_Gain *
          CA_CSE1_V1e_wo_LOSV2b_P.K_e3_CSE1_Value;

        /* Gain: '<S69>/Gain K_e4_CSE1' incorporates:
         *  Constant: '<S69>/K_e4_CSE1'
         */
        CA_CSE1_V1e_wo_LOSV2b_B.GainK_e4_CSE1 =
          CA_CSE1_V1e_wo_LOSV2b_P.GainK_e4_CSE1_Gain *
          CA_CSE1_V1e_wo_LOSV2b_P.K_e4_CSE1_Value;

        /* Gain: '<S69>/Gain K_e5_CSE1' incorporates:
         *  Constant: '<S69>/K_e5_CSE1'
         */
        CA_CSE1_V1e_wo_LOSV2b_B.GainK_e5_CSE1 =
          CA_CSE1_V1e_wo_LOSV2b_P.GainK_e5_CSE1_Gain *
          CA_CSE1_V1e_wo_LOSV2b_P.K_e5_CSE1_Value;

        /* Reshape: '<S69>/Thruster Gain matrix' incorporates:
         *  Constant: '<S69>/Constant'
         */
        CA_CSE1_V1e_wo_LOSV2b_B.ThrusterGainmatrix_l[0] =
          CA_CSE1_V1e_wo_LOSV2b_B.GainK_e1_CSE1;
        CA_CSE1_V1e_wo_LOSV2b_B.ThrusterGainmatrix_l[1] =
          CA_CSE1_V1e_wo_LOSV2b_P.Constant_Value_o;
        CA_CSE1_V1e_wo_LOSV2b_B.ThrusterGainmatrix_l[2] =
          CA_CSE1_V1e_wo_LOSV2b_P.Constant_Value_o;
        CA_CSE1_V1e_wo_LOSV2b_B.ThrusterGainmatrix_l[3] =
          CA_CSE1_V1e_wo_LOSV2b_P.Constant_Value_o;
        CA_CSE1_V1e_wo_LOSV2b_B.ThrusterGainmatrix_l[4] =
          CA_CSE1_V1e_wo_LOSV2b_P.Constant_Value_o;
        CA_CSE1_V1e_wo_LOSV2b_B.ThrusterGainmatrix_l[5] =
          CA_CSE1_V1e_wo_LOSV2b_P.Constant_Value_o;
        CA_CSE1_V1e_wo_LOSV2b_B.ThrusterGainmatrix_l[6] =
          CA_CSE1_V1e_wo_LOSV2b_B.GainK_e2_CSE1;
        CA_CSE1_V1e_wo_LOSV2b_B.ThrusterGainmatrix_l[7] =
          CA_CSE1_V1e_wo_LOSV2b_P.Constant_Value_o;
        CA_CSE1_V1e_wo_LOSV2b_B.ThrusterGainmatrix_l[8] =
          CA_CSE1_V1e_wo_LOSV2b_P.Constant_Value_o;
        CA_CSE1_V1e_wo_LOSV2b_B.ThrusterGainmatrix_l[9] =
          CA_CSE1_V1e_wo_LOSV2b_P.Constant_Value_o;
        CA_CSE1_V1e_wo_LOSV2b_B.ThrusterGainmatrix_l[10] =
          CA_CSE1_V1e_wo_LOSV2b_P.Constant_Value_o;
        CA_CSE1_V1e_wo_LOSV2b_B.ThrusterGainmatrix_l[11] =
          CA_CSE1_V1e_wo_LOSV2b_P.Constant_Value_o;
        CA_CSE1_V1e_wo_LOSV2b_B.ThrusterGainmatrix_l[12] =
          CA_CSE1_V1e_wo_LOSV2b_B.GainK_e3_CSE1;
        CA_CSE1_V1e_wo_LOSV2b_B.ThrusterGainmatrix_l[13] =
          CA_CSE1_V1e_wo_LOSV2b_P.Constant_Value_o;
        CA_CSE1_V1e_wo_LOSV2b_B.ThrusterGainmatrix_l[14] =
          CA_CSE1_V1e_wo_LOSV2b_P.Constant_Value_o;
        CA_CSE1_V1e_wo_LOSV2b_B.ThrusterGainmatrix_l[15] =
          CA_CSE1_V1e_wo_LOSV2b_P.Constant_Value_o;
        CA_CSE1_V1e_wo_LOSV2b_B.ThrusterGainmatrix_l[16] =
          CA_CSE1_V1e_wo_LOSV2b_P.Constant_Value_o;
        CA_CSE1_V1e_wo_LOSV2b_B.ThrusterGainmatrix_l[17] =
          CA_CSE1_V1e_wo_LOSV2b_P.Constant_Value_o;
        CA_CSE1_V1e_wo_LOSV2b_B.ThrusterGainmatrix_l[18] =
          CA_CSE1_V1e_wo_LOSV2b_B.GainK_e4_CSE1;
        CA_CSE1_V1e_wo_LOSV2b_B.ThrusterGainmatrix_l[19] =
          CA_CSE1_V1e_wo_LOSV2b_P.Constant_Value_o;
        CA_CSE1_V1e_wo_LOSV2b_B.ThrusterGainmatrix_l[20] =
          CA_CSE1_V1e_wo_LOSV2b_P.Constant_Value_o;
        CA_CSE1_V1e_wo_LOSV2b_B.ThrusterGainmatrix_l[21] =
          CA_CSE1_V1e_wo_LOSV2b_P.Constant_Value_o;
        CA_CSE1_V1e_wo_LOSV2b_B.ThrusterGainmatrix_l[22] =
          CA_CSE1_V1e_wo_LOSV2b_P.Constant_Value_o;
        CA_CSE1_V1e_wo_LOSV2b_B.ThrusterGainmatrix_l[23] =
          CA_CSE1_V1e_wo_LOSV2b_P.Constant_Value_o;
        CA_CSE1_V1e_wo_LOSV2b_B.ThrusterGainmatrix_l[24] =
          CA_CSE1_V1e_wo_LOSV2b_B.GainK_e5_CSE1;
      }

      /* SignalConversion: '<S66>/TmpHiddenBufferAttau_cse1Inport3' */
      CA_CSE1_V1e_wo_LOSV2b_B.TmpHiddenBufferAttau_cse1Inport[0] =
        CA_CSE1_V1e_wo_LOSV2b_B.u_1plant;
      CA_CSE1_V1e_wo_LOSV2b_B.TmpHiddenBufferAttau_cse1Inport[1] =
        CA_CSE1_V1e_wo_LOSV2b_B.u_2plant;
      CA_CSE1_V1e_wo_LOSV2b_B.TmpHiddenBufferAttau_cse1Inport[2] =
        CA_CSE1_V1e_wo_LOSV2b_B.u_3plant;
      CA_CSE1_V1e_wo_LOSV2b_B.TmpHiddenBufferAttau_cse1Inport[3] =
        CA_CSE1_V1e_wo_LOSV2b_B.u_4plant;
      CA_CSE1_V1e_wo_LOSV2b_B.TmpHiddenBufferAttau_cse1Inport[4] =
        CA_CSE1_V1e_wo_LOSV2b_B.u_5plant;

      /* Product: '<S66>/tau_cse1' */
      for (i = 0; i < 3; i++) {
        for (tmp_4 = 0; tmp_4 < 5; tmp_4++) {
          tmp_2[i + 3 * tmp_4] = 0.0;
          for (tmp_3 = 0; tmp_3 < 5; tmp_3++) {
            tmp_2[i + 3 * tmp_4] = CA_CSE1_V1e_wo_LOSV2b_B.x5_df[3 * tmp_3 + i] *
              CA_CSE1_V1e_wo_LOSV2b_B.ThrusterGainmatrix_l[5 * tmp_4 + tmp_3] +
              tmp_2[3 * tmp_4 + i];
          }
        }
      }

      for (i = 0; i < 3; i++) {
        CA_CSE1_V1e_wo_LOSV2b_B.tau_cse1[i] = 0.0;
        for (tmp_4 = 0; tmp_4 < 5; tmp_4++) {
          CA_CSE1_V1e_wo_LOSV2b_B.tau_cse1[i] = tmp_2[3 * tmp_4 + i] *
            CA_CSE1_V1e_wo_LOSV2b_B.TmpHiddenBufferAttau_cse1Inport[tmp_4] +
            CA_CSE1_V1e_wo_LOSV2b_B.tau_cse1[i];
        }
      }

      /* Gain: '<S66>/CSE1 tau_surge' */
      CA_CSE1_V1e_wo_LOSV2b_B.CSE1tau_surge =
        CA_CSE1_V1e_wo_LOSV2b_P.CSE1tau_surge_Gain *
        CA_CSE1_V1e_wo_LOSV2b_B.tau_cse1[0];

      /* Gain: '<S66>/CSE1 tau_sway' */
      CA_CSE1_V1e_wo_LOSV2b_B.CSE1tau_sway =
        CA_CSE1_V1e_wo_LOSV2b_P.CSE1tau_sway_Gain *
        CA_CSE1_V1e_wo_LOSV2b_B.tau_cse1[1];

      /* Gain: '<S66>/CSE1 tau_yaw' */
      CA_CSE1_V1e_wo_LOSV2b_B.CSE1tau_yaw =
        CA_CSE1_V1e_wo_LOSV2b_P.CSE1tau_yaw_Gain *
        CA_CSE1_V1e_wo_LOSV2b_B.tau_cse1[2];
    }

    /* end of Outputs for SubSystem: '<S5>/CSE1' */
    if (rtmIsMajorTimeStep(CA_CSE1_V1e_wo_LOSV2b_M)) {
    }
  }

  /* tid is required for a uniform function interface.
   * Argument tid is not used in the function. */
  UNUSED_PARAMETER(tid);
}

/* Model update function */
void CA_CSE1_V1e_wo_LOSV2b_update(int_T tid)
{
  {
    real_T tmp[15];
    int32_T tmp_0;
    int32_T tmp_1;
    int32_T tmp_2;

    /* Update for enable SubSystem: '<S5>/Linear Simulator' incorporates:
     *  Update for EnablePort: '<S67>/Enable'
     */
    if (CA_CSE1_V1e_wo_LOSV2b_DWork.LinearSimulator_MODE == SUBSYS_ENABLED) {
      /* Gain: '<S80>/Gain u_1' */
      CA_CSE1_V1e_wo_LOSV2b_B.Gainu_1 = CA_CSE1_V1e_wo_LOSV2b_P.Gainu_1_Gain *
        CA_CSE1_V1e_wo_LOSV2b_B.u_1plant;

      /* Gain: '<S80>/Gain u_2' */
      CA_CSE1_V1e_wo_LOSV2b_B.Gainu_2 = CA_CSE1_V1e_wo_LOSV2b_P.Gainu_2_Gain *
        CA_CSE1_V1e_wo_LOSV2b_B.u_2plant;

      /* Gain: '<S80>/Gain u_3' */
      CA_CSE1_V1e_wo_LOSV2b_B.Gainu_3 = CA_CSE1_V1e_wo_LOSV2b_P.Gainu_3_Gain *
        CA_CSE1_V1e_wo_LOSV2b_B.u_3plant;

      /* Gain: '<S80>/Gain u_4' */
      CA_CSE1_V1e_wo_LOSV2b_B.Gainu_4 = CA_CSE1_V1e_wo_LOSV2b_P.Gainu_4_Gain *
        CA_CSE1_V1e_wo_LOSV2b_B.u_4plant;

      /* Gain: '<S80>/Gain BT power' */
      CA_CSE1_V1e_wo_LOSV2b_B.GainBTpower =
        CA_CSE1_V1e_wo_LOSV2b_P.GainBTpower_Gain *
        CA_CSE1_V1e_wo_LOSV2b_B.BTpowerlmit;

      /* Product: '<S89>/delta rise limit' */
      CA_CSE1_V1e_wo_LOSV2b_B.deltariselimit =
        CA_CSE1_V1e_wo_LOSV2b_B.GainBTpower * CA_CSE1_V1e_wo_LOSV2b_B.sampletime;

      /* Sum: '<S89>/Difference Inputs1' */
      CA_CSE1_V1e_wo_LOSV2b_B.UkYk1 = CA_CSE1_V1e_wo_LOSV2b_B.u_5plant -
        CA_CSE1_V1e_wo_LOSV2b_B.Yk1;

      /* RelationalOperator: '<S91>/LowerRelop1' */
      CA_CSE1_V1e_wo_LOSV2b_B.LowerRelop1 = (CA_CSE1_V1e_wo_LOSV2b_B.UkYk1 >
        CA_CSE1_V1e_wo_LOSV2b_B.deltariselimit);

      /* Gain: '<S80>/Neg' */
      CA_CSE1_V1e_wo_LOSV2b_B.Neg = CA_CSE1_V1e_wo_LOSV2b_P.Neg_Gain_o *
        CA_CSE1_V1e_wo_LOSV2b_B.GainBTpower;

      /* Product: '<S89>/delta fall limit' */
      CA_CSE1_V1e_wo_LOSV2b_B.deltafalllimit = CA_CSE1_V1e_wo_LOSV2b_B.Neg *
        CA_CSE1_V1e_wo_LOSV2b_B.sampletime;

      /* RelationalOperator: '<S91>/UpperRelop' */
      CA_CSE1_V1e_wo_LOSV2b_B.UpperRelop = (CA_CSE1_V1e_wo_LOSV2b_B.UkYk1 <
        CA_CSE1_V1e_wo_LOSV2b_B.deltafalllimit);

      /* Switch: '<S91>/Switch' */
      if (CA_CSE1_V1e_wo_LOSV2b_B.UpperRelop) {
        CA_CSE1_V1e_wo_LOSV2b_B.Switch = CA_CSE1_V1e_wo_LOSV2b_B.deltafalllimit;
      } else {
        CA_CSE1_V1e_wo_LOSV2b_B.Switch = CA_CSE1_V1e_wo_LOSV2b_B.UkYk1;
      }

      /* Switch: '<S91>/Switch2' */
      if (CA_CSE1_V1e_wo_LOSV2b_B.LowerRelop1) {
        CA_CSE1_V1e_wo_LOSV2b_B.Switch2 = CA_CSE1_V1e_wo_LOSV2b_B.deltariselimit;
      } else {
        CA_CSE1_V1e_wo_LOSV2b_B.Switch2 = CA_CSE1_V1e_wo_LOSV2b_B.Switch;
      }

      /* Sum: '<S89>/Difference Inputs2' */
      CA_CSE1_V1e_wo_LOSV2b_B.DifferenceInputs2 =
        CA_CSE1_V1e_wo_LOSV2b_B.Switch2 + CA_CSE1_V1e_wo_LOSV2b_B.Yk1;

      /* Gain: '<S80>/Gain u_5' */
      CA_CSE1_V1e_wo_LOSV2b_B.Gainu_5 = CA_CSE1_V1e_wo_LOSV2b_P.Gainu_5_Gain *
        CA_CSE1_V1e_wo_LOSV2b_B.DifferenceInputs2;

      /* SignalConversion: '<S80>/TmpHiddenBufferAtT_e^+ K_e^-1 u_eInport3' */
      CA_CSE1_V1e_wo_LOSV2b_B.TmpHiddenBufferAtT_eK_e1u_eInpo[0] =
        CA_CSE1_V1e_wo_LOSV2b_B.Gainu_1;
      CA_CSE1_V1e_wo_LOSV2b_B.TmpHiddenBufferAtT_eK_e1u_eInpo[1] =
        CA_CSE1_V1e_wo_LOSV2b_B.Gainu_2;
      CA_CSE1_V1e_wo_LOSV2b_B.TmpHiddenBufferAtT_eK_e1u_eInpo[2] =
        CA_CSE1_V1e_wo_LOSV2b_B.Gainu_3;
      CA_CSE1_V1e_wo_LOSV2b_B.TmpHiddenBufferAtT_eK_e1u_eInpo[3] =
        CA_CSE1_V1e_wo_LOSV2b_B.Gainu_4;
      CA_CSE1_V1e_wo_LOSV2b_B.TmpHiddenBufferAtT_eK_e1u_eInpo[4] =
        CA_CSE1_V1e_wo_LOSV2b_B.Gainu_5;

      /* Product: '<S80>/T_e^+ K_e^-1 u_e' */
      for (tmp_0 = 0; tmp_0 < 3; tmp_0++) {
        for (tmp_2 = 0; tmp_2 < 5; tmp_2++) {
          tmp[tmp_0 + 3 * tmp_2] = 0.0;
          for (tmp_1 = 0; tmp_1 < 5; tmp_1++) {
            tmp[tmp_0 + 3 * tmp_2] = CA_CSE1_V1e_wo_LOSV2b_B.x5_d[3 * tmp_1 +
              tmp_0] * CA_CSE1_V1e_wo_LOSV2b_B.ThrusterGainmatrix_e[5 * tmp_2 +
              tmp_1] + tmp[3 * tmp_2 + tmp_0];
          }
        }
      }

      for (tmp_0 = 0; tmp_0 < 3; tmp_0++) {
        CA_CSE1_V1e_wo_LOSV2b_B.T_eK_e1u_e[tmp_0] = 0.0;
        for (tmp_2 = 0; tmp_2 < 5; tmp_2++) {
          CA_CSE1_V1e_wo_LOSV2b_B.T_eK_e1u_e[tmp_0] = tmp[3 * tmp_2 + tmp_0] *
            CA_CSE1_V1e_wo_LOSV2b_B.TmpHiddenBufferAtT_eK_e1u_eInpo[tmp_2] +
            CA_CSE1_V1e_wo_LOSV2b_B.T_eK_e1u_e[tmp_0];
        }
      }

      /* Gain: '<S80>/tau_surge_hil' */
      CA_CSE1_V1e_wo_LOSV2b_B.tau_surge_hil =
        CA_CSE1_V1e_wo_LOSV2b_P.tau_surge_hil_Gain *
        CA_CSE1_V1e_wo_LOSV2b_B.T_eK_e1u_e[0];

      /* Gain: '<S80>/tau_sway_hil' */
      CA_CSE1_V1e_wo_LOSV2b_B.tau_sway_hil =
        CA_CSE1_V1e_wo_LOSV2b_P.tau_sway_hil_Gain *
        CA_CSE1_V1e_wo_LOSV2b_B.T_eK_e1u_e[1];

      /* Gain: '<S80>/tau_yaw_hil' */
      CA_CSE1_V1e_wo_LOSV2b_B.tau_yaw_hil =
        CA_CSE1_V1e_wo_LOSV2b_P.tau_yaw_hil_Gain *
        CA_CSE1_V1e_wo_LOSV2b_B.T_eK_e1u_e[2];

      /* Sum: '<S79>/Sum' */
      CA_CSE1_V1e_wo_LOSV2b_B.Sum_j2[0] = CA_CSE1_V1e_wo_LOSV2b_B.tau_surge_hil
        - CA_CSE1_V1e_wo_LOSV2b_B.Product1_b[0];
      CA_CSE1_V1e_wo_LOSV2b_B.Sum_j2[1] = CA_CSE1_V1e_wo_LOSV2b_B.tau_sway_hil -
        CA_CSE1_V1e_wo_LOSV2b_B.Product1_b[1];
      CA_CSE1_V1e_wo_LOSV2b_B.Sum_j2[2] = CA_CSE1_V1e_wo_LOSV2b_B.tau_yaw_hil -
        CA_CSE1_V1e_wo_LOSV2b_B.Product1_b[2];

      /* Product: '<S79>/Product2' */
      for (tmp_0 = 0; tmp_0 < 3; tmp_0++) {
        CA_CSE1_V1e_wo_LOSV2b_B.Product2_i[tmp_0] = 0.0;
        CA_CSE1_V1e_wo_LOSV2b_B.Product2_i[tmp_0] =
          CA_CSE1_V1e_wo_LOSV2b_B.Inverse[tmp_0] *
          CA_CSE1_V1e_wo_LOSV2b_B.Sum_j2[0] +
          CA_CSE1_V1e_wo_LOSV2b_B.Product2_i[tmp_0];
        CA_CSE1_V1e_wo_LOSV2b_B.Product2_i[tmp_0] =
          CA_CSE1_V1e_wo_LOSV2b_B.Inverse[tmp_0 + 3] *
          CA_CSE1_V1e_wo_LOSV2b_B.Sum_j2[1] +
          CA_CSE1_V1e_wo_LOSV2b_B.Product2_i[tmp_0];
        CA_CSE1_V1e_wo_LOSV2b_B.Product2_i[tmp_0] =
          CA_CSE1_V1e_wo_LOSV2b_B.Inverse[tmp_0 + 6] *
          CA_CSE1_V1e_wo_LOSV2b_B.Sum_j2[2] +
          CA_CSE1_V1e_wo_LOSV2b_B.Product2_i[tmp_0];
      }

      /* Fcn: '<S86>/x->r' */
      CA_CSE1_V1e_wo_LOSV2b_B.xr = rt_hypot_snf(CA_CSE1_V1e_wo_LOSV2b_B.u_2plant,
        CA_CSE1_V1e_wo_LOSV2b_B.u_1plant);

      /* Fcn: '<S86>/x->theta' */
      CA_CSE1_V1e_wo_LOSV2b_B.xtheta = rt_atan2_snf
        (CA_CSE1_V1e_wo_LOSV2b_B.u_1plant, CA_CSE1_V1e_wo_LOSV2b_B.u_2plant);

      /* Fcn: '<S87>/x->r' */
      CA_CSE1_V1e_wo_LOSV2b_B.xr_g = rt_hypot_snf
        (CA_CSE1_V1e_wo_LOSV2b_B.u_4plant, CA_CSE1_V1e_wo_LOSV2b_B.u_3plant);

      /* Fcn: '<S87>/x->theta' */
      CA_CSE1_V1e_wo_LOSV2b_B.xtheta_a = rt_atan2_snf
        (CA_CSE1_V1e_wo_LOSV2b_B.u_3plant, CA_CSE1_V1e_wo_LOSV2b_B.u_4plant);

      /* Gain: '<S80>/VSP_angle_deg_port' */
      CA_CSE1_V1e_wo_LOSV2b_B.VSP_angle_deg_port =
        CA_CSE1_V1e_wo_LOSV2b_P.VSP_angle_deg_port_Gain *
        CA_CSE1_V1e_wo_LOSV2b_B.xtheta;

      /* Gain: '<S80>/VSP_angle_deg_stbd' */
      CA_CSE1_V1e_wo_LOSV2b_B.VSP_angle_deg_stbd =
        CA_CSE1_V1e_wo_LOSV2b_P.VSP_angle_deg_stbd_Gain *
        CA_CSE1_V1e_wo_LOSV2b_B.xtheta_a;
      if (rtmIsMajorTimeStep(CA_CSE1_V1e_wo_LOSV2b_M)) {
        /* Update for UnitDelay: '<S89>/Delay Input2' */
        CA_CSE1_V1e_wo_LOSV2b_DWork.DelayInput2_DSTATE =
          CA_CSE1_V1e_wo_LOSV2b_B.DifferenceInputs2;
      }
    }

    /* end of Update for SubSystem: '<S5>/Linear Simulator' */

    /* Derivative Block: '<S63>/Derivative' */
    {
      real_T timeStampA =
        CA_CSE1_V1e_wo_LOSV2b_DWork.Derivative_RWORK.TimeStampA;
      real_T timeStampB =
        CA_CSE1_V1e_wo_LOSV2b_DWork.Derivative_RWORK.TimeStampB;
      real_T *lastBank =
        &CA_CSE1_V1e_wo_LOSV2b_DWork.Derivative_RWORK.TimeStampA;
      if (timeStampA != rtInf) {
        if (timeStampB == rtInf) {
          lastBank += 7;
        } else if (timeStampA >= timeStampB) {
          lastBank += 7;
        }
      }

      *lastBank++ = CA_CSE1_V1e_wo_LOSV2b_M->Timing.t[0];
      *lastBank++ = CA_CSE1_V1e_wo_LOSV2b_B.mm2mx;
      *lastBank++ = CA_CSE1_V1e_wo_LOSV2b_B.mm2my;
      *lastBank++ = CA_CSE1_V1e_wo_LOSV2b_B.mm2mz;
      *lastBank++ = CA_CSE1_V1e_wo_LOSV2b_B.d2rroll;
      *lastBank++ = CA_CSE1_V1e_wo_LOSV2b_B.d2rpitch;
      *lastBank++ = CA_CSE1_V1e_wo_LOSV2b_B.d2ryaw;
    }

    /* Update for enable SubSystem: '<S1>/DP control' incorporates:
     *  Update for EnablePort: '<S6>/Enable'
     */
    if (CA_CSE1_V1e_wo_LOSV2b_DWork.DPcontrol_MODE == SUBSYS_ENABLED) {
    }

    /* end of Update for SubSystem: '<S1>/DP control' */
    if (rtmIsMajorTimeStep(CA_CSE1_V1e_wo_LOSV2b_M)) {
      /* Update for Memory: '<S52>/Memory2' */
      CA_CSE1_V1e_wo_LOSV2b_DWork.Memory2_PreviousInput =
        CA_CSE1_V1e_wo_LOSV2b_B.Output_m;

      /* Update for Memory: '<S52>/Memory1' */
      CA_CSE1_V1e_wo_LOSV2b_DWork.Memory1_PreviousInput =
        CA_CSE1_V1e_wo_LOSV2b_B.Integrator;

      /* Update for Memory: '<S52>/Memory' */
      CA_CSE1_V1e_wo_LOSV2b_DWork.Memory_PreviousInput =
        CA_CSE1_V1e_wo_LOSV2b_B.Output;

      /* Update for Memory: '<S52>/Memory3' */
      CA_CSE1_V1e_wo_LOSV2b_DWork.Memory3_PreviousInput =
        CA_CSE1_V1e_wo_LOSV2b_B.trigfun1;
    }

    /* Derivative Block: '<S54>/Derivative' */
    {
      real_T timeStampA =
        CA_CSE1_V1e_wo_LOSV2b_DWork.Derivative_RWORK_m.TimeStampA;
      real_T timeStampB =
        CA_CSE1_V1e_wo_LOSV2b_DWork.Derivative_RWORK_m.TimeStampB;
      real_T *lastBank =
        &CA_CSE1_V1e_wo_LOSV2b_DWork.Derivative_RWORK_m.TimeStampA;
      if (timeStampA != rtInf) {
        if (timeStampB == rtInf) {
          lastBank += 2;
        } else if (timeStampA >= timeStampB) {
          lastBank += 2;
        }
      }

      *lastBank++ = CA_CSE1_V1e_wo_LOSV2b_M->Timing.t[0];
      *lastBank++ = CA_CSE1_V1e_wo_LOSV2b_P.U_d_Value;
    }

    if (rtmIsMajorTimeStep(CA_CSE1_V1e_wo_LOSV2b_M)) {
      /* Update for Memory: '<S53>/Memory' */
      CA_CSE1_V1e_wo_LOSV2b_DWork.Memory_PreviousInput_d =
        CA_CSE1_V1e_wo_LOSV2b_B.Divide;

      /* Update for Memory: '<S53>/Memory1' */
      CA_CSE1_V1e_wo_LOSV2b_DWork.Memory1_PreviousInput_g =
        CA_CSE1_V1e_wo_LOSV2b_B.Integrator;

      /* Update for Memory: '<S53>/Memory2' */
      CA_CSE1_V1e_wo_LOSV2b_DWork.Memory2_PreviousInput_e =
        CA_CSE1_V1e_wo_LOSV2b_B.Divide1;

      /* Update for Memory: '<S53>/Memory3' */
      CA_CSE1_V1e_wo_LOSV2b_DWork.Memory3_PreviousInput_n =
        CA_CSE1_V1e_wo_LOSV2b_B.Divide2;
    }

    /* Derivative Block: '<S63>/Derivative1' */
    {
      real_T timeStampA =
        CA_CSE1_V1e_wo_LOSV2b_DWork.Derivative1_RWORK.TimeStampA;
      real_T timeStampB =
        CA_CSE1_V1e_wo_LOSV2b_DWork.Derivative1_RWORK.TimeStampB;
      real_T *lastBank =
        &CA_CSE1_V1e_wo_LOSV2b_DWork.Derivative1_RWORK.TimeStampA;
      if (timeStampA != rtInf) {
        if (timeStampB == rtInf) {
          lastBank += 7;
        } else if (timeStampA >= timeStampB) {
          lastBank += 7;
        }
      }

      *lastBank++ = CA_CSE1_V1e_wo_LOSV2b_M->Timing.t[0];
      *lastBank++ = CA_CSE1_V1e_wo_LOSV2b_B.mm2mx1;
      *lastBank++ = CA_CSE1_V1e_wo_LOSV2b_B.mm2my1;
      *lastBank++ = CA_CSE1_V1e_wo_LOSV2b_B.mm2mz1;
      *lastBank++ = CA_CSE1_V1e_wo_LOSV2b_B.d2rroll1;
      *lastBank++ = CA_CSE1_V1e_wo_LOSV2b_B.d2rpitch1;
      *lastBank++ = CA_CSE1_V1e_wo_LOSV2b_B.d2ryaw1;
    }

    if (rtmIsMajorTimeStep(CA_CSE1_V1e_wo_LOSV2b_M)) {
    }
  }

  if (rtmIsMajorTimeStep(CA_CSE1_V1e_wo_LOSV2b_M)) {
    rt_ertODEUpdateContinuousStates(&CA_CSE1_V1e_wo_LOSV2b_M->solverInfo);
  }

  /* Update absolute time for base rate */
  /* The "clockTick0" counts the number of times the code of this task has
   * been executed. The absolute time is the multiplication of "clockTick0"
   * and "Timing.stepSize0". Size of "clockTick0" ensures timer will not
   * overflow during the application lifespan selected.
   * Timer of this task consists of two 32 bit unsigned integers.
   * The two integers represent the low bits Timing.clockTick0 and the high bits
   * Timing.clockTickH0. When the low bit overflows to 0, the high bits increment.
   */
  if (!(++CA_CSE1_V1e_wo_LOSV2b_M->Timing.clockTick0))
    ++CA_CSE1_V1e_wo_LOSV2b_M->Timing.clockTickH0;
  CA_CSE1_V1e_wo_LOSV2b_M->Timing.t[0] =
    CA_CSE1_V1e_wo_LOSV2b_M->Timing.clockTick0 *
    CA_CSE1_V1e_wo_LOSV2b_M->Timing.stepSize0 +
    CA_CSE1_V1e_wo_LOSV2b_M->Timing.clockTickH0 *
    CA_CSE1_V1e_wo_LOSV2b_M->Timing.stepSize0 * 4294967296.0;
  if (rtmIsMajorTimeStep(CA_CSE1_V1e_wo_LOSV2b_M)) {
    /* Update absolute timer for sample time: [0.1s, 0.0s] */
    /* The "clockTick1" counts the number of times the code of this task has
     * been executed. The absolute time is the multiplication of "clockTick1"
     * and "Timing.stepSize1". Size of "clockTick1" ensures timer will not
     * overflow during the application lifespan selected.
     * Timer of this task consists of two 32 bit unsigned integers.
     * The two integers represent the low bits Timing.clockTick1 and the high bits
     * Timing.clockTickH1. When the low bit overflows to 0, the high bits increment.
     */
    if (!(++CA_CSE1_V1e_wo_LOSV2b_M->Timing.clockTick1))
      ++CA_CSE1_V1e_wo_LOSV2b_M->Timing.clockTickH1;
    CA_CSE1_V1e_wo_LOSV2b_M->Timing.t[1] =
      CA_CSE1_V1e_wo_LOSV2b_M->Timing.clockTick1 *
      CA_CSE1_V1e_wo_LOSV2b_M->Timing.stepSize1 +
      CA_CSE1_V1e_wo_LOSV2b_M->Timing.clockTickH1 *
      CA_CSE1_V1e_wo_LOSV2b_M->Timing.stepSize1 * 4294967296.0;
  }

  /* tid is required for a uniform function interface.
   * Argument tid is not used in the function. */
  UNUSED_PARAMETER(tid);
}

/* Derivatives for root system: '<Root>' */
void CA_CSE1_V1e_wo_LOSV2b_derivatives(void)
{
  {
    real_T tmp[15];
    int32_T tmp_0;
    int32_T tmp_1;
    int32_T tmp_2;

    /* TransferFcn Block: '<S48>/Transfer Fcn' */
    {
      ((StateDerivatives_CA_CSE1_V1e_wo *)
        CA_CSE1_V1e_wo_LOSV2b_M->ModelData.derivs)->TransferFcn_CSTATE =
        CA_CSE1_V1e_wo_LOSV2b_P.x_d_Value;
      ((StateDerivatives_CA_CSE1_V1e_wo *)
        CA_CSE1_V1e_wo_LOSV2b_M->ModelData.derivs)->TransferFcn_CSTATE +=
        (CA_CSE1_V1e_wo_LOSV2b_P.TransferFcn_A)*
        CA_CSE1_V1e_wo_LOSV2b_X.TransferFcn_CSTATE;
    }

    /* TransferFcn Block: '<S48>/Transfer Fcn1' */
    {
      ((StateDerivatives_CA_CSE1_V1e_wo *)
        CA_CSE1_V1e_wo_LOSV2b_M->ModelData.derivs)->TransferFcn1_CSTATE =
        CA_CSE1_V1e_wo_LOSV2b_P.y_d_Value;
      ((StateDerivatives_CA_CSE1_V1e_wo *)
        CA_CSE1_V1e_wo_LOSV2b_M->ModelData.derivs)->TransferFcn1_CSTATE +=
        (CA_CSE1_V1e_wo_LOSV2b_P.TransferFcn1_A)*
        CA_CSE1_V1e_wo_LOSV2b_X.TransferFcn1_CSTATE;
    }

    /* TransferFcn Block: '<S48>/Transfer Fcn2' */
    {
      ((StateDerivatives_CA_CSE1_V1e_wo *)
        CA_CSE1_V1e_wo_LOSV2b_M->ModelData.derivs)->TransferFcn2_CSTATE =
        CA_CSE1_V1e_wo_LOSV2b_B.Gain1;
      ((StateDerivatives_CA_CSE1_V1e_wo *)
        CA_CSE1_V1e_wo_LOSV2b_M->ModelData.derivs)->TransferFcn2_CSTATE +=
        (CA_CSE1_V1e_wo_LOSV2b_P.TransferFcn2_A)*
        CA_CSE1_V1e_wo_LOSV2b_X.TransferFcn2_CSTATE;
    }

    /* Derivatives for enable SubSystem: '<S5>/Linear Simulator' */
    if (CA_CSE1_V1e_wo_LOSV2b_DWork.LinearSimulator_MODE == SUBSYS_ENABLED) {
      /* Gain: '<S80>/Gain u_1' */
      CA_CSE1_V1e_wo_LOSV2b_B.Gainu_1 = CA_CSE1_V1e_wo_LOSV2b_P.Gainu_1_Gain *
        CA_CSE1_V1e_wo_LOSV2b_B.u_1plant;

      /* Gain: '<S80>/Gain u_2' */
      CA_CSE1_V1e_wo_LOSV2b_B.Gainu_2 = CA_CSE1_V1e_wo_LOSV2b_P.Gainu_2_Gain *
        CA_CSE1_V1e_wo_LOSV2b_B.u_2plant;

      /* Gain: '<S80>/Gain u_3' */
      CA_CSE1_V1e_wo_LOSV2b_B.Gainu_3 = CA_CSE1_V1e_wo_LOSV2b_P.Gainu_3_Gain *
        CA_CSE1_V1e_wo_LOSV2b_B.u_3plant;

      /* Gain: '<S80>/Gain u_4' */
      CA_CSE1_V1e_wo_LOSV2b_B.Gainu_4 = CA_CSE1_V1e_wo_LOSV2b_P.Gainu_4_Gain *
        CA_CSE1_V1e_wo_LOSV2b_B.u_4plant;

      /* Gain: '<S80>/Gain BT power' */
      CA_CSE1_V1e_wo_LOSV2b_B.GainBTpower =
        CA_CSE1_V1e_wo_LOSV2b_P.GainBTpower_Gain *
        CA_CSE1_V1e_wo_LOSV2b_B.BTpowerlmit;

      /* Product: '<S89>/delta rise limit' */
      CA_CSE1_V1e_wo_LOSV2b_B.deltariselimit =
        CA_CSE1_V1e_wo_LOSV2b_B.GainBTpower * CA_CSE1_V1e_wo_LOSV2b_B.sampletime;

      /* Sum: '<S89>/Difference Inputs1' */
      CA_CSE1_V1e_wo_LOSV2b_B.UkYk1 = CA_CSE1_V1e_wo_LOSV2b_B.u_5plant -
        CA_CSE1_V1e_wo_LOSV2b_B.Yk1;

      /* RelationalOperator: '<S91>/LowerRelop1' */
      CA_CSE1_V1e_wo_LOSV2b_B.LowerRelop1 = (CA_CSE1_V1e_wo_LOSV2b_B.UkYk1 >
        CA_CSE1_V1e_wo_LOSV2b_B.deltariselimit);

      /* Gain: '<S80>/Neg' */
      CA_CSE1_V1e_wo_LOSV2b_B.Neg = CA_CSE1_V1e_wo_LOSV2b_P.Neg_Gain_o *
        CA_CSE1_V1e_wo_LOSV2b_B.GainBTpower;

      /* Product: '<S89>/delta fall limit' */
      CA_CSE1_V1e_wo_LOSV2b_B.deltafalllimit = CA_CSE1_V1e_wo_LOSV2b_B.Neg *
        CA_CSE1_V1e_wo_LOSV2b_B.sampletime;

      /* RelationalOperator: '<S91>/UpperRelop' */
      CA_CSE1_V1e_wo_LOSV2b_B.UpperRelop = (CA_CSE1_V1e_wo_LOSV2b_B.UkYk1 <
        CA_CSE1_V1e_wo_LOSV2b_B.deltafalllimit);

      /* Switch: '<S91>/Switch' */
      if (CA_CSE1_V1e_wo_LOSV2b_B.UpperRelop) {
        CA_CSE1_V1e_wo_LOSV2b_B.Switch = CA_CSE1_V1e_wo_LOSV2b_B.deltafalllimit;
      } else {
        CA_CSE1_V1e_wo_LOSV2b_B.Switch = CA_CSE1_V1e_wo_LOSV2b_B.UkYk1;
      }

      /* Switch: '<S91>/Switch2' */
      if (CA_CSE1_V1e_wo_LOSV2b_B.LowerRelop1) {
        CA_CSE1_V1e_wo_LOSV2b_B.Switch2 = CA_CSE1_V1e_wo_LOSV2b_B.deltariselimit;
      } else {
        CA_CSE1_V1e_wo_LOSV2b_B.Switch2 = CA_CSE1_V1e_wo_LOSV2b_B.Switch;
      }

      /* Sum: '<S89>/Difference Inputs2' */
      CA_CSE1_V1e_wo_LOSV2b_B.DifferenceInputs2 =
        CA_CSE1_V1e_wo_LOSV2b_B.Switch2 + CA_CSE1_V1e_wo_LOSV2b_B.Yk1;

      /* Gain: '<S80>/Gain u_5' */
      CA_CSE1_V1e_wo_LOSV2b_B.Gainu_5 = CA_CSE1_V1e_wo_LOSV2b_P.Gainu_5_Gain *
        CA_CSE1_V1e_wo_LOSV2b_B.DifferenceInputs2;

      /* SignalConversion: '<S80>/TmpHiddenBufferAtT_e^+ K_e^-1 u_eInport3' */
      CA_CSE1_V1e_wo_LOSV2b_B.TmpHiddenBufferAtT_eK_e1u_eInpo[0] =
        CA_CSE1_V1e_wo_LOSV2b_B.Gainu_1;
      CA_CSE1_V1e_wo_LOSV2b_B.TmpHiddenBufferAtT_eK_e1u_eInpo[1] =
        CA_CSE1_V1e_wo_LOSV2b_B.Gainu_2;
      CA_CSE1_V1e_wo_LOSV2b_B.TmpHiddenBufferAtT_eK_e1u_eInpo[2] =
        CA_CSE1_V1e_wo_LOSV2b_B.Gainu_3;
      CA_CSE1_V1e_wo_LOSV2b_B.TmpHiddenBufferAtT_eK_e1u_eInpo[3] =
        CA_CSE1_V1e_wo_LOSV2b_B.Gainu_4;
      CA_CSE1_V1e_wo_LOSV2b_B.TmpHiddenBufferAtT_eK_e1u_eInpo[4] =
        CA_CSE1_V1e_wo_LOSV2b_B.Gainu_5;

      /* Product: '<S80>/T_e^+ K_e^-1 u_e' */
      for (tmp_0 = 0; tmp_0 < 3; tmp_0++) {
        for (tmp_2 = 0; tmp_2 < 5; tmp_2++) {
          tmp[tmp_0 + 3 * tmp_2] = 0.0;
          for (tmp_1 = 0; tmp_1 < 5; tmp_1++) {
            tmp[tmp_0 + 3 * tmp_2] = CA_CSE1_V1e_wo_LOSV2b_B.x5_d[3 * tmp_1 +
              tmp_0] * CA_CSE1_V1e_wo_LOSV2b_B.ThrusterGainmatrix_e[5 * tmp_2 +
              tmp_1] + tmp[3 * tmp_2 + tmp_0];
          }
        }
      }

      for (tmp_0 = 0; tmp_0 < 3; tmp_0++) {
        CA_CSE1_V1e_wo_LOSV2b_B.T_eK_e1u_e[tmp_0] = 0.0;
        for (tmp_2 = 0; tmp_2 < 5; tmp_2++) {
          CA_CSE1_V1e_wo_LOSV2b_B.T_eK_e1u_e[tmp_0] = tmp[3 * tmp_2 + tmp_0] *
            CA_CSE1_V1e_wo_LOSV2b_B.TmpHiddenBufferAtT_eK_e1u_eInpo[tmp_2] +
            CA_CSE1_V1e_wo_LOSV2b_B.T_eK_e1u_e[tmp_0];
        }
      }

      /* Gain: '<S80>/tau_surge_hil' */
      CA_CSE1_V1e_wo_LOSV2b_B.tau_surge_hil =
        CA_CSE1_V1e_wo_LOSV2b_P.tau_surge_hil_Gain *
        CA_CSE1_V1e_wo_LOSV2b_B.T_eK_e1u_e[0];

      /* Gain: '<S80>/tau_sway_hil' */
      CA_CSE1_V1e_wo_LOSV2b_B.tau_sway_hil =
        CA_CSE1_V1e_wo_LOSV2b_P.tau_sway_hil_Gain *
        CA_CSE1_V1e_wo_LOSV2b_B.T_eK_e1u_e[1];

      /* Gain: '<S80>/tau_yaw_hil' */
      CA_CSE1_V1e_wo_LOSV2b_B.tau_yaw_hil =
        CA_CSE1_V1e_wo_LOSV2b_P.tau_yaw_hil_Gain *
        CA_CSE1_V1e_wo_LOSV2b_B.T_eK_e1u_e[2];

      /* Sum: '<S79>/Sum' */
      CA_CSE1_V1e_wo_LOSV2b_B.Sum_j2[0] = CA_CSE1_V1e_wo_LOSV2b_B.tau_surge_hil
        - CA_CSE1_V1e_wo_LOSV2b_B.Product1_b[0];
      CA_CSE1_V1e_wo_LOSV2b_B.Sum_j2[1] = CA_CSE1_V1e_wo_LOSV2b_B.tau_sway_hil -
        CA_CSE1_V1e_wo_LOSV2b_B.Product1_b[1];
      CA_CSE1_V1e_wo_LOSV2b_B.Sum_j2[2] = CA_CSE1_V1e_wo_LOSV2b_B.tau_yaw_hil -
        CA_CSE1_V1e_wo_LOSV2b_B.Product1_b[2];

      /* Product: '<S79>/Product2' */
      for (tmp_0 = 0; tmp_0 < 3; tmp_0++) {
        CA_CSE1_V1e_wo_LOSV2b_B.Product2_i[tmp_0] = 0.0;
        CA_CSE1_V1e_wo_LOSV2b_B.Product2_i[tmp_0] =
          CA_CSE1_V1e_wo_LOSV2b_B.Inverse[tmp_0] *
          CA_CSE1_V1e_wo_LOSV2b_B.Sum_j2[0] +
          CA_CSE1_V1e_wo_LOSV2b_B.Product2_i[tmp_0];
        CA_CSE1_V1e_wo_LOSV2b_B.Product2_i[tmp_0] =
          CA_CSE1_V1e_wo_LOSV2b_B.Inverse[tmp_0 + 3] *
          CA_CSE1_V1e_wo_LOSV2b_B.Sum_j2[1] +
          CA_CSE1_V1e_wo_LOSV2b_B.Product2_i[tmp_0];
        CA_CSE1_V1e_wo_LOSV2b_B.Product2_i[tmp_0] =
          CA_CSE1_V1e_wo_LOSV2b_B.Inverse[tmp_0 + 6] *
          CA_CSE1_V1e_wo_LOSV2b_B.Sum_j2[2] +
          CA_CSE1_V1e_wo_LOSV2b_B.Product2_i[tmp_0];
      }

      /* Fcn: '<S86>/x->r' */
      CA_CSE1_V1e_wo_LOSV2b_B.xr = rt_hypot_snf(CA_CSE1_V1e_wo_LOSV2b_B.u_2plant,
        CA_CSE1_V1e_wo_LOSV2b_B.u_1plant);

      /* Fcn: '<S86>/x->theta' */
      CA_CSE1_V1e_wo_LOSV2b_B.xtheta = rt_atan2_snf
        (CA_CSE1_V1e_wo_LOSV2b_B.u_1plant, CA_CSE1_V1e_wo_LOSV2b_B.u_2plant);

      /* Fcn: '<S87>/x->r' */
      CA_CSE1_V1e_wo_LOSV2b_B.xr_g = rt_hypot_snf
        (CA_CSE1_V1e_wo_LOSV2b_B.u_4plant, CA_CSE1_V1e_wo_LOSV2b_B.u_3plant);

      /* Fcn: '<S87>/x->theta' */
      CA_CSE1_V1e_wo_LOSV2b_B.xtheta_a = rt_atan2_snf
        (CA_CSE1_V1e_wo_LOSV2b_B.u_3plant, CA_CSE1_V1e_wo_LOSV2b_B.u_4plant);

      /* Gain: '<S80>/VSP_angle_deg_port' */
      CA_CSE1_V1e_wo_LOSV2b_B.VSP_angle_deg_port =
        CA_CSE1_V1e_wo_LOSV2b_P.VSP_angle_deg_port_Gain *
        CA_CSE1_V1e_wo_LOSV2b_B.xtheta;

      /* Gain: '<S80>/VSP_angle_deg_stbd' */
      CA_CSE1_V1e_wo_LOSV2b_B.VSP_angle_deg_stbd =
        CA_CSE1_V1e_wo_LOSV2b_P.VSP_angle_deg_stbd_Gain *
        CA_CSE1_V1e_wo_LOSV2b_B.xtheta_a;

      /* Integrator Block: '<S79>/Integrator' */
      {
        if (CA_CSE1_V1e_wo_LOSV2b_P.ResetLinearSimulatorintegrator_== 0.0) {
          ((StateDerivatives_CA_CSE1_V1e_wo *)
            CA_CSE1_V1e_wo_LOSV2b_M->ModelData.derivs)->Integrator_CSTATE_a[0] =
            CA_CSE1_V1e_wo_LOSV2b_B.Product2_i[0];
        } else {
          /* level reset is active*/
          ((StateDerivatives_CA_CSE1_V1e_wo *)
            CA_CSE1_V1e_wo_LOSV2b_M->ModelData.derivs)->Integrator_CSTATE_a[0] =
            0.0;
        }

        if (CA_CSE1_V1e_wo_LOSV2b_P.ResetLinearSimulatorintegrator_== 0.0) {
          ((StateDerivatives_CA_CSE1_V1e_wo *)
            CA_CSE1_V1e_wo_LOSV2b_M->ModelData.derivs)->Integrator_CSTATE_a[1] =
            CA_CSE1_V1e_wo_LOSV2b_B.Product2_i[1];
        } else {
          /* level reset is active*/
          ((StateDerivatives_CA_CSE1_V1e_wo *)
            CA_CSE1_V1e_wo_LOSV2b_M->ModelData.derivs)->Integrator_CSTATE_a[1] =
            0.0;
        }

        if (CA_CSE1_V1e_wo_LOSV2b_P.ResetLinearSimulatorintegrator_== 0.0) {
          ((StateDerivatives_CA_CSE1_V1e_wo *)
            CA_CSE1_V1e_wo_LOSV2b_M->ModelData.derivs)->Integrator_CSTATE_a[2] =
            CA_CSE1_V1e_wo_LOSV2b_B.Product2_i[2];
        } else {
          /* level reset is active*/
          ((StateDerivatives_CA_CSE1_V1e_wo *)
            CA_CSE1_V1e_wo_LOSV2b_M->ModelData.derivs)->Integrator_CSTATE_a[2] =
            0.0;
        }
      }

      /* Integrator Block: '<S79>/Integrator1' */
      {
        if (CA_CSE1_V1e_wo_LOSV2b_P.ResetLinearSimulatorintegrator_== 0.0) {
          ((StateDerivatives_CA_CSE1_V1e_wo *)
            CA_CSE1_V1e_wo_LOSV2b_M->ModelData.derivs)->Integrator1_CSTATE[0] =
            CA_CSE1_V1e_wo_LOSV2b_B.Product3_g[0];
        } else {
          /* level reset is active*/
          ((StateDerivatives_CA_CSE1_V1e_wo *)
            CA_CSE1_V1e_wo_LOSV2b_M->ModelData.derivs)->Integrator1_CSTATE[0] =
            0.0;
        }

        if (CA_CSE1_V1e_wo_LOSV2b_P.ResetLinearSimulatorintegrator_== 0.0) {
          ((StateDerivatives_CA_CSE1_V1e_wo *)
            CA_CSE1_V1e_wo_LOSV2b_M->ModelData.derivs)->Integrator1_CSTATE[1] =
            CA_CSE1_V1e_wo_LOSV2b_B.Product3_g[1];
        } else {
          /* level reset is active*/
          ((StateDerivatives_CA_CSE1_V1e_wo *)
            CA_CSE1_V1e_wo_LOSV2b_M->ModelData.derivs)->Integrator1_CSTATE[1] =
            0.0;
        }

        if (CA_CSE1_V1e_wo_LOSV2b_P.ResetLinearSimulatorintegrator_== 0.0) {
          ((StateDerivatives_CA_CSE1_V1e_wo *)
            CA_CSE1_V1e_wo_LOSV2b_M->ModelData.derivs)->Integrator1_CSTATE[2] =
            CA_CSE1_V1e_wo_LOSV2b_B.Product3_g[2];
        } else {
          /* level reset is active*/
          ((StateDerivatives_CA_CSE1_V1e_wo *)
            CA_CSE1_V1e_wo_LOSV2b_M->ModelData.derivs)->Integrator1_CSTATE[2] =
            0.0;
        }
      }
    } else {
      {
        real_T *dx;
        int_T i;
        dx = &(((StateDerivatives_CA_CSE1_V1e_wo *)
                CA_CSE1_V1e_wo_LOSV2b_M->ModelData.derivs)->Integrator_CSTATE_a
               [0]);
        for (i=0; i < 6; i++) {
          dx[i] = 0.0;
        }
      }
    }

    /* end of Derivatives for SubSystem: '<S5>/Linear Simulator' */

    /* Derivatives for enable SubSystem: '<S1>/DP control' */
    if (CA_CSE1_V1e_wo_LOSV2b_DWork.DPcontrol_MODE == SUBSYS_ENABLED) {
      /* Derivatives for Integrator: '<S16>/Integrator1' */
      ((StateDerivatives_CA_CSE1_V1e_wo *)
        CA_CSE1_V1e_wo_LOSV2b_M->ModelData.derivs)->Integrator1_CSTATE_i[0] =
        CA_CSE1_V1e_wo_LOSV2b_B.Sum6[0];

      /* Derivatives for Integrator: '<S16>/Integrator' */
      ((StateDerivatives_CA_CSE1_V1e_wo *)
        CA_CSE1_V1e_wo_LOSV2b_M->ModelData.derivs)->Integrator_CSTATE_o[0] =
        CA_CSE1_V1e_wo_LOSV2b_B.Sum3_k[0];

      /* Derivatives for Integrator: '<S16>/Integrator1' */
      ((StateDerivatives_CA_CSE1_V1e_wo *)
        CA_CSE1_V1e_wo_LOSV2b_M->ModelData.derivs)->Integrator1_CSTATE_i[1] =
        CA_CSE1_V1e_wo_LOSV2b_B.Sum6[1];

      /* Derivatives for Integrator: '<S16>/Integrator' */
      ((StateDerivatives_CA_CSE1_V1e_wo *)
        CA_CSE1_V1e_wo_LOSV2b_M->ModelData.derivs)->Integrator_CSTATE_o[1] =
        CA_CSE1_V1e_wo_LOSV2b_B.Sum3_k[1];

      /* Derivatives for Integrator: '<S16>/Integrator1' */
      ((StateDerivatives_CA_CSE1_V1e_wo *)
        CA_CSE1_V1e_wo_LOSV2b_M->ModelData.derivs)->Integrator1_CSTATE_i[2] =
        CA_CSE1_V1e_wo_LOSV2b_B.Sum6[2];

      /* Derivatives for Integrator: '<S16>/Integrator' */
      ((StateDerivatives_CA_CSE1_V1e_wo *)
        CA_CSE1_V1e_wo_LOSV2b_M->ModelData.derivs)->Integrator_CSTATE_o[2] =
        CA_CSE1_V1e_wo_LOSV2b_B.Sum3_k[2];

      /* Integrator Block: '<S14>/Integrator' */
      {
        if (CA_CSE1_V1e_wo_LOSV2b_P.Reset_DP_integrator_Value== 0.0) {
          ((StateDerivatives_CA_CSE1_V1e_wo *)
            CA_CSE1_V1e_wo_LOSV2b_M->ModelData.derivs)->Integrator_CSTATE_e[0] =
            CA_CSE1_V1e_wo_LOSV2b_B.TmpHiddenBufferAtKpInport1[0];
        } else {
          /* level reset is active*/
          ((StateDerivatives_CA_CSE1_V1e_wo *)
            CA_CSE1_V1e_wo_LOSV2b_M->ModelData.derivs)->Integrator_CSTATE_e[0] =
            0.0;
        }

        if (CA_CSE1_V1e_wo_LOSV2b_P.Reset_DP_integrator_Value== 0.0) {
          ((StateDerivatives_CA_CSE1_V1e_wo *)
            CA_CSE1_V1e_wo_LOSV2b_M->ModelData.derivs)->Integrator_CSTATE_e[1] =
            CA_CSE1_V1e_wo_LOSV2b_B.TmpHiddenBufferAtKpInport1[1];
        } else {
          /* level reset is active*/
          ((StateDerivatives_CA_CSE1_V1e_wo *)
            CA_CSE1_V1e_wo_LOSV2b_M->ModelData.derivs)->Integrator_CSTATE_e[1] =
            0.0;
        }

        if (CA_CSE1_V1e_wo_LOSV2b_P.Reset_DP_integrator_Value== 0.0) {
          ((StateDerivatives_CA_CSE1_V1e_wo *)
            CA_CSE1_V1e_wo_LOSV2b_M->ModelData.derivs)->Integrator_CSTATE_e[2] =
            CA_CSE1_V1e_wo_LOSV2b_B.TmpHiddenBufferAtKpInport1[2];
        } else {
          /* level reset is active*/
          ((StateDerivatives_CA_CSE1_V1e_wo *)
            CA_CSE1_V1e_wo_LOSV2b_M->ModelData.derivs)->Integrator_CSTATE_e[2] =
            0.0;
        }
      }

      /* Derivatives for Integrator: '<S16>/Integrator4' */
      ((StateDerivatives_CA_CSE1_V1e_wo *)
        CA_CSE1_V1e_wo_LOSV2b_M->ModelData.derivs)->Integrator4_CSTATE[0] =
        CA_CSE1_V1e_wo_LOSV2b_B.Gain3[0];

      /* Derivatives for Integrator: '<S16>/Integrator2' */
      ((StateDerivatives_CA_CSE1_V1e_wo *)
        CA_CSE1_V1e_wo_LOSV2b_M->ModelData.derivs)->Integrator2_CSTATE[0] =
        CA_CSE1_V1e_wo_LOSV2b_B.psi_WF[0];

      /* Derivatives for Integrator: '<S16>/Integrator3' */
      ((StateDerivatives_CA_CSE1_V1e_wo *)
        CA_CSE1_V1e_wo_LOSV2b_M->ModelData.derivs)->Integrator3_CSTATE[0] =
        CA_CSE1_V1e_wo_LOSV2b_B.Sum7[0];

      /* Derivatives for Integrator: '<S16>/Integrator4' */
      ((StateDerivatives_CA_CSE1_V1e_wo *)
        CA_CSE1_V1e_wo_LOSV2b_M->ModelData.derivs)->Integrator4_CSTATE[1] =
        CA_CSE1_V1e_wo_LOSV2b_B.Gain3[1];

      /* Derivatives for Integrator: '<S16>/Integrator2' */
      ((StateDerivatives_CA_CSE1_V1e_wo *)
        CA_CSE1_V1e_wo_LOSV2b_M->ModelData.derivs)->Integrator2_CSTATE[1] =
        CA_CSE1_V1e_wo_LOSV2b_B.psi_WF[1];

      /* Derivatives for Integrator: '<S16>/Integrator3' */
      ((StateDerivatives_CA_CSE1_V1e_wo *)
        CA_CSE1_V1e_wo_LOSV2b_M->ModelData.derivs)->Integrator3_CSTATE[1] =
        CA_CSE1_V1e_wo_LOSV2b_B.Sum7[1];

      /* Derivatives for Integrator: '<S16>/Integrator4' */
      ((StateDerivatives_CA_CSE1_V1e_wo *)
        CA_CSE1_V1e_wo_LOSV2b_M->ModelData.derivs)->Integrator4_CSTATE[2] =
        CA_CSE1_V1e_wo_LOSV2b_B.Gain3[2];

      /* Derivatives for Integrator: '<S16>/Integrator2' */
      ((StateDerivatives_CA_CSE1_V1e_wo *)
        CA_CSE1_V1e_wo_LOSV2b_M->ModelData.derivs)->Integrator2_CSTATE[2] =
        CA_CSE1_V1e_wo_LOSV2b_B.psi_WF[2];

      /* Derivatives for Integrator: '<S16>/Integrator3' */
      ((StateDerivatives_CA_CSE1_V1e_wo *)
        CA_CSE1_V1e_wo_LOSV2b_M->ModelData.derivs)->Integrator3_CSTATE[2] =
        CA_CSE1_V1e_wo_LOSV2b_B.Sum7[2];
    } else {
      {
        real_T *dx;
        int_T i;
        dx = &(((StateDerivatives_CA_CSE1_V1e_wo *)
                CA_CSE1_V1e_wo_LOSV2b_M->ModelData.derivs)->
               Integrator1_CSTATE_i[0]);
        for (i=0; i < 18; i++) {
          dx[i] = 0.0;
        }
      }
    }

    /* end of Derivatives for SubSystem: '<S1>/DP control' */

    /* Derivatives for Integrator: '<S35>/Integrator' */
    ((StateDerivatives_CA_CSE1_V1e_wo *)
      CA_CSE1_V1e_wo_LOSV2b_M->ModelData.derivs)->Integrator_CSTATE =
      CA_CSE1_V1e_wo_LOSV2b_B.Sum_d;
  }
}

/* Model initialize function */
void CA_CSE1_V1e_wo_LOSV2b_initialize(boolean_T firstTime)
{
  (void)firstTime;

  /* Registration code */

  /* initialize non-finites */
  rt_InitInfAndNaN(sizeof(real_T));

  /* initialize real-time model */
  (void) memset((void *)CA_CSE1_V1e_wo_LOSV2b_M,0,
                sizeof(RT_MODEL_CA_CSE1_V1e_wo_LOSV2b));

  {
    /* Setup solver object */
    rtsiSetSimTimeStepPtr(&CA_CSE1_V1e_wo_LOSV2b_M->solverInfo,
                          &CA_CSE1_V1e_wo_LOSV2b_M->Timing.simTimeStep);
    rtsiSetTPtr(&CA_CSE1_V1e_wo_LOSV2b_M->solverInfo, &rtmGetTPtr
                (CA_CSE1_V1e_wo_LOSV2b_M));
    rtsiSetStepSizePtr(&CA_CSE1_V1e_wo_LOSV2b_M->solverInfo,
                       &CA_CSE1_V1e_wo_LOSV2b_M->Timing.stepSize0);
    rtsiSetdXPtr(&CA_CSE1_V1e_wo_LOSV2b_M->solverInfo,
                 &CA_CSE1_V1e_wo_LOSV2b_M->ModelData.derivs);
    rtsiSetContStatesPtr(&CA_CSE1_V1e_wo_LOSV2b_M->solverInfo,
                         &CA_CSE1_V1e_wo_LOSV2b_M->ModelData.contStates);
    rtsiSetNumContStatesPtr(&CA_CSE1_V1e_wo_LOSV2b_M->solverInfo,
      &CA_CSE1_V1e_wo_LOSV2b_M->Sizes.numContStates);
    rtsiSetErrorStatusPtr(&CA_CSE1_V1e_wo_LOSV2b_M->solverInfo,
                          (&rtmGetErrorStatus(CA_CSE1_V1e_wo_LOSV2b_M)));
    rtsiSetRTModelPtr(&CA_CSE1_V1e_wo_LOSV2b_M->solverInfo,
                      CA_CSE1_V1e_wo_LOSV2b_M);
  }

  rtsiSetSimTimeStep(&CA_CSE1_V1e_wo_LOSV2b_M->solverInfo, MAJOR_TIME_STEP);
  CA_CSE1_V1e_wo_LOSV2b_M->ModelData.intgData.y =
    CA_CSE1_V1e_wo_LOSV2b_M->ModelData.odeY;
  CA_CSE1_V1e_wo_LOSV2b_M->ModelData.intgData.f[0] =
    CA_CSE1_V1e_wo_LOSV2b_M->ModelData.odeF[0];
  CA_CSE1_V1e_wo_LOSV2b_M->ModelData.intgData.f[1] =
    CA_CSE1_V1e_wo_LOSV2b_M->ModelData.odeF[1];
  CA_CSE1_V1e_wo_LOSV2b_M->ModelData.intgData.f[2] =
    CA_CSE1_V1e_wo_LOSV2b_M->ModelData.odeF[2];
  CA_CSE1_V1e_wo_LOSV2b_M->ModelData.contStates = ((real_T *)
    &CA_CSE1_V1e_wo_LOSV2b_X);
  rtsiSetSolverData(&CA_CSE1_V1e_wo_LOSV2b_M->solverInfo, (void *)
                    &CA_CSE1_V1e_wo_LOSV2b_M->ModelData.intgData);
  rtsiSetSolverName(&CA_CSE1_V1e_wo_LOSV2b_M->solverInfo,"ode3");

  /* Initialize timing info */
  {
    int_T *mdlTsMap = CA_CSE1_V1e_wo_LOSV2b_M->Timing.sampleTimeTaskIDArray;
    mdlTsMap[0] = 0;
    mdlTsMap[1] = 1;
    CA_CSE1_V1e_wo_LOSV2b_M->Timing.sampleTimeTaskIDPtr = (&mdlTsMap[0]);
    CA_CSE1_V1e_wo_LOSV2b_M->Timing.sampleTimes =
      (&CA_CSE1_V1e_wo_LOSV2b_M->Timing.sampleTimesArray[0]);
    CA_CSE1_V1e_wo_LOSV2b_M->Timing.offsetTimes =
      (&CA_CSE1_V1e_wo_LOSV2b_M->Timing.offsetTimesArray[0]);

    /* task periods */
    CA_CSE1_V1e_wo_LOSV2b_M->Timing.sampleTimes[0] = (0.0);
    CA_CSE1_V1e_wo_LOSV2b_M->Timing.sampleTimes[1] = (0.1);

    /* task offsets */
    CA_CSE1_V1e_wo_LOSV2b_M->Timing.offsetTimes[0] = (0.0);
    CA_CSE1_V1e_wo_LOSV2b_M->Timing.offsetTimes[1] = (0.0);
  }

  rtmSetTPtr(CA_CSE1_V1e_wo_LOSV2b_M, &CA_CSE1_V1e_wo_LOSV2b_M->Timing.tArray[0]);

  {
    int_T *mdlSampleHits = CA_CSE1_V1e_wo_LOSV2b_M->Timing.sampleHitArray;
    mdlSampleHits[0] = 1;
    mdlSampleHits[1] = 1;
    CA_CSE1_V1e_wo_LOSV2b_M->Timing.sampleHits = (&mdlSampleHits[0]);
  }

  rtmSetTFinal(CA_CSE1_V1e_wo_LOSV2b_M, -1);
  CA_CSE1_V1e_wo_LOSV2b_M->Timing.stepSize0 = 0.1;
  CA_CSE1_V1e_wo_LOSV2b_M->Timing.stepSize1 = 0.1;
  rtmSetFirstInitCond(CA_CSE1_V1e_wo_LOSV2b_M, 1);

  /* Setup for data logging */
  {
    static RTWLogInfo rt_DataLoggingInfo;
    CA_CSE1_V1e_wo_LOSV2b_M->rtwLogInfo = &rt_DataLoggingInfo;
    rtliSetLogXSignalInfo(CA_CSE1_V1e_wo_LOSV2b_M->rtwLogInfo, (NULL));
    rtliSetLogXSignalPtrs(CA_CSE1_V1e_wo_LOSV2b_M->rtwLogInfo, (NULL));
    rtliSetLogT(CA_CSE1_V1e_wo_LOSV2b_M->rtwLogInfo, "");
    rtliSetLogX(CA_CSE1_V1e_wo_LOSV2b_M->rtwLogInfo, "");
    rtliSetLogXFinal(CA_CSE1_V1e_wo_LOSV2b_M->rtwLogInfo, "");
    rtliSetSigLog(CA_CSE1_V1e_wo_LOSV2b_M->rtwLogInfo, "");
    rtliSetLogVarNameModifier(CA_CSE1_V1e_wo_LOSV2b_M->rtwLogInfo, "rt_");
    rtliSetLogFormat(CA_CSE1_V1e_wo_LOSV2b_M->rtwLogInfo, 0);
    rtliSetLogMaxRows(CA_CSE1_V1e_wo_LOSV2b_M->rtwLogInfo, 0);
    rtliSetLogDecimation(CA_CSE1_V1e_wo_LOSV2b_M->rtwLogInfo, 1);
    rtliSetLogY(CA_CSE1_V1e_wo_LOSV2b_M->rtwLogInfo, "");
    rtliSetLogYSignalInfo(CA_CSE1_V1e_wo_LOSV2b_M->rtwLogInfo, (NULL));
    rtliSetLogYSignalPtrs(CA_CSE1_V1e_wo_LOSV2b_M->rtwLogInfo, (NULL));
  }

  CA_CSE1_V1e_wo_LOSV2b_M->solverInfoPtr = (&CA_CSE1_V1e_wo_LOSV2b_M->solverInfo);
  CA_CSE1_V1e_wo_LOSV2b_M->Timing.stepSize = (0.1);
  rtsiSetFixedStepSize(&CA_CSE1_V1e_wo_LOSV2b_M->solverInfo, 0.1);
  rtsiSetSolverMode(&CA_CSE1_V1e_wo_LOSV2b_M->solverInfo,
                    SOLVER_MODE_SINGLETASKING);

  /* block I/O */
  CA_CSE1_V1e_wo_LOSV2b_M->ModelData.blockIO = ((void *)
    &CA_CSE1_V1e_wo_LOSV2b_B);
  (void) memset(((void *) &CA_CSE1_V1e_wo_LOSV2b_B),0,
                sizeof(BlockIO_CA_CSE1_V1e_wo_LOSV2b));

  /* parameters */
  CA_CSE1_V1e_wo_LOSV2b_M->ModelData.defaultParam = ((real_T *)
    &CA_CSE1_V1e_wo_LOSV2b_P);

  /* states (continuous) */
  {
    real_T *x = (real_T *) &CA_CSE1_V1e_wo_LOSV2b_X;
    CA_CSE1_V1e_wo_LOSV2b_M->ModelData.contStates = (x);
    (void) memset((void *)x,0,
                  sizeof(ContinuousStates_CA_CSE1_V1e_wo));
  }

  /* states (dwork) */
  CA_CSE1_V1e_wo_LOSV2b_M->Work.dwork = ((void *) &CA_CSE1_V1e_wo_LOSV2b_DWork);
  (void) memset((void *)&CA_CSE1_V1e_wo_LOSV2b_DWork, 0,
                sizeof(D_Work_CA_CSE1_V1e_wo_LOSV2b));
  CA_CSE1_V1e_wo_L_PrevZCSigState.Integrator_Reset_ZCE = UNINITIALIZED_ZCSIG;
  CA_CSE1_V1e_wo_L_PrevZCSigState.Integrator1_Reset_ZCE = UNINITIALIZED_ZCSIG;
  CA_CSE1_V1e_wo_L_PrevZCSigState.Integrator_Reset_ZCE_b = UNINITIALIZED_ZCSIG;
}

/* Model terminate function */
void CA_CSE1_V1e_wo_LOSV2b_terminate(void)
{
  /* Terminate for enable SubSystem: '<S1>/DP control' */

  /* ToFile Block: '<S6>/To File' */
  {
    FILE *fp = (FILE *) CA_CSE1_V1e_wo_LOSV2b_DWork.ToFile_PWORK_m.FilePtr;
    if (fp != (NULL)) {
      const char *fileName = "CSE1_data_eta_w.mat";
      if (fclose(fp) == EOF) {
        rtmSetErrorStatus(CA_CSE1_V1e_wo_LOSV2b_M,
                          "Error closing MAT-file CSE1_data_eta_w.mat");
        return;
      }

      if ((fp = fopen(fileName, "r+b")) == (NULL)) {
        rtmSetErrorStatus(CA_CSE1_V1e_wo_LOSV2b_M,
                          "Error reopening MAT-file CSE1_data_eta_w.mat");
        return;
      }

      if (rt_WriteMat4FileHeader(fp, 4,
           CA_CSE1_V1e_wo_LOSV2b_DWork.ToFile_IWORK_b.Count, "cse1_data")) {
        rtmSetErrorStatus(CA_CSE1_V1e_wo_LOSV2b_M,
                          "Error writing header for cse1_data to MAT-file CSE1_data_eta_w.mat");
      }

      if (fclose(fp) == EOF) {
        rtmSetErrorStatus(CA_CSE1_V1e_wo_LOSV2b_M,
                          "Error closing MAT-file CSE1_data_eta_w.mat");
        return;
      }

      CA_CSE1_V1e_wo_LOSV2b_DWork.ToFile_PWORK_m.FilePtr = (NULL);
    }
  }

  /* ToFile Block: '<S14>/To File' */
  {
    FILE *fp = (FILE *) CA_CSE1_V1e_wo_LOSV2b_DWork.ToFile_PWORK_p.FilePtr;
    if (fp != (NULL)) {
      const char *fileName = "CSE1_data_reg_error.mat";
      if (fclose(fp) == EOF) {
        rtmSetErrorStatus(CA_CSE1_V1e_wo_LOSV2b_M,
                          "Error closing MAT-file CSE1_data_reg_error.mat");
        return;
      }

      if ((fp = fopen(fileName, "r+b")) == (NULL)) {
        rtmSetErrorStatus(CA_CSE1_V1e_wo_LOSV2b_M,
                          "Error reopening MAT-file CSE1_data_reg_error.mat");
        return;
      }

      if (rt_WriteMat4FileHeader(fp, 4,
           CA_CSE1_V1e_wo_LOSV2b_DWork.ToFile_IWORK_j.Count,
           "cse1_data_reg_error")) {
        rtmSetErrorStatus(CA_CSE1_V1e_wo_LOSV2b_M,
                          "Error writing header for cse1_data_reg_error to MAT-file CSE1_data_reg_error.mat");
      }

      if (fclose(fp) == EOF) {
        rtmSetErrorStatus(CA_CSE1_V1e_wo_LOSV2b_M,
                          "Error closing MAT-file CSE1_data_reg_error.mat");
        return;
      }

      CA_CSE1_V1e_wo_LOSV2b_DWork.ToFile_PWORK_p.FilePtr = (NULL);
    }
  }

  /* end of Terminate for SubSystem: '<S1>/DP control' */

  /* ToFile Block: '<Root>/To File' */
  {
    FILE *fp = (FILE *) CA_CSE1_V1e_wo_LOSV2b_DWork.ToFile_PWORK.FilePtr;
    if (fp != (NULL)) {
      const char *fileName = "CSE1_data.mat";
      if (fclose(fp) == EOF) {
        rtmSetErrorStatus(CA_CSE1_V1e_wo_LOSV2b_M,
                          "Error closing MAT-file CSE1_data.mat");
        return;
      }

      if ((fp = fopen(fileName, "r+b")) == (NULL)) {
        rtmSetErrorStatus(CA_CSE1_V1e_wo_LOSV2b_M,
                          "Error reopening MAT-file CSE1_data.mat");
        return;
      }

      if (rt_WriteMat4FileHeader(fp, 23,
           CA_CSE1_V1e_wo_LOSV2b_DWork.ToFile_IWORK.Count, "cse1_data")) {
        rtmSetErrorStatus(CA_CSE1_V1e_wo_LOSV2b_M,
                          "Error writing header for cse1_data to MAT-file CSE1_data.mat");
      }

      if (fclose(fp) == EOF) {
        rtmSetErrorStatus(CA_CSE1_V1e_wo_LOSV2b_M,
                          "Error closing MAT-file CSE1_data.mat");
        return;
      }

      CA_CSE1_V1e_wo_LOSV2b_DWork.ToFile_PWORK.FilePtr = (NULL);
    }
  }

  /* ToFile Block: '<Root>/To File1' */
  {
    FILE *fp = (FILE *) CA_CSE1_V1e_wo_LOSV2b_DWork.ToFile1_PWORK.FilePtr;
    if (fp != (NULL)) {
      const char *fileName = "theta.mat";
      if (fclose(fp) == EOF) {
        rtmSetErrorStatus(CA_CSE1_V1e_wo_LOSV2b_M,
                          "Error closing MAT-file theta.mat");
        return;
      }

      if ((fp = fopen(fileName, "r+b")) == (NULL)) {
        rtmSetErrorStatus(CA_CSE1_V1e_wo_LOSV2b_M,
                          "Error reopening MAT-file theta.mat");
        return;
      }

      if (rt_WriteMat4FileHeader(fp, 2,
           CA_CSE1_V1e_wo_LOSV2b_DWork.ToFile1_IWORK.Count, "theta_saved")) {
        rtmSetErrorStatus(CA_CSE1_V1e_wo_LOSV2b_M,
                          "Error writing header for theta_saved to MAT-file theta.mat");
      }

      if (fclose(fp) == EOF) {
        rtmSetErrorStatus(CA_CSE1_V1e_wo_LOSV2b_M,
                          "Error closing MAT-file theta.mat");
        return;
      }

      CA_CSE1_V1e_wo_LOSV2b_DWork.ToFile1_PWORK.FilePtr = (NULL);
    }
  }

  /* ToFile Block: '<S49>/To File (eta_d)' */
  {
    FILE *fp = (FILE *) CA_CSE1_V1e_wo_LOSV2b_DWork.ToFileeta_d_PWORK.FilePtr;
    if (fp != (NULL)) {
      const char *fileName = "guidance_saved.mat";
      if (fclose(fp) == EOF) {
        rtmSetErrorStatus(CA_CSE1_V1e_wo_LOSV2b_M,
                          "Error closing MAT-file guidance_saved.mat");
        return;
      }

      if ((fp = fopen(fileName, "r+b")) == (NULL)) {
        rtmSetErrorStatus(CA_CSE1_V1e_wo_LOSV2b_M,
                          "Error reopening MAT-file guidance_saved.mat");
        return;
      }

      if (rt_WriteMat4FileHeader(fp, 13,
           CA_CSE1_V1e_wo_LOSV2b_DWork.ToFileeta_d_IWORK.Count, "guidance_vars"))
      {
        rtmSetErrorStatus(CA_CSE1_V1e_wo_LOSV2b_M,
                          "Error writing header for guidance_vars to MAT-file guidance_saved.mat");
      }

      if (fclose(fp) == EOF) {
        rtmSetErrorStatus(CA_CSE1_V1e_wo_LOSV2b_M,
                          "Error closing MAT-file guidance_saved.mat");
        return;
      }

      CA_CSE1_V1e_wo_LOSV2b_DWork.ToFileeta_d_PWORK.FilePtr = (NULL);
    }
  }
}

/*========================================================================*
 * Start of GRT compatible call interface                                 *
 *========================================================================*/
void MdlOutputs(int_T tid)
{
  CA_CSE1_V1e_wo_LOSV2b_output(tid);
}

void MdlUpdate(int_T tid)
{
  CA_CSE1_V1e_wo_LOSV2b_update(tid);
}

void MdlInitializeSizes(void)
{
  CA_CSE1_V1e_wo_LOSV2b_M->Sizes.numContStates = (28);/* Number of continuous states */
  CA_CSE1_V1e_wo_LOSV2b_M->Sizes.numY = (0);/* Number of model outputs */
  CA_CSE1_V1e_wo_LOSV2b_M->Sizes.numU = (0);/* Number of model inputs */
  CA_CSE1_V1e_wo_LOSV2b_M->Sizes.sysDirFeedThru = (0);/* The model is not direct feedthrough */
  CA_CSE1_V1e_wo_LOSV2b_M->Sizes.numSampTimes = (2);/* Number of sample times */
  CA_CSE1_V1e_wo_LOSV2b_M->Sizes.numBlocks = (751);/* Number of blocks */
  CA_CSE1_V1e_wo_LOSV2b_M->Sizes.numBlockIO = (538);/* Number of block outputs */
  CA_CSE1_V1e_wo_LOSV2b_M->Sizes.numBlockPrms = (806);/* Sum of parameter "widths" */
}

void MdlInitializeSampleTimes(void)
{
}

void MdlInitialize(void)
{
  /* TransferFcn Block: '<S48>/Transfer Fcn' */
  CA_CSE1_V1e_wo_LOSV2b_X.TransferFcn_CSTATE = 0.0;

  /* TransferFcn Block: '<S48>/Transfer Fcn1' */
  CA_CSE1_V1e_wo_LOSV2b_X.TransferFcn1_CSTATE = 0.0;

  /* TransferFcn Block: '<S48>/Transfer Fcn2' */
  CA_CSE1_V1e_wo_LOSV2b_X.TransferFcn2_CSTATE = 0.0;

  /* Derivative Block: '<S63>/Derivative' */
  CA_CSE1_V1e_wo_LOSV2b_DWork.Derivative_RWORK.TimeStampA = rtInf;
  CA_CSE1_V1e_wo_LOSV2b_DWork.Derivative_RWORK.TimeStampB = rtInf;

  /* InitializeConditions for Memory: '<S52>/Memory2' */
  CA_CSE1_V1e_wo_LOSV2b_DWork.Memory2_PreviousInput =
    CA_CSE1_V1e_wo_LOSV2b_P.Memory2_X0;

  /* InitializeConditions for Memory: '<S52>/Memory1' */
  CA_CSE1_V1e_wo_LOSV2b_DWork.Memory1_PreviousInput =
    CA_CSE1_V1e_wo_LOSV2b_P.Memory1_X0;

  /* InitializeConditions for Integrator: '<S35>/Integrator' */
  CA_CSE1_V1e_wo_LOSV2b_X.Integrator_CSTATE =
    CA_CSE1_V1e_wo_LOSV2b_P.Integrator_IC;

  /* InitializeConditions for Memory: '<S52>/Memory' */
  CA_CSE1_V1e_wo_LOSV2b_DWork.Memory_PreviousInput =
    CA_CSE1_V1e_wo_LOSV2b_P.Memory_X0;

  /* InitializeConditions for Memory: '<S52>/Memory3' */
  CA_CSE1_V1e_wo_LOSV2b_DWork.Memory3_PreviousInput =
    CA_CSE1_V1e_wo_LOSV2b_P.Memory3_X0;

  /* Derivative Block: '<S54>/Derivative' */
  CA_CSE1_V1e_wo_LOSV2b_DWork.Derivative_RWORK_m.TimeStampA = rtInf;
  CA_CSE1_V1e_wo_LOSV2b_DWork.Derivative_RWORK_m.TimeStampB = rtInf;

  /* InitializeConditions for Memory: '<S53>/Memory' */
  CA_CSE1_V1e_wo_LOSV2b_DWork.Memory_PreviousInput_d =
    CA_CSE1_V1e_wo_LOSV2b_P.Memory_X0_h;

  /* InitializeConditions for Memory: '<S53>/Memory1' */
  CA_CSE1_V1e_wo_LOSV2b_DWork.Memory1_PreviousInput_g =
    CA_CSE1_V1e_wo_LOSV2b_P.Memory1_X0_f;

  /* InitializeConditions for Memory: '<S53>/Memory2' */
  CA_CSE1_V1e_wo_LOSV2b_DWork.Memory2_PreviousInput_e =
    CA_CSE1_V1e_wo_LOSV2b_P.Memory2_X0_a;

  /* InitializeConditions for Memory: '<S53>/Memory3' */
  CA_CSE1_V1e_wo_LOSV2b_DWork.Memory3_PreviousInput_n =
    CA_CSE1_V1e_wo_LOSV2b_P.Memory3_X0_d;

  /* Derivative Block: '<S63>/Derivative1' */
  CA_CSE1_V1e_wo_LOSV2b_DWork.Derivative1_RWORK.TimeStampA = rtInf;
  CA_CSE1_V1e_wo_LOSV2b_DWork.Derivative1_RWORK.TimeStampB = rtInf;

  /* set "at time zero" to false */
  if (rtmIsFirstInitCond(CA_CSE1_V1e_wo_LOSV2b_M)) {
    rtmSetFirstInitCond(CA_CSE1_V1e_wo_LOSV2b_M, 0);
  }
}

void MdlStart(void)
{
  {
    int32_T i;

    /* Create Identity Matrix for Block: '<S7>/K_e^-1' */
    {
      int_T i;
      real_T *dWork = &CA_CSE1_V1e_wo_LOSV2b_DWork.K_e1_DWORK4[0];
      for (i = 0; i < 25; i++) {
        *dWork++ = 0.0;
      }

      dWork = &CA_CSE1_V1e_wo_LOSV2b_DWork.K_e1_DWORK4[0];
      while (dWork < &CA_CSE1_V1e_wo_LOSV2b_DWork.K_e1_DWORK4[0]+25) {
        *dWork = 1;
        dWork += 6;
      }
    }

    /* Start for enable SubSystem: '<S5>/Linear Simulator' */
    CA_CSE1_V1e_wo_LOSV2b_DWork.LinearSimulator_MODE = SUBSYS_DISABLED;

    /* Start for Constant: '<S82>/psi_0' */
    CA_CSE1_V1e_wo_LOSV2b_B.psi_0 = CA_CSE1_V1e_wo_LOSV2b_P.psi_0_Value;

    /* Start for Constant: '<S82>/x_0' */
    CA_CSE1_V1e_wo_LOSV2b_B.x_0 = CA_CSE1_V1e_wo_LOSV2b_P.x_0_Value;

    /* Start for Constant: '<S82>/y_0' */
    CA_CSE1_V1e_wo_LOSV2b_B.y_0 = CA_CSE1_V1e_wo_LOSV2b_P.y_0_Value;

    /* Start for Constant: '<S83>/r_0' */
    CA_CSE1_V1e_wo_LOSV2b_B.r_0 = CA_CSE1_V1e_wo_LOSV2b_P.r_0_Value;

    /* Start for Constant: '<S83>/u_0' */
    CA_CSE1_V1e_wo_LOSV2b_B.u_0 = CA_CSE1_V1e_wo_LOSV2b_P.u_0_Value;

    /* Start for Constant: '<S83>/v_0' */
    CA_CSE1_V1e_wo_LOSV2b_B.v_0 = CA_CSE1_V1e_wo_LOSV2b_P.v_0_Value;

    /* Create Identity Matrix for Block: '<S84>/Inverse' */
    {
      int_T i;
      real_T *dWork = &CA_CSE1_V1e_wo_LOSV2b_DWork.Inverse_DWORK4[0];
      for (i = 0; i < 9; i++) {
        *dWork++ = 0.0;
      }

      dWork = &CA_CSE1_V1e_wo_LOSV2b_DWork.Inverse_DWORK4[0];
      while (dWork < &CA_CSE1_V1e_wo_LOSV2b_DWork.Inverse_DWORK4[0]+9) {
        *dWork = 1;
        dWork += 4;
      }
    }

    /* Start for UnitDelay: '<S89>/Delay Input2' */
    CA_CSE1_V1e_wo_LOSV2b_B.Yk1 = CA_CSE1_V1e_wo_LOSV2b_P.DelayInput2_X0;

    /* Integrator Block: '<S79>/Integrator' */
    if (rtmIsFirstInitCond(CA_CSE1_V1e_wo_LOSV2b_M)) {
      CA_CSE1_V1e_wo_LOSV2b_X.Integrator_CSTATE_a[0] = 0.0;
      CA_CSE1_V1e_wo_LOSV2b_X.Integrator_CSTATE_a[1] = 0.0;
      CA_CSE1_V1e_wo_LOSV2b_X.Integrator_CSTATE_a[2] = 0.0;
    }

    CA_CSE1_V1e_wo_LOSV2b_DWork.Integrator_IWORK.IcNeedsLoading = 1;

    /* Integrator Block: '<S79>/Integrator1' */
    if (rtmIsFirstInitCond(CA_CSE1_V1e_wo_LOSV2b_M)) {
      CA_CSE1_V1e_wo_LOSV2b_X.Integrator1_CSTATE[0] = 0.0;
      CA_CSE1_V1e_wo_LOSV2b_X.Integrator1_CSTATE[1] = 0.0;
      CA_CSE1_V1e_wo_LOSV2b_X.Integrator1_CSTATE[2] = 0.0;
    }

    CA_CSE1_V1e_wo_LOSV2b_DWork.Integrator1_IWORK.IcNeedsLoading = 1;

    /* InitializeConditions for UnitDelay: '<S89>/Delay Input2' */
    CA_CSE1_V1e_wo_LOSV2b_DWork.DelayInput2_DSTATE =
      CA_CSE1_V1e_wo_LOSV2b_P.DelayInput2_X0;

    /* end of Start for SubSystem: '<S5>/Linear Simulator' */

    /* Start for enable SubSystem: '<S1>/DP control' */
    CA_CSE1_V1e_wo_LOSV2b_DWork.DPcontrol_MODE = SUBSYS_DISABLED;

    /* ToFile Block: '<S6>/To File' */
    {
      const char *fileName = "CSE1_data_eta_w.mat";
      FILE *fp;
      if ((fp = fopen(fileName, "wb")) == (NULL)) {
        rtmSetErrorStatus(CA_CSE1_V1e_wo_LOSV2b_M,
                          "Error creating .mat file CSE1_data_eta_w.mat");
        return;
      }

      if (rt_WriteMat4FileHeader(fp,4,0,"cse1_data")) {
        rtmSetErrorStatus(CA_CSE1_V1e_wo_LOSV2b_M,
                          "Error writing mat file header to file CSE1_data_eta_w.mat");
        return;
      }

      CA_CSE1_V1e_wo_LOSV2b_DWork.ToFile_IWORK_b.Count = 0;
      CA_CSE1_V1e_wo_LOSV2b_DWork.ToFile_IWORK_b.Decimation = -1;
      CA_CSE1_V1e_wo_LOSV2b_DWork.ToFile_PWORK_m.FilePtr = fp;
    }

    /* ToFile Block: '<S14>/To File' */
    {
      const char *fileName = "CSE1_data_reg_error.mat";
      FILE *fp;
      if ((fp = fopen(fileName, "wb")) == (NULL)) {
        rtmSetErrorStatus(CA_CSE1_V1e_wo_LOSV2b_M,
                          "Error creating .mat file CSE1_data_reg_error.mat");
        return;
      }

      if (rt_WriteMat4FileHeader(fp,4,0,"cse1_data_reg_error")) {
        rtmSetErrorStatus(CA_CSE1_V1e_wo_LOSV2b_M,
                          "Error writing mat file header to file CSE1_data_reg_error.mat");
        return;
      }

      CA_CSE1_V1e_wo_LOSV2b_DWork.ToFile_IWORK_j.Count = 0;
      CA_CSE1_V1e_wo_LOSV2b_DWork.ToFile_IWORK_j.Decimation = -1;
      CA_CSE1_V1e_wo_LOSV2b_DWork.ToFile_PWORK_p.FilePtr = fp;
    }

    /* Create Identity Matrix for Block: '<S6>/K_e^-1' */
    {
      int_T i;
      real_T *dWork = &CA_CSE1_V1e_wo_LOSV2b_DWork.K_e1_DWORK4_m[0];
      for (i = 0; i < 25; i++) {
        *dWork++ = 0.0;
      }

      dWork = &CA_CSE1_V1e_wo_LOSV2b_DWork.K_e1_DWORK4_m[0];
      while (dWork < &CA_CSE1_V1e_wo_LOSV2b_DWork.K_e1_DWORK4_m[0]+25) {
        *dWork = 1;
        dWork += 6;
      }
    }

    /* InitializeConditions for Integrator: '<S16>/Integrator1' */
    CA_CSE1_V1e_wo_LOSV2b_X.Integrator1_CSTATE_i[0] =
      CA_CSE1_V1e_wo_LOSV2b_P.Integrator1_IC;

    /* InitializeConditions for Integrator: '<S16>/Integrator' */
    CA_CSE1_V1e_wo_LOSV2b_X.Integrator_CSTATE_o[0] =
      CA_CSE1_V1e_wo_LOSV2b_P.Integrator_IC_n;

    /* InitializeConditions for Integrator: '<S16>/Integrator1' */
    CA_CSE1_V1e_wo_LOSV2b_X.Integrator1_CSTATE_i[1] =
      CA_CSE1_V1e_wo_LOSV2b_P.Integrator1_IC;

    /* InitializeConditions for Integrator: '<S16>/Integrator' */
    CA_CSE1_V1e_wo_LOSV2b_X.Integrator_CSTATE_o[1] =
      CA_CSE1_V1e_wo_LOSV2b_P.Integrator_IC_n;

    /* InitializeConditions for Integrator: '<S16>/Integrator1' */
    CA_CSE1_V1e_wo_LOSV2b_X.Integrator1_CSTATE_i[2] =
      CA_CSE1_V1e_wo_LOSV2b_P.Integrator1_IC;

    /* InitializeConditions for Integrator: '<S16>/Integrator' */
    CA_CSE1_V1e_wo_LOSV2b_X.Integrator_CSTATE_o[2] =
      CA_CSE1_V1e_wo_LOSV2b_P.Integrator_IC_n;

    /* Integrator Block: '<S14>/Integrator' */
    CA_CSE1_V1e_wo_LOSV2b_X.Integrator_CSTATE_e[0] =
      CA_CSE1_V1e_wo_LOSV2b_P.Integrator_IC_d;
    CA_CSE1_V1e_wo_LOSV2b_X.Integrator_CSTATE_e[1] =
      CA_CSE1_V1e_wo_LOSV2b_P.Integrator_IC_d;
    CA_CSE1_V1e_wo_LOSV2b_X.Integrator_CSTATE_e[2] =
      CA_CSE1_V1e_wo_LOSV2b_P.Integrator_IC_d;

    /* InitializeConditions for Integrator: '<S16>/Integrator4' */
    CA_CSE1_V1e_wo_LOSV2b_X.Integrator4_CSTATE[0] =
      CA_CSE1_V1e_wo_LOSV2b_P.Integrator4_IC;

    /* InitializeConditions for Integrator: '<S16>/Integrator2' */
    CA_CSE1_V1e_wo_LOSV2b_X.Integrator2_CSTATE[0] =
      CA_CSE1_V1e_wo_LOSV2b_P.Integrator2_IC;

    /* InitializeConditions for Integrator: '<S16>/Integrator3' */
    CA_CSE1_V1e_wo_LOSV2b_X.Integrator3_CSTATE[0] =
      CA_CSE1_V1e_wo_LOSV2b_P.Integrator3_IC;

    /* InitializeConditions for Integrator: '<S16>/Integrator4' */
    CA_CSE1_V1e_wo_LOSV2b_X.Integrator4_CSTATE[1] =
      CA_CSE1_V1e_wo_LOSV2b_P.Integrator4_IC;

    /* InitializeConditions for Integrator: '<S16>/Integrator2' */
    CA_CSE1_V1e_wo_LOSV2b_X.Integrator2_CSTATE[1] =
      CA_CSE1_V1e_wo_LOSV2b_P.Integrator2_IC;

    /* InitializeConditions for Integrator: '<S16>/Integrator3' */
    CA_CSE1_V1e_wo_LOSV2b_X.Integrator3_CSTATE[1] =
      CA_CSE1_V1e_wo_LOSV2b_P.Integrator3_IC;

    /* InitializeConditions for Integrator: '<S16>/Integrator4' */
    CA_CSE1_V1e_wo_LOSV2b_X.Integrator4_CSTATE[2] =
      CA_CSE1_V1e_wo_LOSV2b_P.Integrator4_IC;

    /* InitializeConditions for Integrator: '<S16>/Integrator2' */
    CA_CSE1_V1e_wo_LOSV2b_X.Integrator2_CSTATE[2] =
      CA_CSE1_V1e_wo_LOSV2b_P.Integrator2_IC;

    /* InitializeConditions for Integrator: '<S16>/Integrator3' */
    CA_CSE1_V1e_wo_LOSV2b_X.Integrator3_CSTATE[2] =
      CA_CSE1_V1e_wo_LOSV2b_P.Integrator3_IC;

    /* VirtualOutportStart for Outport: '<S6>/Thruster_Command_DP' */
    for (i = 0; i < 5; i++) {
      CA_CSE1_V1e_wo_LOSV2b_B.Saturation_f[i] =
        CA_CSE1_V1e_wo_LOSV2b_P.Thruster_Command_DP_Y0[i];
    }

    CA_CSE1_V1e_wo_LOSV2b_B.BT_power_limit =
      CA_CSE1_V1e_wo_LOSV2b_P.Thruster_Command_DP_Y0[5];
    CA_CSE1_V1e_wo_LOSV2b_B.VSP_speeds =
      CA_CSE1_V1e_wo_LOSV2b_P.Thruster_Command_DP_Y0[6];

    /* end of Start for SubSystem: '<S1>/DP control' */

    /* Create Identity Matrix for Block: '<S8>/K_e^-1' */
    {
      int_T i;
      real_T *dWork = &CA_CSE1_V1e_wo_LOSV2b_DWork.K_e1_DWORK4_d[0];
      for (i = 0; i < 25; i++) {
        *dWork++ = 0.0;
      }

      dWork = &CA_CSE1_V1e_wo_LOSV2b_DWork.K_e1_DWORK4_d[0];
      while (dWork < &CA_CSE1_V1e_wo_LOSV2b_DWork.K_e1_DWORK4_d[0]+25) {
        *dWork = 1;
        dWork += 6;
      }
    }

    /* Start for InitialCondition: '<S55>/IC' */
    CA_CSE1_V1e_wo_LOSV2b_DWork.IC_FirstOutputTime = (rtMinusInf);

    /* ToFile Block: '<Root>/To File' */
    {
      const char *fileName = "CSE1_data.mat";
      FILE *fp;
      if ((fp = fopen(fileName, "wb")) == (NULL)) {
        rtmSetErrorStatus(CA_CSE1_V1e_wo_LOSV2b_M,
                          "Error creating .mat file CSE1_data.mat");
        return;
      }

      if (rt_WriteMat4FileHeader(fp,23,0,"cse1_data")) {
        rtmSetErrorStatus(CA_CSE1_V1e_wo_LOSV2b_M,
                          "Error writing mat file header to file CSE1_data.mat");
        return;
      }

      CA_CSE1_V1e_wo_LOSV2b_DWork.ToFile_IWORK.Count = 0;
      CA_CSE1_V1e_wo_LOSV2b_DWork.ToFile_IWORK.Decimation = -1;
      CA_CSE1_V1e_wo_LOSV2b_DWork.ToFile_PWORK.FilePtr = fp;
    }

    /* ToFile Block: '<Root>/To File1' */
    {
      const char *fileName = "theta.mat";
      FILE *fp;
      if ((fp = fopen(fileName, "wb")) == (NULL)) {
        rtmSetErrorStatus(CA_CSE1_V1e_wo_LOSV2b_M,
                          "Error creating .mat file theta.mat");
        return;
      }

      if (rt_WriteMat4FileHeader(fp,2,0,"theta_saved")) {
        rtmSetErrorStatus(CA_CSE1_V1e_wo_LOSV2b_M,
                          "Error writing mat file header to file theta.mat");
        return;
      }

      CA_CSE1_V1e_wo_LOSV2b_DWork.ToFile1_IWORK.Count = 0;
      CA_CSE1_V1e_wo_LOSV2b_DWork.ToFile1_IWORK.Decimation = -1;
      CA_CSE1_V1e_wo_LOSV2b_DWork.ToFile1_PWORK.FilePtr = fp;
    }

    /* ToFile Block: '<S49>/To File (eta_d)' */
    {
      const char *fileName = "guidance_saved.mat";
      FILE *fp;
      if ((fp = fopen(fileName, "wb")) == (NULL)) {
        rtmSetErrorStatus(CA_CSE1_V1e_wo_LOSV2b_M,
                          "Error creating .mat file guidance_saved.mat");
        return;
      }

      if (rt_WriteMat4FileHeader(fp,13,0,"guidance_vars")) {
        rtmSetErrorStatus(CA_CSE1_V1e_wo_LOSV2b_M,
                          "Error writing mat file header to file guidance_saved.mat");
        return;
      }

      CA_CSE1_V1e_wo_LOSV2b_DWork.ToFileeta_d_IWORK.Count = 0;
      CA_CSE1_V1e_wo_LOSV2b_DWork.ToFileeta_d_IWORK.Decimation = -1;
      CA_CSE1_V1e_wo_LOSV2b_DWork.ToFileeta_d_PWORK.FilePtr = fp;
    }

    /* Start for enable SubSystem: '<S5>/CSE1' */
    CA_CSE1_V1e_wo_LOSV2b_DWork.CSE1_MODE = SUBSYS_DISABLED;

    /* end of Start for SubSystem: '<S5>/CSE1' */
  }

  MdlInitialize();
}

RT_MODEL_CA_CSE1_V1e_wo_LOSV2b *CA_CSE1_V1e_wo_LOSV2b(void)
{
  CA_CSE1_V1e_wo_LOSV2b_initialize(1);
  return CA_CSE1_V1e_wo_LOSV2b_M;
}

void MdlTerminate(void)
{
  CA_CSE1_V1e_wo_LOSV2b_terminate();
}

/*========================================================================*
 * End of GRT compatible call interface                                   *
 *========================================================================*/

/*
   This file contains automatically generated code for functions
   to update the inports and outports of a Simulink/Realtime Workshop
   model. Calls to these functions should be made before each step is taken
   (inports, call SetExternalInputs) and after each step is taken
   (outports, call SetExternalOutputs.)
 */
#ifdef NI_ROOTMODEL_CA_CSE1_V1e_wo_LOSV2b
#include "model_info.h"
#include "SIT_API.h"
#include <stddef.h>
#include <stdlib.h>
#include <float.h>

double NIRT_GetValueByDataType(void* ptr,int subindex, int type, int Complex)
{
  switch (type)
  {
   case 0:
    return (double)(((real_T *)ptr)[subindex]);

   case 1:
    return (double)(((real32_T *)ptr)[subindex]);

   case 2:
    return (double)(((int8_T *)ptr)[subindex]);

   case 3:
    return (double)(((uint8_T *)ptr)[subindex]);

   case 4:
    return (double)(((int16_T *)ptr)[subindex]);

   case 5:
    return (double)(((uint16_T *)ptr)[subindex]);

   case 6:
    return (double)(((int32_T *)ptr)[subindex]);

   case 7:
    return (double)(((uint32_T *)ptr)[subindex]);

   case 8:
    return (double)(((boolean_T *)ptr)[subindex]);

   case 10:
    //Type is renamed. Call GetValueByDataType on its contained type
    return NIRT_GetValueByDataType(ptr,subindex,6,Complex);

   case 13:
    //Type is array. Call GetValueByDataType on its contained type
    return NIRT_GetValueByDataType(ptr,subindex,7,Complex);

   case 16:
    //Type is renamed. Call GetValueByDataType on its contained type
    return NIRT_GetValueByDataType(ptr,subindex,3,Complex);

   case 17:
    //Type is matrix. Call GetValueByDataType on its contained type
    return NIRT_GetValueByDataType(ptr,subindex,0,Complex);

   case 18:
    //Type is matrix. Call GetValueByDataType on its contained type
    return NIRT_GetValueByDataType(ptr,subindex,0,Complex);

   case 19:
    //Type is matrix. Call GetValueByDataType on its contained type
    return NIRT_GetValueByDataType(ptr,subindex,0,Complex);

   case 20:
    //Type is matrix. Call GetValueByDataType on its contained type
    return NIRT_GetValueByDataType(ptr,subindex,0,Complex);

   case 21:
    //Type is matrix. Call GetValueByDataType on its contained type
    return NIRT_GetValueByDataType(ptr,subindex,0,Complex);

   case 22:
    //Type is matrix. Call GetValueByDataType on its contained type
    return NIRT_GetValueByDataType(ptr,subindex,10,Complex);

   case 23:
    //Type is matrix. Call GetValueByDataType on its contained type
    return NIRT_GetValueByDataType(ptr,subindex,11,Complex);

   case 24:
    //Type is matrix. Call GetValueByDataType on its contained type
    return NIRT_GetValueByDataType(ptr,subindex,0,Complex);

   case 25:
    //Type is matrix. Call GetValueByDataType on its contained type
    return NIRT_GetValueByDataType(ptr,subindex,0,Complex);

   case 26:
    //Type is matrix. Call GetValueByDataType on its contained type
    return NIRT_GetValueByDataType(ptr,subindex,0,Complex);

   case 27:
    //Type is matrix. Call GetValueByDataType on its contained type
    return NIRT_GetValueByDataType(ptr,subindex,6,Complex);

   case 28:
    //Type is matrix. Call GetValueByDataType on its contained type
    return NIRT_GetValueByDataType(ptr,subindex,0,Complex);

   case 29:
    //Type is matrix. Call GetValueByDataType on its contained type
    return NIRT_GetValueByDataType(ptr,subindex,0,Complex);

   case 30:
    //Type is matrix. Call GetValueByDataType on its contained type
    return NIRT_GetValueByDataType(ptr,subindex,0,Complex);

   case 31:
    //Type is matrix. Call GetValueByDataType on its contained type
    return NIRT_GetValueByDataType(ptr,subindex,0,Complex);

   case 32:
    //Type is matrix. Call GetValueByDataType on its contained type
    return NIRT_GetValueByDataType(ptr,subindex,0,Complex);

   case 33:
    //Type is matrix. Call GetValueByDataType on its contained type
    return NIRT_GetValueByDataType(ptr,subindex,0,Complex);

   case 34:
    //Type is matrix. Call GetValueByDataType on its contained type
    return NIRT_GetValueByDataType(ptr,subindex,0,Complex);

   case 35:
    //Type is matrix. Call GetValueByDataType on its contained type
    return NIRT_GetValueByDataType(ptr,subindex,0,Complex);

   case 36:
    //Type is matrix. Call GetValueByDataType on its contained type
    return NIRT_GetValueByDataType(ptr,subindex,0,Complex);

   case 37:
    //Type is matrix. Call GetValueByDataType on its contained type
    return NIRT_GetValueByDataType(ptr,subindex,0,Complex);

   case 38:
    //Type is matrix. Call GetValueByDataType on its contained type
    return NIRT_GetValueByDataType(ptr,subindex,0,Complex);

   case 39:
    //Type is matrix. Call GetValueByDataType on its contained type
    return NIRT_GetValueByDataType(ptr,subindex,0,Complex);

   case 40:
    //Type is matrix. Call GetValueByDataType on its contained type
    return NIRT_GetValueByDataType(ptr,subindex,0,Complex);

   case 41:
    //Type is matrix. Call GetValueByDataType on its contained type
    return NIRT_GetValueByDataType(ptr,subindex,0,Complex);

   case 42:
    //Type is matrix. Call GetValueByDataType on its contained type
    return NIRT_GetValueByDataType(ptr,subindex,0,Complex);

   case 43:
    //Type is matrix. Call GetValueByDataType on its contained type
    return NIRT_GetValueByDataType(ptr,subindex,6,Complex);

   case 44:
    //Type is matrix. Call GetValueByDataType on its contained type
    return NIRT_GetValueByDataType(ptr,subindex,3,Complex);

   case 45:
    //Type is matrix. Call GetValueByDataType on its contained type
    return NIRT_GetValueByDataType(ptr,subindex,0,Complex);

   case 46:
    //Type is matrix. Call GetValueByDataType on its contained type
    return NIRT_GetValueByDataType(ptr,subindex,0,Complex);

   case 47:
    //Type is matrix. Call GetValueByDataType on its contained type
    return NIRT_GetValueByDataType(ptr,subindex,0,Complex);

   case 48:
    //Type is matrix. Call GetValueByDataType on its contained type
    return NIRT_GetValueByDataType(ptr,subindex,8,Complex);

   case 57:
    //Type is matrix. Call GetValueByDataType on its contained type
    return NIRT_GetValueByDataType(ptr,subindex,0,Complex);

   case 58:
    //Type is matrix. Call GetValueByDataType on its contained type
    return NIRT_GetValueByDataType(ptr,subindex,0,Complex);

   case 59:
    //Type is matrix. Call GetValueByDataType on its contained type
    return NIRT_GetValueByDataType(ptr,subindex,0,Complex);

   case 60:
    //Type is matrix. Call GetValueByDataType on its contained type
    return NIRT_GetValueByDataType(ptr,subindex,0,Complex);
  }

  // return ((double *)ptr)[subindex];
  return rtNaN;
}

long NIRT_SetValueByDataType(void* ptr,int subindex, double value, int type, int
  Complex)
{
  //Complex is only used for R14.3 and down
  switch (type)
  {
   case 0:
    ((real_T *)ptr)[subindex] = (real_T)value;
    return NI_OK;

   case 1:
    ((real32_T *)ptr)[subindex] = (real32_T)value;
    return NI_OK;

   case 2:
    ((int8_T *)ptr)[subindex] = (int8_T)value;
    return NI_OK;

   case 3:
    ((uint8_T *)ptr)[subindex] = (uint8_T)value;
    return NI_OK;

   case 4:
    ((int16_T *)ptr)[subindex] = (int16_T)value;
    return NI_OK;

   case 5:
    ((uint16_T *)ptr)[subindex] = (uint16_T)value;
    return NI_OK;

   case 6:
    ((int32_T *)ptr)[subindex] = (int32_T)value;
    return NI_OK;

   case 7:
    ((uint32_T *)ptr)[subindex] = (uint32_T)value;
    return NI_OK;

   case 8:
    ((boolean_T *)ptr)[subindex] = (boolean_T)value;
    return NI_OK;

   case 10:
    //Type is renamed. Call SetValueByDataType on its contained type
    return NIRT_SetValueByDataType(ptr,subindex,value,6,Complex);

   case 13:
    //Type is array. Call SetValueByDataType on its contained type
    return NIRT_SetValueByDataType(ptr,subindex,value,7,Complex);

   case 16:
    //Type is renamed. Call SetValueByDataType on its contained type
    return NIRT_SetValueByDataType(ptr,subindex,value,3,Complex);

   case 17:
    //Type is matrix. Call SetValueByDataType on its contained type
    return NIRT_SetValueByDataType(ptr,subindex,value,0,Complex);

   case 18:
    //Type is matrix. Call SetValueByDataType on its contained type
    return NIRT_SetValueByDataType(ptr,subindex,value,0,Complex);

   case 19:
    //Type is matrix. Call SetValueByDataType on its contained type
    return NIRT_SetValueByDataType(ptr,subindex,value,0,Complex);

   case 20:
    //Type is matrix. Call SetValueByDataType on its contained type
    return NIRT_SetValueByDataType(ptr,subindex,value,0,Complex);

   case 21:
    //Type is matrix. Call SetValueByDataType on its contained type
    return NIRT_SetValueByDataType(ptr,subindex,value,0,Complex);

   case 22:
    //Type is matrix. Call SetValueByDataType on its contained type
    return NIRT_SetValueByDataType(ptr,subindex,value,10,Complex);

   case 23:
    //Type is matrix. Call SetValueByDataType on its contained type
    return NIRT_SetValueByDataType(ptr,subindex,value,11,Complex);

   case 24:
    //Type is matrix. Call SetValueByDataType on its contained type
    return NIRT_SetValueByDataType(ptr,subindex,value,0,Complex);

   case 25:
    //Type is matrix. Call SetValueByDataType on its contained type
    return NIRT_SetValueByDataType(ptr,subindex,value,0,Complex);

   case 26:
    //Type is matrix. Call SetValueByDataType on its contained type
    return NIRT_SetValueByDataType(ptr,subindex,value,0,Complex);

   case 27:
    //Type is matrix. Call SetValueByDataType on its contained type
    return NIRT_SetValueByDataType(ptr,subindex,value,6,Complex);

   case 28:
    //Type is matrix. Call SetValueByDataType on its contained type
    return NIRT_SetValueByDataType(ptr,subindex,value,0,Complex);

   case 29:
    //Type is matrix. Call SetValueByDataType on its contained type
    return NIRT_SetValueByDataType(ptr,subindex,value,0,Complex);

   case 30:
    //Type is matrix. Call SetValueByDataType on its contained type
    return NIRT_SetValueByDataType(ptr,subindex,value,0,Complex);

   case 31:
    //Type is matrix. Call SetValueByDataType on its contained type
    return NIRT_SetValueByDataType(ptr,subindex,value,0,Complex);

   case 32:
    //Type is matrix. Call SetValueByDataType on its contained type
    return NIRT_SetValueByDataType(ptr,subindex,value,0,Complex);

   case 33:
    //Type is matrix. Call SetValueByDataType on its contained type
    return NIRT_SetValueByDataType(ptr,subindex,value,0,Complex);

   case 34:
    //Type is matrix. Call SetValueByDataType on its contained type
    return NIRT_SetValueByDataType(ptr,subindex,value,0,Complex);

   case 35:
    //Type is matrix. Call SetValueByDataType on its contained type
    return NIRT_SetValueByDataType(ptr,subindex,value,0,Complex);

   case 36:
    //Type is matrix. Call SetValueByDataType on its contained type
    return NIRT_SetValueByDataType(ptr,subindex,value,0,Complex);

   case 37:
    //Type is matrix. Call SetValueByDataType on its contained type
    return NIRT_SetValueByDataType(ptr,subindex,value,0,Complex);

   case 38:
    //Type is matrix. Call SetValueByDataType on its contained type
    return NIRT_SetValueByDataType(ptr,subindex,value,0,Complex);

   case 39:
    //Type is matrix. Call SetValueByDataType on its contained type
    return NIRT_SetValueByDataType(ptr,subindex,value,0,Complex);

   case 40:
    //Type is matrix. Call SetValueByDataType on its contained type
    return NIRT_SetValueByDataType(ptr,subindex,value,0,Complex);

   case 41:
    //Type is matrix. Call SetValueByDataType on its contained type
    return NIRT_SetValueByDataType(ptr,subindex,value,0,Complex);

   case 42:
    //Type is matrix. Call SetValueByDataType on its contained type
    return NIRT_SetValueByDataType(ptr,subindex,value,0,Complex);

   case 43:
    //Type is matrix. Call SetValueByDataType on its contained type
    return NIRT_SetValueByDataType(ptr,subindex,value,6,Complex);

   case 44:
    //Type is matrix. Call SetValueByDataType on its contained type
    return NIRT_SetValueByDataType(ptr,subindex,value,3,Complex);

   case 45:
    //Type is matrix. Call SetValueByDataType on its contained type
    return NIRT_SetValueByDataType(ptr,subindex,value,0,Complex);

   case 46:
    //Type is matrix. Call SetValueByDataType on its contained type
    return NIRT_SetValueByDataType(ptr,subindex,value,0,Complex);

   case 47:
    //Type is matrix. Call SetValueByDataType on its contained type
    return NIRT_SetValueByDataType(ptr,subindex,value,0,Complex);

   case 48:
    //Type is matrix. Call SetValueByDataType on its contained type
    return NIRT_SetValueByDataType(ptr,subindex,value,8,Complex);

   case 57:
    //Type is matrix. Call SetValueByDataType on its contained type
    return NIRT_SetValueByDataType(ptr,subindex,value,0,Complex);

   case 58:
    //Type is matrix. Call SetValueByDataType on its contained type
    return NIRT_SetValueByDataType(ptr,subindex,value,0,Complex);

   case 59:
    //Type is matrix. Call SetValueByDataType on its contained type
    return NIRT_SetValueByDataType(ptr,subindex,value,0,Complex);

   case 60:
    //Type is matrix. Call SetValueByDataType on its contained type
    return NIRT_SetValueByDataType(ptr,subindex,value,0,Complex);
  }

  //No matching datatype conversion
  return NI_ERROR;
}

extern CA_CSE1_V1e_wo_LOSV2b_rtModel *S;
extern _SITexportglobals SITexportglobals;
void SetExternalInputs(double* data, int* TaskSampleHit)
{
  int index = 0, count = 0;

  // Naviagation Systems/Qualisys 6 DOF/QTM In
  if (TaskSampleHit[0]) {
    for (count = 0; count < 16; count++) {
      NIRT_SetValueByDataType(CA_CSE1_V1e_wo_LOSV2b_B.QTMIn, count, data[index++],
        38, 0);
    }
  } else {
    index += 16;
  }

  // HMI/SIT zAI0
  if (TaskSampleHit[1]) {
    NIRT_SetValueByDataType(&CA_CSE1_V1e_wo_LOSV2b_B.SITzAI0, 0, data[index++],
      0, 0);
  } else {
    index += 1;
  }

  // HMI/SIT zAI1
  if (TaskSampleHit[1]) {
    NIRT_SetValueByDataType(&CA_CSE1_V1e_wo_LOSV2b_B.SITzAI1, 0, data[index++],
      0, 0);
  } else {
    index += 1;
  }

  // HMI/SIT zAI2
  if (TaskSampleHit[1]) {
    NIRT_SetValueByDataType(&CA_CSE1_V1e_wo_LOSV2b_B.SITzAI2, 0, data[index++],
      0, 0);
  } else {
    index += 1;
  }
}                                      /* of SetExternalInputs */

long NumInputPorts(void)
{
  return 19;
}

double ni_extout[7];
void SetExternalOutputs(double* data, int* TaskSampleHit)
{
  int index = 0, count = 0;

  // Plants/CSE1/Bow Thruster/SIT Out5 BT: Virtual Signal # 0
  if (TaskSampleHit[0]) {              // sample and hold
    ni_extout[index++] = NIRT_GetValueByDataType
      (&CA_CSE1_V1e_wo_LOSV2b_B.Switch2_l,0,0,0);
  } else {
    index += 1;
  }

  // Plants/CSE1/Voith Schneider Propeller /SIT Out1 Servo1: Virtual Signal # 0
  if (TaskSampleHit[0]) {              // sample and hold
    ni_extout[index++] = NIRT_GetValueByDataType(&CA_CSE1_V1e_wo_LOSV2b_B.Servo1,
      0,0,0);
  } else {
    index += 1;
  }

  // Plants/CSE1/Voith Schneider Propeller /SIT Out2 Servo2: Virtual Signal # 0
  if (TaskSampleHit[0]) {              // sample and hold
    ni_extout[index++] = NIRT_GetValueByDataType(&CA_CSE1_V1e_wo_LOSV2b_B.Servo2,
      0,0,0);
  } else {
    index += 1;
  }

  // Plants/CSE1/Voith Schneider Propeller /SIT Out3 Servo3: Virtual Signal # 0
  if (TaskSampleHit[0]) {              // sample and hold
    ni_extout[index++] = NIRT_GetValueByDataType(&CA_CSE1_V1e_wo_LOSV2b_B.Servo3,
      0,0,0);
  } else {
    index += 1;
  }

  // Plants/CSE1/Voith Schneider Propeller /SIT Out4 Servo4: Virtual Signal # 0
  if (TaskSampleHit[0]) {              // sample and hold
    ni_extout[index++] = NIRT_GetValueByDataType(&CA_CSE1_V1e_wo_LOSV2b_B.Servo4,
      0,0,0);
  } else {
    index += 1;
  }

  // Plants/CSE1/Voith Schneider Propeller /SIT Out6 VSPS Port: Virtual Signal # 0
  if (TaskSampleHit[0]) {              // sample and hold
    ni_extout[index++] = NIRT_GetValueByDataType
      (&CA_CSE1_V1e_wo_LOSV2b_B.VSPSPort,0,0,0);
  } else {
    index += 1;
  }

  // Plants/CSE1/Voith Schneider Propeller /SIT Out7 VSPS Starboard: Virtual Signal # 0
  if (TaskSampleHit[0]) {              // sample and hold
    ni_extout[index++] = NIRT_GetValueByDataType
      (&CA_CSE1_V1e_wo_LOSV2b_B.VSPSStarboard,0,0,0);
  } else {
    index += 1;
  }

  if (data)
    memcpy(&data[0], &ni_extout[0], sizeof(ni_extout));
}

long NumOutputPorts(void)
{
  return 7;
}

int NI_InitExternalOutputs()
{
  int index = 0, count = 0;

  // Plants/CSE1/Bow Thruster/SIT Out5 BT: Virtual Signal # 0
  ni_extout[index++] = NIRT_GetValueByDataType
    (&CA_CSE1_V1e_wo_LOSV2b_B.Switch2_l,0,0,0);

  // Plants/CSE1/Voith Schneider Propeller /SIT Out1 Servo1: Virtual Signal # 0
  ni_extout[index++] = NIRT_GetValueByDataType(&CA_CSE1_V1e_wo_LOSV2b_B.Servo1,0,
    0,0);

  // Plants/CSE1/Voith Schneider Propeller /SIT Out2 Servo2: Virtual Signal # 0
  ni_extout[index++] = NIRT_GetValueByDataType(&CA_CSE1_V1e_wo_LOSV2b_B.Servo2,0,
    0,0);

  // Plants/CSE1/Voith Schneider Propeller /SIT Out3 Servo3: Virtual Signal # 0
  ni_extout[index++] = NIRT_GetValueByDataType(&CA_CSE1_V1e_wo_LOSV2b_B.Servo3,0,
    0,0);

  // Plants/CSE1/Voith Schneider Propeller /SIT Out4 Servo4: Virtual Signal # 0
  ni_extout[index++] = NIRT_GetValueByDataType(&CA_CSE1_V1e_wo_LOSV2b_B.Servo4,0,
    0,0);

  // Plants/CSE1/Voith Schneider Propeller /SIT Out6 VSPS Port: Virtual Signal # 0
  ni_extout[index++] = NIRT_GetValueByDataType(&CA_CSE1_V1e_wo_LOSV2b_B.VSPSPort,
    0,0,0);

  // Plants/CSE1/Voith Schneider Propeller /SIT Out7 VSPS Starboard: Virtual Signal # 0
  ni_extout[index++] = NIRT_GetValueByDataType
    (&CA_CSE1_V1e_wo_LOSV2b_B.VSPSStarboard,0,0,0);
  return NI_OK;
}

// by default, all elements (inclulding	scalars) have 2 dimensions [1,1]
static NI_Parameter NI_ParamList[] = {
  { 0, "ca_cse1_v1e_wo_losv2b/Naviagation Systems/Qualisys 6 DOF/QTM In3/Gain",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, QTMIn3_Gain), 39, 1, 2, 0, "", 0 },

  { 1, "ca_cse1_v1e_wo_losv2b/Naviagation Systems/Qualisys 6 DOF/mm2m x/Gain",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, mm2mx_Gain), 39, 1, 2, 2, "", 0 },

  { 2, "ca_cse1_v1e_wo_losv2b/Naviagation Systems/Qualisys 6 DOF/QTM In4/Gain",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, QTMIn4_Gain), 39, 1, 2, 4, "", 0 },

  { 3, "ca_cse1_v1e_wo_losv2b/Naviagation Systems/Qualisys 6 DOF/mm2m y/Gain",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, mm2my_Gain), 39, 1, 2, 6, "", 0 },

  { 4, "ca_cse1_v1e_wo_losv2b/Naviagation Systems/Qualisys 6 DOF/QTM In5/Gain",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, QTMIn5_Gain), 39, 1, 2, 8, "", 0 },

  { 5, "ca_cse1_v1e_wo_losv2b/Naviagation Systems/Qualisys 6 DOF/mm2m z/Gain",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, mm2mz_Gain), 39, 1, 2, 10, "", 0 },

  { 6, "ca_cse1_v1e_wo_losv2b/Naviagation Systems/Qualisys 6 DOF/QTM In8/Gain",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, QTMIn8_Gain), 39, 1, 2, 12, "", 0
  },

  { 7, "ca_cse1_v1e_wo_losv2b/Naviagation Systems/Qualisys 6 DOF/d2r roll/Gain",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, d2rroll_Gain), 39, 1, 2, 14, "", 0
  },

  { 8, "ca_cse1_v1e_wo_losv2b/Naviagation Systems/Qualisys 6 DOF/QTM In7/Gain",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, QTMIn7_Gain), 39, 1, 2, 16, "", 0
  },

  { 9, "ca_cse1_v1e_wo_losv2b/Naviagation Systems/Qualisys 6 DOF/d2r pitch/Gain",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, d2rpitch_Gain), 39, 1, 2, 18, "",
    0 },

  { 10, "ca_cse1_v1e_wo_losv2b/Naviagation Systems/Qualisys 6 DOF/QTM In6/Gain",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, QTMIn6_Gain), 39, 1, 2, 20, "", 0
  },

  { 11, "ca_cse1_v1e_wo_losv2b/Naviagation Systems/Qualisys 6 DOF/d2r yaw/Gain",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, d2ryaw_Gain), 39, 1, 2, 22, "", 0
  },

  { 12, "ca_cse1_v1e_wo_losv2b/Control Systems/Control Mode/Value", offsetof
    (Parameters_CA_CSE1_V1e_wo_LOSV2, ControlMode_Value), 39, 1, 2, 24, "", 0 },

  { 13, "ca_cse1_v1e_wo_losv2b/HMI/Panel command inputs/u1/Value", offsetof
    (Parameters_CA_CSE1_V1e_wo_LOSV2, u1_Value), 39, 1, 2, 26, "", 0 },

  { 14, "ca_cse1_v1e_wo_losv2b/HMI/Panel command inputs/Panel  u_1/Gain",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, Panelu_1_Gain), 39, 1, 2, 28, "",
    0 },

  { 15, "ca_cse1_v1e_wo_losv2b/HMI/Panel command inputs/u2/Value", offsetof
    (Parameters_CA_CSE1_V1e_wo_LOSV2, u2_Value), 39, 1, 2, 30, "", 0 },

  { 16, "ca_cse1_v1e_wo_losv2b/HMI/Panel command inputs/Panel u_2/Gain",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, Panelu_2_Gain), 39, 1, 2, 32, "",
    0 },

  { 17, "ca_cse1_v1e_wo_losv2b/HMI/Panel command inputs/u3/Value", offsetof
    (Parameters_CA_CSE1_V1e_wo_LOSV2, u3_Value), 39, 1, 2, 34, "", 0 },

  { 18, "ca_cse1_v1e_wo_losv2b/HMI/Panel command inputs/Panel u_3/Gain",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, Panelu_3_Gain), 39, 1, 2, 36, "",
    0 },

  { 19, "ca_cse1_v1e_wo_losv2b/HMI/Panel command inputs/u4/Value", offsetof
    (Parameters_CA_CSE1_V1e_wo_LOSV2, u4_Value), 39, 1, 2, 38, "", 0 },

  { 20, "ca_cse1_v1e_wo_losv2b/HMI/Panel command inputs/Panel u_4/Gain",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, Panelu_4_Gain), 39, 1, 2, 40, "",
    0 },

  { 21, "ca_cse1_v1e_wo_losv2b/HMI/Panel command inputs/u5/Value", offsetof
    (Parameters_CA_CSE1_V1e_wo_LOSV2, u5_Value), 39, 1, 2, 42, "", 0 },

  { 22, "ca_cse1_v1e_wo_losv2b/HMI/Panel command inputs/Panel u_5/Gain",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, Panelu_5_Gain), 39, 1, 2, 44, "",
    0 },

  { 23, "ca_cse1_v1e_wo_losv2b/HMI/PS3 input/LabVIEW_BT_Power/Value", offsetof
    (Parameters_CA_CSE1_V1e_wo_LOSV2, LabVIEW_BT_Power_Value), 39, 1, 2, 46, "",
    0 },

  { 24, "ca_cse1_v1e_wo_losv2b/HMI/PS3 input/LabVIEW_VSP_Speed/Value", offsetof
    (Parameters_CA_CSE1_V1e_wo_LOSV2, LabVIEW_VSP_Speed_Value), 39, 1, 2, 48, "",
    0 },

  { 25, "ca_cse1_v1e_wo_losv2b/HMI/PS3 input/PS3 signals/JS_L_Y/Value", offsetof
    (Parameters_CA_CSE1_V1e_wo_LOSV2, JS_L_Y_Value), 39, 1, 2, 50, "", 0 },

  { 26, "ca_cse1_v1e_wo_losv2b/HMI/PS3 input/PS3 signals/Scaling_JS_L_Y/Gain",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, Scaling_JS_L_Y_Gain), 39, 1, 2, 52,
    "", 0 },

  { 27,
    "ca_cse1_v1e_wo_losv2b/Control Systems/Manual Thrust control/PS3 u_1/Gain",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, PS3u_1_Gain), 39, 1, 2, 54, "", 0
  },

  { 28, "ca_cse1_v1e_wo_losv2b/HMI/PS3 input/PS3 signals/JS_L_X/Value", offsetof
    (Parameters_CA_CSE1_V1e_wo_LOSV2, JS_L_X_Value), 39, 1, 2, 56, "", 0 },

  { 29, "ca_cse1_v1e_wo_losv2b/HMI/PS3 input/PS3 signals/Scaling_JS_L_X/Gain",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, Scaling_JS_L_X_Gain), 39, 1, 2, 58,
    "", 0 },

  { 30,
    "ca_cse1_v1e_wo_losv2b/Control Systems/Manual Thrust control/PS3 u_2/Gain",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, PS3u_2_Gain), 39, 1, 2, 60, "", 0
  },

  { 31, "ca_cse1_v1e_wo_losv2b/HMI/PS3 input/PS3 signals/JS_R_Y/Value", offsetof
    (Parameters_CA_CSE1_V1e_wo_LOSV2, JS_R_Y_Value), 39, 1, 2, 62, "", 0 },

  { 32, "ca_cse1_v1e_wo_losv2b/HMI/PS3 input/PS3 signals/Scaling_JS_R_Y/Gain",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, Scaling_JS_R_Y_Gain), 39, 1, 2, 64,
    "", 0 },

  { 33,
    "ca_cse1_v1e_wo_losv2b/Control Systems/Manual Thrust control/PS3 u_3/Gain",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, PS3u_3_Gain), 39, 1, 2, 66, "", 0
  },

  { 34, "ca_cse1_v1e_wo_losv2b/HMI/PS3 input/PS3 signals/JS_R_X/Value", offsetof
    (Parameters_CA_CSE1_V1e_wo_LOSV2, JS_R_X_Value), 39, 1, 2, 68, "", 0 },

  { 35, "ca_cse1_v1e_wo_losv2b/HMI/PS3 input/PS3 signals/Scaling_JS_R_X/Gain",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, Scaling_JS_R_X_Gain), 39, 1, 2, 70,
    "", 0 },

  { 36,
    "ca_cse1_v1e_wo_losv2b/Control Systems/Manual Thrust control/PS3 u_4/Gain",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, PS3u_4_Gain), 39, 1, 2, 72, "", 0
  },

  { 37, "ca_cse1_v1e_wo_losv2b/HMI/PS3 input/PS3 signals/L2/Value", offsetof
    (Parameters_CA_CSE1_V1e_wo_LOSV2, L2_Value), 39, 1, 2, 74, "", 0 },

  { 38, "ca_cse1_v1e_wo_losv2b/HMI/PS3 input/PS3 signals/R2/Value", offsetof
    (Parameters_CA_CSE1_V1e_wo_LOSV2, R2_Value), 39, 1, 2, 76, "", 0 },

  { 39,
    "ca_cse1_v1e_wo_losv2b/Control Systems/Manual Thrust control/PS3 u_5/Gain",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, PS3u_5_Gain), 39, 1, 2, 78, "", 0
  },

  { 40,
    "ca_cse1_v1e_wo_losv2b/Control Systems/Joystick Control/K_e/K_e1_joystick/Value",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, K_e1_joystick_Value), 39, 1, 2, 80,
    "", 0 },

  { 41,
    "ca_cse1_v1e_wo_losv2b/Control Systems/Joystick Control/K_e/Gain K_e1_joystick/Gain",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, GainK_e1_joystick_Gain), 39, 1, 2,
    82, "", 0 },

  { 42,
    "ca_cse1_v1e_wo_losv2b/Control Systems/Joystick Control/K_e/Constant/Value",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, Constant_Value), 39, 1, 2, 84, "",
    0 },

  { 43,
    "ca_cse1_v1e_wo_losv2b/Control Systems/Joystick Control/K_e/K_e2_joystick/Value",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, K_e2_joystick_Value), 39, 1, 2, 86,
    "", 0 },

  { 44,
    "ca_cse1_v1e_wo_losv2b/Control Systems/Joystick Control/K_e/Gain K_e2_joystick/Gain",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, GainK_e2_joystick_Gain), 39, 1, 2,
    88, "", 0 },

  { 45,
    "ca_cse1_v1e_wo_losv2b/Control Systems/Joystick Control/K_e/K_e3_joystick/Value",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, K_e3_joystick_Value), 39, 1, 2, 90,
    "", 0 },

  { 46,
    "ca_cse1_v1e_wo_losv2b/Control Systems/Joystick Control/K_e/Gain K_e3_joystick/Gain",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, GainK_e3_joystick_Gain), 39, 1, 2,
    92, "", 0 },

  { 47,
    "ca_cse1_v1e_wo_losv2b/Control Systems/Joystick Control/K_e/K_e4_joystick/Value",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, K_e4_joystick_Value), 39, 1, 2, 94,
    "", 0 },

  { 48,
    "ca_cse1_v1e_wo_losv2b/Control Systems/Joystick Control/K_e/Gain K_e4_joystick/Gain",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, GainK_e4_joystick_Gain), 39, 1, 2,
    96, "", 0 },

  { 49,
    "ca_cse1_v1e_wo_losv2b/Control Systems/Joystick Control/K_e/K_e5_joystick/Value",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, K_e5_joystick_Value), 39, 1, 2, 98,
    "", 0 },

  { 50,
    "ca_cse1_v1e_wo_losv2b/Control Systems/Joystick Control/K_e/Gain K_e5_joystick/Gain",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, GainK_e5_joystick_Gain), 39, 1, 2,
    100, "", 0 },

  { 51, "ca_cse1_v1e_wo_losv2b/Control Systems/Joystick Control/T_e/T_e11/Value",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, T_e11_Value), 39, 1, 2, 102, "", 0
  },

  { 52, "ca_cse1_v1e_wo_losv2b/Control Systems/Joystick Control/T_e/T_e21/Value",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, T_e21_Value), 39, 1, 2, 104, "", 0
  },

  { 53, "ca_cse1_v1e_wo_losv2b/Control Systems/Joystick Control/T_e/l_y1/Value",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, l_y1_Value), 39, 1, 2, 106, "", 0
  },

  { 54, "ca_cse1_v1e_wo_losv2b/Control Systems/Joystick Control/T_e/T_e12/Value",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, T_e12_Value), 39, 1, 2, 108, "", 0
  },

  { 55, "ca_cse1_v1e_wo_losv2b/Control Systems/Joystick Control/T_e/T_e22/Value",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, T_e22_Value), 39, 1, 2, 110, "", 0
  },

  { 56, "ca_cse1_v1e_wo_losv2b/Control Systems/Joystick Control/T_e/l_x1/Value",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, l_x1_Value), 39, 1, 2, 112, "", 0
  },

  { 57, "ca_cse1_v1e_wo_losv2b/Control Systems/Joystick Control/T_e/-l_x1/Gain",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, l_x1_Gain), 39, 1, 2, 114, "", 0 },

  { 58, "ca_cse1_v1e_wo_losv2b/Control Systems/Joystick Control/T_e/T_e13/Value",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, T_e13_Value), 39, 1, 2, 116, "", 0
  },

  { 59, "ca_cse1_v1e_wo_losv2b/Control Systems/Joystick Control/T_e/T_e23/Value",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, T_e23_Value), 39, 1, 2, 118, "", 0
  },

  { 60, "ca_cse1_v1e_wo_losv2b/Control Systems/Joystick Control/T_e/l_y2/Value",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, l_y2_Value), 39, 1, 2, 120, "", 0
  },

  { 61, "ca_cse1_v1e_wo_losv2b/Control Systems/Joystick Control/T_e/-l_y2/Gain",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, l_y2_Gain), 39, 1, 2, 122, "", 0 },

  { 62, "ca_cse1_v1e_wo_losv2b/Control Systems/Joystick Control/T_e/T_e14/Value",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, T_e14_Value), 39, 1, 2, 124, "", 0
  },

  { 63, "ca_cse1_v1e_wo_losv2b/Control Systems/Joystick Control/T_e/T_e24/Value",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, T_e24_Value), 39, 1, 2, 126, "", 0
  },

  { 64, "ca_cse1_v1e_wo_losv2b/Control Systems/Joystick Control/T_e/l_x2/Value",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, l_x2_Value), 39, 1, 2, 128, "", 0
  },

  { 65, "ca_cse1_v1e_wo_losv2b/Control Systems/Joystick Control/T_e/-l_x2/Gain",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, l_x2_Gain), 39, 1, 2, 130, "", 0 },

  { 66, "ca_cse1_v1e_wo_losv2b/Control Systems/Joystick Control/T_e/T_e15/Value",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, T_e15_Value), 39, 1, 2, 132, "", 0
  },

  { 67, "ca_cse1_v1e_wo_losv2b/Control Systems/Joystick Control/T_e/T_e25/Value",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, T_e25_Value), 39, 1, 2, 134, "", 0
  },

  { 68, "ca_cse1_v1e_wo_losv2b/Control Systems/Joystick Control/T_e/l_x3/Value",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, l_x3_Value), 39, 1, 2, 136, "", 0
  },

  { 69,
    "ca_cse1_v1e_wo_losv2b/Control Systems/Joystick Control/Joystick tau_surge/Gain",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, Joysticktau_surge_Gain), 39, 1, 2,
    138, "", 0 },

  { 70,
    "ca_cse1_v1e_wo_losv2b/Control Systems/Joystick Control/Saturation1/UpperLimit",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, Saturation1_UpperSat), 39, 1, 2,
    140, "", 0 },

  { 71,
    "ca_cse1_v1e_wo_losv2b/Control Systems/Joystick Control/Saturation1/LowerLimit",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, Saturation1_LowerSat), 39, 1, 2,
    142, "", 0 },

  { 72,
    "ca_cse1_v1e_wo_losv2b/Control Systems/Joystick Control/Joystick tau_sway/Gain",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, Joysticktau_sway_Gain), 39, 1, 2,
    144, "", 0 },

  { 73,
    "ca_cse1_v1e_wo_losv2b/Control Systems/Joystick Control/Saturation2/UpperLimit",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, Saturation2_UpperSat), 39, 1, 2,
    146, "", 0 },

  { 74,
    "ca_cse1_v1e_wo_losv2b/Control Systems/Joystick Control/Saturation2/LowerLimit",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, Saturation2_LowerSat), 39, 1, 2,
    148, "", 0 },

  { 75,
    "ca_cse1_v1e_wo_losv2b/Control Systems/Joystick Control/Joystick tau_yaw/Gain",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, Joysticktau_yaw_Gain), 39, 1, 2,
    150, "", 0 },

  { 76,
    "ca_cse1_v1e_wo_losv2b/Control Systems/Joystick Control/Saturation3/UpperLimit",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, Saturation3_UpperSat), 39, 1, 2,
    152, "", 0 },

  { 77,
    "ca_cse1_v1e_wo_losv2b/Control Systems/Joystick Control/Saturation3/LowerLimit",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, Saturation3_LowerSat), 39, 1, 2,
    154, "", 0 },

  { 78,
    "ca_cse1_v1e_wo_losv2b/Control Systems/Joystick Control/Saturation/UpperLimit",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, Saturation_UpperSat), 39, 1, 2,
    156, "", 0 },

  { 79,
    "ca_cse1_v1e_wo_losv2b/Control Systems/Joystick Control/Saturation/LowerLimit",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, Saturation_LowerSat), 39, 1, 2,
    158, "", 0 },

  { 80,
    "ca_cse1_v1e_wo_losv2b/Control Systems/Joystick Control/Joystick u_1/Gain",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, Joysticku_1_Gain), 39, 1, 2, 160,
    "", 0 },

  { 81,
    "ca_cse1_v1e_wo_losv2b/Control Systems/Joystick Control/Joystick u_2/Gain",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, Joysticku_2_Gain), 39, 1, 2, 162,
    "", 0 },

  { 82,
    "ca_cse1_v1e_wo_losv2b/Control Systems/Joystick Control/Joystick u_3/Gain",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, Joysticku_3_Gain), 39, 1, 2, 164,
    "", 0 },

  { 83,
    "ca_cse1_v1e_wo_losv2b/Control Systems/Joystick Control/Joystick u_4/Gain",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, Joysticku_4_Gain), 39, 1, 2, 166,
    "", 0 },

  { 84,
    "ca_cse1_v1e_wo_losv2b/Control Systems/Joystick Control/Joystick u_5/Gain",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, Joysticku_5_Gain), 39, 1, 2, 168,
    "", 0 },

  { 85, "ca_cse1_v1e_wo_losv2b/Guidance Systems/DP/Enable eta_d LPF/Value",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, Enableeta_dLPF_Value), 39, 1, 2,
    170, "", 0 },

  { 86, "ca_cse1_v1e_wo_losv2b/HMI/DP input/x_d/Value", offsetof
    (Parameters_CA_CSE1_V1e_wo_LOSV2, x_d_Value), 39, 1, 2, 172, "", 0 },

  { 87, "ca_cse1_v1e_wo_losv2b/HMI/DP input/y_d/Value", offsetof
    (Parameters_CA_CSE1_V1e_wo_LOSV2, y_d_Value), 39, 1, 2, 174, "", 0 },

  { 88, "ca_cse1_v1e_wo_losv2b/HMI/DP input/psi_d/Value", offsetof
    (Parameters_CA_CSE1_V1e_wo_LOSV2, psi_d_Value), 39, 1, 2, 176, "", 0 },

  { 89, "ca_cse1_v1e_wo_losv2b/HMI/DP input/Degrees to Radians/Gain1/Gain",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, Gain1_Gain), 39, 1, 2, 178, "", 0
  },

  { 90, "ca_cse1_v1e_wo_losv2b/Guidance Systems/DP/Transfer Fcn/A", offsetof
    (Parameters_CA_CSE1_V1e_wo_LOSV2, TransferFcn_A), 39, 1, 2, 180, "", 0 },

  { 91, "ca_cse1_v1e_wo_losv2b/Guidance Systems/DP/Transfer Fcn/C", offsetof
    (Parameters_CA_CSE1_V1e_wo_LOSV2, TransferFcn_C), 39, 1, 2, 182, "", 0 },

  { 92, "ca_cse1_v1e_wo_losv2b/Guidance Systems/DP/Transfer Fcn1/A", offsetof
    (Parameters_CA_CSE1_V1e_wo_LOSV2, TransferFcn1_A), 39, 1, 2, 184, "", 0 },

  { 93, "ca_cse1_v1e_wo_losv2b/Guidance Systems/DP/Transfer Fcn1/C", offsetof
    (Parameters_CA_CSE1_V1e_wo_LOSV2, TransferFcn1_C), 39, 1, 2, 186, "", 0 },

  { 94, "ca_cse1_v1e_wo_losv2b/Guidance Systems/DP/Transfer Fcn2/A", offsetof
    (Parameters_CA_CSE1_V1e_wo_LOSV2, TransferFcn2_A), 39, 1, 2, 188, "", 0 },

  { 95, "ca_cse1_v1e_wo_losv2b/Guidance Systems/DP/Transfer Fcn2/C", offsetof
    (Parameters_CA_CSE1_V1e_wo_LOSV2, TransferFcn2_C), 39, 1, 2, 190, "", 0 },

  { 96, "ca_cse1_v1e_wo_losv2b/Guidance Systems/DP/eta_d DP N/Gain", offsetof
    (Parameters_CA_CSE1_V1e_wo_LOSV2, eta_dDPN_Gain), 39, 1, 2, 192, "", 0 },

  { 97, "ca_cse1_v1e_wo_losv2b/Guidance Systems/DP/eta_d DP E/Gain", offsetof
    (Parameters_CA_CSE1_V1e_wo_LOSV2, eta_dDPE_Gain), 39, 1, 2, 194, "", 0 },

  { 98, "ca_cse1_v1e_wo_losv2b/Guidance Systems/DP/eta_d DP Psi/Gain", offsetof
    (Parameters_CA_CSE1_V1e_wo_LOSV2, eta_dDPPsi_Gain), 39, 1, 2, 196, "", 0 },

  { 99,
    "ca_cse1_v1e_wo_losv2b/Naviagation Systems/Controller Input Selector/Value",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, ControllerInputSelector_Value), 39,
    1, 2, 198, "", 0 },

  { 100, "ca_cse1_v1e_wo_losv2b/Plants/Enable Linear Simulator/Value", offsetof
    (Parameters_CA_CSE1_V1e_wo_LOSV2, EnableLinearSimulator_Value), 39, 1, 2,
    200, "", 0 },

  { 101, "ca_cse1_v1e_wo_losv2b/Naviagation Systems/eta_surge/Gain", offsetof
    (Parameters_CA_CSE1_V1e_wo_LOSV2, eta_surge_Gain), 39, 1, 2, 202, "", 0 },

  { 102, "ca_cse1_v1e_wo_losv2b/Naviagation Systems/eta_sway/Gain", offsetof
    (Parameters_CA_CSE1_V1e_wo_LOSV2, eta_sway_Gain), 39, 1, 2, 204, "", 0 },

  { 103, "ca_cse1_v1e_wo_losv2b/Naviagation Systems/eta_yaw/Gain", offsetof
    (Parameters_CA_CSE1_V1e_wo_LOSV2, eta_yaw_Gain), 39, 1, 2, 206, "", 0 },

  { 104,
    "ca_cse1_v1e_wo_losv2b/Naviagation Systems/Qualisys 6 DOF/Constant1/Value",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, Constant1_Value), 33, 9, 2, 208,
    "", 0 },

  { 105, "ca_cse1_v1e_wo_losv2b/Naviagation Systems/nu_surge/Gain", offsetof
    (Parameters_CA_CSE1_V1e_wo_LOSV2, nu_surge_Gain), 39, 1, 2, 210, "", 0 },

  { 106, "ca_cse1_v1e_wo_losv2b/Naviagation Systems/nu_sway/Gain", offsetof
    (Parameters_CA_CSE1_V1e_wo_LOSV2, nu_sway_Gain), 39, 1, 2, 212, "", 0 },

  { 107, "ca_cse1_v1e_wo_losv2b/Naviagation Systems/nu_yaw/Gain", offsetof
    (Parameters_CA_CSE1_V1e_wo_LOSV2, nu_yaw_Gain), 39, 1, 2, 214, "", 0 },

  { 108,
    "ca_cse1_v1e_wo_losv2b/Control Systems/if DP Control Mode/Constant/Value",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, Constant_Value_c), 39, 1, 2, 216,
    "", 0 },

  { 109,
    "ca_cse1_v1e_wo_losv2b/Control Systems/Maneuvering controller/K_e/K_e1_DP/Value",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, K_e1_DP_Value), 39, 1, 2, 218, "",
    0 },

  { 110,
    "ca_cse1_v1e_wo_losv2b/Control Systems/Maneuvering controller/K_e/Gain K_e1_DP/Gain",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, GainK_e1_DP_Gain), 39, 1, 2, 220,
    "", 0 },

  { 111,
    "ca_cse1_v1e_wo_losv2b/Control Systems/Maneuvering controller/K_e/Constant/Value",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, Constant_Value_cz), 39, 1, 2, 222,
    "", 0 },

  { 112,
    "ca_cse1_v1e_wo_losv2b/Control Systems/Maneuvering controller/K_e/K_e2_DP/Value",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, K_e2_DP_Value), 39, 1, 2, 224, "",
    0 },

  { 113,
    "ca_cse1_v1e_wo_losv2b/Control Systems/Maneuvering controller/K_e/Gain K_e2_DP/Gain",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, GainK_e2_DP_Gain), 39, 1, 2, 226,
    "", 0 },

  { 114,
    "ca_cse1_v1e_wo_losv2b/Control Systems/Maneuvering controller/K_e/K_e3_DP/Value",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, K_e3_DP_Value), 39, 1, 2, 228, "",
    0 },

  { 115,
    "ca_cse1_v1e_wo_losv2b/Control Systems/Maneuvering controller/K_e/Gain K_e3_DP/Gain",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, GainK_e3_DP_Gain), 39, 1, 2, 230,
    "", 0 },

  { 116,
    "ca_cse1_v1e_wo_losv2b/Control Systems/Maneuvering controller/K_e/K_e4_DP/Value",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, K_e4_DP_Value), 39, 1, 2, 232, "",
    0 },

  { 117,
    "ca_cse1_v1e_wo_losv2b/Control Systems/Maneuvering controller/K_e/Gain K_e4_DP/Gain",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, GainK_e4_DP_Gain), 39, 1, 2, 234,
    "", 0 },

  { 118,
    "ca_cse1_v1e_wo_losv2b/Control Systems/Maneuvering controller/K_e/K_e5_DP/Value",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, K_e5_DP_Value), 39, 1, 2, 236, "",
    0 },

  { 119,
    "ca_cse1_v1e_wo_losv2b/Control Systems/Maneuvering controller/K_e/Gain K_e5_DP/Gain",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, GainK_e5_DP_Gain), 39, 1, 2, 238,
    "", 0 },

  { 120,
    "ca_cse1_v1e_wo_losv2b/Control Systems/Maneuvering controller/T_e/T_e11/Value",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, T_e11_Value_f), 39, 1, 2, 240, "",
    0 },

  { 121,
    "ca_cse1_v1e_wo_losv2b/Control Systems/Maneuvering controller/T_e/T_e21/Value",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, T_e21_Value_m), 39, 1, 2, 242, "",
    0 },

  { 122,
    "ca_cse1_v1e_wo_losv2b/Control Systems/Maneuvering controller/T_e/l_y1/Value",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, l_y1_Value_m), 39, 1, 2, 244, "",
    0 },

  { 123,
    "ca_cse1_v1e_wo_losv2b/Control Systems/Maneuvering controller/T_e/T_e12/Value",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, T_e12_Value_a), 39, 1, 2, 246, "",
    0 },

  { 124,
    "ca_cse1_v1e_wo_losv2b/Control Systems/Maneuvering controller/T_e/T_e22/Value",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, T_e22_Value_p), 39, 1, 2, 248, "",
    0 },

  { 125,
    "ca_cse1_v1e_wo_losv2b/Control Systems/Maneuvering controller/T_e/l_x1/Value",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, l_x1_Value_h), 39, 1, 2, 250, "",
    0 },

  { 126,
    "ca_cse1_v1e_wo_losv2b/Control Systems/Maneuvering controller/T_e/-l_x1/Gain",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, l_x1_Gain_h), 39, 1, 2, 252, "", 0
  },

  { 127,
    "ca_cse1_v1e_wo_losv2b/Control Systems/Maneuvering controller/T_e/T_e13/Value",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, T_e13_Value_d), 39, 1, 2, 254, "",
    0 },

  { 128,
    "ca_cse1_v1e_wo_losv2b/Control Systems/Maneuvering controller/T_e/T_e23/Value",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, T_e23_Value_h), 39, 1, 2, 256, "",
    0 },

  { 129,
    "ca_cse1_v1e_wo_losv2b/Control Systems/Maneuvering controller/T_e/l_y2/Value",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, l_y2_Value_b), 39, 1, 2, 258, "",
    0 },

  { 130,
    "ca_cse1_v1e_wo_losv2b/Control Systems/Maneuvering controller/T_e/-l_y2/Gain",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, l_y2_Gain_g), 39, 1, 2, 260, "", 0
  },

  { 131,
    "ca_cse1_v1e_wo_losv2b/Control Systems/Maneuvering controller/T_e/T_e14/Value",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, T_e14_Value_o), 39, 1, 2, 262, "",
    0 },

  { 132,
    "ca_cse1_v1e_wo_losv2b/Control Systems/Maneuvering controller/T_e/T_e24/Value",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, T_e24_Value_m), 39, 1, 2, 264, "",
    0 },

  { 133,
    "ca_cse1_v1e_wo_losv2b/Control Systems/Maneuvering controller/T_e/l_x2/Value",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, l_x2_Value_p), 39, 1, 2, 266, "",
    0 },

  { 134,
    "ca_cse1_v1e_wo_losv2b/Control Systems/Maneuvering controller/T_e/-l_x2/Gain",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, l_x2_Gain_i), 39, 1, 2, 268, "", 0
  },

  { 135,
    "ca_cse1_v1e_wo_losv2b/Control Systems/Maneuvering controller/T_e/T_e15/Value",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, T_e15_Value_j), 39, 1, 2, 270, "",
    0 },

  { 136,
    "ca_cse1_v1e_wo_losv2b/Control Systems/Maneuvering controller/T_e/T_e25/Value",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, T_e25_Value_j), 39, 1, 2, 272, "",
    0 },

  { 137,
    "ca_cse1_v1e_wo_losv2b/Control Systems/Maneuvering controller/T_e/l_x3/Value",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, l_x3_Value_o), 39, 1, 2, 274, "",
    0 },

  { 138,
    "ca_cse1_v1e_wo_losv2b/Guidance Systems/Path generator (iceberg towing)/N_d1/Step/Time",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, Step_Time), 39, 1, 2, 276, "", 0 },

  { 139,
    "ca_cse1_v1e_wo_losv2b/Guidance Systems/Path generator (iceberg towing)/N_d1/Step/Before",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, Step_Y0), 39, 1, 2, 278, "", 0 },

  { 140,
    "ca_cse1_v1e_wo_losv2b/Guidance Systems/Path generator (iceberg towing)/N_d1/Step/After",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, Step_YFinal), 39, 1, 2, 280, "", 0
  },

  { 141,
    "ca_cse1_v1e_wo_losv2b/Guidance Systems/Path generator (iceberg towing)/N_d1/Constant/Value",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, Constant_Value_j), 39, 1, 2, 282,
    "", 0 },

  { 142,
    "ca_cse1_v1e_wo_losv2b/Guidance Systems/Path generator (iceberg towing)/N_d1/Constant1/Value",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, Constant1_Value_i), 39, 1, 2, 284,
    "", 0 },

  { 143,
    "ca_cse1_v1e_wo_losv2b/Guidance Systems/Path generator (iceberg towing)/E_d/Step/Time",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, Step_Time_l), 39, 1, 2, 286, "", 0
  },

  { 144,
    "ca_cse1_v1e_wo_losv2b/Guidance Systems/Path generator (iceberg towing)/E_d/Step/Before",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, Step_Y0_k), 39, 1, 2, 288, "", 0 },

  { 145,
    "ca_cse1_v1e_wo_losv2b/Guidance Systems/Path generator (iceberg towing)/E_d/Step/After",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, Step_YFinal_l), 39, 1, 2, 290, "",
    0 },

  { 146,
    "ca_cse1_v1e_wo_losv2b/Guidance Systems/Path generator (iceberg towing)/E_d/Constant/Value",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, Constant_Value_k), 39, 1, 2, 292,
    "", 0 },

  { 147,
    "ca_cse1_v1e_wo_losv2b/Guidance Systems/Path generator (iceberg towing)/E_d/Constant1/Value",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, Constant1_Value_d), 39, 1, 2, 294,
    "", 0 },

  { 148,
    "ca_cse1_v1e_wo_losv2b/Guidance Systems/Path generator (iceberg towing)/eta_d_theta maker/Memory2/X0",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, Memory2_X0), 39, 1, 2, 296, "", 0
  },

  { 149,
    "ca_cse1_v1e_wo_losv2b/Guidance Systems/Path generator (iceberg towing)/eta_d_theta maker/Memory1/X0",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, Memory1_X0), 39, 1, 2, 298, "", 0
  },

  { 150,
    "ca_cse1_v1e_wo_losv2b/Control Systems/Maneuvering controller/Path controller/theta maker/Integrator/InitialCondition",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, Integrator_IC), 39, 1, 2, 300, "",
    0 },

  { 151,
    "ca_cse1_v1e_wo_losv2b/Guidance Systems/Path generator (iceberg towing)/eta_d_theta maker/Memory/X0",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, Memory_X0), 39, 1, 2, 302, "", 0 },

  { 152,
    "ca_cse1_v1e_wo_losv2b/Control Systems/Maneuvering controller/Path controller/alpha_1/K_p/Gain",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, K_p_Gain), 33, 9, 2, 304, "", 0 },

  { 153,
    "ca_cse1_v1e_wo_losv2b/Guidance Systems/Path generator (iceberg towing)/eta_d_theta maker/Memory3/X0",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, Memory3_X0), 39, 1, 2, 306, "", 0
  },

  { 154,
    "ca_cse1_v1e_wo_losv2b/Guidance Systems/Path generator (iceberg towing)/U_d/Value",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, U_d_Value), 39, 1, 2, 308, "", 0 },

  { 155,
    "ca_cse1_v1e_wo_losv2b/Control Systems/Maneuvering controller/Path controller/tau_s/K_d/Gain",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, K_d_Gain), 33, 9, 2, 310, "", 0 },

  { 156,
    "ca_cse1_v1e_wo_losv2b/Control Systems/Maneuvering controller/Path controller/tau_s/D_s/Gain",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, D_s_Gain), 33, 9, 2, 312, "", 0 },

  { 157,
    "ca_cse1_v1e_wo_losv2b/Control Systems/Maneuvering controller/Path controller/sigma_1/S/Gain",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, S_Gain), 33, 9, 2, 314, "", 0 },

  { 158,
    "ca_cse1_v1e_wo_losv2b/Control Systems/Maneuvering controller/Path controller/sigma_1/K_p/Gain",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, K_p_Gain_k), 33, 9, 2, 316, "", 0
  },

  { 159,
    "ca_cse1_v1e_wo_losv2b/Control Systems/Maneuvering controller/Path controller/sigma_1/S1/Value",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, S1_Value), 33, 9, 2, 318, "", 0 },

  { 160,
    "ca_cse1_v1e_wo_losv2b/Control Systems/Maneuvering controller/Path controller/tau_s/M_s/Gain",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, M_s_Gain), 33, 9, 2, 320, "", 0 },

  { 161,
    "ca_cse1_v1e_wo_losv2b/Control Systems/Maneuvering controller/Path controller/alpha_1_theta/K_p/Gain",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, K_p_Gain_p), 33, 9, 2, 322, "", 0
  },

  { 162,
    "ca_cse1_v1e_wo_losv2b/Guidance Systems/Path generator (iceberg towing)/eta_d_theta2 maker/Memory/X0",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, Memory_X0_h), 39, 1, 2, 324, "", 0
  },

  { 163,
    "ca_cse1_v1e_wo_losv2b/Guidance Systems/Path generator (iceberg towing)/eta_d_theta2 maker/Memory1/X0",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, Memory1_X0_f), 39, 1, 2, 326, "",
    0 },

  { 164,
    "ca_cse1_v1e_wo_losv2b/Guidance Systems/Path generator (iceberg towing)/eta_d_theta2 maker/Memory2/X0",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, Memory2_X0_a), 39, 1, 2, 328, "",
    0 },

  { 165,
    "ca_cse1_v1e_wo_losv2b/Guidance Systems/Path generator (iceberg towing)/v_s_theta maker/Gain/Gain",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, Gain_Gain), 39, 1, 2, 330, "", 0 },

  { 166,
    "ca_cse1_v1e_wo_losv2b/Guidance Systems/Path generator (iceberg towing)/v_s_theta maker/power/Value",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, power_Value), 39, 1, 2, 332, "", 0
  },

  { 167,
    "ca_cse1_v1e_wo_losv2b/Guidance Systems/Path generator (iceberg towing)/v_s_theta maker/IC/Value",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, IC_Value), 39, 1, 2, 334, "", 0 },

  { 168,
    "ca_cse1_v1e_wo_losv2b/Guidance Systems/Path generator (iceberg towing)/eta_d_theta2 maker/Memory3/X0",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, Memory3_X0_d), 39, 1, 2, 336, "",
    0 },

  { 169,
    "ca_cse1_v1e_wo_losv2b/Control Systems/Maneuvering controller/Path controller/theta maker/M_s/Gain",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, M_s_Gain_f), 33, 9, 2, 338, "", 0
  },

  { 170,
    "ca_cse1_v1e_wo_losv2b/Control Systems/Maneuvering controller/Path controller/theta maker/mu/Gain",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, mu_Gain), 39, 1, 2, 340, "", 0 },

  { 171,
    "ca_cse1_v1e_wo_losv2b/Control Systems/Maneuvering controller/Path controller/tau_s/M_s1/Gain",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, M_s1_Gain), 33, 9, 2, 342, "", 0 },

  { 172,
    "ca_cse1_v1e_wo_losv2b/Naviagation Systems/Qualisys 6 DOF/QTM In10/Gain",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, QTMIn10_Gain), 39, 1, 2, 344, "",
    0 },

  { 173, "ca_cse1_v1e_wo_losv2b/Naviagation Systems/Qualisys 6 DOF/mm2m x1/Gain",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, mm2mx1_Gain), 39, 1, 2, 346, "", 0
  },

  { 174, "ca_cse1_v1e_wo_losv2b/Naviagation Systems/eta_i_surge/Gain", offsetof
    (Parameters_CA_CSE1_V1e_wo_LOSV2, eta_i_surge_Gain), 39, 1, 2, 348, "", 0 },

  { 175,
    "ca_cse1_v1e_wo_losv2b/Naviagation Systems/Qualisys 6 DOF/QTM In11/Gain",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, QTMIn11_Gain), 39, 1, 2, 350, "",
    0 },

  { 176, "ca_cse1_v1e_wo_losv2b/Naviagation Systems/Qualisys 6 DOF/mm2m y1/Gain",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, mm2my1_Gain), 39, 1, 2, 352, "", 0
  },

  { 177, "ca_cse1_v1e_wo_losv2b/Naviagation Systems/eta_i_sway/Gain", offsetof
    (Parameters_CA_CSE1_V1e_wo_LOSV2, eta_i_sway_Gain), 39, 1, 2, 354, "", 0 },

  { 178,
    "ca_cse1_v1e_wo_losv2b/Naviagation Systems/Qualisys 6 DOF/QTM In13/Gain",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, QTMIn13_Gain), 39, 1, 2, 356, "",
    0 },

  { 179,
    "ca_cse1_v1e_wo_losv2b/Naviagation Systems/Qualisys 6 DOF/d2r yaw1/Gain",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, d2ryaw1_Gain), 39, 1, 2, 358, "",
    0 },

  { 180, "ca_cse1_v1e_wo_losv2b/Naviagation Systems/eta_i_yaw/Gain", offsetof
    (Parameters_CA_CSE1_V1e_wo_LOSV2, eta_i_yaw_Gain), 39, 1, 2, 360, "", 0 },

  { 181, "ca_cse1_v1e_wo_losv2b/Control Systems/Tension estimator/K_tow/Gain",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, K_tow_Gain), 33, 9, 2, 362, "", 0
  },

  { 182,
    "ca_cse1_v1e_wo_losv2b/Control Systems/Maneuvering controller/DEBUG/Value",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, DEBUG_Value), 59, 3, 2, 364, "", 0
  },

  { 183,
    "ca_cse1_v1e_wo_losv2b/Control Systems/Maneuvering controller/DP u_1/Gain",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, DPu_1_Gain), 39, 1, 2, 366, "", 0
  },

  { 184,
    "ca_cse1_v1e_wo_losv2b/Control Systems/Maneuvering controller/DP u_2/Gain",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, DPu_2_Gain), 39, 1, 2, 368, "", 0
  },

  { 185,
    "ca_cse1_v1e_wo_losv2b/Control Systems/Maneuvering controller/DP u_3/Gain",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, DPu_3_Gain), 39, 1, 2, 370, "", 0
  },

  { 186,
    "ca_cse1_v1e_wo_losv2b/Control Systems/Maneuvering controller/DP u_4/Gain",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, DPu_4_Gain), 39, 1, 2, 372, "", 0
  },

  { 187,
    "ca_cse1_v1e_wo_losv2b/Control Systems/Maneuvering controller/DP u_5/Gain",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, DPu_5_Gain), 39, 1, 2, 374, "", 0
  },

  { 188,
    "ca_cse1_v1e_wo_losv2b/Control Systems/Maneuvering controller/Saturation/UpperLimit",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, Saturation_UpperSat_g), 39, 1, 2,
    376, "", 0 },

  { 189,
    "ca_cse1_v1e_wo_losv2b/Control Systems/Maneuvering controller/Saturation/LowerLimit",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, Saturation_LowerSat_f), 39, 1, 2,
    378, "", 0 },

  { 190,
    "ca_cse1_v1e_wo_losv2b/Control Systems/Maneuvering controller/BT_power_limit/Value",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, BT_power_limit_Value), 39, 1, 2,
    380, "", 0 },

  { 191,
    "ca_cse1_v1e_wo_losv2b/Control Systems/Maneuvering controller/VSP_speeds/Value",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, VSP_speeds_Value), 39, 1, 2, 382,
    "", 0 },

  { 192, "ca_cse1_v1e_wo_losv2b/Control Systems/Saturation/UpperLimit", offsetof
    (Parameters_CA_CSE1_V1e_wo_LOSV2, Saturation_UpperSat_m), 39, 1, 2, 384, "",
    0 },

  { 193, "ca_cse1_v1e_wo_losv2b/Control Systems/Saturation/LowerLimit", offsetof
    (Parameters_CA_CSE1_V1e_wo_LOSV2, Saturation_LowerSat_fh), 39, 1, 2, 386, "",
    0 },

  { 194,
    "ca_cse1_v1e_wo_losv2b/Control Systems/if iceberg control mode/Constant/Value",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, Constant_Value_a), 39, 1, 2, 388,
    "", 0 },

  { 195, "ca_cse1_v1e_wo_losv2b/Guidance Systems/DP/eta_d Psi deg/Gain",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, eta_dPsideg_Gain), 39, 1, 2, 390,
    "", 0 },

  { 196, "ca_cse1_v1e_wo_losv2b/HMI/Battery Bow Thruster/Gain", offsetof
    (Parameters_CA_CSE1_V1e_wo_LOSV2, BatteryBowThruster_Gain), 39, 1, 2, 392,
    "", 0 },

  { 197, "ca_cse1_v1e_wo_losv2b/HMI/Battery Servo/Gain", offsetof
    (Parameters_CA_CSE1_V1e_wo_LOSV2, BatteryServo_Gain), 39, 1, 2, 394, "", 0 },

  { 198, "ca_cse1_v1e_wo_losv2b/HMI/Battery Main/Gain", offsetof
    (Parameters_CA_CSE1_V1e_wo_LOSV2, BatteryMain_Gain), 39, 1, 2, 396, "", 0 },

  { 199,
    "ca_cse1_v1e_wo_losv2b/Naviagation Systems/Qualisys 6 DOF/Constant2/Value",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, Constant2_Value), 33, 9, 2, 398,
    "", 0 },

  { 200,
    "ca_cse1_v1e_wo_losv2b/Naviagation Systems/Qualisys 6 DOF/QTM In12/Gain",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, QTMIn12_Gain), 39, 1, 2, 400, "",
    0 },

  { 201, "ca_cse1_v1e_wo_losv2b/Naviagation Systems/Qualisys 6 DOF/mm2m z1/Gain",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, mm2mz1_Gain), 39, 1, 2, 402, "", 0
  },

  { 202,
    "ca_cse1_v1e_wo_losv2b/Naviagation Systems/Qualisys 6 DOF/QTM In15/Gain",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, QTMIn15_Gain), 39, 1, 2, 404, "",
    0 },

  { 203,
    "ca_cse1_v1e_wo_losv2b/Naviagation Systems/Qualisys 6 DOF/d2r roll1/Gain",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, d2rroll1_Gain), 39, 1, 2, 406, "",
    0 },

  { 204,
    "ca_cse1_v1e_wo_losv2b/Naviagation Systems/Qualisys 6 DOF/QTM In14/Gain",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, QTMIn14_Gain), 39, 1, 2, 408, "",
    0 },

  { 205,
    "ca_cse1_v1e_wo_losv2b/Naviagation Systems/Qualisys 6 DOF/d2r pitch1/Gain",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, d2rpitch1_Gain), 39, 1, 2, 410, "",
    0 },

  { 206,
    "ca_cse1_v1e_wo_losv2b/Naviagation Systems/Qualisys 6 DOF/QTM In1 FPS/Gain",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, QTMIn1FPS_Gain), 39, 1, 2, 412, "",
    0 },

  { 207,
    "ca_cse1_v1e_wo_losv2b/Naviagation Systems/Qualisys 6 DOF/QTM In16 Residual/Gain",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, QTMIn16Residual_Gain), 39, 1, 2,
    414, "", 0 },

  { 208,
    "ca_cse1_v1e_wo_losv2b/Naviagation Systems/Qualisys 6 DOF/QTM In2 Error/Gain",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, QTMIn2Error_Gain), 39, 1, 2, 416,
    "", 0 },

  { 209,
    "ca_cse1_v1e_wo_losv2b/Naviagation Systems/Qualisys 6 DOF/QTM In9 Residual/Gain",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, QTMIn9Residual_Gain), 39, 1, 2,
    418, "", 0 },

  { 210, "ca_cse1_v1e_wo_losv2b/Naviagation Systems/nu_i_surge/Gain", offsetof
    (Parameters_CA_CSE1_V1e_wo_LOSV2, nu_i_surge_Gain), 39, 1, 2, 420, "", 0 },

  { 211, "ca_cse1_v1e_wo_losv2b/Naviagation Systems/nu_i_sway/Gain", offsetof
    (Parameters_CA_CSE1_V1e_wo_LOSV2, nu_i_sway_Gain), 39, 1, 2, 422, "", 0 },

  { 212, "ca_cse1_v1e_wo_losv2b/Naviagation Systems/nu_i_yaw/Gain", offsetof
    (Parameters_CA_CSE1_V1e_wo_LOSV2, nu_i_yaw_Gain), 39, 1, 2, 424, "", 0 },

  { 213, "ca_cse1_v1e_wo_losv2b/Plants/u_1 plant/Gain", offsetof
    (Parameters_CA_CSE1_V1e_wo_LOSV2, u_1plant_Gain), 39, 1, 2, 426, "", 0 },

  { 214, "ca_cse1_v1e_wo_losv2b/Plants/u_2 plant/Gain", offsetof
    (Parameters_CA_CSE1_V1e_wo_LOSV2, u_2plant_Gain), 39, 1, 2, 428, "", 0 },

  { 215, "ca_cse1_v1e_wo_losv2b/Plants/u_3 plant/Gain", offsetof
    (Parameters_CA_CSE1_V1e_wo_LOSV2, u_3plant_Gain), 39, 1, 2, 430, "", 0 },

  { 216, "ca_cse1_v1e_wo_losv2b/Plants/u_4 plant/Gain", offsetof
    (Parameters_CA_CSE1_V1e_wo_LOSV2, u_4plant_Gain), 39, 1, 2, 432, "", 0 },

  { 217, "ca_cse1_v1e_wo_losv2b/Plants/u_5 plant/Gain", offsetof
    (Parameters_CA_CSE1_V1e_wo_LOSV2, u_5plant_Gain), 39, 1, 2, 434, "", 0 },

  { 218, "ca_cse1_v1e_wo_losv2b/Plants/BT power lmit/Gain", offsetof
    (Parameters_CA_CSE1_V1e_wo_LOSV2, BTpowerlmit_Gain), 39, 1, 2, 436, "", 0 },

  { 219, "ca_cse1_v1e_wo_losv2b/Plants/VSP speed/Gain", offsetof
    (Parameters_CA_CSE1_V1e_wo_LOSV2, VSPspeed_Gain), 39, 1, 2, 438, "", 0 },

  { 220, "ca_cse1_v1e_wo_losv2b/Plants/Enable CSE1/Value", offsetof
    (Parameters_CA_CSE1_V1e_wo_LOSV2, EnableCSE1_Value), 39, 1, 2, 440, "", 0 },

  { 221,
    "ca_cse1_v1e_wo_losv2b/Control Systems/DP control/Thruster_Command_DP/InitialOutput",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, Thruster_Command_DP_Y0), 60, 7, 2,
    442, "", 0 },

  { 222,
    "ca_cse1_v1e_wo_losv2b/Control Systems/DP control/Passive DP wave filter1/Integrator1/InitialCondition",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, Integrator1_IC), 39, 1, 2, 444, "",
    0 },

  { 223, "ca_cse1_v1e_wo_losv2b/Control Systems/DP control/BT_power_limit/Value",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, BT_power_limit_Value_f), 39, 1, 2,
    446, "", 0 },

  { 224, "ca_cse1_v1e_wo_losv2b/Control Systems/DP control/Enable Filter/Value",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, EnableFilter_Value), 39, 1, 2, 448,
    "", 0 },

  { 225,
    "ca_cse1_v1e_wo_losv2b/Control Systems/DP control/Passive DP wave filter1/Integrator/InitialCondition",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, Integrator_IC_n), 39, 1, 2, 450,
    "", 0 },

  { 226,
    "ca_cse1_v1e_wo_losv2b/Control Systems/DP control/Passive DP wave filter1/[-inf inf] to [-pi pi]/Saturation/UpperLimit",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, Saturation_UpperSat_gq), 39, 1, 2,
    452, "", 0 },

  { 227,
    "ca_cse1_v1e_wo_losv2b/Control Systems/DP control/Passive DP wave filter1/[-inf inf] to [-pi pi]/Saturation/LowerLimit",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, Saturation_LowerSat_l), 39, 1, 2,
    454, "", 0 },

  { 228,
    "ca_cse1_v1e_wo_losv2b/Control Systems/DP control/Passive DP wave filter1/[-inf inf] to [-pi pi]/Gain/Gain",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, Gain_Gain_n), 39, 1, 2, 456, "", 0
  },

  { 229,
    "ca_cse1_v1e_wo_losv2b/Control Systems/DP control/Passive DP wave filter1/[-inf inf] to [-pi pi]/Constant/Value",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, Constant_Value_e), 39, 1, 2, 458,
    "", 0 },

  { 230,
    "ca_cse1_v1e_wo_losv2b/Control Systems/DP control/DP controller/eta N/Gain",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, etaN_Gain), 39, 1, 2, 460, "", 0 },

  { 231,
    "ca_cse1_v1e_wo_losv2b/Control Systems/DP control/DP controller/eta E/Gain",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, etaE_Gain), 39, 1, 2, 462, "", 0 },

  { 232,
    "ca_cse1_v1e_wo_losv2b/Control Systems/DP control/DP controller/eta Psi/Gain",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, etaPsi_Gain), 39, 1, 2, 464, "", 0
  },

  { 233,
    "ca_cse1_v1e_wo_losv2b/Control Systems/DP control/DP controller/Reg_e_N_hil/Gain",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, Reg_e_N_hil_Gain), 39, 1, 2, 466,
    "", 0 },

  { 234,
    "ca_cse1_v1e_wo_losv2b/Control Systems/DP control/DP controller/Reg_e_E_hil/Gain",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, Reg_e_E_hil_Gain), 39, 1, 2, 468,
    "", 0 },

  { 235,
    "ca_cse1_v1e_wo_losv2b/Control Systems/DP control/DP controller/Reg_e_Psi_hil/Gain",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, Reg_e_Psi_hil_Gain), 39, 1, 2, 470,
    "", 0 },

  { 236,
    "ca_cse1_v1e_wo_losv2b/Control Systems/DP control/DP controller/Reset_DP_integrator/Value",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, Reset_DP_integrator_Value), 39, 1,
    2, 472, "", 0 },

  { 237,
    "ca_cse1_v1e_wo_losv2b/Control Systems/DP control/DP controller/Integrator/InitialCondition",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, Integrator_IC_d), 39, 1, 2, 474,
    "", 0 },

  { 238,
    "ca_cse1_v1e_wo_losv2b/Control Systems/DP control/Passive DP wave filter1/Integrator4/InitialCondition",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, Integrator4_IC), 39, 1, 2, 476, "",
    0 },

  { 239,
    "ca_cse1_v1e_wo_losv2b/Control Systems/DP control/DP controller/Kd/Gain",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, Kd_Gain), 33, 9, 2, 478, "", 0 },

  { 240,
    "ca_cse1_v1e_wo_losv2b/Control Systems/DP control/DP controller/Kd_scale/Value",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, Kd_scale_Value), 39, 1, 2, 480, "",
    0 },

  { 241,
    "ca_cse1_v1e_wo_losv2b/Control Systems/DP control/DP controller/K_d 1/Gain",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, K_d1_Gain), 39, 1, 2, 482, "", 0 },

  { 242,
    "ca_cse1_v1e_wo_losv2b/Control Systems/DP control/DP controller/K_d 2/Gain",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, K_d2_Gain), 39, 1, 2, 484, "", 0 },

  { 243,
    "ca_cse1_v1e_wo_losv2b/Control Systems/DP control/DP controller/K_d 3/Gain",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, K_d3_Gain), 39, 1, 2, 486, "", 0 },

  { 244,
    "ca_cse1_v1e_wo_losv2b/Control Systems/DP control/DP controller/K_d 3 deg/Gain",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, K_d3deg_Gain), 39, 1, 2, 488, "",
    0 },

  { 245,
    "ca_cse1_v1e_wo_losv2b/Control Systems/DP control/DP controller/Ki/Gain",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, Ki_Gain), 33, 9, 2, 490, "", 0 },

  { 246,
    "ca_cse1_v1e_wo_losv2b/Control Systems/DP control/DP controller/Ki_scale/Value",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, Ki_scale_Value), 39, 1, 2, 492, "",
    0 },

  { 247,
    "ca_cse1_v1e_wo_losv2b/Control Systems/DP control/DP controller/K_i 1/Gain",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, K_i1_Gain), 39, 1, 2, 494, "", 0 },

  { 248,
    "ca_cse1_v1e_wo_losv2b/Control Systems/DP control/DP controller/K_i 2/Gain",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, K_i2_Gain), 39, 1, 2, 496, "", 0 },

  { 249,
    "ca_cse1_v1e_wo_losv2b/Control Systems/DP control/DP controller/K_i 3/Gain",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, K_i3_Gain), 39, 1, 2, 498, "", 0 },

  { 250,
    "ca_cse1_v1e_wo_losv2b/Control Systems/DP control/DP controller/K_i 3 deg/Gain",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, K_i3deg_Gain), 39, 1, 2, 500, "",
    0 },

  { 251,
    "ca_cse1_v1e_wo_losv2b/Control Systems/DP control/DP controller/Kp_scale/Value",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, Kp_scale_Value), 39, 1, 2, 502, "",
    0 },

  { 252,
    "ca_cse1_v1e_wo_losv2b/Control Systems/DP control/DP controller/[-inf inf] to [-pi pi]1/Saturation/UpperLimit",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, Saturation_UpperSat_o), 39, 1, 2,
    504, "", 0 },

  { 253,
    "ca_cse1_v1e_wo_losv2b/Control Systems/DP control/DP controller/[-inf inf] to [-pi pi]1/Saturation/LowerLimit",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, Saturation_LowerSat_n), 39, 1, 2,
    506, "", 0 },

  { 254,
    "ca_cse1_v1e_wo_losv2b/Control Systems/DP control/DP controller/[-inf inf] to [-pi pi]1/Gain/Gain",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, Gain_Gain_d), 39, 1, 2, 508, "", 0
  },

  { 255,
    "ca_cse1_v1e_wo_losv2b/Control Systems/DP control/DP controller/[-inf inf] to [-pi pi]1/Constant/Value",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, Constant_Value_g), 39, 1, 2, 510,
    "", 0 },

  { 256,
    "ca_cse1_v1e_wo_losv2b/Control Systems/DP control/DP controller/[-inf inf] to [-pi pi]/Saturation/UpperLimit",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, Saturation_UpperSat_d), 39, 1, 2,
    512, "", 0 },

  { 257,
    "ca_cse1_v1e_wo_losv2b/Control Systems/DP control/DP controller/[-inf inf] to [-pi pi]/Saturation/LowerLimit",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, Saturation_LowerSat_h), 39, 1, 2,
    514, "", 0 },

  { 258,
    "ca_cse1_v1e_wo_losv2b/Control Systems/DP control/DP controller/[-inf inf] to [-pi pi]/Gain/Gain",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, Gain_Gain_e), 39, 1, 2, 516, "", 0
  },

  { 259,
    "ca_cse1_v1e_wo_losv2b/Control Systems/DP control/DP controller/[-inf inf] to [-pi pi]/Constant/Value",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, Constant_Value_i), 39, 1, 2, 518,
    "", 0 },

  { 260,
    "ca_cse1_v1e_wo_losv2b/Control Systems/DP control/DP controller/Kp/Gain",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, Kp_Gain), 33, 9, 2, 520, "", 0 },

  { 261,
    "ca_cse1_v1e_wo_losv2b/Control Systems/DP control/DP controller/K_p 1/Gain",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, K_p1_Gain), 39, 1, 2, 522, "", 0 },

  { 262,
    "ca_cse1_v1e_wo_losv2b/Control Systems/DP control/DP controller/K_p 2/Gain",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, K_p2_Gain), 39, 1, 2, 524, "", 0 },

  { 263,
    "ca_cse1_v1e_wo_losv2b/Control Systems/DP control/DP controller/K_p 3/Gain",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, K_p3_Gain), 39, 1, 2, 526, "", 0 },

  { 264,
    "ca_cse1_v1e_wo_losv2b/Control Systems/DP control/DP controller/K_p 3 deg/Gain",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, K_p3deg_Gain), 39, 1, 2, 528, "",
    0 },

  { 265,
    "ca_cse1_v1e_wo_losv2b/Control Systems/DP control/DP controller/Reg_e_Psi_deg/Gain",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, Reg_e_Psi_deg_Gain), 39, 1, 2, 530,
    "", 0 },

  { 266,
    "ca_cse1_v1e_wo_losv2b/Control Systems/DP control/DP controller/eta Psi deg/Gain",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, etaPsideg_Gain), 39, 1, 2, 532, "",
    0 },

  { 267, "ca_cse1_v1e_wo_losv2b/Control Systems/DP control/DP tau_surge/Gain",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, DPtau_surge_Gain), 39, 1, 2, 534,
    "", 0 },

  { 268, "ca_cse1_v1e_wo_losv2b/Control Systems/DP control/DP tau_sway/Gain",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, DPtau_sway_Gain), 39, 1, 2, 536,
    "", 0 },

  { 269, "ca_cse1_v1e_wo_losv2b/Control Systems/DP control/DP tau_yaw/Gain",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, DPtau_yaw_Gain), 39, 1, 2, 538, "",
    0 },

  { 270, "ca_cse1_v1e_wo_losv2b/Control Systems/DP control/K_e/K_e1_DP/Value",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, K_e1_DP_Value_k), 39, 1, 2, 540,
    "", 0 },

  { 271,
    "ca_cse1_v1e_wo_losv2b/Control Systems/DP control/K_e/Gain K_e1_DP/Gain",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, GainK_e1_DP_Gain_p), 39, 1, 2, 542,
    "", 0 },

  { 272, "ca_cse1_v1e_wo_losv2b/Control Systems/DP control/K_e/Constant/Value",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, Constant_Value_cb), 39, 1, 2, 544,
    "", 0 },

  { 273, "ca_cse1_v1e_wo_losv2b/Control Systems/DP control/K_e/K_e2_DP/Value",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, K_e2_DP_Value_i), 39, 1, 2, 546,
    "", 0 },

  { 274,
    "ca_cse1_v1e_wo_losv2b/Control Systems/DP control/K_e/Gain K_e2_DP/Gain",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, GainK_e2_DP_Gain_c), 39, 1, 2, 548,
    "", 0 },

  { 275, "ca_cse1_v1e_wo_losv2b/Control Systems/DP control/K_e/K_e3_DP/Value",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, K_e3_DP_Value_g), 39, 1, 2, 550,
    "", 0 },

  { 276,
    "ca_cse1_v1e_wo_losv2b/Control Systems/DP control/K_e/Gain K_e3_DP/Gain",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, GainK_e3_DP_Gain_j), 39, 1, 2, 552,
    "", 0 },

  { 277, "ca_cse1_v1e_wo_losv2b/Control Systems/DP control/K_e/K_e4_DP/Value",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, K_e4_DP_Value_f), 39, 1, 2, 554,
    "", 0 },

  { 278,
    "ca_cse1_v1e_wo_losv2b/Control Systems/DP control/K_e/Gain K_e4_DP/Gain",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, GainK_e4_DP_Gain_n), 39, 1, 2, 556,
    "", 0 },

  { 279, "ca_cse1_v1e_wo_losv2b/Control Systems/DP control/K_e/K_e5_DP/Value",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, K_e5_DP_Value_e), 39, 1, 2, 558,
    "", 0 },

  { 280,
    "ca_cse1_v1e_wo_losv2b/Control Systems/DP control/K_e/Gain K_e5_DP/Gain",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, GainK_e5_DP_Gain_c), 39, 1, 2, 560,
    "", 0 },

  { 281, "ca_cse1_v1e_wo_losv2b/Control Systems/DP control/T_e/T_e11/Value",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, T_e11_Value_p), 39, 1, 2, 562, "",
    0 },

  { 282, "ca_cse1_v1e_wo_losv2b/Control Systems/DP control/T_e/T_e21/Value",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, T_e21_Value_c), 39, 1, 2, 564, "",
    0 },

  { 283, "ca_cse1_v1e_wo_losv2b/Control Systems/DP control/T_e/l_y1/Value",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, l_y1_Value_b), 39, 1, 2, 566, "",
    0 },

  { 284, "ca_cse1_v1e_wo_losv2b/Control Systems/DP control/T_e/T_e12/Value",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, T_e12_Value_i), 39, 1, 2, 568, "",
    0 },

  { 285, "ca_cse1_v1e_wo_losv2b/Control Systems/DP control/T_e/T_e22/Value",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, T_e22_Value_o), 39, 1, 2, 570, "",
    0 },

  { 286, "ca_cse1_v1e_wo_losv2b/Control Systems/DP control/T_e/l_x1/Value",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, l_x1_Value_l), 39, 1, 2, 572, "",
    0 },

  { 287, "ca_cse1_v1e_wo_losv2b/Control Systems/DP control/T_e/-l_x1/Gain",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, l_x1_Gain_a), 39, 1, 2, 574, "", 0
  },

  { 288, "ca_cse1_v1e_wo_losv2b/Control Systems/DP control/T_e/T_e13/Value",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, T_e13_Value_dc), 39, 1, 2, 576, "",
    0 },

  { 289, "ca_cse1_v1e_wo_losv2b/Control Systems/DP control/T_e/T_e23/Value",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, T_e23_Value_i), 39, 1, 2, 578, "",
    0 },

  { 290, "ca_cse1_v1e_wo_losv2b/Control Systems/DP control/T_e/l_y2/Value",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, l_y2_Value_o), 39, 1, 2, 580, "",
    0 },

  { 291, "ca_cse1_v1e_wo_losv2b/Control Systems/DP control/T_e/-l_y2/Gain",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, l_y2_Gain_j), 39, 1, 2, 582, "", 0
  },

  { 292, "ca_cse1_v1e_wo_losv2b/Control Systems/DP control/T_e/T_e14/Value",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, T_e14_Value_oq), 39, 1, 2, 584, "",
    0 },

  { 293, "ca_cse1_v1e_wo_losv2b/Control Systems/DP control/T_e/T_e24/Value",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, T_e24_Value_h), 39, 1, 2, 586, "",
    0 },

  { 294, "ca_cse1_v1e_wo_losv2b/Control Systems/DP control/T_e/l_x2/Value",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, l_x2_Value_o), 39, 1, 2, 588, "",
    0 },

  { 295, "ca_cse1_v1e_wo_losv2b/Control Systems/DP control/T_e/-l_x2/Gain",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, l_x2_Gain_b), 39, 1, 2, 590, "", 0
  },

  { 296, "ca_cse1_v1e_wo_losv2b/Control Systems/DP control/T_e/T_e15/Value",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, T_e15_Value_g), 39, 1, 2, 592, "",
    0 },

  { 297, "ca_cse1_v1e_wo_losv2b/Control Systems/DP control/T_e/T_e25/Value",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, T_e25_Value_f), 39, 1, 2, 594, "",
    0 },

  { 298, "ca_cse1_v1e_wo_losv2b/Control Systems/DP control/T_e/l_x3/Value",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, l_x3_Value_h), 39, 1, 2, 596, "",
    0 },

  { 299, "ca_cse1_v1e_wo_losv2b/Control Systems/DP control/DP u_1/Gain",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, DPu_1_Gain_e), 39, 1, 2, 598, "",
    0 },

  { 300, "ca_cse1_v1e_wo_losv2b/Control Systems/DP control/DP u_2/Gain",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, DPu_2_Gain_b), 39, 1, 2, 600, "",
    0 },

  { 301, "ca_cse1_v1e_wo_losv2b/Control Systems/DP control/DP u_3/Gain",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, DPu_3_Gain_f), 39, 1, 2, 602, "",
    0 },

  { 302, "ca_cse1_v1e_wo_losv2b/Control Systems/DP control/DP u_4/Gain",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, DPu_4_Gain_h), 39, 1, 2, 604, "",
    0 },

  { 303, "ca_cse1_v1e_wo_losv2b/Control Systems/DP control/DP u_5/Gain",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, DPu_5_Gain_d), 39, 1, 2, 606, "",
    0 },

  { 304,
    "ca_cse1_v1e_wo_losv2b/Control Systems/DP control/Passive DP wave filter1/Gain1/Gain",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, Gain1_Gain_m), 33, 9, 2, 608, "",
    0 },

  { 305,
    "ca_cse1_v1e_wo_losv2b/Control Systems/DP control/Passive DP wave filter1/Integrator2/InitialCondition",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, Integrator2_IC), 39, 1, 2, 610, "",
    0 },

  { 306,
    "ca_cse1_v1e_wo_losv2b/Control Systems/DP control/Passive DP wave filter1/Gain2/Gain",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, Gain2_Gain), 33, 9, 2, 612, "", 0
  },

  { 307,
    "ca_cse1_v1e_wo_losv2b/Control Systems/DP control/Passive DP wave filter1/[-inf inf] to [-pi pi]1/Saturation/UpperLimit",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, Saturation_UpperSat_a), 39, 1, 2,
    614, "", 0 },

  { 308,
    "ca_cse1_v1e_wo_losv2b/Control Systems/DP control/Passive DP wave filter1/[-inf inf] to [-pi pi]1/Saturation/LowerLimit",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, Saturation_LowerSat_fw), 39, 1, 2,
    616, "", 0 },

  { 309,
    "ca_cse1_v1e_wo_losv2b/Control Systems/DP control/Passive DP wave filter1/[-inf inf] to [-pi pi]1/Gain/Gain",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, Gain_Gain_g), 39, 1, 2, 618, "", 0
  },

  { 310,
    "ca_cse1_v1e_wo_losv2b/Control Systems/DP control/Passive DP wave filter1/[-inf inf] to [-pi pi]1/Constant/Value",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, Constant_Value_h), 39, 1, 2, 620,
    "", 0 },

  { 311,
    "ca_cse1_v1e_wo_losv2b/Control Systems/DP control/Passive DP wave filter1/K4/Gain",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, K4_Gain), 33, 9, 2, 622, "", 0 },

  { 312,
    "ca_cse1_v1e_wo_losv2b/Control Systems/DP control/Passive DP wave filter1/Integrator3/InitialCondition",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, Integrator3_IC), 39, 1, 2, 624, "",
    0 },

  { 313,
    "ca_cse1_v1e_wo_losv2b/Control Systems/DP control/Passive DP wave filter1/Gain6/Gain",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, Gain6_Gain), 33, 9, 2, 626, "", 0
  },

  { 314,
    "ca_cse1_v1e_wo_losv2b/Control Systems/DP control/Passive DP wave filter1/Gain3/Gain",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, Gain3_Gain), 33, 9, 2, 628, "", 0
  },

  { 315,
    "ca_cse1_v1e_wo_losv2b/Control Systems/DP control/Passive DP wave filter1/K11/Gain",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, K11_Gain), 33, 9, 2, 630, "", 0 },

  { 316,
    "ca_cse1_v1e_wo_losv2b/Control Systems/DP control/Passive DP wave filter1/K12/Gain",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, K12_Gain), 33, 9, 2, 632, "", 0 },

  { 317,
    "ca_cse1_v1e_wo_losv2b/Control Systems/DP control/Passive DP wave filter1/K2/Gain",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, K2_Gain), 33, 9, 2, 634, "", 0 },

  { 318,
    "ca_cse1_v1e_wo_losv2b/Control Systems/DP control/Passive DP wave filter1/K3/Gain",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, K3_Gain), 33, 9, 2, 636, "", 0 },

  { 319,
    "ca_cse1_v1e_wo_losv2b/Control Systems/DP control/Passive DP wave filter1/inv(T_b)/Gain",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, invT_b_Gain), 33, 9, 2, 638, "", 0
  },

  { 320,
    "ca_cse1_v1e_wo_losv2b/Control Systems/DP control/Saturation/UpperLimit",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, Saturation_UpperSat_ga), 39, 1, 2,
    640, "", 0 },

  { 321,
    "ca_cse1_v1e_wo_losv2b/Control Systems/DP control/Saturation/LowerLimit",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, Saturation_LowerSat_o), 39, 1, 2,
    642, "", 0 },

  { 322, "ca_cse1_v1e_wo_losv2b/Control Systems/DP control/VSP_speeds/Value",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, VSP_speeds_Value_a), 39, 1, 2, 644,
    "", 0 },

  { 323, "ca_cse1_v1e_wo_losv2b/Plants/CSE1/Bow Thruster/BT_D_Gain1/Gain",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, BT_D_Gain1_Gain), 39, 1, 2, 646,
    "", 0 },

  { 324, "ca_cse1_v1e_wo_losv2b/Plants/CSE1/Bow Thruster/BT_Power_Offset1/Value",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, BT_Power_Offset1_Value), 39, 1, 2,
    648, "", 0 },

  { 325, "ca_cse1_v1e_wo_losv2b/Plants/CSE1/Bow Thruster/BT_D_Gain2/Gain",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, BT_D_Gain2_Gain), 39, 1, 2, 650,
    "", 0 },

  { 326, "ca_cse1_v1e_wo_losv2b/Plants/CSE1/Bow Thruster/BT_L_Gain1/Gain",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, BT_L_Gain1_Gain), 39, 1, 2, 652,
    "", 0 },

  { 327, "ca_cse1_v1e_wo_losv2b/Plants/CSE1/Bow Thruster/BT_L_Gain2/Gain",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, BT_L_Gain2_Gain), 39, 1, 2, 654,
    "", 0 },

  { 328, "ca_cse1_v1e_wo_losv2b/Plants/CSE1/Bow Thruster/BT_Power_Offset2/Value",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, BT_Power_Offset2_Value), 39, 1, 2,
    656, "", 0 },

  { 329, "ca_cse1_v1e_wo_losv2b/Plants/CSE1/Bow Thruster/BT_Power_Offset3/Value",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, BT_Power_Offset3_Value), 39, 1, 2,
    658, "", 0 },

  { 330, "ca_cse1_v1e_wo_losv2b/Plants/CSE1/Bow Thruster/Constant/Value",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, Constant_Value_ef), 39, 1, 2, 660,
    "", 0 },

  { 331, "ca_cse1_v1e_wo_losv2b/Plants/CSE1/Bow Thruster/Constant1/Value",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, Constant1_Value_n), 39, 1, 2, 662,
    "", 0 },

  { 332, "ca_cse1_v1e_wo_losv2b/Plants/CSE1/Bow Thruster/Neg/Gain", offsetof
    (Parameters_CA_CSE1_V1e_wo_LOSV2, Neg_Gain), 39, 1, 2, 664, "", 0 },

  { 333, "ca_cse1_v1e_wo_losv2b/Plants/CSE1/Voith Schneider Propeller /-x/Gain",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, x_Gain), 39, 1, 2, 666, "", 0 },

  { 334, "ca_cse1_v1e_wo_losv2b/Plants/CSE1/Voith Schneider Propeller /-y/Gain",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, y_Gain), 39, 1, 2, 668, "", 0 },

  { 335,
    "ca_cse1_v1e_wo_losv2b/Plants/CSE1/Voith Schneider Propeller /Radians to Degrees Port/Gain/Gain",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, Gain_Gain_k), 39, 1, 2, 670, "", 0
  },

  { 336,
    "ca_cse1_v1e_wo_losv2b/Plants/CSE1/Voith Schneider Propeller /Radians to Degrees Staroard/Gain/Gain",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, Gain_Gain_o), 39, 1, 2, 672, "", 0
  },

  { 337,
    "ca_cse1_v1e_wo_losv2b/Plants/CSE1/Voith Schneider Propeller /Servo1/RowIndex",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, Servo1_RowIdx), 34, 3, 2, 674, "",
    0 },

  { 338,
    "ca_cse1_v1e_wo_losv2b/Plants/CSE1/Voith Schneider Propeller /Servo1/ColumnIndex",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, Servo1_ColIdx), 34, 3, 2, 676, "",
    0 },

  { 339,
    "ca_cse1_v1e_wo_losv2b/Plants/CSE1/Voith Schneider Propeller /Servo1/Table",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, Servo1_Table), 33, 9, 2, 678, "",
    0 },

  { 340,
    "ca_cse1_v1e_wo_losv2b/Plants/CSE1/Voith Schneider Propeller /Servo2/RowIndex",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, Servo2_RowIdx), 34, 3, 2, 680, "",
    0 },

  { 341,
    "ca_cse1_v1e_wo_losv2b/Plants/CSE1/Voith Schneider Propeller /Servo2/ColumnIndex",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, Servo2_ColIdx), 34, 3, 2, 682, "",
    0 },

  { 342,
    "ca_cse1_v1e_wo_losv2b/Plants/CSE1/Voith Schneider Propeller /Servo2/Table",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, Servo2_Table), 33, 9, 2, 684, "",
    0 },

  { 343,
    "ca_cse1_v1e_wo_losv2b/Plants/CSE1/Voith Schneider Propeller /Servo3/RowIndex",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, Servo3_RowIdx), 34, 3, 2, 686, "",
    0 },

  { 344,
    "ca_cse1_v1e_wo_losv2b/Plants/CSE1/Voith Schneider Propeller /Servo3/ColumnIndex",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, Servo3_ColIdx), 34, 3, 2, 688, "",
    0 },

  { 345,
    "ca_cse1_v1e_wo_losv2b/Plants/CSE1/Voith Schneider Propeller /Servo3/Table",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, Servo3_Table), 33, 9, 2, 690, "",
    0 },

  { 346,
    "ca_cse1_v1e_wo_losv2b/Plants/CSE1/Voith Schneider Propeller /Servo4/RowIndex",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, Servo4_RowIdx), 34, 3, 2, 692, "",
    0 },

  { 347,
    "ca_cse1_v1e_wo_losv2b/Plants/CSE1/Voith Schneider Propeller /Servo4/ColumnIndex",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, Servo4_ColIdx), 34, 3, 2, 694, "",
    0 },

  { 348,
    "ca_cse1_v1e_wo_losv2b/Plants/CSE1/Voith Schneider Propeller /Servo4/Table",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, Servo4_Table), 33, 9, 2, 696, "",
    0 },

  { 349,
    "ca_cse1_v1e_wo_losv2b/Plants/CSE1/Voith Schneider Propeller /VPS_Speed_Gain/Gain",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, VPS_Speed_Gain_Gain), 39, 1, 2,
    698, "", 0 },

  { 350,
    "ca_cse1_v1e_wo_losv2b/Plants/CSE1/Voith Schneider Propeller /VPS_Power_Offset/Value",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, VPS_Power_Offset_Value), 39, 1, 2,
    700, "", 0 },

  { 351,
    "ca_cse1_v1e_wo_losv2b/Plants/CSE1/Voith Schneider Propeller /VSPS Port/Gain",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, VSPSPort_Gain), 39, 1, 2, 702, "",
    0 },

  { 352,
    "ca_cse1_v1e_wo_losv2b/Plants/CSE1/Voith Schneider Propeller /VSPS Starboard/Gain",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, VSPSStarboard_Gain), 39, 1, 2, 704,
    "", 0 },

  { 353, "ca_cse1_v1e_wo_losv2b/Plants/CSE1/T_e/T_e11/Value", offsetof
    (Parameters_CA_CSE1_V1e_wo_LOSV2, T_e11_Value_i), 39, 1, 2, 706, "", 0 },

  { 354, "ca_cse1_v1e_wo_losv2b/Plants/CSE1/T_e/T_e21/Value", offsetof
    (Parameters_CA_CSE1_V1e_wo_LOSV2, T_e21_Value_p), 39, 1, 2, 708, "", 0 },

  { 355, "ca_cse1_v1e_wo_losv2b/Plants/CSE1/T_e/l_y1/Value", offsetof
    (Parameters_CA_CSE1_V1e_wo_LOSV2, l_y1_Value_a), 39, 1, 2, 710, "", 0 },

  { 356, "ca_cse1_v1e_wo_losv2b/Plants/CSE1/T_e/T_e12/Value", offsetof
    (Parameters_CA_CSE1_V1e_wo_LOSV2, T_e12_Value_o), 39, 1, 2, 712, "", 0 },

  { 357, "ca_cse1_v1e_wo_losv2b/Plants/CSE1/T_e/T_e22/Value", offsetof
    (Parameters_CA_CSE1_V1e_wo_LOSV2, T_e22_Value_pn), 39, 1, 2, 714, "", 0 },

  { 358, "ca_cse1_v1e_wo_losv2b/Plants/CSE1/T_e/l_x1/Value", offsetof
    (Parameters_CA_CSE1_V1e_wo_LOSV2, l_x1_Value_j), 39, 1, 2, 716, "", 0 },

  { 359, "ca_cse1_v1e_wo_losv2b/Plants/CSE1/T_e/-l_x1/Gain", offsetof
    (Parameters_CA_CSE1_V1e_wo_LOSV2, l_x1_Gain_f), 39, 1, 2, 718, "", 0 },

  { 360, "ca_cse1_v1e_wo_losv2b/Plants/CSE1/T_e/T_e13/Value", offsetof
    (Parameters_CA_CSE1_V1e_wo_LOSV2, T_e13_Value_l), 39, 1, 2, 720, "", 0 },

  { 361, "ca_cse1_v1e_wo_losv2b/Plants/CSE1/T_e/T_e23/Value", offsetof
    (Parameters_CA_CSE1_V1e_wo_LOSV2, T_e23_Value_c), 39, 1, 2, 722, "", 0 },

  { 362, "ca_cse1_v1e_wo_losv2b/Plants/CSE1/T_e/l_y2/Value", offsetof
    (Parameters_CA_CSE1_V1e_wo_LOSV2, l_y2_Value_g), 39, 1, 2, 724, "", 0 },

  { 363, "ca_cse1_v1e_wo_losv2b/Plants/CSE1/T_e/-l_y2/Gain", offsetof
    (Parameters_CA_CSE1_V1e_wo_LOSV2, l_y2_Gain_c), 39, 1, 2, 726, "", 0 },

  { 364, "ca_cse1_v1e_wo_losv2b/Plants/CSE1/T_e/T_e14/Value", offsetof
    (Parameters_CA_CSE1_V1e_wo_LOSV2, T_e14_Value_g), 39, 1, 2, 728, "", 0 },

  { 365, "ca_cse1_v1e_wo_losv2b/Plants/CSE1/T_e/T_e24/Value", offsetof
    (Parameters_CA_CSE1_V1e_wo_LOSV2, T_e24_Value_i), 39, 1, 2, 730, "", 0 },

  { 366, "ca_cse1_v1e_wo_losv2b/Plants/CSE1/T_e/l_x2/Value", offsetof
    (Parameters_CA_CSE1_V1e_wo_LOSV2, l_x2_Value_f), 39, 1, 2, 732, "", 0 },

  { 367, "ca_cse1_v1e_wo_losv2b/Plants/CSE1/T_e/-l_x2/Gain", offsetof
    (Parameters_CA_CSE1_V1e_wo_LOSV2, l_x2_Gain_j), 39, 1, 2, 734, "", 0 },

  { 368, "ca_cse1_v1e_wo_losv2b/Plants/CSE1/T_e/T_e15/Value", offsetof
    (Parameters_CA_CSE1_V1e_wo_LOSV2, T_e15_Value_c), 39, 1, 2, 736, "", 0 },

  { 369, "ca_cse1_v1e_wo_losv2b/Plants/CSE1/T_e/T_e25/Value", offsetof
    (Parameters_CA_CSE1_V1e_wo_LOSV2, T_e25_Value_jq), 39, 1, 2, 738, "", 0 },

  { 370, "ca_cse1_v1e_wo_losv2b/Plants/CSE1/T_e/l_x3/Value", offsetof
    (Parameters_CA_CSE1_V1e_wo_LOSV2, l_x3_Value_m), 39, 1, 2, 740, "", 0 },

  { 371, "ca_cse1_v1e_wo_losv2b/Plants/CSE1/K_e/K_e1_CSE1/Value", offsetof
    (Parameters_CA_CSE1_V1e_wo_LOSV2, K_e1_CSE1_Value), 39, 1, 2, 742, "", 0 },

  { 372, "ca_cse1_v1e_wo_losv2b/Plants/CSE1/K_e/Gain K_e1_CSE1/Gain", offsetof
    (Parameters_CA_CSE1_V1e_wo_LOSV2, GainK_e1_CSE1_Gain), 39, 1, 2, 744, "", 0
  },

  { 373, "ca_cse1_v1e_wo_losv2b/Plants/CSE1/K_e/Constant/Value", offsetof
    (Parameters_CA_CSE1_V1e_wo_LOSV2, Constant_Value_o), 39, 1, 2, 746, "", 0 },

  { 374, "ca_cse1_v1e_wo_losv2b/Plants/CSE1/K_e/K_e2_CSE1/Value", offsetof
    (Parameters_CA_CSE1_V1e_wo_LOSV2, K_e2_CSE1_Value), 39, 1, 2, 748, "", 0 },

  { 375, "ca_cse1_v1e_wo_losv2b/Plants/CSE1/K_e/Gain K_e2_CSE1/Gain", offsetof
    (Parameters_CA_CSE1_V1e_wo_LOSV2, GainK_e2_CSE1_Gain), 39, 1, 2, 750, "", 0
  },

  { 376, "ca_cse1_v1e_wo_losv2b/Plants/CSE1/K_e/K_e3_CSE1/Value", offsetof
    (Parameters_CA_CSE1_V1e_wo_LOSV2, K_e3_CSE1_Value), 39, 1, 2, 752, "", 0 },

  { 377, "ca_cse1_v1e_wo_losv2b/Plants/CSE1/K_e/Gain K_e3_CSE1/Gain", offsetof
    (Parameters_CA_CSE1_V1e_wo_LOSV2, GainK_e3_CSE1_Gain), 39, 1, 2, 754, "", 0
  },

  { 378, "ca_cse1_v1e_wo_losv2b/Plants/CSE1/K_e/K_e4_CSE1/Value", offsetof
    (Parameters_CA_CSE1_V1e_wo_LOSV2, K_e4_CSE1_Value), 39, 1, 2, 756, "", 0 },

  { 379, "ca_cse1_v1e_wo_losv2b/Plants/CSE1/K_e/Gain K_e4_CSE1/Gain", offsetof
    (Parameters_CA_CSE1_V1e_wo_LOSV2, GainK_e4_CSE1_Gain), 39, 1, 2, 758, "", 0
  },

  { 380, "ca_cse1_v1e_wo_losv2b/Plants/CSE1/K_e/K_e5_CSE1/Value", offsetof
    (Parameters_CA_CSE1_V1e_wo_LOSV2, K_e5_CSE1_Value), 39, 1, 2, 760, "", 0 },

  { 381, "ca_cse1_v1e_wo_losv2b/Plants/CSE1/K_e/Gain K_e5_CSE1/Gain", offsetof
    (Parameters_CA_CSE1_V1e_wo_LOSV2, GainK_e5_CSE1_Gain), 39, 1, 2, 762, "", 0
  },

  { 382, "ca_cse1_v1e_wo_losv2b/Plants/CSE1/CSE1 tau_surge/Gain", offsetof
    (Parameters_CA_CSE1_V1e_wo_LOSV2, CSE1tau_surge_Gain), 39, 1, 2, 764, "", 0
  },

  { 383, "ca_cse1_v1e_wo_losv2b/Plants/CSE1/CSE1 tau_sway/Gain", offsetof
    (Parameters_CA_CSE1_V1e_wo_LOSV2, CSE1tau_sway_Gain), 39, 1, 2, 766, "", 0 },

  { 384, "ca_cse1_v1e_wo_losv2b/Plants/CSE1/CSE1 tau_yaw/Gain", offsetof
    (Parameters_CA_CSE1_V1e_wo_LOSV2, CSE1tau_yaw_Gain), 39, 1, 2, 768, "", 0 },

  { 385, "ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/u to tau/Gain u_1/Gain",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, Gainu_1_Gain), 39, 1, 2, 770, "",
    0 },

  { 386, "ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/u to tau/Gain u_2/Gain",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, Gainu_2_Gain), 39, 1, 2, 772, "",
    0 },

  { 387, "ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/u to tau/Gain u_3/Gain",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, Gainu_3_Gain), 39, 1, 2, 774, "",
    0 },

  { 388, "ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/u to tau/Gain u_4/Gain",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, Gainu_4_Gain), 39, 1, 2, 776, "",
    0 },

  { 389,
    "ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/u to tau/Gain BT power/Gain",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, GainBTpower_Gain), 39, 1, 2, 778,
    "", 0 },

  { 390, "ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/u to tau/Neg/Gain",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, Neg_Gain_o), 39, 1, 2, 780, "", 0
  },

  { 391, "ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/u to tau/Gain u_5/Gain",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, Gainu_5_Gain), 39, 1, 2, 782, "",
    0 },

  { 392,
    "ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/u to tau/tau_surge_hil/Gain",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, tau_surge_hil_Gain), 39, 1, 2, 784,
    "", 0 },

  { 393,
    "ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/u to tau/tau_sway_hil/Gain",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, tau_sway_hil_Gain), 39, 1, 2, 786,
    "", 0 },

  { 394,
    "ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/u to tau/tau_yaw_hil/Gain",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, tau_yaw_hil_Gain), 39, 1, 2, 788,
    "", 0 },

  { 395,
    "ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/u to tau/VSP_angle_deg_port/Gain",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, VSP_angle_deg_port_Gain), 39, 1, 2,
    790, "", 0 },

  { 396,
    "ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/u to tau/VSP_angle_deg_stbd/Gain",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, VSP_angle_deg_stbd_Gain), 39, 1, 2,
    792, "", 0 },

  { 397,
    "ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/Vessel Dynamics/D_L/N_r/Value",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, N_r_Value), 39, 1, 2, 794, "", 0 },

  { 398,
    "ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/Vessel Dynamics/D_L/-N_r/Gain",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, N_r_Gain), 39, 1, 2, 796, "", 0 },

  { 399,
    "ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/Vessel Dynamics/D_L/N_v/Value",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, N_v_Value), 39, 1, 2, 798, "", 0 },

  { 400,
    "ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/Vessel Dynamics/D_L/-N_v/Gain",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, N_v_Gain), 39, 1, 2, 800, "", 0 },

  { 401,
    "ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/Vessel Dynamics/D_L/X_u/Value",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, X_u_Value), 39, 1, 2, 802, "", 0 },

  { 402,
    "ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/Vessel Dynamics/D_L/-X_u/Gain",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, X_u_Gain), 39, 1, 2, 804, "", 0 },

  { 403,
    "ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/Vessel Dynamics/D_L/Y_v/Value",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, Y_v_Value), 39, 1, 2, 806, "", 0 },

  { 404,
    "ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/Vessel Dynamics/D_L/-Y_v/Gain",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, Y_v_Gain), 39, 1, 2, 808, "", 0 },

  { 405,
    "ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/Vessel Dynamics/D_L/Y_r/Value",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, Y_r_Value), 39, 1, 2, 810, "", 0 },

  { 406,
    "ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/Vessel Dynamics/D_L/-Y_vr/Gain",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, Y_vr_Gain), 39, 1, 2, 812, "", 0 },

  { 407,
    "ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/Vessel Dynamics/D_L/D_L_12/Value",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, D_L_12_Value), 39, 1, 2, 814, "",
    0 },

  { 408,
    "ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/Vessel Dynamics/D_L/D_L_13/Value",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, D_L_13_Value), 39, 1, 2, 816, "",
    0 },

  { 409,
    "ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/Vessel Dynamics/D_L/D_L_21/Value",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, D_L_21_Value), 39, 1, 2, 818, "",
    0 },

  { 410,
    "ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/Vessel Dynamics/D_L/D_L_31/Value",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, D_L_31_Value), 39, 1, 2, 820, "",
    0 },

  { 411,
    "ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/Vessel Dynamics/Initial eta/psi_0/Value",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, psi_0_Value), 39, 1, 2, 822, "", 0
  },

  { 412,
    "ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/Vessel Dynamics/Initial eta/x_0/Value",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, x_0_Value), 39, 1, 2, 824, "", 0 },

  { 413,
    "ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/Vessel Dynamics/Initial eta/y_0/Value",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, y_0_Value), 39, 1, 2, 826, "", 0 },

  { 414,
    "ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/Vessel Dynamics/Initial nu/r_0/Value",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, r_0_Value), 39, 1, 2, 828, "", 0 },

  { 415,
    "ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/Vessel Dynamics/Initial nu/u_0/Value",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, u_0_Value), 39, 1, 2, 830, "", 0 },

  { 416,
    "ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/Vessel Dynamics/Initial nu/v_0/Value",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, v_0_Value), 39, 1, 2, 832, "", 0 },

  { 417,
    "ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/Vessel Dynamics/Reset Linear Simulator integrator/Value",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, ResetLinearSimulatorintegrator_),
    39, 1, 2, 834, "", 0 },

  { 418,
    "ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/Vessel Dynamics/M_inv/I_z/Value",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, I_z_Value), 39, 1, 2, 836, "", 0 },

  { 419,
    "ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/Vessel Dynamics/M_inv/m/Value",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, m_Value), 39, 1, 2, 838, "", 0 },

  { 420,
    "ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/Vessel Dynamics/M_inv/X_udot/Value",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, X_udot_Value), 39, 1, 2, 840, "",
    0 },

  { 421,
    "ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/Vessel Dynamics/M_inv/M_21/Value",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, M_21_Value), 39, 1, 2, 842, "", 0
  },

  { 422,
    "ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/Vessel Dynamics/M_inv/M_31/Value",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, M_31_Value), 39, 1, 2, 844, "", 0
  },

  { 423,
    "ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/Vessel Dynamics/M_inv/M_12/Value",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, M_12_Value), 39, 1, 2, 846, "", 0
  },

  { 424,
    "ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/Vessel Dynamics/M_inv/Y_vdot/Value",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, Y_vdot_Value), 39, 1, 2, 848, "",
    0 },

  { 425,
    "ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/Vessel Dynamics/M_inv/x_g/Value",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, x_g_Value), 39, 1, 2, 850, "", 0 },

  { 426,
    "ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/Vessel Dynamics/M_inv/N_vdot/Value",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, N_vdot_Value), 39, 1, 2, 852, "",
    0 },

  { 427,
    "ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/Vessel Dynamics/M_inv/M_13/Value",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, M_13_Value), 39, 1, 2, 854, "", 0
  },

  { 428,
    "ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/Vessel Dynamics/M_inv/Y_rdot/Value",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, Y_rdot_Value), 39, 1, 2, 856, "",
    0 },

  { 429,
    "ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/Vessel Dynamics/M_inv/N_rdot/Value",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, N_rdot_Value), 39, 1, 2, 858, "",
    0 },

  { 430,
    "ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/u to tau/T_e/T_e11/Value",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, T_e11_Value_o), 39, 1, 2, 860, "",
    0 },

  { 431,
    "ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/u to tau/T_e/T_e21/Value",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, T_e21_Value_l), 39, 1, 2, 862, "",
    0 },

  { 432, "ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/u to tau/T_e/l_y1/Value",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, l_y1_Value_n), 39, 1, 2, 864, "",
    0 },

  { 433,
    "ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/u to tau/T_e/T_e12/Value",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, T_e12_Value_p), 39, 1, 2, 866, "",
    0 },

  { 434,
    "ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/u to tau/T_e/T_e22/Value",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, T_e22_Value_k), 39, 1, 2, 868, "",
    0 },

  { 435, "ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/u to tau/T_e/l_x1/Value",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, l_x1_Value_d), 39, 1, 2, 870, "",
    0 },

  { 436, "ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/u to tau/T_e/-l_x1/Gain",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, l_x1_Gain_o), 39, 1, 2, 872, "", 0
  },

  { 437,
    "ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/u to tau/T_e/T_e13/Value",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, T_e13_Value_k), 39, 1, 2, 874, "",
    0 },

  { 438,
    "ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/u to tau/T_e/T_e23/Value",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, T_e23_Value_e), 39, 1, 2, 876, "",
    0 },

  { 439, "ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/u to tau/T_e/l_y2/Value",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, l_y2_Value_j), 39, 1, 2, 878, "",
    0 },

  { 440, "ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/u to tau/T_e/-l_y2/Gain",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, l_y2_Gain_h), 39, 1, 2, 880, "", 0
  },

  { 441,
    "ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/u to tau/T_e/T_e14/Value",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, T_e14_Value_d), 39, 1, 2, 882, "",
    0 },

  { 442,
    "ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/u to tau/T_e/T_e24/Value",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, T_e24_Value_g), 39, 1, 2, 884, "",
    0 },

  { 443, "ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/u to tau/T_e/l_x2/Value",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, l_x2_Value_k), 39, 1, 2, 886, "",
    0 },

  { 444, "ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/u to tau/T_e/-l_x2/Gain",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, l_x2_Gain_c), 39, 1, 2, 888, "", 0
  },

  { 445,
    "ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/u to tau/T_e/T_e15/Value",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, T_e15_Value_p), 39, 1, 2, 890, "",
    0 },

  { 446,
    "ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/u to tau/T_e/T_e25/Value",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, T_e25_Value_o), 39, 1, 2, 892, "",
    0 },

  { 447, "ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/u to tau/T_e/l_x3/Value",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, l_x3_Value_b), 39, 1, 2, 894, "",
    0 },

  { 448,
    "ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/u to tau/K_e/K_e1_hil/Value",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, K_e1_hil_Value), 39, 1, 2, 896, "",
    0 },

  { 449,
    "ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/u to tau/K_e/Gain K_e1_hil/Gain",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, GainK_e1_hil_Gain), 39, 1, 2, 898,
    "", 0 },

  { 450,
    "ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/u to tau/K_e/Constant41/Value",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, Constant41_Value), 39, 1, 2, 900,
    "", 0 },

  { 451,
    "ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/u to tau/K_e/K_e2_hil/Value",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, K_e2_hil_Value), 39, 1, 2, 902, "",
    0 },

  { 452,
    "ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/u to tau/K_e/Gain K_e2_hil/Gain",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, GainK_e2_hil_Gain), 39, 1, 2, 904,
    "", 0 },

  { 453,
    "ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/u to tau/K_e/K_e3_hil/Value",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, K_e3_hil_Value), 39, 1, 2, 906, "",
    0 },

  { 454,
    "ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/u to tau/K_e/Gain K_e3_hil/Gain",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, GainK_e3_hil_Gain), 39, 1, 2, 908,
    "", 0 },

  { 455,
    "ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/u to tau/K_e/K_e4_hil/Value",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, K_e4_hil_Value), 39, 1, 2, 910, "",
    0 },

  { 456,
    "ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/u to tau/K_e/Gain K_e4_hil/Gain",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, GainK_e4_hil_Gain), 39, 1, 2, 912,
    "", 0 },

  { 457,
    "ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/u to tau/K_e/K_e5_hil/Value",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, K_e5_hil_Value), 39, 1, 2, 914, "",
    0 },

  { 458,
    "ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/u to tau/K_e/Gain K_e5_hil/Gain",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, GainK_e5_hil_Gain), 39, 1, 2, 916,
    "", 0 },

  { 459,
    "ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/u to tau/Rate Limiter Dynamic/sample time/WtEt",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, sampletime_WtEt), 0, 1, 2, 918, "",
    0 },

  { 460,
    "ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/u to tau/Rate Limiter Dynamic/Delay Input2/X0",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, DelayInput2_X0), 39, 1, 2, 920, "",
    0 },

  { 461,
    "ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/Vessel Dynamics/R(psi)/R31/Value",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, R31_Value), 39, 1, 2, 922, "", 0 },

  { 462,
    "ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/Vessel Dynamics/R(psi)/R32/Value",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, R32_Value), 39, 1, 2, 924, "", 0 },

  { 463,
    "ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/Vessel Dynamics/R(psi)/R13/Value",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, R13_Value), 39, 1, 2, 926, "", 0 },

  { 464,
    "ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/Vessel Dynamics/R(psi)/R23/Value",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, R23_Value), 39, 1, 2, 928, "", 0 },

  { 465,
    "ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/Vessel Dynamics/R(psi)/R33/Value",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, R33_Value), 39, 1, 2, 930, "", 0 },

  { 466, "ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/eta_surge_hil/Gain",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, eta_surge_hil_Gain), 39, 1, 2, 932,
    "", 0 },

  { 467, "ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/eta_sway_hil/Gain",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, eta_sway_hil_Gain), 39, 1, 2, 934,
    "", 0 },

  { 468, "ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/eta_yaw_hil/Gain",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, eta_yaw_hil_Gain), 39, 1, 2, 936,
    "", 0 },

  { 469, "ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/etadot_surge_hil/Gain",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, etadot_surge_hil_Gain), 39, 1, 2,
    938, "", 0 },

  { 470, "ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/etadot_sway_hil/Gain",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, etadot_sway_hil_Gain), 39, 1, 2,
    940, "", 0 },

  { 471, "ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/etadot_yaw_hil/Gain",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, etadot_yaw_hil_Gain), 39, 1, 2,
    942, "", 0 },

  { 472, "ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/nu_surge_hil/Gain",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, nu_surge_hil_Gain), 39, 1, 2, 944,
    "", 0 },

  { 473, "ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/nu_sway_hil/Gain",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, nu_sway_hil_Gain), 39, 1, 2, 946,
    "", 0 },

  { 474, "ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/nu_yaw_hil/Gain",
    offsetof(Parameters_CA_CSE1_V1e_wo_LOSV2, nu_yaw_hil_Gain), 39, 1, 2, 948,
    "", 0 },
};

static int NI_ParamListSize = 475;
static int NI_ParamDimList[] = {
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Naviagation Systems/Qualisys 6 DOF/QTM In3/Gain */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Naviagation Systems/Qualisys 6 DOF/mm2m x/Gain */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Naviagation Systems/Qualisys 6 DOF/QTM In4/Gain */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Naviagation Systems/Qualisys 6 DOF/mm2m y/Gain */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Naviagation Systems/Qualisys 6 DOF/QTM In5/Gain */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Naviagation Systems/Qualisys 6 DOF/mm2m z/Gain */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Naviagation Systems/Qualisys 6 DOF/QTM In8/Gain */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Naviagation Systems/Qualisys 6 DOF/d2r roll/Gain */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Naviagation Systems/Qualisys 6 DOF/QTM In7/Gain */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Naviagation Systems/Qualisys 6 DOF/d2r pitch/Gain */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Naviagation Systems/Qualisys 6 DOF/QTM In6/Gain */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Naviagation Systems/Qualisys 6 DOF/d2r yaw/Gain */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Control Systems/Control Mode/Value */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/HMI/Panel command inputs/u1/Value */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/HMI/Panel command inputs/Panel  u_1/Gain */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/HMI/Panel command inputs/u2/Value */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/HMI/Panel command inputs/Panel u_2/Gain */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/HMI/Panel command inputs/u3/Value */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/HMI/Panel command inputs/Panel u_3/Gain */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/HMI/Panel command inputs/u4/Value */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/HMI/Panel command inputs/Panel u_4/Gain */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/HMI/Panel command inputs/u5/Value */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/HMI/Panel command inputs/Panel u_5/Gain */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/HMI/PS3 input/LabVIEW_BT_Power/Value */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/HMI/PS3 input/LabVIEW_VSP_Speed/Value */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/HMI/PS3 input/PS3 signals/JS_L_Y/Value */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/HMI/PS3 input/PS3 signals/Scaling_JS_L_Y/Gain */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Control Systems/Manual Thrust control/PS3 u_1/Gain */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/HMI/PS3 input/PS3 signals/JS_L_X/Value */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/HMI/PS3 input/PS3 signals/Scaling_JS_L_X/Gain */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Control Systems/Manual Thrust control/PS3 u_2/Gain */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/HMI/PS3 input/PS3 signals/JS_R_Y/Value */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/HMI/PS3 input/PS3 signals/Scaling_JS_R_Y/Gain */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Control Systems/Manual Thrust control/PS3 u_3/Gain */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/HMI/PS3 input/PS3 signals/JS_R_X/Value */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/HMI/PS3 input/PS3 signals/Scaling_JS_R_X/Gain */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Control Systems/Manual Thrust control/PS3 u_4/Gain */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/HMI/PS3 input/PS3 signals/L2/Value */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/HMI/PS3 input/PS3 signals/R2/Value */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Control Systems/Manual Thrust control/PS3 u_5/Gain */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Control Systems/Joystick Control/K_e/K_e1_joystick/Value */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Control Systems/Joystick Control/K_e/Gain K_e1_joystick/Gain */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Control Systems/Joystick Control/K_e/Constant/Value */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Control Systems/Joystick Control/K_e/K_e2_joystick/Value */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Control Systems/Joystick Control/K_e/Gain K_e2_joystick/Gain */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Control Systems/Joystick Control/K_e/K_e3_joystick/Value */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Control Systems/Joystick Control/K_e/Gain K_e3_joystick/Gain */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Control Systems/Joystick Control/K_e/K_e4_joystick/Value */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Control Systems/Joystick Control/K_e/Gain K_e4_joystick/Gain */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Control Systems/Joystick Control/K_e/K_e5_joystick/Value */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Control Systems/Joystick Control/K_e/Gain K_e5_joystick/Gain */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Control Systems/Joystick Control/T_e/T_e11/Value */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Control Systems/Joystick Control/T_e/T_e21/Value */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Control Systems/Joystick Control/T_e/l_y1/Value */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Control Systems/Joystick Control/T_e/T_e12/Value */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Control Systems/Joystick Control/T_e/T_e22/Value */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Control Systems/Joystick Control/T_e/l_x1/Value */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Control Systems/Joystick Control/T_e/-l_x1/Gain */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Control Systems/Joystick Control/T_e/T_e13/Value */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Control Systems/Joystick Control/T_e/T_e23/Value */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Control Systems/Joystick Control/T_e/l_y2/Value */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Control Systems/Joystick Control/T_e/-l_y2/Gain */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Control Systems/Joystick Control/T_e/T_e14/Value */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Control Systems/Joystick Control/T_e/T_e24/Value */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Control Systems/Joystick Control/T_e/l_x2/Value */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Control Systems/Joystick Control/T_e/-l_x2/Gain */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Control Systems/Joystick Control/T_e/T_e15/Value */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Control Systems/Joystick Control/T_e/T_e25/Value */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Control Systems/Joystick Control/T_e/l_x3/Value */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Control Systems/Joystick Control/Joystick tau_surge/Gain */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Control Systems/Joystick Control/Saturation1/UpperLimit */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Control Systems/Joystick Control/Saturation1/LowerLimit */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Control Systems/Joystick Control/Joystick tau_sway/Gain */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Control Systems/Joystick Control/Saturation2/UpperLimit */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Control Systems/Joystick Control/Saturation2/LowerLimit */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Control Systems/Joystick Control/Joystick tau_yaw/Gain */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Control Systems/Joystick Control/Saturation3/UpperLimit */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Control Systems/Joystick Control/Saturation3/LowerLimit */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Control Systems/Joystick Control/Saturation/UpperLimit */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Control Systems/Joystick Control/Saturation/LowerLimit */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Control Systems/Joystick Control/Joystick u_1/Gain */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Control Systems/Joystick Control/Joystick u_2/Gain */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Control Systems/Joystick Control/Joystick u_3/Gain */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Control Systems/Joystick Control/Joystick u_4/Gain */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Control Systems/Joystick Control/Joystick u_5/Gain */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Guidance Systems/DP/Enable eta_d LPF/Value */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/HMI/DP input/x_d/Value */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/HMI/DP input/y_d/Value */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/HMI/DP input/psi_d/Value */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/HMI/DP input/Degrees to Radians/Gain1/Gain */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Guidance Systems/DP/Transfer Fcn/A */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Guidance Systems/DP/Transfer Fcn/C */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Guidance Systems/DP/Transfer Fcn1/A */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Guidance Systems/DP/Transfer Fcn1/C */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Guidance Systems/DP/Transfer Fcn2/A */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Guidance Systems/DP/Transfer Fcn2/C */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Guidance Systems/DP/eta_d DP N/Gain */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Guidance Systems/DP/eta_d DP E/Gain */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Guidance Systems/DP/eta_d DP Psi/Gain */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Naviagation Systems/Controller Input Selector/Value */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Plants/Enable Linear Simulator/Value */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Naviagation Systems/eta_surge/Gain */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Naviagation Systems/eta_sway/Gain */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Naviagation Systems/eta_yaw/Gain */
  3, 3,                                /* ca_cse1_v1e_wo_losv2b/Naviagation Systems/Qualisys 6 DOF/Constant1/Value */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Naviagation Systems/nu_surge/Gain */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Naviagation Systems/nu_sway/Gain */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Naviagation Systems/nu_yaw/Gain */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Control Systems/if DP Control Mode/Constant/Value */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Control Systems/Maneuvering controller/K_e/K_e1_DP/Value */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Control Systems/Maneuvering controller/K_e/Gain K_e1_DP/Gain */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Control Systems/Maneuvering controller/K_e/Constant/Value */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Control Systems/Maneuvering controller/K_e/K_e2_DP/Value */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Control Systems/Maneuvering controller/K_e/Gain K_e2_DP/Gain */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Control Systems/Maneuvering controller/K_e/K_e3_DP/Value */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Control Systems/Maneuvering controller/K_e/Gain K_e3_DP/Gain */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Control Systems/Maneuvering controller/K_e/K_e4_DP/Value */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Control Systems/Maneuvering controller/K_e/Gain K_e4_DP/Gain */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Control Systems/Maneuvering controller/K_e/K_e5_DP/Value */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Control Systems/Maneuvering controller/K_e/Gain K_e5_DP/Gain */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Control Systems/Maneuvering controller/T_e/T_e11/Value */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Control Systems/Maneuvering controller/T_e/T_e21/Value */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Control Systems/Maneuvering controller/T_e/l_y1/Value */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Control Systems/Maneuvering controller/T_e/T_e12/Value */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Control Systems/Maneuvering controller/T_e/T_e22/Value */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Control Systems/Maneuvering controller/T_e/l_x1/Value */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Control Systems/Maneuvering controller/T_e/-l_x1/Gain */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Control Systems/Maneuvering controller/T_e/T_e13/Value */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Control Systems/Maneuvering controller/T_e/T_e23/Value */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Control Systems/Maneuvering controller/T_e/l_y2/Value */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Control Systems/Maneuvering controller/T_e/-l_y2/Gain */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Control Systems/Maneuvering controller/T_e/T_e14/Value */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Control Systems/Maneuvering controller/T_e/T_e24/Value */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Control Systems/Maneuvering controller/T_e/l_x2/Value */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Control Systems/Maneuvering controller/T_e/-l_x2/Gain */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Control Systems/Maneuvering controller/T_e/T_e15/Value */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Control Systems/Maneuvering controller/T_e/T_e25/Value */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Control Systems/Maneuvering controller/T_e/l_x3/Value */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Guidance Systems/Path generator (iceberg towing)/N_d1/Step/Time */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Guidance Systems/Path generator (iceberg towing)/N_d1/Step/Before */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Guidance Systems/Path generator (iceberg towing)/N_d1/Step/After */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Guidance Systems/Path generator (iceberg towing)/N_d1/Constant/Value */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Guidance Systems/Path generator (iceberg towing)/N_d1/Constant1/Value */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Guidance Systems/Path generator (iceberg towing)/E_d/Step/Time */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Guidance Systems/Path generator (iceberg towing)/E_d/Step/Before */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Guidance Systems/Path generator (iceberg towing)/E_d/Step/After */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Guidance Systems/Path generator (iceberg towing)/E_d/Constant/Value */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Guidance Systems/Path generator (iceberg towing)/E_d/Constant1/Value */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Guidance Systems/Path generator (iceberg towing)/eta_d_theta maker/Memory2/X0 */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Guidance Systems/Path generator (iceberg towing)/eta_d_theta maker/Memory1/X0 */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Control Systems/Maneuvering controller/Path controller/theta maker/Integrator/InitialCondition */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Guidance Systems/Path generator (iceberg towing)/eta_d_theta maker/Memory/X0 */
  3, 3,                                /* ca_cse1_v1e_wo_losv2b/Control Systems/Maneuvering controller/Path controller/alpha_1/K_p/Gain */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Guidance Systems/Path generator (iceberg towing)/eta_d_theta maker/Memory3/X0 */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Guidance Systems/Path generator (iceberg towing)/U_d/Value */
  3, 3,                                /* ca_cse1_v1e_wo_losv2b/Control Systems/Maneuvering controller/Path controller/tau_s/K_d/Gain */
  3, 3,                                /* ca_cse1_v1e_wo_losv2b/Control Systems/Maneuvering controller/Path controller/tau_s/D_s/Gain */
  3, 3,                                /* ca_cse1_v1e_wo_losv2b/Control Systems/Maneuvering controller/Path controller/sigma_1/S/Gain */
  3, 3,                                /* ca_cse1_v1e_wo_losv2b/Control Systems/Maneuvering controller/Path controller/sigma_1/K_p/Gain */
  3, 3,                                /* ca_cse1_v1e_wo_losv2b/Control Systems/Maneuvering controller/Path controller/sigma_1/S1/Value */
  3, 3,                                /* ca_cse1_v1e_wo_losv2b/Control Systems/Maneuvering controller/Path controller/tau_s/M_s/Gain */
  3, 3,                                /* ca_cse1_v1e_wo_losv2b/Control Systems/Maneuvering controller/Path controller/alpha_1_theta/K_p/Gain */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Guidance Systems/Path generator (iceberg towing)/eta_d_theta2 maker/Memory/X0 */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Guidance Systems/Path generator (iceberg towing)/eta_d_theta2 maker/Memory1/X0 */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Guidance Systems/Path generator (iceberg towing)/eta_d_theta2 maker/Memory2/X0 */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Guidance Systems/Path generator (iceberg towing)/v_s_theta maker/Gain/Gain */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Guidance Systems/Path generator (iceberg towing)/v_s_theta maker/power/Value */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Guidance Systems/Path generator (iceberg towing)/v_s_theta maker/IC/Value */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Guidance Systems/Path generator (iceberg towing)/eta_d_theta2 maker/Memory3/X0 */
  3, 3,                                /* ca_cse1_v1e_wo_losv2b/Control Systems/Maneuvering controller/Path controller/theta maker/M_s/Gain */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Control Systems/Maneuvering controller/Path controller/theta maker/mu/Gain */
  3, 3,                                /* ca_cse1_v1e_wo_losv2b/Control Systems/Maneuvering controller/Path controller/tau_s/M_s1/Gain */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Naviagation Systems/Qualisys 6 DOF/QTM In10/Gain */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Naviagation Systems/Qualisys 6 DOF/mm2m x1/Gain */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Naviagation Systems/eta_i_surge/Gain */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Naviagation Systems/Qualisys 6 DOF/QTM In11/Gain */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Naviagation Systems/Qualisys 6 DOF/mm2m y1/Gain */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Naviagation Systems/eta_i_sway/Gain */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Naviagation Systems/Qualisys 6 DOF/QTM In13/Gain */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Naviagation Systems/Qualisys 6 DOF/d2r yaw1/Gain */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Naviagation Systems/eta_i_yaw/Gain */
  3, 3,                                /* ca_cse1_v1e_wo_losv2b/Control Systems/Tension estimator/K_tow/Gain */
  3, 1,                                /* ca_cse1_v1e_wo_losv2b/Control Systems/Maneuvering controller/DEBUG/Value */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Control Systems/Maneuvering controller/DP u_1/Gain */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Control Systems/Maneuvering controller/DP u_2/Gain */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Control Systems/Maneuvering controller/DP u_3/Gain */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Control Systems/Maneuvering controller/DP u_4/Gain */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Control Systems/Maneuvering controller/DP u_5/Gain */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Control Systems/Maneuvering controller/Saturation/UpperLimit */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Control Systems/Maneuvering controller/Saturation/LowerLimit */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Control Systems/Maneuvering controller/BT_power_limit/Value */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Control Systems/Maneuvering controller/VSP_speeds/Value */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Control Systems/Saturation/UpperLimit */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Control Systems/Saturation/LowerLimit */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Control Systems/if iceberg control mode/Constant/Value */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Guidance Systems/DP/eta_d Psi deg/Gain */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/HMI/Battery Bow Thruster/Gain */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/HMI/Battery Servo/Gain */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/HMI/Battery Main/Gain */
  3, 3,                                /* ca_cse1_v1e_wo_losv2b/Naviagation Systems/Qualisys 6 DOF/Constant2/Value */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Naviagation Systems/Qualisys 6 DOF/QTM In12/Gain */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Naviagation Systems/Qualisys 6 DOF/mm2m z1/Gain */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Naviagation Systems/Qualisys 6 DOF/QTM In15/Gain */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Naviagation Systems/Qualisys 6 DOF/d2r roll1/Gain */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Naviagation Systems/Qualisys 6 DOF/QTM In14/Gain */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Naviagation Systems/Qualisys 6 DOF/d2r pitch1/Gain */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Naviagation Systems/Qualisys 6 DOF/QTM In1 FPS/Gain */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Naviagation Systems/Qualisys 6 DOF/QTM In16 Residual/Gain */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Naviagation Systems/Qualisys 6 DOF/QTM In2 Error/Gain */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Naviagation Systems/Qualisys 6 DOF/QTM In9 Residual/Gain */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Naviagation Systems/nu_i_surge/Gain */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Naviagation Systems/nu_i_sway/Gain */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Naviagation Systems/nu_i_yaw/Gain */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Plants/u_1 plant/Gain */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Plants/u_2 plant/Gain */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Plants/u_3 plant/Gain */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Plants/u_4 plant/Gain */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Plants/u_5 plant/Gain */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Plants/BT power lmit/Gain */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Plants/VSP speed/Gain */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Plants/Enable CSE1/Value */
  7, 1,                                /* ca_cse1_v1e_wo_losv2b/Control Systems/DP control/Thruster_Command_DP/InitialOutput */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Control Systems/DP control/Passive DP wave filter1/Integrator1/InitialCondition */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Control Systems/DP control/BT_power_limit/Value */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Control Systems/DP control/Enable Filter/Value */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Control Systems/DP control/Passive DP wave filter1/Integrator/InitialCondition */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Control Systems/DP control/Passive DP wave filter1/[-inf inf] to [-pi pi]/Saturation/UpperLimit */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Control Systems/DP control/Passive DP wave filter1/[-inf inf] to [-pi pi]/Saturation/LowerLimit */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Control Systems/DP control/Passive DP wave filter1/[-inf inf] to [-pi pi]/Gain/Gain */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Control Systems/DP control/Passive DP wave filter1/[-inf inf] to [-pi pi]/Constant/Value */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Control Systems/DP control/DP controller/eta N/Gain */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Control Systems/DP control/DP controller/eta E/Gain */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Control Systems/DP control/DP controller/eta Psi/Gain */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Control Systems/DP control/DP controller/Reg_e_N_hil/Gain */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Control Systems/DP control/DP controller/Reg_e_E_hil/Gain */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Control Systems/DP control/DP controller/Reg_e_Psi_hil/Gain */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Control Systems/DP control/DP controller/Reset_DP_integrator/Value */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Control Systems/DP control/DP controller/Integrator/InitialCondition */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Control Systems/DP control/Passive DP wave filter1/Integrator4/InitialCondition */
  3, 3,                                /* ca_cse1_v1e_wo_losv2b/Control Systems/DP control/DP controller/Kd/Gain */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Control Systems/DP control/DP controller/Kd_scale/Value */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Control Systems/DP control/DP controller/K_d 1/Gain */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Control Systems/DP control/DP controller/K_d 2/Gain */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Control Systems/DP control/DP controller/K_d 3/Gain */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Control Systems/DP control/DP controller/K_d 3 deg/Gain */
  3, 3,                                /* ca_cse1_v1e_wo_losv2b/Control Systems/DP control/DP controller/Ki/Gain */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Control Systems/DP control/DP controller/Ki_scale/Value */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Control Systems/DP control/DP controller/K_i 1/Gain */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Control Systems/DP control/DP controller/K_i 2/Gain */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Control Systems/DP control/DP controller/K_i 3/Gain */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Control Systems/DP control/DP controller/K_i 3 deg/Gain */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Control Systems/DP control/DP controller/Kp_scale/Value */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Control Systems/DP control/DP controller/[-inf inf] to [-pi pi]1/Saturation/UpperLimit */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Control Systems/DP control/DP controller/[-inf inf] to [-pi pi]1/Saturation/LowerLimit */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Control Systems/DP control/DP controller/[-inf inf] to [-pi pi]1/Gain/Gain */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Control Systems/DP control/DP controller/[-inf inf] to [-pi pi]1/Constant/Value */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Control Systems/DP control/DP controller/[-inf inf] to [-pi pi]/Saturation/UpperLimit */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Control Systems/DP control/DP controller/[-inf inf] to [-pi pi]/Saturation/LowerLimit */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Control Systems/DP control/DP controller/[-inf inf] to [-pi pi]/Gain/Gain */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Control Systems/DP control/DP controller/[-inf inf] to [-pi pi]/Constant/Value */
  3, 3,                                /* ca_cse1_v1e_wo_losv2b/Control Systems/DP control/DP controller/Kp/Gain */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Control Systems/DP control/DP controller/K_p 1/Gain */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Control Systems/DP control/DP controller/K_p 2/Gain */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Control Systems/DP control/DP controller/K_p 3/Gain */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Control Systems/DP control/DP controller/K_p 3 deg/Gain */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Control Systems/DP control/DP controller/Reg_e_Psi_deg/Gain */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Control Systems/DP control/DP controller/eta Psi deg/Gain */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Control Systems/DP control/DP tau_surge/Gain */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Control Systems/DP control/DP tau_sway/Gain */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Control Systems/DP control/DP tau_yaw/Gain */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Control Systems/DP control/K_e/K_e1_DP/Value */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Control Systems/DP control/K_e/Gain K_e1_DP/Gain */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Control Systems/DP control/K_e/Constant/Value */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Control Systems/DP control/K_e/K_e2_DP/Value */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Control Systems/DP control/K_e/Gain K_e2_DP/Gain */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Control Systems/DP control/K_e/K_e3_DP/Value */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Control Systems/DP control/K_e/Gain K_e3_DP/Gain */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Control Systems/DP control/K_e/K_e4_DP/Value */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Control Systems/DP control/K_e/Gain K_e4_DP/Gain */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Control Systems/DP control/K_e/K_e5_DP/Value */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Control Systems/DP control/K_e/Gain K_e5_DP/Gain */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Control Systems/DP control/T_e/T_e11/Value */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Control Systems/DP control/T_e/T_e21/Value */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Control Systems/DP control/T_e/l_y1/Value */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Control Systems/DP control/T_e/T_e12/Value */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Control Systems/DP control/T_e/T_e22/Value */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Control Systems/DP control/T_e/l_x1/Value */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Control Systems/DP control/T_e/-l_x1/Gain */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Control Systems/DP control/T_e/T_e13/Value */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Control Systems/DP control/T_e/T_e23/Value */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Control Systems/DP control/T_e/l_y2/Value */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Control Systems/DP control/T_e/-l_y2/Gain */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Control Systems/DP control/T_e/T_e14/Value */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Control Systems/DP control/T_e/T_e24/Value */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Control Systems/DP control/T_e/l_x2/Value */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Control Systems/DP control/T_e/-l_x2/Gain */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Control Systems/DP control/T_e/T_e15/Value */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Control Systems/DP control/T_e/T_e25/Value */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Control Systems/DP control/T_e/l_x3/Value */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Control Systems/DP control/DP u_1/Gain */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Control Systems/DP control/DP u_2/Gain */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Control Systems/DP control/DP u_3/Gain */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Control Systems/DP control/DP u_4/Gain */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Control Systems/DP control/DP u_5/Gain */
  3, 3,                                /* ca_cse1_v1e_wo_losv2b/Control Systems/DP control/Passive DP wave filter1/Gain1/Gain */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Control Systems/DP control/Passive DP wave filter1/Integrator2/InitialCondition */
  3, 3,                                /* ca_cse1_v1e_wo_losv2b/Control Systems/DP control/Passive DP wave filter1/Gain2/Gain */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Control Systems/DP control/Passive DP wave filter1/[-inf inf] to [-pi pi]1/Saturation/UpperLimit */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Control Systems/DP control/Passive DP wave filter1/[-inf inf] to [-pi pi]1/Saturation/LowerLimit */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Control Systems/DP control/Passive DP wave filter1/[-inf inf] to [-pi pi]1/Gain/Gain */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Control Systems/DP control/Passive DP wave filter1/[-inf inf] to [-pi pi]1/Constant/Value */
  3, 3,                                /* ca_cse1_v1e_wo_losv2b/Control Systems/DP control/Passive DP wave filter1/K4/Gain */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Control Systems/DP control/Passive DP wave filter1/Integrator3/InitialCondition */
  3, 3,                                /* ca_cse1_v1e_wo_losv2b/Control Systems/DP control/Passive DP wave filter1/Gain6/Gain */
  3, 3,                                /* ca_cse1_v1e_wo_losv2b/Control Systems/DP control/Passive DP wave filter1/Gain3/Gain */
  3, 3,                                /* ca_cse1_v1e_wo_losv2b/Control Systems/DP control/Passive DP wave filter1/K11/Gain */
  3, 3,                                /* ca_cse1_v1e_wo_losv2b/Control Systems/DP control/Passive DP wave filter1/K12/Gain */
  3, 3,                                /* ca_cse1_v1e_wo_losv2b/Control Systems/DP control/Passive DP wave filter1/K2/Gain */
  3, 3,                                /* ca_cse1_v1e_wo_losv2b/Control Systems/DP control/Passive DP wave filter1/K3/Gain */
  3, 3,                                /* ca_cse1_v1e_wo_losv2b/Control Systems/DP control/Passive DP wave filter1/inv(T_b)/Gain */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Control Systems/DP control/Saturation/UpperLimit */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Control Systems/DP control/Saturation/LowerLimit */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Control Systems/DP control/VSP_speeds/Value */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Plants/CSE1/Bow Thruster/BT_D_Gain1/Gain */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Plants/CSE1/Bow Thruster/BT_Power_Offset1/Value */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Plants/CSE1/Bow Thruster/BT_D_Gain2/Gain */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Plants/CSE1/Bow Thruster/BT_L_Gain1/Gain */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Plants/CSE1/Bow Thruster/BT_L_Gain2/Gain */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Plants/CSE1/Bow Thruster/BT_Power_Offset2/Value */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Plants/CSE1/Bow Thruster/BT_Power_Offset3/Value */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Plants/CSE1/Bow Thruster/Constant/Value */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Plants/CSE1/Bow Thruster/Constant1/Value */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Plants/CSE1/Bow Thruster/Neg/Gain */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Plants/CSE1/Voith Schneider Propeller /-x/Gain */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Plants/CSE1/Voith Schneider Propeller /-y/Gain */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Plants/CSE1/Voith Schneider Propeller /Radians to Degrees Port/Gain/Gain */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Plants/CSE1/Voith Schneider Propeller /Radians to Degrees Staroard/Gain/Gain */
  1, 3,                                /* ca_cse1_v1e_wo_losv2b/Plants/CSE1/Voith Schneider Propeller /Servo1/RowIndex */
  1, 3,                                /* ca_cse1_v1e_wo_losv2b/Plants/CSE1/Voith Schneider Propeller /Servo1/ColumnIndex */
  3, 3,                                /* ca_cse1_v1e_wo_losv2b/Plants/CSE1/Voith Schneider Propeller /Servo1/Table */
  1, 3,                                /* ca_cse1_v1e_wo_losv2b/Plants/CSE1/Voith Schneider Propeller /Servo2/RowIndex */
  1, 3,                                /* ca_cse1_v1e_wo_losv2b/Plants/CSE1/Voith Schneider Propeller /Servo2/ColumnIndex */
  3, 3,                                /* ca_cse1_v1e_wo_losv2b/Plants/CSE1/Voith Schneider Propeller /Servo2/Table */
  1, 3,                                /* ca_cse1_v1e_wo_losv2b/Plants/CSE1/Voith Schneider Propeller /Servo3/RowIndex */
  1, 3,                                /* ca_cse1_v1e_wo_losv2b/Plants/CSE1/Voith Schneider Propeller /Servo3/ColumnIndex */
  3, 3,                                /* ca_cse1_v1e_wo_losv2b/Plants/CSE1/Voith Schneider Propeller /Servo3/Table */
  1, 3,                                /* ca_cse1_v1e_wo_losv2b/Plants/CSE1/Voith Schneider Propeller /Servo4/RowIndex */
  1, 3,                                /* ca_cse1_v1e_wo_losv2b/Plants/CSE1/Voith Schneider Propeller /Servo4/ColumnIndex */
  3, 3,                                /* ca_cse1_v1e_wo_losv2b/Plants/CSE1/Voith Schneider Propeller /Servo4/Table */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Plants/CSE1/Voith Schneider Propeller /VPS_Speed_Gain/Gain */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Plants/CSE1/Voith Schneider Propeller /VPS_Power_Offset/Value */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Plants/CSE1/Voith Schneider Propeller /VSPS Port/Gain */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Plants/CSE1/Voith Schneider Propeller /VSPS Starboard/Gain */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Plants/CSE1/T_e/T_e11/Value */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Plants/CSE1/T_e/T_e21/Value */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Plants/CSE1/T_e/l_y1/Value */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Plants/CSE1/T_e/T_e12/Value */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Plants/CSE1/T_e/T_e22/Value */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Plants/CSE1/T_e/l_x1/Value */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Plants/CSE1/T_e/-l_x1/Gain */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Plants/CSE1/T_e/T_e13/Value */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Plants/CSE1/T_e/T_e23/Value */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Plants/CSE1/T_e/l_y2/Value */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Plants/CSE1/T_e/-l_y2/Gain */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Plants/CSE1/T_e/T_e14/Value */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Plants/CSE1/T_e/T_e24/Value */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Plants/CSE1/T_e/l_x2/Value */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Plants/CSE1/T_e/-l_x2/Gain */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Plants/CSE1/T_e/T_e15/Value */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Plants/CSE1/T_e/T_e25/Value */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Plants/CSE1/T_e/l_x3/Value */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Plants/CSE1/K_e/K_e1_CSE1/Value */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Plants/CSE1/K_e/Gain K_e1_CSE1/Gain */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Plants/CSE1/K_e/Constant/Value */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Plants/CSE1/K_e/K_e2_CSE1/Value */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Plants/CSE1/K_e/Gain K_e2_CSE1/Gain */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Plants/CSE1/K_e/K_e3_CSE1/Value */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Plants/CSE1/K_e/Gain K_e3_CSE1/Gain */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Plants/CSE1/K_e/K_e4_CSE1/Value */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Plants/CSE1/K_e/Gain K_e4_CSE1/Gain */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Plants/CSE1/K_e/K_e5_CSE1/Value */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Plants/CSE1/K_e/Gain K_e5_CSE1/Gain */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Plants/CSE1/CSE1 tau_surge/Gain */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Plants/CSE1/CSE1 tau_sway/Gain */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Plants/CSE1/CSE1 tau_yaw/Gain */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/u to tau/Gain u_1/Gain */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/u to tau/Gain u_2/Gain */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/u to tau/Gain u_3/Gain */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/u to tau/Gain u_4/Gain */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/u to tau/Gain BT power/Gain */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/u to tau/Neg/Gain */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/u to tau/Gain u_5/Gain */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/u to tau/tau_surge_hil/Gain */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/u to tau/tau_sway_hil/Gain */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/u to tau/tau_yaw_hil/Gain */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/u to tau/VSP_angle_deg_port/Gain */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/u to tau/VSP_angle_deg_stbd/Gain */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/Vessel Dynamics/D_L/N_r/Value */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/Vessel Dynamics/D_L/-N_r/Gain */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/Vessel Dynamics/D_L/N_v/Value */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/Vessel Dynamics/D_L/-N_v/Gain */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/Vessel Dynamics/D_L/X_u/Value */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/Vessel Dynamics/D_L/-X_u/Gain */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/Vessel Dynamics/D_L/Y_v/Value */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/Vessel Dynamics/D_L/-Y_v/Gain */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/Vessel Dynamics/D_L/Y_r/Value */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/Vessel Dynamics/D_L/-Y_vr/Gain */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/Vessel Dynamics/D_L/D_L_12/Value */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/Vessel Dynamics/D_L/D_L_13/Value */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/Vessel Dynamics/D_L/D_L_21/Value */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/Vessel Dynamics/D_L/D_L_31/Value */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/Vessel Dynamics/Initial eta/psi_0/Value */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/Vessel Dynamics/Initial eta/x_0/Value */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/Vessel Dynamics/Initial eta/y_0/Value */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/Vessel Dynamics/Initial nu/r_0/Value */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/Vessel Dynamics/Initial nu/u_0/Value */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/Vessel Dynamics/Initial nu/v_0/Value */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/Vessel Dynamics/Reset Linear Simulator integrator/Value */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/Vessel Dynamics/M_inv/I_z/Value */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/Vessel Dynamics/M_inv/m/Value */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/Vessel Dynamics/M_inv/X_udot/Value */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/Vessel Dynamics/M_inv/M_21/Value */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/Vessel Dynamics/M_inv/M_31/Value */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/Vessel Dynamics/M_inv/M_12/Value */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/Vessel Dynamics/M_inv/Y_vdot/Value */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/Vessel Dynamics/M_inv/x_g/Value */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/Vessel Dynamics/M_inv/N_vdot/Value */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/Vessel Dynamics/M_inv/M_13/Value */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/Vessel Dynamics/M_inv/Y_rdot/Value */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/Vessel Dynamics/M_inv/N_rdot/Value */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/u to tau/T_e/T_e11/Value */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/u to tau/T_e/T_e21/Value */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/u to tau/T_e/l_y1/Value */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/u to tau/T_e/T_e12/Value */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/u to tau/T_e/T_e22/Value */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/u to tau/T_e/l_x1/Value */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/u to tau/T_e/-l_x1/Gain */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/u to tau/T_e/T_e13/Value */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/u to tau/T_e/T_e23/Value */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/u to tau/T_e/l_y2/Value */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/u to tau/T_e/-l_y2/Gain */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/u to tau/T_e/T_e14/Value */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/u to tau/T_e/T_e24/Value */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/u to tau/T_e/l_x2/Value */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/u to tau/T_e/-l_x2/Gain */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/u to tau/T_e/T_e15/Value */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/u to tau/T_e/T_e25/Value */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/u to tau/T_e/l_x3/Value */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/u to tau/K_e/K_e1_hil/Value */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/u to tau/K_e/Gain K_e1_hil/Gain */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/u to tau/K_e/Constant41/Value */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/u to tau/K_e/K_e2_hil/Value */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/u to tau/K_e/Gain K_e2_hil/Gain */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/u to tau/K_e/K_e3_hil/Value */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/u to tau/K_e/Gain K_e3_hil/Gain */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/u to tau/K_e/K_e4_hil/Value */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/u to tau/K_e/Gain K_e4_hil/Gain */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/u to tau/K_e/K_e5_hil/Value */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/u to tau/K_e/Gain K_e5_hil/Gain */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/u to tau/Rate Limiter Dynamic/sample time/WtEt */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/u to tau/Rate Limiter Dynamic/Delay Input2/X0 */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/Vessel Dynamics/R(psi)/R31/Value */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/Vessel Dynamics/R(psi)/R32/Value */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/Vessel Dynamics/R(psi)/R13/Value */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/Vessel Dynamics/R(psi)/R23/Value */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/Vessel Dynamics/R(psi)/R33/Value */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/eta_surge_hil/Gain */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/eta_sway_hil/Gain */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/eta_yaw_hil/Gain */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/etadot_surge_hil/Gain */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/etadot_sway_hil/Gain */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/etadot_yaw_hil/Gain */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/nu_surge_hil/Gain */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/nu_sway_hil/Gain */
  1, 1,                                /* ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/nu_yaw_hil/Gain */
};

static int NI_VariablesListSize = 0;
static char *NI_VariablesList[] = {
  ""
};

static int NI_SigListSize = 524;
static NI_Signal NI_SigList[] = {
  { 0, "ca_cse1_v1e_wo_losv2b/Naviagation Systems/Qualisys 6 DOF/QTM In", 0, "",
    offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, QTMIn), BLOCKIO_SIG, 38, 16, 2, 0, 0
  },

  { 1, "ca_cse1_v1e_wo_losv2b/Naviagation Systems/Qualisys 6 DOF/QTM In3", 0, "",
    offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, QTMIn3), BLOCKIO_SIG, 39, 1, 2, 2, 0
  },

  { 2, "ca_cse1_v1e_wo_losv2b/Naviagation Systems/Qualisys 6 DOF/mm2m x", 0, "",
    offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, mm2mx), BLOCKIO_SIG, 39, 1, 2, 4, 0
  },

  { 3, "ca_cse1_v1e_wo_losv2b/Naviagation Systems/Qualisys 6 DOF/QTM In4", 0, "",
    offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, QTMIn4), BLOCKIO_SIG, 39, 1, 2, 6, 0
  },

  { 4, "ca_cse1_v1e_wo_losv2b/Naviagation Systems/Qualisys 6 DOF/mm2m y", 0, "",
    offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, mm2my), BLOCKIO_SIG, 39, 1, 2, 8, 0
  },

  { 5, "ca_cse1_v1e_wo_losv2b/Naviagation Systems/Qualisys 6 DOF/QTM In5", 0, "",
    offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, QTMIn5), BLOCKIO_SIG, 39, 1, 2, 10,
    0 },

  { 6, "ca_cse1_v1e_wo_losv2b/Naviagation Systems/Qualisys 6 DOF/mm2m z", 0, "",
    offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, mm2mz), BLOCKIO_SIG, 39, 1, 2, 12, 0
  },

  { 7, "ca_cse1_v1e_wo_losv2b/Naviagation Systems/Qualisys 6 DOF/QTM In8", 0, "",
    offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, QTMIn8), BLOCKIO_SIG, 39, 1, 2, 14,
    0 },

  { 8, "ca_cse1_v1e_wo_losv2b/Naviagation Systems/Qualisys 6 DOF/d2r roll", 0,
    "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, d2rroll), BLOCKIO_SIG, 39, 1, 2,
    16, 0 },

  { 9, "ca_cse1_v1e_wo_losv2b/Naviagation Systems/Qualisys 6 DOF/QTM In7", 0, "",
    offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, QTMIn7), BLOCKIO_SIG, 39, 1, 2, 18,
    0 },

  { 10, "ca_cse1_v1e_wo_losv2b/Naviagation Systems/Qualisys 6 DOF/d2r pitch", 0,
    "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, d2rpitch), BLOCKIO_SIG, 39, 1, 2,
    20, 0 },

  { 11, "ca_cse1_v1e_wo_losv2b/Naviagation Systems/Qualisys 6 DOF/QTM In6", 0,
    "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, QTMIn6), BLOCKIO_SIG, 39, 1, 2,
    22, 0 },

  { 12, "ca_cse1_v1e_wo_losv2b/Naviagation Systems/Qualisys 6 DOF/d2r yaw", 0,
    "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, d2ryaw), BLOCKIO_SIG, 39, 1, 2,
    24, 0 },

  { 13, "ca_cse1_v1e_wo_losv2b/HMI/Panel command inputs/Panel  u_1", 0, "",
    offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, Panelu_1), BLOCKIO_SIG, 0, 1, 2, 26,
    0 },

  { 14, "ca_cse1_v1e_wo_losv2b/HMI/Panel command inputs/Panel u_2", 0, "",
    offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, Panelu_2), BLOCKIO_SIG, 0, 1, 2, 28,
    0 },

  { 15, "ca_cse1_v1e_wo_losv2b/HMI/Panel command inputs/Panel u_3", 0, "",
    offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, Panelu_3), BLOCKIO_SIG, 0, 1, 2, 30,
    0 },

  { 16, "ca_cse1_v1e_wo_losv2b/HMI/Panel command inputs/Panel u_4", 0, "",
    offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, Panelu_4), BLOCKIO_SIG, 0, 1, 2, 32,
    0 },

  { 17, "ca_cse1_v1e_wo_losv2b/HMI/Panel command inputs/Panel u_5", 0, "",
    offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, Panelu_5), BLOCKIO_SIG, 0, 1, 2, 34,
    0 },

  { 18, "ca_cse1_v1e_wo_losv2b/HMI/PS3 input/PS3 signals/Scaling_JS_L_Y", 0,
    "[-1,1]", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, u1), BLOCKIO_SIG, 0, 1, 2,
    36, 0 },

  { 19, "ca_cse1_v1e_wo_losv2b/Control Systems/Manual Thrust control/PS3 u_1", 0,
    "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, PS3u_1), BLOCKIO_SIG, 0, 1, 2,
    38, 0 },

  { 20, "ca_cse1_v1e_wo_losv2b/HMI/PS3 input/PS3 signals/Scaling_JS_L_X", 0,
    "[-1,1]", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, u1_p), BLOCKIO_SIG, 0, 1,
    2, 40, 0 },

  { 21, "ca_cse1_v1e_wo_losv2b/Control Systems/Manual Thrust control/PS3 u_2", 0,
    "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, PS3u_2), BLOCKIO_SIG, 0, 1, 2,
    42, 0 },

  { 22, "ca_cse1_v1e_wo_losv2b/HMI/PS3 input/PS3 signals/Scaling_JS_R_Y", 0,
    "[-1,1]", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, u1_a), BLOCKIO_SIG, 0, 1,
    2, 44, 0 },

  { 23, "ca_cse1_v1e_wo_losv2b/Control Systems/Manual Thrust control/PS3 u_3", 0,
    "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, PS3u_3), BLOCKIO_SIG, 0, 1, 2,
    46, 0 },

  { 24, "ca_cse1_v1e_wo_losv2b/HMI/PS3 input/PS3 signals/Scaling_JS_R_X", 0,
    "[-1,1]", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, u1_i), BLOCKIO_SIG, 0, 1,
    2, 48, 0 },

  { 25, "ca_cse1_v1e_wo_losv2b/Control Systems/Manual Thrust control/PS3 u_4", 0,
    "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, PS3u_4), BLOCKIO_SIG, 0, 1, 2,
    50, 0 },

  { 26, "ca_cse1_v1e_wo_losv2b/Control Systems/Manual Thrust control/Add", 0,
    "Bow Thruster direction", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b,
    BowThrusterdirection), BLOCKIO_SIG, 0, 1, 2, 52, 0 },

  { 27, "ca_cse1_v1e_wo_losv2b/Control Systems/Manual Thrust control/PS3 u_5", 0,
    "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, PS3u_5), BLOCKIO_SIG, 0, 1, 2,
    54, 0 },

  { 28,
    "ca_cse1_v1e_wo_losv2b/Control Systems/Joystick Control/K_e/Gain K_e1_joystick",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, GainK_e1_joystick),
    BLOCKIO_SIG, 0, 1, 2, 56, 0 },

  { 29,
    "ca_cse1_v1e_wo_losv2b/Control Systems/Joystick Control/K_e/Gain K_e2_joystick",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, GainK_e2_joystick),
    BLOCKIO_SIG, 0, 1, 2, 58, 0 },

  { 30,
    "ca_cse1_v1e_wo_losv2b/Control Systems/Joystick Control/K_e/Gain K_e3_joystick",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, GainK_e3_joystick),
    BLOCKIO_SIG, 0, 1, 2, 60, 0 },

  { 31,
    "ca_cse1_v1e_wo_losv2b/Control Systems/Joystick Control/K_e/Gain K_e4_joystick",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, GainK_e4_joystick),
    BLOCKIO_SIG, 0, 1, 2, 62, 0 },

  { 32,
    "ca_cse1_v1e_wo_losv2b/Control Systems/Joystick Control/K_e/Gain K_e5_joystick",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, GainK_e5_joystick),
    BLOCKIO_SIG, 0, 1, 2, 64, 0 },

  { 33,
    "ca_cse1_v1e_wo_losv2b/Control Systems/Joystick Control/K_e/Thruster Gain matrix",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, ThrusterGainmatrix),
    BLOCKIO_SIG, 25, 25, 2, 66, 0 },

  { 34, "ca_cse1_v1e_wo_losv2b/Control Systems/Joystick Control/K_e^-1", 0, "",
    offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, K_e1), BLOCKIO_SIG, 25, 25, 2, 68, 0
  },

  { 35, "ca_cse1_v1e_wo_losv2b/Control Systems/Joystick Control/T_e/-l_x1", 0,
    "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, l_x1), BLOCKIO_SIG, 0, 1, 2, 70,
    0 },

  { 36, "ca_cse1_v1e_wo_losv2b/Control Systems/Joystick Control/T_e/-l_y2", 0,
    "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, l_y2), BLOCKIO_SIG, 0, 1, 2, 72,
    0 },

  { 37, "ca_cse1_v1e_wo_losv2b/Control Systems/Joystick Control/T_e/-l_x2", 0,
    "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, l_x2), BLOCKIO_SIG, 0, 1, 2, 74,
    0 },

  { 38, "ca_cse1_v1e_wo_losv2b/Control Systems/Joystick Control/T_e/3x5", 0, "",
    offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, x5), BLOCKIO_SIG, 29, 15, 2, 76, 0 },

  { 39, "ca_cse1_v1e_wo_losv2b/Control Systems/Joystick Control/T_e^+", 0, "",
    offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, T_e), BLOCKIO_SIG, 28, 15, 2, 78, 0
  },

  { 40, "ca_cse1_v1e_wo_losv2b/Control Systems/Joystick Control/T_e^+ K_e^-1", 0,
    "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, T_eK_e1), BLOCKIO_SIG, 28, 15, 2,
    80, 0 },

  { 41, "ca_cse1_v1e_wo_losv2b/Control Systems/Joystick Control/Sum1", 0, "",
    offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, Sum1), BLOCKIO_SIG, 0, 1, 2, 82, 0 },

  { 42,
    "ca_cse1_v1e_wo_losv2b/Control Systems/Joystick Control/Joystick tau_surge",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, Joysticktau_surge),
    BLOCKIO_SIG, 0, 1, 2, 84, 0 },

  { 43, "ca_cse1_v1e_wo_losv2b/Control Systems/Joystick Control/Saturation1", 0,
    "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, Saturation1), BLOCKIO_SIG, 0, 1,
    2, 86, 0 },

  { 44, "ca_cse1_v1e_wo_losv2b/Control Systems/Joystick Control/Sum2", 0, "",
    offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, Sum2), BLOCKIO_SIG, 0, 1, 2, 88, 0 },

  { 45,
    "ca_cse1_v1e_wo_losv2b/Control Systems/Joystick Control/Joystick tau_sway",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, Joysticktau_sway),
    BLOCKIO_SIG, 0, 1, 2, 90, 0 },

  { 46, "ca_cse1_v1e_wo_losv2b/Control Systems/Joystick Control/Saturation2", 0,
    "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, Saturation2), BLOCKIO_SIG, 0, 1,
    2, 92, 0 },

  { 47, "ca_cse1_v1e_wo_losv2b/Control Systems/Joystick Control/Sum", 0, "",
    offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, Sum), BLOCKIO_SIG, 0, 1, 2, 94, 0 },

  { 48,
    "ca_cse1_v1e_wo_losv2b/Control Systems/Joystick Control/Joystick tau_yaw", 0,
    "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, Joysticktau_yaw), BLOCKIO_SIG, 0,
    1, 2, 96, 0 },

  { 49, "ca_cse1_v1e_wo_losv2b/Control Systems/Joystick Control/Saturation3", 0,
    "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, Saturation3), BLOCKIO_SIG, 0, 1,
    2, 98, 0 },

  { 50, "ca_cse1_v1e_wo_losv2b/Control Systems/Joystick Control/Product1", 0, "",
    offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, Product1), BLOCKIO_SIG, 18, 5, 2,
    100, 0 },

  { 51, "ca_cse1_v1e_wo_losv2b/Control Systems/Joystick Control/Saturation", 0,
    "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, Saturation), BLOCKIO_SIG, 18, 5,
    2, 102, 0 },

  { 52, "ca_cse1_v1e_wo_losv2b/Control Systems/Joystick Control/Joystick u_1", 0,
    "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, Joysticku_1), BLOCKIO_SIG, 0, 1,
    2, 104, 0 },

  { 53, "ca_cse1_v1e_wo_losv2b/Control Systems/Joystick Control/Joystick u_2", 0,
    "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, Joysticku_2), BLOCKIO_SIG, 0, 1,
    2, 106, 0 },

  { 54, "ca_cse1_v1e_wo_losv2b/Control Systems/Joystick Control/Joystick u_3", 0,
    "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, Joysticku_3), BLOCKIO_SIG, 0, 1,
    2, 108, 0 },

  { 55, "ca_cse1_v1e_wo_losv2b/Control Systems/Joystick Control/Joystick u_4", 0,
    "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, Joysticku_4), BLOCKIO_SIG, 0, 1,
    2, 110, 0 },

  { 56, "ca_cse1_v1e_wo_losv2b/Control Systems/Joystick Control/Joystick u_5", 0,
    "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, Joysticku_5), BLOCKIO_SIG, 0, 1,
    2, 112, 0 },

  { 57, "ca_cse1_v1e_wo_losv2b/HMI/DP input/Degrees to Radians/Gain1", 0, "",
    offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, Gain1), BLOCKIO_SIG, 0, 1, 2, 114, 0
  },

  { 58, "ca_cse1_v1e_wo_losv2b/Guidance Systems/DP/Transfer Fcn", 0, "",
    offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, TransferFcn), BLOCKIO_SIG, 0, 1, 2,
    116, 0 },

  { 59, "ca_cse1_v1e_wo_losv2b/Guidance Systems/DP/Transfer Fcn1", 0, "",
    offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, TransferFcn1), BLOCKIO_SIG, 0, 1, 2,
    118, 0 },

  { 60, "ca_cse1_v1e_wo_losv2b/Guidance Systems/DP/Transfer Fcn2", 0, "",
    offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, TransferFcn2), BLOCKIO_SIG, 0, 1, 2,
    120, 0 },

  { 61, "ca_cse1_v1e_wo_losv2b/Guidance Systems/DP/Multiport Switch", 0, "",
    offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, MultiportSwitch), BLOCKIO_SIG, 17, 3,
    2, 122, 0 },

  { 62, "ca_cse1_v1e_wo_losv2b/Guidance Systems/DP/eta_d DP N", 0, "", offsetof
    (BlockIO_CA_CSE1_V1e_wo_LOSV2b, eta_dDPN), BLOCKIO_SIG, 0, 1, 2, 124, 0 },

  { 63, "ca_cse1_v1e_wo_losv2b/Guidance Systems/DP/eta_d DP E", 0, "", offsetof
    (BlockIO_CA_CSE1_V1e_wo_LOSV2b, eta_dDPE), BLOCKIO_SIG, 0, 1, 2, 126, 0 },

  { 64, "ca_cse1_v1e_wo_losv2b/Guidance Systems/DP/eta_d DP Psi", 0, "",
    offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, eta_dDPPsi), BLOCKIO_SIG, 0, 1, 2,
    128, 0 },

  { 65, "ca_cse1_v1e_wo_losv2b/Naviagation Systems/Eta Switch", 0, "", offsetof
    (BlockIO_CA_CSE1_V1e_wo_LOSV2b, EtaSwitch), BLOCKIO_SIG, 17, 3, 2, 130, 0 },

  { 66, "ca_cse1_v1e_wo_losv2b/Naviagation Systems/eta_surge", 0, "", offsetof
    (BlockIO_CA_CSE1_V1e_wo_LOSV2b, eta_surge), BLOCKIO_SIG, 0, 1, 2, 132, 0 },

  { 67, "ca_cse1_v1e_wo_losv2b/Naviagation Systems/eta_sway", 0, "", offsetof
    (BlockIO_CA_CSE1_V1e_wo_LOSV2b, eta_sway), BLOCKIO_SIG, 0, 1, 2, 134, 0 },

  { 68, "ca_cse1_v1e_wo_losv2b/Naviagation Systems/eta_yaw", 0, "", offsetof
    (BlockIO_CA_CSE1_V1e_wo_LOSV2b, eta_yaw), BLOCKIO_SIG, 0, 1, 2, 136, 0 },

  { 69,
    "ca_cse1_v1e_wo_losv2b/Naviagation Systems/Qualisys 6 DOF/Euler angles to inverse rotation matrix/sin(theta)",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, sintheta), BLOCKIO_SIG, 17, 3,
    2, 138, 0 },

  { 70,
    "ca_cse1_v1e_wo_losv2b/Naviagation Systems/Qualisys 6 DOF/Euler angles to inverse rotation matrix/cos(theta)",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, costheta), BLOCKIO_SIG, 17, 3,
    2, 140, 0 },

  { 71,
    "ca_cse1_v1e_wo_losv2b/Naviagation Systems/Qualisys 6 DOF/Euler angles to inverse rotation matrix/R11",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, R11), BLOCKIO_SIG, 0, 1, 2,
    142, 0 },

  { 72,
    "ca_cse1_v1e_wo_losv2b/Naviagation Systems/Qualisys 6 DOF/Euler angles to inverse rotation matrix/R21",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, R21), BLOCKIO_SIG, 0, 1, 2,
    144, 0 },

  { 73,
    "ca_cse1_v1e_wo_losv2b/Naviagation Systems/Qualisys 6 DOF/Euler angles to inverse rotation matrix/R31",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, R31), BLOCKIO_SIG, 0, 1, 2,
    146, 0 },

  { 74,
    "ca_cse1_v1e_wo_losv2b/Naviagation Systems/Qualisys 6 DOF/Euler angles to inverse rotation matrix/R12",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, R12), BLOCKIO_SIG, 0, 1, 2,
    148, 0 },

  { 75,
    "ca_cse1_v1e_wo_losv2b/Naviagation Systems/Qualisys 6 DOF/Euler angles to inverse rotation matrix/R22",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, R22), BLOCKIO_SIG, 0, 1, 2,
    150, 0 },

  { 76,
    "ca_cse1_v1e_wo_losv2b/Naviagation Systems/Qualisys 6 DOF/Euler angles to inverse rotation matrix/R32",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, R32), BLOCKIO_SIG, 0, 1, 2,
    152, 0 },

  { 77,
    "ca_cse1_v1e_wo_losv2b/Naviagation Systems/Qualisys 6 DOF/Euler angles to inverse rotation matrix/R13",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, R13), BLOCKIO_SIG, 0, 1, 2,
    154, 0 },

  { 78,
    "ca_cse1_v1e_wo_losv2b/Naviagation Systems/Qualisys 6 DOF/Euler angles to inverse rotation matrix/R23",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, R23), BLOCKIO_SIG, 0, 1, 2,
    156, 0 },

  { 79,
    "ca_cse1_v1e_wo_losv2b/Naviagation Systems/Qualisys 6 DOF/Euler angles to inverse rotation matrix/R33",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, R33), BLOCKIO_SIG, 0, 1, 2,
    158, 0 },

  { 80,
    "ca_cse1_v1e_wo_losv2b/Naviagation Systems/Qualisys 6 DOF/Euler angles to inverse rotation matrix/Reshape 9x1->3x3",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, Reshape9x13x3), BLOCKIO_SIG,
    33, 9, 2, 160, 0 },

  { 81,
    "ca_cse1_v1e_wo_losv2b/Naviagation Systems/Qualisys 6 DOF/Matrix Concatenate2",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, MatrixConcatenate2),
    BLOCKIO_SIG, 42, 36, 2, 162, 0 },

  { 82, "ca_cse1_v1e_wo_losv2b/Naviagation Systems/Qualisys 6 DOF/Derivative", 0,
    "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, Derivative), BLOCKIO_SIG, 19, 6,
    2, 164, 0 },

  { 83, "ca_cse1_v1e_wo_losv2b/Naviagation Systems/Qualisys 6 DOF/Product", 0,
    "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, Product), BLOCKIO_SIG, 19, 6, 2,
    166, 0 },

  { 84, "ca_cse1_v1e_wo_losv2b/Naviagation Systems/Nu Switch", 0, "", offsetof
    (BlockIO_CA_CSE1_V1e_wo_LOSV2b, NuSwitch), BLOCKIO_SIG, 17, 3, 2, 168, 0 },

  { 85, "ca_cse1_v1e_wo_losv2b/Naviagation Systems/nu_surge", 0, "", offsetof
    (BlockIO_CA_CSE1_V1e_wo_LOSV2b, nu_surge), BLOCKIO_SIG, 0, 1, 2, 170, 0 },

  { 86, "ca_cse1_v1e_wo_losv2b/Naviagation Systems/nu_sway", 0, "", offsetof
    (BlockIO_CA_CSE1_V1e_wo_LOSV2b, nu_sway), BLOCKIO_SIG, 0, 1, 2, 172, 0 },

  { 87, "ca_cse1_v1e_wo_losv2b/Naviagation Systems/nu_yaw", 0, "", offsetof
    (BlockIO_CA_CSE1_V1e_wo_LOSV2b, nu_yaw), BLOCKIO_SIG, 0, 1, 2, 174, 0 },

  { 88,
    "ca_cse1_v1e_wo_losv2b/Control Systems/Maneuvering controller/K_e/Gain K_e1_DP",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, GainK_e1_DP), BLOCKIO_SIG, 0,
    1, 2, 176, 0 },

  { 89,
    "ca_cse1_v1e_wo_losv2b/Control Systems/Maneuvering controller/K_e/Gain K_e2_DP",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, GainK_e2_DP), BLOCKIO_SIG, 0,
    1, 2, 178, 0 },

  { 90,
    "ca_cse1_v1e_wo_losv2b/Control Systems/Maneuvering controller/K_e/Gain K_e3_DP",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, GainK_e3_DP), BLOCKIO_SIG, 0,
    1, 2, 180, 0 },

  { 91,
    "ca_cse1_v1e_wo_losv2b/Control Systems/Maneuvering controller/K_e/Gain K_e4_DP",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, GainK_e4_DP), BLOCKIO_SIG, 0,
    1, 2, 182, 0 },

  { 92,
    "ca_cse1_v1e_wo_losv2b/Control Systems/Maneuvering controller/K_e/Gain K_e5_DP",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, GainK_e5_DP), BLOCKIO_SIG, 0,
    1, 2, 184, 0 },

  { 93,
    "ca_cse1_v1e_wo_losv2b/Control Systems/Maneuvering controller/K_e/Thruster Gain matrix",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, ThrusterGainmatrix_c),
    BLOCKIO_SIG, 25, 25, 2, 186, 0 },

  { 94, "ca_cse1_v1e_wo_losv2b/Control Systems/Maneuvering controller/K_e^-1", 0,
    "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, K_e1_h), BLOCKIO_SIG, 25, 25, 2,
    188, 0 },

  { 95, "ca_cse1_v1e_wo_losv2b/Control Systems/Maneuvering controller/T_e/-l_x1",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, l_x1_o), BLOCKIO_SIG, 0, 1, 2,
    190, 0 },

  { 96, "ca_cse1_v1e_wo_losv2b/Control Systems/Maneuvering controller/T_e/-l_y2",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, l_y2_g), BLOCKIO_SIG, 0, 1, 2,
    192, 0 },

  { 97, "ca_cse1_v1e_wo_losv2b/Control Systems/Maneuvering controller/T_e/-l_x2",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, l_x2_i), BLOCKIO_SIG, 0, 1, 2,
    194, 0 },

  { 98, "ca_cse1_v1e_wo_losv2b/Control Systems/Maneuvering controller/T_e/3x5",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, x5_p), BLOCKIO_SIG, 29, 15, 2,
    196, 0 },

  { 99, "ca_cse1_v1e_wo_losv2b/Control Systems/Maneuvering controller/T_e^+", 0,
    "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, T_e_j), BLOCKIO_SIG, 28, 15, 2,
    198, 0 },

  { 100, "ca_cse1_v1e_wo_losv2b/Control Systems/Maneuvering controller/Product",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, Product_h), BLOCKIO_SIG, 28,
    15, 2, 200, 0 },

  { 101,
    "ca_cse1_v1e_wo_losv2b/Guidance Systems/Path generator (iceberg towing)/N_d1/Step",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, Step), BLOCKIO_SIG, 0, 1, 2,
    202, 0 },

  { 102,
    "ca_cse1_v1e_wo_losv2b/Guidance Systems/Path generator (iceberg towing)/N_d1/Clock",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, Clock), BLOCKIO_SIG, 0, 1, 2,
    204, 0 },

  { 103,
    "ca_cse1_v1e_wo_losv2b/Guidance Systems/Path generator (iceberg towing)/N_d1/Sum",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, Sum_m), BLOCKIO_SIG, 0, 1, 2,
    206, 0 },

  { 104,
    "ca_cse1_v1e_wo_losv2b/Guidance Systems/Path generator (iceberg towing)/N_d1/Product",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, Product_c), BLOCKIO_SIG, 0, 1,
    2, 208, 0 },

  { 105,
    "ca_cse1_v1e_wo_losv2b/Guidance Systems/Path generator (iceberg towing)/N_d1/Output",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, Output), BLOCKIO_SIG, 0, 1, 2,
    210, 0 },

  { 106,
    "ca_cse1_v1e_wo_losv2b/Guidance Systems/Path generator (iceberg towing)/E_d/Step",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, Step_f), BLOCKIO_SIG, 0, 1, 2,
    212, 0 },

  { 107,
    "ca_cse1_v1e_wo_losv2b/Guidance Systems/Path generator (iceberg towing)/E_d/Clock",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, Clock_o), BLOCKIO_SIG, 0, 1,
    2, 214, 0 },

  { 108,
    "ca_cse1_v1e_wo_losv2b/Guidance Systems/Path generator (iceberg towing)/E_d/Sum",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, Sum_o), BLOCKIO_SIG, 0, 1, 2,
    216, 0 },

  { 109,
    "ca_cse1_v1e_wo_losv2b/Guidance Systems/Path generator (iceberg towing)/E_d/Product",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, Product_d), BLOCKIO_SIG, 0, 1,
    2, 218, 0 },

  { 110,
    "ca_cse1_v1e_wo_losv2b/Guidance Systems/Path generator (iceberg towing)/E_d/Output",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, Output_m), BLOCKIO_SIG, 0, 1,
    2, 220, 0 },

  { 111,
    "ca_cse1_v1e_wo_losv2b/Guidance Systems/Path generator (iceberg towing)/eta_d_theta maker/Memory2",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, Memory2), BLOCKIO_SIG, 0, 1,
    2, 222, 0 },

  { 112,
    "ca_cse1_v1e_wo_losv2b/Guidance Systems/Path generator (iceberg towing)/eta_d_theta maker/Sum2",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, Sum2_f), BLOCKIO_SIG, 0, 1, 2,
    224, 0 },

  { 113,
    "ca_cse1_v1e_wo_losv2b/Guidance Systems/Path generator (iceberg towing)/eta_d_theta maker/Memory1",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, Memory1), BLOCKIO_SIG, 0, 1,
    2, 226, 0 },

  { 114,
    "ca_cse1_v1e_wo_losv2b/Control Systems/Maneuvering controller/Path controller/theta maker/Integrator",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, Integrator), BLOCKIO_SIG, 0,
    1, 2, 228, 0 },

  { 115,
    "ca_cse1_v1e_wo_losv2b/Guidance Systems/Path generator (iceberg towing)/eta_d_theta maker/Sum1",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, Sum1_h), BLOCKIO_SIG, 0, 1, 2,
    230, 0 },

  { 116,
    "ca_cse1_v1e_wo_losv2b/Guidance Systems/Path generator (iceberg towing)/eta_d_theta maker/Divide1",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, Divide1), BLOCKIO_SIG, 0, 1,
    2, 232, 0 },

  { 117,
    "ca_cse1_v1e_wo_losv2b/Guidance Systems/Path generator (iceberg towing)/eta_d_theta maker/Memory",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, Memory), BLOCKIO_SIG, 0, 1, 2,
    234, 0 },

  { 118,
    "ca_cse1_v1e_wo_losv2b/Guidance Systems/Path generator (iceberg towing)/eta_d_theta maker/Sum",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, Sum_g), BLOCKIO_SIG, 0, 1, 2,
    236, 0 },

  { 119,
    "ca_cse1_v1e_wo_losv2b/Guidance Systems/Path generator (iceberg towing)/eta_d_theta maker/Divide",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, Divide), BLOCKIO_SIG, 0, 1, 2,
    238, 0 },

  { 120,
    "ca_cse1_v1e_wo_losv2b/Guidance Systems/Path generator (iceberg towing)/eta_d_theta maker/trigfun1",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, trigfun1), BLOCKIO_SIG, 0, 1,
    2, 240, 0 },

  { 121,
    "ca_cse1_v1e_wo_losv2b/Control Systems/Maneuvering controller/Path controller/z_1/Sum",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, Sum_b), BLOCKIO_SIG, 17, 3, 2,
    242, 0 },

  { 122,
    "ca_cse1_v1e_wo_losv2b/Control Systems/Maneuvering controller/Path controller/z_1/Transposed rotation  matrix in yaw/Row1",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, Row1), BLOCKIO_SIG, 0, 1, 2,
    244, 0 },

  { 123,
    "ca_cse1_v1e_wo_losv2b/Control Systems/Maneuvering controller/Path controller/z_1/Transposed rotation  matrix in yaw/Row2",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, Row2), BLOCKIO_SIG, 0, 1, 2,
    246, 0 },

  { 124,
    "ca_cse1_v1e_wo_losv2b/Control Systems/Maneuvering controller/Path controller/z_1/Transposed rotation  matrix in yaw/Row3",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, Row3), BLOCKIO_SIG, 0, 1, 2,
    248, 0 },

  { 125,
    "ca_cse1_v1e_wo_losv2b/Control Systems/Maneuvering controller/Path controller/alpha_1/K_p",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, K_p), BLOCKIO_SIG, 17, 3, 2,
    250, 0 },

  { 126,
    "ca_cse1_v1e_wo_losv2b/Guidance Systems/Path generator (iceberg towing)/eta_d_theta maker/Memory3",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, Memory3), BLOCKIO_SIG, 0, 1,
    2, 252, 0 },

  { 127,
    "ca_cse1_v1e_wo_losv2b/Guidance Systems/Path generator (iceberg towing)/eta_d_theta maker/Sum3",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, Sum3), BLOCKIO_SIG, 0, 1, 2,
    254, 0 },

  { 128,
    "ca_cse1_v1e_wo_losv2b/Guidance Systems/Path generator (iceberg towing)/eta_d_theta maker/Divide2",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, Divide2), BLOCKIO_SIG, 0, 1,
    2, 256, 0 },

  { 129,
    "ca_cse1_v1e_wo_losv2b/Control Systems/Maneuvering controller/Path controller/alpha_1/Transposed rotation  matrix in yaw/Row1",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, Row1_f), BLOCKIO_SIG, 0, 1, 2,
    258, 0 },

  { 130,
    "ca_cse1_v1e_wo_losv2b/Control Systems/Maneuvering controller/Path controller/alpha_1/Transposed rotation  matrix in yaw/Row2",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, Row2_o), BLOCKIO_SIG, 0, 1, 2,
    260, 0 },

  { 131,
    "ca_cse1_v1e_wo_losv2b/Control Systems/Maneuvering controller/Path controller/alpha_1/Transposed rotation  matrix in yaw/Row3",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, Row3_n), BLOCKIO_SIG, 0, 1, 2,
    262, 0 },

  { 132,
    "ca_cse1_v1e_wo_losv2b/Guidance Systems/Path generator (iceberg towing)/v_s and v_s_t maker/mf1",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, mf1), BLOCKIO_SIG, 0, 1, 2,
    264, 0 },

  { 133,
    "ca_cse1_v1e_wo_losv2b/Guidance Systems/Path generator (iceberg towing)/v_s and v_s_t maker/mf2",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, mf2), BLOCKIO_SIG, 0, 1, 2,
    266, 0 },

  { 134,
    "ca_cse1_v1e_wo_losv2b/Guidance Systems/Path generator (iceberg towing)/v_s and v_s_t maker/Sum",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, Sum_j), BLOCKIO_SIG, 0, 1, 2,
    268, 0 },

  { 135,
    "ca_cse1_v1e_wo_losv2b/Guidance Systems/Path generator (iceberg towing)/v_s and v_s_t maker/Sqrt",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, Sqrt), BLOCKIO_SIG, 0, 1, 2,
    270, 0 },

  { 136,
    "ca_cse1_v1e_wo_losv2b/Guidance Systems/Path generator (iceberg towing)/v_s and v_s_t maker/Divide1",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, Divide1_o), BLOCKIO_SIG, 0, 1,
    2, 272, 0 },

  { 137,
    "ca_cse1_v1e_wo_losv2b/Control Systems/Maneuvering controller/Path controller/alpha_1/Product1",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, Product1_o), BLOCKIO_SIG, 17,
    3, 2, 274, 0 },

  { 138,
    "ca_cse1_v1e_wo_losv2b/Control Systems/Maneuvering controller/Path controller/alpha_1/Sum",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, Sum_e), BLOCKIO_SIG, 17, 3, 2,
    276, 0 },

  { 139,
    "ca_cse1_v1e_wo_losv2b/Control Systems/Maneuvering controller/Path controller/z_2/Sum",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, Sum_ei), BLOCKIO_SIG, 17, 3,
    2, 278, 0 },

  { 140,
    "ca_cse1_v1e_wo_losv2b/Control Systems/Maneuvering controller/Path controller/tau_s/K_d",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, K_d), BLOCKIO_SIG, 17, 3, 2,
    280, 0 },

  { 141,
    "ca_cse1_v1e_wo_losv2b/Control Systems/Maneuvering controller/Path controller/tau_s/D_s",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, D_s), BLOCKIO_SIG, 17, 3, 2,
    282, 0 },

  { 142,
    "ca_cse1_v1e_wo_losv2b/Control Systems/Maneuvering controller/Path controller/sigma_1/S",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, S), BLOCKIO_SIG, 17, 3, 2,
    284, 0 },

  { 143,
    "ca_cse1_v1e_wo_losv2b/Control Systems/Maneuvering controller/Path controller/sigma_1/Product1",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, Product1_o0), BLOCKIO_SIG, 17,
    3, 2, 286, 0 },

  { 144,
    "ca_cse1_v1e_wo_losv2b/Control Systems/Maneuvering controller/Path controller/sigma_1/Sum1",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, Sum1_b), BLOCKIO_SIG, 17, 3,
    2, 288, 0 },

  { 145,
    "ca_cse1_v1e_wo_losv2b/Control Systems/Maneuvering controller/Path controller/sigma_1/K_p",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, K_p_n), BLOCKIO_SIG, 17, 3, 2,
    290, 0 },

  { 146,
    "ca_cse1_v1e_wo_losv2b/Control Systems/Maneuvering controller/Path controller/sigma_1/R^T (psi_i)/Row1",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, Row1_g), BLOCKIO_SIG, 0, 1, 2,
    292, 0 },

  { 147,
    "ca_cse1_v1e_wo_losv2b/Control Systems/Maneuvering controller/Path controller/sigma_1/R^T (psi_i)/Row2",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, Row2_m), BLOCKIO_SIG, 0, 1, 2,
    294, 0 },

  { 148,
    "ca_cse1_v1e_wo_losv2b/Control Systems/Maneuvering controller/Path controller/sigma_1/R^T (psi_i)/Row3",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, Row3_p), BLOCKIO_SIG, 0, 1, 2,
    296, 0 },

  { 149,
    "ca_cse1_v1e_wo_losv2b/Control Systems/Maneuvering controller/Path controller/sigma_1/Product6",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, Product6), BLOCKIO_SIG, 17, 3,
    2, 298, 0 },

  { 150,
    "ca_cse1_v1e_wo_losv2b/Control Systems/Maneuvering controller/Path controller/sigma_1/Product5",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, Product5), BLOCKIO_SIG, 17, 3,
    2, 300, 0 },

  { 151,
    "ca_cse1_v1e_wo_losv2b/Guidance Systems/Path generator (iceberg towing)/v_s and v_s_t maker/Derivative",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, Derivative_o), BLOCKIO_SIG, 0,
    1, 2, 302, 0 },

  { 152,
    "ca_cse1_v1e_wo_losv2b/Guidance Systems/Path generator (iceberg towing)/v_s and v_s_t maker/Divide",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, Divide_g), BLOCKIO_SIG, 0, 1,
    2, 304, 0 },

  { 153,
    "ca_cse1_v1e_wo_losv2b/Control Systems/Maneuvering controller/Path controller/sigma_1/Product3",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, Product3), BLOCKIO_SIG, 17, 3,
    2, 306, 0 },

  { 154,
    "ca_cse1_v1e_wo_losv2b/Control Systems/Maneuvering controller/Path controller/sigma_1/Sum",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, Sum_jh), BLOCKIO_SIG, 17, 3,
    2, 308, 0 },

  { 155,
    "ca_cse1_v1e_wo_losv2b/Control Systems/Maneuvering controller/Path controller/tau_s/M_s",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, M_s), BLOCKIO_SIG, 17, 3, 2,
    310, 0 },

  { 156,
    "ca_cse1_v1e_wo_losv2b/Control Systems/Maneuvering controller/Path controller/alpha_1_theta/R^T (psi_i)/Row1",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, Row1_n), BLOCKIO_SIG, 0, 1, 2,
    312, 0 },

  { 157,
    "ca_cse1_v1e_wo_losv2b/Control Systems/Maneuvering controller/Path controller/alpha_1_theta/R^T (psi_i)/Row2",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, Row2_i), BLOCKIO_SIG, 0, 1, 2,
    314, 0 },

  { 158,
    "ca_cse1_v1e_wo_losv2b/Control Systems/Maneuvering controller/Path controller/alpha_1_theta/R^T (psi_i)/Row3",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, Row3_d), BLOCKIO_SIG, 0, 1, 2,
    316, 0 },

  { 159,
    "ca_cse1_v1e_wo_losv2b/Control Systems/Maneuvering controller/Path controller/alpha_1_theta/K_p",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, K_p_f), BLOCKIO_SIG, 17, 3, 2,
    318, 0 },

  { 160,
    "ca_cse1_v1e_wo_losv2b/Guidance Systems/Path generator (iceberg towing)/eta_d_theta2 maker/Memory",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, Memory_n), BLOCKIO_SIG, 0, 1,
    2, 320, 0 },

  { 161,
    "ca_cse1_v1e_wo_losv2b/Guidance Systems/Path generator (iceberg towing)/eta_d_theta2 maker/Sum",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, Sum_n), BLOCKIO_SIG, 0, 1, 2,
    322, 0 },

  { 162,
    "ca_cse1_v1e_wo_losv2b/Guidance Systems/Path generator (iceberg towing)/eta_d_theta2 maker/Memory1",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, Memory1_o), BLOCKIO_SIG, 0, 1,
    2, 324, 0 },

  { 163,
    "ca_cse1_v1e_wo_losv2b/Guidance Systems/Path generator (iceberg towing)/eta_d_theta2 maker/Sum1",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, Sum1_c), BLOCKIO_SIG, 0, 1, 2,
    326, 0 },

  { 164,
    "ca_cse1_v1e_wo_losv2b/Guidance Systems/Path generator (iceberg towing)/eta_d_theta2 maker/Divide",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, Divide_d), BLOCKIO_SIG, 0, 1,
    2, 328, 0 },

  { 165,
    "ca_cse1_v1e_wo_losv2b/Guidance Systems/Path generator (iceberg towing)/v_s_theta maker/Product",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, Product_p), BLOCKIO_SIG, 0, 1,
    2, 330, 0 },

  { 166,
    "ca_cse1_v1e_wo_losv2b/Guidance Systems/Path generator (iceberg towing)/eta_d_theta2 maker/Memory2",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, Memory2_k), BLOCKIO_SIG, 0, 1,
    2, 332, 0 },

  { 167,
    "ca_cse1_v1e_wo_losv2b/Guidance Systems/Path generator (iceberg towing)/eta_d_theta2 maker/Sum2",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, Sum2_m), BLOCKIO_SIG, 0, 1, 2,
    334, 0 },

  { 168,
    "ca_cse1_v1e_wo_losv2b/Guidance Systems/Path generator (iceberg towing)/eta_d_theta2 maker/Divide1",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, Divide1_m), BLOCKIO_SIG, 0, 1,
    2, 336, 0 },

  { 169,
    "ca_cse1_v1e_wo_losv2b/Guidance Systems/Path generator (iceberg towing)/v_s_theta maker/Product1",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, Product1_g), BLOCKIO_SIG, 0,
    1, 2, 338, 0 },

  { 170,
    "ca_cse1_v1e_wo_losv2b/Guidance Systems/Path generator (iceberg towing)/v_s_theta maker/Sum",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, Sum_k), BLOCKIO_SIG, 0, 1, 2,
    340, 0 },

  { 171,
    "ca_cse1_v1e_wo_losv2b/Guidance Systems/Path generator (iceberg towing)/v_s_theta maker/Gain",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, Gain), BLOCKIO_SIG, 0, 1, 2,
    342, 0 },

  { 172,
    "ca_cse1_v1e_wo_losv2b/Guidance Systems/Path generator (iceberg towing)/v_s_theta maker/mf1",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, mf1_f), BLOCKIO_SIG, 0, 1, 2,
    344, 0 },

  { 173,
    "ca_cse1_v1e_wo_losv2b/Guidance Systems/Path generator (iceberg towing)/v_s_theta maker/mf2",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, mf2_b), BLOCKIO_SIG, 0, 1, 2,
    346, 0 },

  { 174,
    "ca_cse1_v1e_wo_losv2b/Guidance Systems/Path generator (iceberg towing)/v_s_theta maker/Sum1",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, Sum1_p), BLOCKIO_SIG, 0, 1, 2,
    348, 0 },

  { 175,
    "ca_cse1_v1e_wo_losv2b/Guidance Systems/Path generator (iceberg towing)/v_s_theta maker/mf3",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, mf3), BLOCKIO_SIG, 0, 1, 2,
    350, 0 },

  { 176,
    "ca_cse1_v1e_wo_losv2b/Guidance Systems/Path generator (iceberg towing)/v_s_theta maker/IC",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, IC), BLOCKIO_SIG, 0, 1, 2,
    352, 0 },

  { 177,
    "ca_cse1_v1e_wo_losv2b/Guidance Systems/Path generator (iceberg towing)/v_s_theta maker/Divide",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, Divide_a), BLOCKIO_SIG, 0, 1,
    2, 354, 0 },

  { 178,
    "ca_cse1_v1e_wo_losv2b/Guidance Systems/Path generator (iceberg towing)/v_s_theta maker/Product2",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, Product2), BLOCKIO_SIG, 0, 1,
    2, 356, 0 },

  { 179,
    "ca_cse1_v1e_wo_losv2b/Control Systems/Maneuvering controller/Path controller/alpha_1_theta/Product2",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, Product2_e), BLOCKIO_SIG, 17,
    3, 2, 358, 0 },

  { 180,
    "ca_cse1_v1e_wo_losv2b/Guidance Systems/Path generator (iceberg towing)/eta_d_theta2 maker/Memory3",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, Memory3_c), BLOCKIO_SIG, 0, 1,
    2, 360, 0 },

  { 181,
    "ca_cse1_v1e_wo_losv2b/Guidance Systems/Path generator (iceberg towing)/eta_d_theta2 maker/Sum3",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, Sum3_g), BLOCKIO_SIG, 0, 1, 2,
    362, 0 },

  { 182,
    "ca_cse1_v1e_wo_losv2b/Guidance Systems/Path generator (iceberg towing)/eta_d_theta2 maker/Divide2",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, Divide2_o), BLOCKIO_SIG, 0, 1,
    2, 364, 0 },

  { 183,
    "ca_cse1_v1e_wo_losv2b/Control Systems/Maneuvering controller/Path controller/alpha_1_theta/Product1",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, Product1_o3), BLOCKIO_SIG, 17,
    3, 2, 366, 0 },

  { 184,
    "ca_cse1_v1e_wo_losv2b/Control Systems/Maneuvering controller/Path controller/alpha_1_theta/Sum1",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, Sum1_a), BLOCKIO_SIG, 17, 3,
    2, 368, 0 },

  { 185,
    "ca_cse1_v1e_wo_losv2b/Control Systems/Maneuvering controller/Path controller/alpha_1_theta/R^T (psi_i)1/Row1",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, Row1_k), BLOCKIO_SIG, 0, 1, 2,
    370, 0 },

  { 186,
    "ca_cse1_v1e_wo_losv2b/Control Systems/Maneuvering controller/Path controller/alpha_1_theta/R^T (psi_i)1/Row2",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, Row2_iy), BLOCKIO_SIG, 0, 1,
    2, 372, 0 },

  { 187,
    "ca_cse1_v1e_wo_losv2b/Control Systems/Maneuvering controller/Path controller/alpha_1_theta/R^T (psi_i)1/Row3",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, Row3_k), BLOCKIO_SIG, 0, 1, 2,
    374, 0 },

  { 188,
    "ca_cse1_v1e_wo_losv2b/Control Systems/Maneuvering controller/Path controller/alpha_1_theta/Sum",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, Sum_mm), BLOCKIO_SIG, 17, 3,
    2, 376, 0 },

  { 189,
    "ca_cse1_v1e_wo_losv2b/Control Systems/Maneuvering controller/Path controller/theta maker/t1/Math Function",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, MathFunction), BLOCKIO_SIG,
    34, 3, 2, 378, 0 },

  { 190,
    "ca_cse1_v1e_wo_losv2b/Control Systems/Maneuvering controller/Path controller/theta maker/Transposed rotation  matrix in yaw/Row1",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, Row1_j), BLOCKIO_SIG, 0, 1, 2,
    380, 0 },

  { 191,
    "ca_cse1_v1e_wo_losv2b/Control Systems/Maneuvering controller/Path controller/theta maker/Transposed rotation  matrix in yaw/Row2",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, Row2_my), BLOCKIO_SIG, 0, 1,
    2, 382, 0 },

  { 192,
    "ca_cse1_v1e_wo_losv2b/Control Systems/Maneuvering controller/Path controller/theta maker/Transposed rotation  matrix in yaw/Row3",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, Row3_e), BLOCKIO_SIG, 0, 1, 2,
    384, 0 },

  { 193,
    "ca_cse1_v1e_wo_losv2b/Control Systems/Maneuvering controller/Path controller/theta maker/Product1",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, Product1_p), BLOCKIO_SIG, 0,
    1, 2, 386, 0 },

  { 194,
    "ca_cse1_v1e_wo_losv2b/Control Systems/Maneuvering controller/Path controller/theta maker/t2/Math Function",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, MathFunction_o), BLOCKIO_SIG,
    34, 3, 2, 388, 0 },

  { 195,
    "ca_cse1_v1e_wo_losv2b/Control Systems/Maneuvering controller/Path controller/theta maker/M_s",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, M_s_a), BLOCKIO_SIG, 17, 3, 2,
    390, 0 },

  { 196,
    "ca_cse1_v1e_wo_losv2b/Control Systems/Maneuvering controller/Path controller/theta maker/Product",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, Product_h2), BLOCKIO_SIG, 0,
    1, 2, 392, 0 },

  { 197,
    "ca_cse1_v1e_wo_losv2b/Control Systems/Maneuvering controller/Path controller/theta maker/Sum1",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, Sum1_be), BLOCKIO_SIG, 0, 1,
    2, 394, 0 },

  { 198,
    "ca_cse1_v1e_wo_losv2b/Control Systems/Maneuvering controller/Path controller/theta maker/mu",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, mu), BLOCKIO_SIG, 0, 1, 2,
    396, 0 },

  { 199,
    "ca_cse1_v1e_wo_losv2b/Control Systems/Maneuvering controller/Path controller/theta maker/Sum",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, Sum_d), BLOCKIO_SIG, 0, 1, 2,
    398, 0 },

  { 200,
    "ca_cse1_v1e_wo_losv2b/Control Systems/Maneuvering controller/Path controller/tau_s/Product",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, Product_cb), BLOCKIO_SIG, 17,
    3, 2, 400, 0 },

  { 201,
    "ca_cse1_v1e_wo_losv2b/Control Systems/Maneuvering controller/Path controller/tau_s/M_s1",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, M_s1), BLOCKIO_SIG, 17, 3, 2,
    402, 0 },

  { 202, "ca_cse1_v1e_wo_losv2b/Naviagation Systems/Qualisys 6 DOF/QTM In10", 0,
    "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, QTMIn10), BLOCKIO_SIG, 39, 1, 2,
    404, 0 },

  { 203, "ca_cse1_v1e_wo_losv2b/Naviagation Systems/Qualisys 6 DOF/mm2m x1", 0,
    "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, mm2mx1), BLOCKIO_SIG, 39, 1, 2,
    406, 0 },

  { 204, "ca_cse1_v1e_wo_losv2b/Naviagation Systems/eta_i_surge", 0, "",
    offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, eta_i_surge), BLOCKIO_SIG, 0, 1, 2,
    408, 0 },

  { 205, "ca_cse1_v1e_wo_losv2b/Naviagation Systems/Qualisys 6 DOF/QTM In11", 0,
    "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, QTMIn11), BLOCKIO_SIG, 39, 1, 2,
    410, 0 },

  { 206, "ca_cse1_v1e_wo_losv2b/Naviagation Systems/Qualisys 6 DOF/mm2m y1", 0,
    "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, mm2my1), BLOCKIO_SIG, 39, 1, 2,
    412, 0 },

  { 207, "ca_cse1_v1e_wo_losv2b/Naviagation Systems/eta_i_sway", 0, "", offsetof
    (BlockIO_CA_CSE1_V1e_wo_LOSV2b, eta_i_sway), BLOCKIO_SIG, 0, 1, 2, 414, 0 },

  { 208, "ca_cse1_v1e_wo_losv2b/Naviagation Systems/Qualisys 6 DOF/QTM In13", 0,
    "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, QTMIn13), BLOCKIO_SIG, 39, 1, 2,
    416, 0 },

  { 209, "ca_cse1_v1e_wo_losv2b/Naviagation Systems/Qualisys 6 DOF/d2r yaw1", 0,
    "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, d2ryaw1), BLOCKIO_SIG, 39, 1, 2,
    418, 0 },

  { 210, "ca_cse1_v1e_wo_losv2b/Naviagation Systems/eta_i_yaw", 0, "", offsetof
    (BlockIO_CA_CSE1_V1e_wo_LOSV2b, eta_i_yaw), BLOCKIO_SIG, 0, 1, 2, 420, 0 },

  { 211, "ca_cse1_v1e_wo_losv2b/Control Systems/Tension estimator/Sum", 0, "",
    offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, Sum_c), BLOCKIO_SIG, 17, 3, 2, 422,
    0 },

  { 212, "ca_cse1_v1e_wo_losv2b/Control Systems/Tension estimator/K_tow", 0, "",
    offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, K_tow), BLOCKIO_SIG, 17, 3, 2, 424,
    0 },

  { 213,
    "ca_cse1_v1e_wo_losv2b/Control Systems/Maneuvering controller/Path controller/tau_s/Transposed rotation  matrix in yaw/Row1",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, Row1_o), BLOCKIO_SIG, 0, 1, 2,
    426, 0 },

  { 214,
    "ca_cse1_v1e_wo_losv2b/Control Systems/Maneuvering controller/Path controller/tau_s/Transposed rotation  matrix in yaw/Row2",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, Row2_b), BLOCKIO_SIG, 0, 1, 2,
    428, 0 },

  { 215,
    "ca_cse1_v1e_wo_losv2b/Control Systems/Maneuvering controller/Path controller/tau_s/Transposed rotation  matrix in yaw/Row3",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, Row3_m), BLOCKIO_SIG, 0, 1, 2,
    430, 0 },

  { 216,
    "ca_cse1_v1e_wo_losv2b/Control Systems/Maneuvering controller/Path controller/tau_s/Transposed rotation  matrix in yaw1/Row1",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, Row1_i), BLOCKIO_SIG, 0, 1, 2,
    432, 0 },

  { 217,
    "ca_cse1_v1e_wo_losv2b/Control Systems/Maneuvering controller/Path controller/tau_s/Transposed rotation  matrix in yaw1/Row2",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, Row2_h), BLOCKIO_SIG, 0, 1, 2,
    434, 0 },

  { 218,
    "ca_cse1_v1e_wo_losv2b/Control Systems/Maneuvering controller/Path controller/tau_s/Transposed rotation  matrix in yaw1/Row3",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, Row3_pl), BLOCKIO_SIG, 0, 1,
    2, 436, 0 },

  { 219,
    "ca_cse1_v1e_wo_losv2b/Control Systems/Maneuvering controller/Path controller/tau_s/Sum",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, Sum_g1), BLOCKIO_SIG, 17, 3,
    2, 438, 0 },

  { 220, "ca_cse1_v1e_wo_losv2b/Control Systems/Maneuvering controller/Product1",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, Product1_pj), BLOCKIO_SIG, 18,
    5, 2, 440, 0 },

  { 221, "ca_cse1_v1e_wo_losv2b/Control Systems/Maneuvering controller/DP u_1",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, DPu_1), BLOCKIO_SIG, 0, 1, 2,
    442, 0 },

  { 222, "ca_cse1_v1e_wo_losv2b/Control Systems/Maneuvering controller/DP u_2",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, DPu_2), BLOCKIO_SIG, 0, 1, 2,
    444, 0 },

  { 223, "ca_cse1_v1e_wo_losv2b/Control Systems/Maneuvering controller/DP u_3",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, DPu_3), BLOCKIO_SIG, 0, 1, 2,
    446, 0 },

  { 224, "ca_cse1_v1e_wo_losv2b/Control Systems/Maneuvering controller/DP u_4",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, DPu_4), BLOCKIO_SIG, 0, 1, 2,
    448, 0 },

  { 225, "ca_cse1_v1e_wo_losv2b/Control Systems/Maneuvering controller/DP u_5",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, DPu_5), BLOCKIO_SIG, 0, 1, 2,
    450, 0 },

  { 226,
    "ca_cse1_v1e_wo_losv2b/Control Systems/Maneuvering controller/Saturation", 0,
    "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, Saturation_o), BLOCKIO_SIG, 18,
    5, 2, 452, 0 },

  { 227, "ca_cse1_v1e_wo_losv2b/Control Systems/Control Switch", 0, "", offsetof
    (BlockIO_CA_CSE1_V1e_wo_LOSV2b, ControlSwitch), BLOCKIO_SIG, 21, 7, 2, 454,
    0 },

  { 228, "ca_cse1_v1e_wo_losv2b/Control Systems/Saturation", 0, "", offsetof
    (BlockIO_CA_CSE1_V1e_wo_LOSV2b, Saturation_c), BLOCKIO_SIG, 21, 7, 2, 456, 0
  },

  { 229, "ca_cse1_v1e_wo_losv2b/Guidance Systems/DP/eta_d Psi deg", 0, "",
    offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, eta_dPsideg), BLOCKIO_SIG, 0, 1, 2,
    458, 0 },

  { 230, "ca_cse1_v1e_wo_losv2b/HMI/SIT zAI0", 0, "", offsetof
    (BlockIO_CA_CSE1_V1e_wo_LOSV2b, SITzAI0), BLOCKIO_SIG, 0, 1, 2, 460, 0 },

  { 231, "ca_cse1_v1e_wo_losv2b/HMI/Battery Bow Thruster", 0, "", offsetof
    (BlockIO_CA_CSE1_V1e_wo_LOSV2b, BatteryBowThruster), BLOCKIO_SIG, 0, 1, 2,
    462, 0 },

  { 232, "ca_cse1_v1e_wo_losv2b/HMI/SIT zAI1", 0, "", offsetof
    (BlockIO_CA_CSE1_V1e_wo_LOSV2b, SITzAI1), BLOCKIO_SIG, 0, 1, 2, 464, 0 },

  { 233, "ca_cse1_v1e_wo_losv2b/HMI/Battery Servo", 0, "", offsetof
    (BlockIO_CA_CSE1_V1e_wo_LOSV2b, BatteryServo), BLOCKIO_SIG, 0, 1, 2, 466, 0
  },

  { 234, "ca_cse1_v1e_wo_losv2b/HMI/SIT zAI2", 0, "", offsetof
    (BlockIO_CA_CSE1_V1e_wo_LOSV2b, SITzAI2), BLOCKIO_SIG, 0, 1, 2, 468, 0 },

  { 235, "ca_cse1_v1e_wo_losv2b/HMI/Battery Main", 0, "", offsetof
    (BlockIO_CA_CSE1_V1e_wo_LOSV2b, BatteryMain), BLOCKIO_SIG, 0, 1, 2, 470, 0 },

  { 236, "ca_cse1_v1e_wo_losv2b/Naviagation Systems/Qualisys 6 DOF/QTM In12", 0,
    "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, QTMIn12), BLOCKIO_SIG, 39, 1, 2,
    472, 0 },

  { 237, "ca_cse1_v1e_wo_losv2b/Naviagation Systems/Qualisys 6 DOF/mm2m z1", 0,
    "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, mm2mz1), BLOCKIO_SIG, 39, 1, 2,
    474, 0 },

  { 238, "ca_cse1_v1e_wo_losv2b/Naviagation Systems/Qualisys 6 DOF/QTM In15", 0,
    "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, QTMIn15), BLOCKIO_SIG, 39, 1, 2,
    476, 0 },

  { 239, "ca_cse1_v1e_wo_losv2b/Naviagation Systems/Qualisys 6 DOF/d2r roll1", 0,
    "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, d2rroll1), BLOCKIO_SIG, 39, 1, 2,
    478, 0 },

  { 240, "ca_cse1_v1e_wo_losv2b/Naviagation Systems/Qualisys 6 DOF/QTM In14", 0,
    "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, QTMIn14), BLOCKIO_SIG, 39, 1, 2,
    480, 0 },

  { 241, "ca_cse1_v1e_wo_losv2b/Naviagation Systems/Qualisys 6 DOF/d2r pitch1",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, d2rpitch1), BLOCKIO_SIG, 39,
    1, 2, 482, 0 },

  { 242, "ca_cse1_v1e_wo_losv2b/Naviagation Systems/Qualisys 6 DOF/Derivative1",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, Derivative1), BLOCKIO_SIG, 19,
    6, 2, 484, 0 },

  { 243,
    "ca_cse1_v1e_wo_losv2b/Naviagation Systems/Qualisys 6 DOF/Euler angles to inverse rotation matrix1/sin(theta)",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, sintheta_n), BLOCKIO_SIG, 17,
    3, 2, 486, 0 },

  { 244,
    "ca_cse1_v1e_wo_losv2b/Naviagation Systems/Qualisys 6 DOF/Euler angles to inverse rotation matrix1/cos(theta)",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, costheta_l), BLOCKIO_SIG, 17,
    3, 2, 488, 0 },

  { 245,
    "ca_cse1_v1e_wo_losv2b/Naviagation Systems/Qualisys 6 DOF/Euler angles to inverse rotation matrix1/R11",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, R11_j), BLOCKIO_SIG, 0, 1, 2,
    490, 0 },

  { 246,
    "ca_cse1_v1e_wo_losv2b/Naviagation Systems/Qualisys 6 DOF/Euler angles to inverse rotation matrix1/R12",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, R12_e), BLOCKIO_SIG, 0, 1, 2,
    492, 0 },

  { 247,
    "ca_cse1_v1e_wo_losv2b/Naviagation Systems/Qualisys 6 DOF/Euler angles to inverse rotation matrix1/R13",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, R13_j), BLOCKIO_SIG, 0, 1, 2,
    494, 0 },

  { 248,
    "ca_cse1_v1e_wo_losv2b/Naviagation Systems/Qualisys 6 DOF/Euler angles to inverse rotation matrix1/R21",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, R21_a), BLOCKIO_SIG, 0, 1, 2,
    496, 0 },

  { 249,
    "ca_cse1_v1e_wo_losv2b/Naviagation Systems/Qualisys 6 DOF/Euler angles to inverse rotation matrix1/R22",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, R22_e), BLOCKIO_SIG, 0, 1, 2,
    498, 0 },

  { 250,
    "ca_cse1_v1e_wo_losv2b/Naviagation Systems/Qualisys 6 DOF/Euler angles to inverse rotation matrix1/R23",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, R23_h), BLOCKIO_SIG, 0, 1, 2,
    500, 0 },

  { 251,
    "ca_cse1_v1e_wo_losv2b/Naviagation Systems/Qualisys 6 DOF/Euler angles to inverse rotation matrix1/R31",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, R31_f), BLOCKIO_SIG, 0, 1, 2,
    502, 0 },

  { 252,
    "ca_cse1_v1e_wo_losv2b/Naviagation Systems/Qualisys 6 DOF/Euler angles to inverse rotation matrix1/R32",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, R32_p), BLOCKIO_SIG, 0, 1, 2,
    504, 0 },

  { 253,
    "ca_cse1_v1e_wo_losv2b/Naviagation Systems/Qualisys 6 DOF/Euler angles to inverse rotation matrix1/R33",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, R33_j), BLOCKIO_SIG, 0, 1, 2,
    506, 0 },

  { 254,
    "ca_cse1_v1e_wo_losv2b/Naviagation Systems/Qualisys 6 DOF/Euler angles to inverse rotation matrix1/Reshape 9x1->3x3",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, Reshape9x13x3_m), BLOCKIO_SIG,
    33, 9, 2, 508, 0 },

  { 255,
    "ca_cse1_v1e_wo_losv2b/Naviagation Systems/Qualisys 6 DOF/Matrix Concatenate5",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, MatrixConcatenate5),
    BLOCKIO_SIG, 42, 36, 2, 510, 0 },

  { 256, "ca_cse1_v1e_wo_losv2b/Naviagation Systems/Qualisys 6 DOF/Product1", 0,
    "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, Product1_l), BLOCKIO_SIG, 19, 6,
    2, 512, 0 },

  { 257, "ca_cse1_v1e_wo_losv2b/Naviagation Systems/Qualisys 6 DOF/QTM In1 FPS",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, QTMIn1FPS), BLOCKIO_SIG, 39,
    1, 2, 514, 0 },

  { 258,
    "ca_cse1_v1e_wo_losv2b/Naviagation Systems/Qualisys 6 DOF/QTM In16 Residual",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, QTMIn16Residual), BLOCKIO_SIG,
    39, 1, 2, 516, 0 },

  { 259,
    "ca_cse1_v1e_wo_losv2b/Naviagation Systems/Qualisys 6 DOF/QTM In2 Error", 0,
    "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, QTMIn2Error), BLOCKIO_SIG, 39, 1,
    2, 518, 0 },

  { 260,
    "ca_cse1_v1e_wo_losv2b/Naviagation Systems/Qualisys 6 DOF/QTM In9 Residual",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, QTMIn9Residual), BLOCKIO_SIG,
    39, 1, 2, 520, 0 },

  { 261, "ca_cse1_v1e_wo_losv2b/Naviagation Systems/nu_i_surge", 0, "", offsetof
    (BlockIO_CA_CSE1_V1e_wo_LOSV2b, nu_i_surge), BLOCKIO_SIG, 0, 1, 2, 522, 0 },

  { 262, "ca_cse1_v1e_wo_losv2b/Naviagation Systems/nu_i_sway", 0, "", offsetof
    (BlockIO_CA_CSE1_V1e_wo_LOSV2b, nu_i_sway), BLOCKIO_SIG, 0, 1, 2, 524, 0 },

  { 263, "ca_cse1_v1e_wo_losv2b/Naviagation Systems/nu_i_yaw", 0, "", offsetof
    (BlockIO_CA_CSE1_V1e_wo_LOSV2b, nu_i_yaw), BLOCKIO_SIG, 0, 1, 2, 526, 0 },

  { 264, "ca_cse1_v1e_wo_losv2b/Plants/u_1 plant", 0, "", offsetof
    (BlockIO_CA_CSE1_V1e_wo_LOSV2b, u_1plant), BLOCKIO_SIG, 0, 1, 2, 528, 0 },

  { 265, "ca_cse1_v1e_wo_losv2b/Plants/u_2 plant", 0, "", offsetof
    (BlockIO_CA_CSE1_V1e_wo_LOSV2b, u_2plant), BLOCKIO_SIG, 0, 1, 2, 530, 0 },

  { 266, "ca_cse1_v1e_wo_losv2b/Plants/u_3 plant", 0, "", offsetof
    (BlockIO_CA_CSE1_V1e_wo_LOSV2b, u_3plant), BLOCKIO_SIG, 0, 1, 2, 532, 0 },

  { 267, "ca_cse1_v1e_wo_losv2b/Plants/u_4 plant", 0, "", offsetof
    (BlockIO_CA_CSE1_V1e_wo_LOSV2b, u_4plant), BLOCKIO_SIG, 0, 1, 2, 534, 0 },

  { 268, "ca_cse1_v1e_wo_losv2b/Plants/u_5 plant", 0, "", offsetof
    (BlockIO_CA_CSE1_V1e_wo_LOSV2b, u_5plant), BLOCKIO_SIG, 0, 1, 2, 536, 0 },

  { 269, "ca_cse1_v1e_wo_losv2b/Plants/BT power lmit", 0, "", offsetof
    (BlockIO_CA_CSE1_V1e_wo_LOSV2b, BTpowerlmit), BLOCKIO_SIG, 0, 1, 2, 538, 0 },

  { 270, "ca_cse1_v1e_wo_losv2b/Plants/VSP speed", 0, "", offsetof
    (BlockIO_CA_CSE1_V1e_wo_LOSV2b, VSPspeed), BLOCKIO_SIG, 0, 1, 2, 540, 0 },

  { 271,
    "ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/Vessel Dynamics/D_L/-N_r", 0,
    "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, N_r), BLOCKIO_SIG, 0, 1, 2, 542,
    0 },

  { 272,
    "ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/Vessel Dynamics/D_L/-N_v", 0,
    "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, N_v), BLOCKIO_SIG, 0, 1, 2, 544,
    0 },

  { 273,
    "ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/Vessel Dynamics/D_L/-X_u", 0,
    "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, X_u), BLOCKIO_SIG, 0, 1, 2, 546,
    0 },

  { 274,
    "ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/Vessel Dynamics/D_L/-Y_v", 0,
    "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, Y_v), BLOCKIO_SIG, 0, 1, 2, 548,
    0 },

  { 275,
    "ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/Vessel Dynamics/D_L/-Y_vr", 0,
    "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, Y_vr), BLOCKIO_SIG, 0, 1, 2, 550,
    0 },

  { 276,
    "ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/Vessel Dynamics/D_L/Linear Dampning matrix",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, LinearDampningmatrix),
    BLOCKIO_SIG, 33, 9, 2, 552, 0 },

  { 277,
    "ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/Vessel Dynamics/Initial eta/psi_0",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, psi_0), BLOCKIO_SIG, 0, 1, 2,
    554, 0 },

  { 278,
    "ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/Vessel Dynamics/Initial eta/x_0",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, x_0), BLOCKIO_SIG, 0, 1, 2,
    556, 0 },

  { 279,
    "ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/Vessel Dynamics/Initial eta/y_0",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, y_0), BLOCKIO_SIG, 0, 1, 2,
    558, 0 },

  { 280,
    "ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/Vessel Dynamics/Initial nu/r_0",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, r_0), BLOCKIO_SIG, 0, 1, 2,
    560, 0 },

  { 281,
    "ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/Vessel Dynamics/Initial nu/u_0",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, u_0), BLOCKIO_SIG, 0, 1, 2,
    562, 0 },

  { 282,
    "ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/Vessel Dynamics/Initial nu/v_0",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, v_0), BLOCKIO_SIG, 0, 1, 2,
    564, 0 },

  { 283,
    "ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/Vessel Dynamics/Integrator",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, Integrator_o), BLOCKIO_SIG,
    17, 3, 2, 566, 0 },

  { 284,
    "ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/Vessel Dynamics/Integrator1",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, Integrator1), BLOCKIO_SIG, 17,
    3, 2, 568, 0 },

  { 285,
    "ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/Vessel Dynamics/M_inv/M_11",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, M_11), BLOCKIO_SIG, 0, 1, 2,
    570, 0 },

  { 286,
    "ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/Vessel Dynamics/M_inv/M_22",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, M_22), BLOCKIO_SIG, 0, 1, 2,
    572, 0 },

  { 287,
    "ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/Vessel Dynamics/M_inv/m x_g",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, mx_g), BLOCKIO_SIG, 0, 1, 2,
    574, 0 },

  { 288,
    "ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/Vessel Dynamics/M_inv/M_32",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, M_32), BLOCKIO_SIG, 0, 1, 2,
    576, 0 },

  { 289,
    "ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/Vessel Dynamics/M_inv/M_23",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, M_23), BLOCKIO_SIG, 0, 1, 2,
    578, 0 },

  { 290,
    "ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/Vessel Dynamics/M_inv/M_33",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, M_33), BLOCKIO_SIG, 0, 1, 2,
    580, 0 },

  { 291, "ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/Vessel Dynamics/M_inv/M",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, M), BLOCKIO_SIG, 33, 9, 2,
    582, 0 },

  { 292,
    "ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/Vessel Dynamics/M_inv/Inverse",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, Inverse), BLOCKIO_SIG, 33, 9,
    2, 584, 0 },

  { 293,
    "ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/Vessel Dynamics/Product1", 0,
    "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, Product1_b), BLOCKIO_SIG, 17, 3,
    2, 586, 0 },

  { 294, "ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/u to tau/T_e/-l_x1", 0,
    "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, l_x1_j), BLOCKIO_SIG, 0, 1, 2,
    588, 0 },

  { 295, "ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/u to tau/T_e/-l_y2", 0,
    "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, l_y2_p), BLOCKIO_SIG, 0, 1, 2,
    590, 0 },

  { 296, "ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/u to tau/T_e/-l_x2", 0,
    "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, l_x2_o), BLOCKIO_SIG, 0, 1, 2,
    592, 0 },

  { 297, "ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/u to tau/T_e/3x5", 0, "",
    offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, x5_d), BLOCKIO_SIG, 29, 15, 2, 594,
    0 },

  { 298,
    "ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/u to tau/K_e/Gain K_e1_hil",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, GainK_e1_hil), BLOCKIO_SIG, 0,
    1, 2, 596, 0 },

  { 299,
    "ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/u to tau/K_e/Gain K_e2_hil",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, GainK_e2_hil), BLOCKIO_SIG, 0,
    1, 2, 598, 0 },

  { 300,
    "ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/u to tau/K_e/Gain K_e3_hil",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, GainK_e3_hil), BLOCKIO_SIG, 0,
    1, 2, 600, 0 },

  { 301,
    "ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/u to tau/K_e/Gain K_e4_hil",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, GainK_e4_hil), BLOCKIO_SIG, 0,
    1, 2, 602, 0 },

  { 302,
    "ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/u to tau/K_e/Gain K_e5_hil",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, GainK_e5_hil), BLOCKIO_SIG, 0,
    1, 2, 604, 0 },

  { 303,
    "ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/u to tau/K_e/Thruster Gain matrix",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, ThrusterGainmatrix_e),
    BLOCKIO_SIG, 25, 25, 2, 606, 0 },

  { 304,
    "ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/u to tau/Rate Limiter Dynamic/sample time",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, sampletime), BLOCKIO_SIG, 0,
    1, 2, 608, 0 },

  { 305,
    "ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/u to tau/Rate Limiter Dynamic/Delay Input2",
    0, "Y(k-1)", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, Yk1), BLOCKIO_SIG, 0, 1,
    2, 610, 0 },

  { 306,
    "ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/Vessel Dynamics/R(psi)/R11",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, R11_b), BLOCKIO_SIG, 0, 1, 2,
    612, 0 },

  { 307,
    "ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/Vessel Dynamics/R(psi)/R21",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, R21_af), BLOCKIO_SIG, 0, 1, 2,
    614, 0 },

  { 308,
    "ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/Vessel Dynamics/R(psi)/R12",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, R12_m), BLOCKIO_SIG, 0, 1, 2,
    616, 0 },

  { 309,
    "ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/Vessel Dynamics/R(psi)/R22",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, R22_h), BLOCKIO_SIG, 0, 1, 2,
    618, 0 },

  { 310,
    "ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/Vessel Dynamics/R(psi)/R(psi)",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, Rpsi), BLOCKIO_SIG, 33, 9, 2,
    620, 0 },

  { 311,
    "ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/Vessel Dynamics/Product3", 0,
    "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, Product3_g), BLOCKIO_SIG, 17, 3,
    2, 622, 0 },

  { 312, "ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/eta_surge_hil", 0, "",
    offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, eta_surge_hil), BLOCKIO_SIG, 0, 1, 2,
    624, 0 },

  { 313, "ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/eta_sway_hil", 0, "",
    offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, eta_sway_hil), BLOCKIO_SIG, 0, 1, 2,
    626, 0 },

  { 314, "ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/eta_yaw_hil", 0, "",
    offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, eta_yaw_hil), BLOCKIO_SIG, 0, 1, 2,
    628, 0 },

  { 315, "ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/etadot_surge_hil", 0, "",
    offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, etadot_surge_hil), BLOCKIO_SIG, 0, 1,
    2, 630, 0 },

  { 316, "ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/etadot_sway_hil", 0, "",
    offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, etadot_sway_hil), BLOCKIO_SIG, 0, 1,
    2, 632, 0 },

  { 317, "ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/etadot_yaw_hil", 0, "",
    offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, etadot_yaw_hil), BLOCKIO_SIG, 0, 1,
    2, 634, 0 },

  { 318, "ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/nu_surge_hil", 0, "",
    offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, nu_surge_hil), BLOCKIO_SIG, 0, 1, 2,
    636, 0 },

  { 319, "ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/nu_sway_hil", 0, "",
    offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, nu_sway_hil), BLOCKIO_SIG, 0, 1, 2,
    638, 0 },

  { 320, "ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/nu_yaw_hil", 0, "",
    offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, nu_yaw_hil), BLOCKIO_SIG, 0, 1, 2,
    640, 0 },

  { 321, "ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/u to tau/Gain u_1", 0,
    "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, Gainu_1), BLOCKIO_SIG, 0, 1, 2,
    642, 0 },

  { 322, "ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/u to tau/Gain u_2", 0,
    "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, Gainu_2), BLOCKIO_SIG, 0, 1, 2,
    644, 0 },

  { 323, "ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/u to tau/Gain u_3", 0,
    "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, Gainu_3), BLOCKIO_SIG, 0, 1, 2,
    646, 0 },

  { 324, "ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/u to tau/Gain u_4", 0,
    "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, Gainu_4), BLOCKIO_SIG, 0, 1, 2,
    648, 0 },

  { 325, "ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/u to tau/Gain BT power",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, GainBTpower), BLOCKIO_SIG, 0,
    1, 2, 650, 0 },

  { 326,
    "ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/u to tau/Rate Limiter Dynamic/delta rise limit",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, deltariselimit), BLOCKIO_SIG,
    0, 1, 2, 652, 0 },

  { 327,
    "ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/u to tau/Rate Limiter Dynamic/Difference Inputs1",
    0, "( U(k) - Y(k-1) )", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, UkYk1),
    BLOCKIO_SIG, 0, 1, 2, 654, 0 },

  { 328, "ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/u to tau/Neg", 0, "",
    offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, Neg), BLOCKIO_SIG, 0, 1, 2, 656, 0 },

  { 329,
    "ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/u to tau/Rate Limiter Dynamic/delta fall limit",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, deltafalllimit), BLOCKIO_SIG,
    0, 1, 2, 658, 0 },

  { 330,
    "ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/u to tau/Rate Limiter Dynamic/Saturation Dynamic/Switch",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, Switch), BLOCKIO_SIG, 0, 1, 2,
    660, 0 },

  { 331,
    "ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/u to tau/Rate Limiter Dynamic/Saturation Dynamic/Switch2",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, Switch2), BLOCKIO_SIG, 0, 1,
    2, 662, 0 },

  { 332,
    "ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/u to tau/Rate Limiter Dynamic/Difference Inputs2",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, DifferenceInputs2),
    BLOCKIO_SIG, 0, 1, 2, 664, 0 },

  { 333, "ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/u to tau/Gain u_5", 0,
    "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, Gainu_5), BLOCKIO_SIG, 0, 1, 2,
    666, 0 },

  { 334,
    "ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/u to tau/T_e^+ K_e^-1 u_e", 0,
    "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, T_eK_e1u_e), BLOCKIO_SIG, 17, 3,
    2, 668, 0 },

  { 335, "ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/u to tau/tau_surge_hil",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, tau_surge_hil), BLOCKIO_SIG,
    0, 1, 2, 670, 0 },

  { 336, "ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/u to tau/tau_sway_hil",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, tau_sway_hil), BLOCKIO_SIG, 0,
    1, 2, 672, 0 },

  { 337, "ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/u to tau/tau_yaw_hil", 0,
    "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, tau_yaw_hil), BLOCKIO_SIG, 0, 1,
    2, 674, 0 },

  { 338, "ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/Vessel Dynamics/Sum", 0,
    "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, Sum_j2), BLOCKIO_SIG, 17, 3, 2,
    676, 0 },

  { 339,
    "ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/Vessel Dynamics/Product2", 0,
    "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, Product2_i), BLOCKIO_SIG, 17, 3,
    2, 678, 0 },

  { 340,
    "ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/u to tau/Cartesian to Polar Port/x->r",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, xr), BLOCKIO_SIG, 0, 1, 2,
    680, 0 },

  { 341,
    "ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/u to tau/Cartesian to Polar Port/x->theta",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, xtheta), BLOCKIO_SIG, 0, 1, 2,
    682, 0 },

  { 342,
    "ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/u to tau/Cartesian to Polar Stbd/x->r",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, xr_g), BLOCKIO_SIG, 0, 1, 2,
    684, 0 },

  { 343,
    "ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/u to tau/Cartesian to Polar Stbd/x->theta",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, xtheta_a), BLOCKIO_SIG, 0, 1,
    2, 686, 0 },

  { 344,
    "ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/u to tau/VSP_angle_deg_port",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, VSP_angle_deg_port),
    BLOCKIO_SIG, 0, 1, 2, 688, 0 },

  { 345,
    "ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/u to tau/VSP_angle_deg_stbd",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, VSP_angle_deg_stbd),
    BLOCKIO_SIG, 0, 1, 2, 690, 0 },

  { 346, "ca_cse1_v1e_wo_losv2b/Plants/CSE1/Bow Thruster/BT_D_Gain1", 0, "",
    offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, BT_D_Gain1), BLOCKIO_SIG, 0, 1, 2,
    692, 0 },

  { 347, "ca_cse1_v1e_wo_losv2b/Plants/CSE1/Bow Thruster/BT_D_Gain2", 0, "",
    offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, BT_D_Gain2), BLOCKIO_SIG, 0, 1, 2,
    694, 0 },

  { 348, "ca_cse1_v1e_wo_losv2b/Plants/CSE1/Bow Thruster/Add", 0, "", offsetof
    (BlockIO_CA_CSE1_V1e_wo_LOSV2b, Add), BLOCKIO_SIG, 0, 1, 2, 696, 0 },

  { 349, "ca_cse1_v1e_wo_losv2b/Plants/CSE1/Bow Thruster/BT_L_Gain1", 0, "",
    offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, BT_L_Gain1), BLOCKIO_SIG, 0, 1, 2,
    698, 0 },

  { 350, "ca_cse1_v1e_wo_losv2b/Plants/CSE1/Bow Thruster/BT_L_Gain2", 0, "",
    offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, BT_L_Gain2), BLOCKIO_SIG, 0, 1, 2,
    700, 0 },

  { 351, "ca_cse1_v1e_wo_losv2b/Plants/CSE1/Bow Thruster/Neg", 0, "", offsetof
    (BlockIO_CA_CSE1_V1e_wo_LOSV2b, Neg_d), BLOCKIO_SIG, 0, 1, 2, 702, 0 },

  { 352, "ca_cse1_v1e_wo_losv2b/Plants/CSE1/Bow Thruster/Sum1", 0, "", offsetof
    (BlockIO_CA_CSE1_V1e_wo_LOSV2b, Sum1_f), BLOCKIO_SIG, 0, 1, 2, 704, 0 },

  { 353, "ca_cse1_v1e_wo_losv2b/Plants/CSE1/Bow Thruster/Sum2", 0, "", offsetof
    (BlockIO_CA_CSE1_V1e_wo_LOSV2b, Sum2_mv), BLOCKIO_SIG, 0, 1, 2, 706, 0 },

  { 354,
    "ca_cse1_v1e_wo_losv2b/Plants/CSE1/Bow Thruster/Saturation Dynamic/Switch",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, Switch_n), BLOCKIO_SIG, 0, 1,
    2, 708, 0 },

  { 355,
    "ca_cse1_v1e_wo_losv2b/Plants/CSE1/Bow Thruster/Saturation Dynamic/Switch2",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, Switch2_l), BLOCKIO_SIG, 0, 1,
    2, 710, 0 },

  { 356,
    "ca_cse1_v1e_wo_losv2b/Plants/CSE1/Bow Thruster/Saturation Dynamic1/Switch",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, Switch_nw), BLOCKIO_SIG, 0, 1,
    2, 712, 0 },

  { 357,
    "ca_cse1_v1e_wo_losv2b/Plants/CSE1/Bow Thruster/Saturation Dynamic1/Switch2",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, Switch2_f), BLOCKIO_SIG, 0, 1,
    2, 714, 0 },

  { 358,
    "ca_cse1_v1e_wo_losv2b/Plants/CSE1/Bow Thruster/Saturation Dynamic2/Switch",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, Switch_m), BLOCKIO_SIG, 0, 1,
    2, 716, 0 },

  { 359,
    "ca_cse1_v1e_wo_losv2b/Plants/CSE1/Bow Thruster/Saturation Dynamic2/Switch2",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, Switch2_o), BLOCKIO_SIG, 0, 1,
    2, 718, 0 },

  { 360, "ca_cse1_v1e_wo_losv2b/Plants/CSE1/Voith Schneider Propeller /Sign", 0,
    "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, Sign), BLOCKIO_SIG, 0, 1, 2, 720,
    0 },

  { 361, "ca_cse1_v1e_wo_losv2b/Plants/CSE1/Voith Schneider Propeller /Product1",
    0, "Port VPS_X", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, PortVPS_X),
    BLOCKIO_SIG, 0, 1, 2, 722, 0 },

  { 362, "ca_cse1_v1e_wo_losv2b/Plants/CSE1/Voith Schneider Propeller /-x", 0,
    "Port VPS_X", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, PortVPS_X_a),
    BLOCKIO_SIG, 0, 1, 2, 724, 0 },

  { 363, "ca_cse1_v1e_wo_losv2b/Plants/CSE1/Voith Schneider Propeller /Product2",
    0, "Port VSP_Y", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, PortVSP_Y),
    BLOCKIO_SIG, 0, 1, 2, 726, 0 },

  { 364, "ca_cse1_v1e_wo_losv2b/Plants/CSE1/Voith Schneider Propeller /-y", 0,
    "Port VSP_Y", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, PortVSP_Y_a),
    BLOCKIO_SIG, 0, 1, 2, 728, 0 },

  { 365,
    "ca_cse1_v1e_wo_losv2b/Plants/CSE1/Voith Schneider Propeller /Cartesian to Polar Port/x->r",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, xr_l), BLOCKIO_SIG, 0, 1, 2,
    730, 0 },

  { 366,
    "ca_cse1_v1e_wo_losv2b/Plants/CSE1/Voith Schneider Propeller /Cartesian to Polar Port/x->theta",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, xtheta_b), BLOCKIO_SIG, 0, 1,
    2, 732, 0 },

  { 367, "ca_cse1_v1e_wo_losv2b/Plants/CSE1/Voith Schneider Propeller /Product3",
    0, "Starboard VSP_X", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, StarboardVSP_X),
    BLOCKIO_SIG, 0, 1, 2, 734, 0 },

  { 368, "ca_cse1_v1e_wo_losv2b/Plants/CSE1/Voith Schneider Propeller /Product4",
    0, "Starboard VSP_Y", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, StarboardVSP_Y),
    BLOCKIO_SIG, 0, 1, 2, 736, 0 },

  { 369,
    "ca_cse1_v1e_wo_losv2b/Plants/CSE1/Voith Schneider Propeller /Cartesian to Polar Starboard/x->r",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, xr_a), BLOCKIO_SIG, 0, 1, 2,
    738, 0 },

  { 370,
    "ca_cse1_v1e_wo_losv2b/Plants/CSE1/Voith Schneider Propeller /Cartesian to Polar Starboard/x->theta",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, xtheta_al), BLOCKIO_SIG, 0, 1,
    2, 740, 0 },

  { 371,
    "ca_cse1_v1e_wo_losv2b/Plants/CSE1/Voith Schneider Propeller /Radians to Degrees Port/Gain",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, Gain_h), BLOCKIO_SIG, 0, 1, 2,
    742, 0 },

  { 372,
    "ca_cse1_v1e_wo_losv2b/Plants/CSE1/Voith Schneider Propeller /Radians to Degrees Staroard/Gain",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, Gain_i), BLOCKIO_SIG, 0, 1, 2,
    744, 0 },

  { 373, "ca_cse1_v1e_wo_losv2b/Plants/CSE1/Voith Schneider Propeller /Servo1",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, Servo1), BLOCKIO_SIG, 0, 1, 2,
    746, 0 },

  { 374, "ca_cse1_v1e_wo_losv2b/Plants/CSE1/Voith Schneider Propeller /Servo2",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, Servo2), BLOCKIO_SIG, 0, 1, 2,
    748, 0 },

  { 375, "ca_cse1_v1e_wo_losv2b/Plants/CSE1/Voith Schneider Propeller /Servo3",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, Servo3), BLOCKIO_SIG, 0, 1, 2,
    750, 0 },

  { 376, "ca_cse1_v1e_wo_losv2b/Plants/CSE1/Voith Schneider Propeller /Servo4",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, Servo4), BLOCKIO_SIG, 0, 1, 2,
    752, 0 },

  { 377,
    "ca_cse1_v1e_wo_losv2b/Plants/CSE1/Voith Schneider Propeller /VPS_Speed_Gain",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, VPS_Speed_Gain), BLOCKIO_SIG,
    0, 1, 2, 754, 0 },

  { 378, "ca_cse1_v1e_wo_losv2b/Plants/CSE1/Voith Schneider Propeller /Sum", 0,
    "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, Sum_er), BLOCKIO_SIG, 0, 1, 2,
    756, 0 },

  { 379,
    "ca_cse1_v1e_wo_losv2b/Plants/CSE1/Voith Schneider Propeller /VSPS Port", 0,
    "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, VSPSPort), BLOCKIO_SIG, 0, 1, 2,
    758, 0 },

  { 380,
    "ca_cse1_v1e_wo_losv2b/Plants/CSE1/Voith Schneider Propeller /VSPS Starboard",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, VSPSStarboard), BLOCKIO_SIG,
    0, 1, 2, 760, 0 },

  { 381, "ca_cse1_v1e_wo_losv2b/Plants/CSE1/T_e/-l_x1", 0, "", offsetof
    (BlockIO_CA_CSE1_V1e_wo_LOSV2b, l_x1_e), BLOCKIO_SIG, 0, 1, 2, 762, 0 },

  { 382, "ca_cse1_v1e_wo_losv2b/Plants/CSE1/T_e/-l_y2", 0, "", offsetof
    (BlockIO_CA_CSE1_V1e_wo_LOSV2b, l_y2_l), BLOCKIO_SIG, 0, 1, 2, 764, 0 },

  { 383, "ca_cse1_v1e_wo_losv2b/Plants/CSE1/T_e/-l_x2", 0, "", offsetof
    (BlockIO_CA_CSE1_V1e_wo_LOSV2b, l_x2_j), BLOCKIO_SIG, 0, 1, 2, 766, 0 },

  { 384, "ca_cse1_v1e_wo_losv2b/Plants/CSE1/T_e/3x5", 0, "", offsetof
    (BlockIO_CA_CSE1_V1e_wo_LOSV2b, x5_df), BLOCKIO_SIG, 29, 15, 2, 768, 0 },

  { 385, "ca_cse1_v1e_wo_losv2b/Plants/CSE1/K_e/Gain K_e1_CSE1", 0, "", offsetof
    (BlockIO_CA_CSE1_V1e_wo_LOSV2b, GainK_e1_CSE1), BLOCKIO_SIG, 0, 1, 2, 770, 0
  },

  { 386, "ca_cse1_v1e_wo_losv2b/Plants/CSE1/K_e/Gain K_e2_CSE1", 0, "", offsetof
    (BlockIO_CA_CSE1_V1e_wo_LOSV2b, GainK_e2_CSE1), BLOCKIO_SIG, 0, 1, 2, 772, 0
  },

  { 387, "ca_cse1_v1e_wo_losv2b/Plants/CSE1/K_e/Gain K_e3_CSE1", 0, "", offsetof
    (BlockIO_CA_CSE1_V1e_wo_LOSV2b, GainK_e3_CSE1), BLOCKIO_SIG, 0, 1, 2, 774, 0
  },

  { 388, "ca_cse1_v1e_wo_losv2b/Plants/CSE1/K_e/Gain K_e4_CSE1", 0, "", offsetof
    (BlockIO_CA_CSE1_V1e_wo_LOSV2b, GainK_e4_CSE1), BLOCKIO_SIG, 0, 1, 2, 776, 0
  },

  { 389, "ca_cse1_v1e_wo_losv2b/Plants/CSE1/K_e/Gain K_e5_CSE1", 0, "", offsetof
    (BlockIO_CA_CSE1_V1e_wo_LOSV2b, GainK_e5_CSE1), BLOCKIO_SIG, 0, 1, 2, 778, 0
  },

  { 390, "ca_cse1_v1e_wo_losv2b/Plants/CSE1/K_e/Thruster Gain matrix", 0, "",
    offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, ThrusterGainmatrix_l), BLOCKIO_SIG,
    25, 25, 2, 780, 0 },

  { 391, "ca_cse1_v1e_wo_losv2b/Plants/CSE1/tau_cse1", 0, "", offsetof
    (BlockIO_CA_CSE1_V1e_wo_LOSV2b, tau_cse1), BLOCKIO_SIG, 17, 3, 2, 782, 0 },

  { 392, "ca_cse1_v1e_wo_losv2b/Plants/CSE1/CSE1 tau_surge", 0, "", offsetof
    (BlockIO_CA_CSE1_V1e_wo_LOSV2b, CSE1tau_surge), BLOCKIO_SIG, 0, 1, 2, 784, 0
  },

  { 393, "ca_cse1_v1e_wo_losv2b/Plants/CSE1/CSE1 tau_sway", 0, "", offsetof
    (BlockIO_CA_CSE1_V1e_wo_LOSV2b, CSE1tau_sway), BLOCKIO_SIG, 0, 1, 2, 786, 0
  },

  { 394, "ca_cse1_v1e_wo_losv2b/Plants/CSE1/CSE1 tau_yaw", 0, "", offsetof
    (BlockIO_CA_CSE1_V1e_wo_LOSV2b, CSE1tau_yaw), BLOCKIO_SIG, 0, 1, 2, 788, 0 },

  { 395,
    "ca_cse1_v1e_wo_losv2b/Control Systems/DP control/Passive DP wave filter1/Integrator1",
    0, "eta_w", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, eta_w), BLOCKIO_SIG, 17,
    3, 2, 790, 0 },

  { 396, "ca_cse1_v1e_wo_losv2b/Control Systems/DP control/BT_power_limit", 0,
    "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, BT_power_limit), BLOCKIO_SIG, 0,
    1, 2, 792, 0 },

  { 397,
    "ca_cse1_v1e_wo_losv2b/Control Systems/DP control/Passive DP wave filter1/Integrator",
    0, "eta", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, eta), BLOCKIO_SIG, 17, 3,
    2, 794, 0 },

  { 398,
    "ca_cse1_v1e_wo_losv2b/Control Systems/DP control/Passive DP wave filter1/[-inf inf] to [-pi pi]/Saturation",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, Saturation_m), BLOCKIO_SIG, 0,
    1, 2, 796, 0 },

  { 399,
    "ca_cse1_v1e_wo_losv2b/Control Systems/DP control/Passive DP wave filter1/[-inf inf] to [-pi pi]/Sign",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, Sign_k), BLOCKIO_SIG, 0, 1, 2,
    798, 0 },

  { 400,
    "ca_cse1_v1e_wo_losv2b/Control Systems/DP control/Passive DP wave filter1/[-inf inf] to [-pi pi]/Gain",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, Gain_k), BLOCKIO_SIG, 0, 1, 2,
    800, 0 },

  { 401,
    "ca_cse1_v1e_wo_losv2b/Control Systems/DP control/Passive DP wave filter1/[-inf inf] to [-pi pi]/Sum1",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, Sum1_i), BLOCKIO_SIG, 0, 1, 2,
    802, 0 },

  { 402,
    "ca_cse1_v1e_wo_losv2b/Control Systems/DP control/Passive DP wave filter1/[-inf inf] to [-pi pi]/Math Function",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, MathFunction_i), BLOCKIO_SIG,
    0, 1, 2, 804, 0 },

  { 403,
    "ca_cse1_v1e_wo_losv2b/Control Systems/DP control/Passive DP wave filter1/[-inf inf] to [-pi pi]/Sum",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, Sum_jb), BLOCKIO_SIG, 0, 1, 2,
    806, 0 },

  { 404, "ca_cse1_v1e_wo_losv2b/Control Systems/DP control/Multiport Switch", 0,
    "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, MultiportSwitch_j), BLOCKIO_SIG,
    17, 3, 2, 808, 0 },

  { 405, "ca_cse1_v1e_wo_losv2b/Control Systems/DP control/DP controller/eta N",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, etaN), BLOCKIO_SIG, 0, 1, 2,
    810, 0 },

  { 406, "ca_cse1_v1e_wo_losv2b/Control Systems/DP control/DP controller/eta E",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, etaE), BLOCKIO_SIG, 0, 1, 2,
    812, 0 },

  { 407,
    "ca_cse1_v1e_wo_losv2b/Control Systems/DP control/DP controller/eta Psi", 0,
    "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, etaPsi), BLOCKIO_SIG, 0, 1, 2,
    814, 0 },

  { 408, "ca_cse1_v1e_wo_losv2b/Control Systems/DP control/DP controller/Sum2",
    0, "regulation error", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b,
    regulationerror), BLOCKIO_SIG, 17, 3, 2, 816, 0 },

  { 409,
    "ca_cse1_v1e_wo_losv2b/Control Systems/DP control/DP controller/Reg_e_N_hil",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, Reg_e_N_hil), BLOCKIO_SIG, 0,
    1, 2, 818, 0 },

  { 410,
    "ca_cse1_v1e_wo_losv2b/Control Systems/DP control/DP controller/Reg_e_E_hil",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, Reg_e_E_hil), BLOCKIO_SIG, 0,
    1, 2, 820, 0 },

  { 411,
    "ca_cse1_v1e_wo_losv2b/Control Systems/DP control/DP controller/Reg_e_Psi_hil",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, Reg_e_Psi_hil), BLOCKIO_SIG,
    0, 1, 2, 822, 0 },

  { 412,
    "ca_cse1_v1e_wo_losv2b/Control Systems/DP control/DP controller/Integrator",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, Integrator_oe), BLOCKIO_SIG,
    17, 3, 2, 824, 0 },

  { 413,
    "ca_cse1_v1e_wo_losv2b/Control Systems/DP control/Passive DP wave filter1/Integrator4",
    0, "nu", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, nu), BLOCKIO_SIG, 17, 3, 2,
    826, 0 },

  { 414, "ca_cse1_v1e_wo_losv2b/Control Systems/DP control/Multiport Switch1", 0,
    "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, MultiportSwitch1), BLOCKIO_SIG,
    17, 3, 2, 828, 0 },

  { 415, "ca_cse1_v1e_wo_losv2b/Control Systems/DP control/DP controller/Kd", 0,
    "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, Kd), BLOCKIO_SIG, 17, 3, 2, 830,
    0 },

  { 416,
    "ca_cse1_v1e_wo_losv2b/Control Systems/DP control/DP controller/Product", 0,
    "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, Product_f), BLOCKIO_SIG, 17, 3,
    2, 832, 0 },

  { 417, "ca_cse1_v1e_wo_losv2b/Control Systems/DP control/DP controller/K_d 1",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, K_d1), BLOCKIO_SIG, 0, 1, 2,
    834, 0 },

  { 418, "ca_cse1_v1e_wo_losv2b/Control Systems/DP control/DP controller/K_d 2",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, K_d2), BLOCKIO_SIG, 0, 1, 2,
    836, 0 },

  { 419, "ca_cse1_v1e_wo_losv2b/Control Systems/DP control/DP controller/K_d 3",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, K_d3), BLOCKIO_SIG, 0, 1, 2,
    838, 0 },

  { 420,
    "ca_cse1_v1e_wo_losv2b/Control Systems/DP control/DP controller/K_d 3 deg",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, K_d3deg), BLOCKIO_SIG, 0, 1,
    2, 840, 0 },

  { 421, "ca_cse1_v1e_wo_losv2b/Control Systems/DP control/DP controller/Ki", 0,
    "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, Ki), BLOCKIO_SIG, 17, 3, 2, 842,
    0 },

  { 422,
    "ca_cse1_v1e_wo_losv2b/Control Systems/DP control/DP controller/Product1", 0,
    "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, Product1_lu), BLOCKIO_SIG, 17, 3,
    2, 844, 0 },

  { 423, "ca_cse1_v1e_wo_losv2b/Control Systems/DP control/DP controller/K_i 1",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, K_i1), BLOCKIO_SIG, 0, 1, 2,
    846, 0 },

  { 424, "ca_cse1_v1e_wo_losv2b/Control Systems/DP control/DP controller/K_i 2",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, K_i2), BLOCKIO_SIG, 0, 1, 2,
    848, 0 },

  { 425, "ca_cse1_v1e_wo_losv2b/Control Systems/DP control/DP controller/K_i 3",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, K_i3), BLOCKIO_SIG, 0, 1, 2,
    850, 0 },

  { 426,
    "ca_cse1_v1e_wo_losv2b/Control Systems/DP control/DP controller/K_i 3 deg",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, K_i3deg), BLOCKIO_SIG, 0, 1,
    2, 852, 0 },

  { 427,
    "ca_cse1_v1e_wo_losv2b/Control Systems/DP control/DP controller/yaw angle",
    0, "psi", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, psi), BLOCKIO_SIG, 0, 1, 2,
    854, 0 },

  { 428,
    "ca_cse1_v1e_wo_losv2b/Control Systems/DP control/DP controller/[-inf inf] to [-pi pi]1/Saturation",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, Saturation_h), BLOCKIO_SIG, 0,
    1, 2, 856, 0 },

  { 429,
    "ca_cse1_v1e_wo_losv2b/Control Systems/DP control/DP controller/[-inf inf] to [-pi pi]1/Sign",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, Sign_i), BLOCKIO_SIG, 0, 1, 2,
    858, 0 },

  { 430,
    "ca_cse1_v1e_wo_losv2b/Control Systems/DP control/DP controller/[-inf inf] to [-pi pi]1/Gain",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, Gain_hg), BLOCKIO_SIG, 0, 1,
    2, 860, 0 },

  { 431,
    "ca_cse1_v1e_wo_losv2b/Control Systems/DP control/DP controller/[-inf inf] to [-pi pi]1/Sum1",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, Sum1_hs), BLOCKIO_SIG, 0, 1,
    2, 862, 0 },

  { 432,
    "ca_cse1_v1e_wo_losv2b/Control Systems/DP control/DP controller/[-inf inf] to [-pi pi]1/Math Function",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, MathFunction_a), BLOCKIO_SIG,
    0, 1, 2, 864, 0 },

  { 433,
    "ca_cse1_v1e_wo_losv2b/Control Systems/DP control/DP controller/[-inf inf] to [-pi pi]1/Sum",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, Sum_kg), BLOCKIO_SIG, 0, 1, 2,
    866, 0 },

  { 434,
    "ca_cse1_v1e_wo_losv2b/Control Systems/DP control/DP controller/[-inf inf] to [-pi pi]/Saturation",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, Saturation_m4), BLOCKIO_SIG,
    0, 1, 2, 868, 0 },

  { 435,
    "ca_cse1_v1e_wo_losv2b/Control Systems/DP control/DP controller/[-inf inf] to [-pi pi]/Sign",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, Sign_b), BLOCKIO_SIG, 0, 1, 2,
    870, 0 },

  { 436,
    "ca_cse1_v1e_wo_losv2b/Control Systems/DP control/DP controller/[-inf inf] to [-pi pi]/Gain",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, Gain_ki), BLOCKIO_SIG, 0, 1,
    2, 872, 0 },

  { 437,
    "ca_cse1_v1e_wo_losv2b/Control Systems/DP control/DP controller/[-inf inf] to [-pi pi]/Sum1",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, Sum1_o), BLOCKIO_SIG, 0, 1, 2,
    874, 0 },

  { 438,
    "ca_cse1_v1e_wo_losv2b/Control Systems/DP control/DP controller/[-inf inf] to [-pi pi]/Math Function",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, MathFunction_d), BLOCKIO_SIG,
    0, 1, 2, 876, 0 },

  { 439,
    "ca_cse1_v1e_wo_losv2b/Control Systems/DP control/DP controller/[-inf inf] to [-pi pi]/Sum",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, Sum_oq), BLOCKIO_SIG, 0, 1, 2,
    878, 0 },

  { 440,
    "ca_cse1_v1e_wo_losv2b/Control Systems/DP control/DP controller/Transposed rotation  matrix in yaw1/Row1",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, Row1_h), BLOCKIO_SIG, 0, 1, 2,
    880, 0 },

  { 441,
    "ca_cse1_v1e_wo_losv2b/Control Systems/DP control/DP controller/Transposed rotation  matrix in yaw1/Row2",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, Row2_h4), BLOCKIO_SIG, 0, 1,
    2, 882, 0 },

  { 442,
    "ca_cse1_v1e_wo_losv2b/Control Systems/DP control/DP controller/Transposed rotation  matrix in yaw1/Row3",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, Row3_a), BLOCKIO_SIG, 0, 1, 2,
    884, 0 },

  { 443, "ca_cse1_v1e_wo_losv2b/Control Systems/DP control/DP controller/Kp", 0,
    "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, Kp), BLOCKIO_SIG, 17, 3, 2, 886,
    0 },

  { 444,
    "ca_cse1_v1e_wo_losv2b/Control Systems/DP control/DP controller/Product2", 0,
    "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, Product2_d), BLOCKIO_SIG, 17, 3,
    2, 888, 0 },

  { 445, "ca_cse1_v1e_wo_losv2b/Control Systems/DP control/DP controller/K_p 1",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, K_p1), BLOCKIO_SIG, 0, 1, 2,
    890, 0 },

  { 446, "ca_cse1_v1e_wo_losv2b/Control Systems/DP control/DP controller/K_p 2",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, K_p2), BLOCKIO_SIG, 0, 1, 2,
    892, 0 },

  { 447, "ca_cse1_v1e_wo_losv2b/Control Systems/DP control/DP controller/K_p 3",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, K_p3), BLOCKIO_SIG, 0, 1, 2,
    894, 0 },

  { 448,
    "ca_cse1_v1e_wo_losv2b/Control Systems/DP control/DP controller/K_p 3 deg",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, K_p3deg), BLOCKIO_SIG, 0, 1,
    2, 896, 0 },

  { 449,
    "ca_cse1_v1e_wo_losv2b/Control Systems/DP control/DP controller/Reg_e_Psi_deg",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, Reg_e_Psi_deg), BLOCKIO_SIG,
    0, 1, 2, 898, 0 },

  { 450, "ca_cse1_v1e_wo_losv2b/Control Systems/DP control/DP controller/Sum3",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, Sum3_l), BLOCKIO_SIG, 17, 3,
    2, 900, 0 },

  { 451, "ca_cse1_v1e_wo_losv2b/Control Systems/DP control/DP controller/Sum1",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, Sum1_g), BLOCKIO_SIG, 17, 3,
    2, 902, 0 },

  { 452,
    "ca_cse1_v1e_wo_losv2b/Control Systems/DP control/DP controller/eta Psi deg",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, etaPsideg), BLOCKIO_SIG, 0, 1,
    2, 904, 0 },

  { 453, "ca_cse1_v1e_wo_losv2b/Control Systems/DP control/DP tau_surge", 0, "",
    offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, DPtau_surge), BLOCKIO_SIG, 0, 1, 2,
    906, 0 },

  { 454, "ca_cse1_v1e_wo_losv2b/Control Systems/DP control/DP tau_sway", 0, "",
    offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, DPtau_sway), BLOCKIO_SIG, 0, 1, 2,
    908, 0 },

  { 455, "ca_cse1_v1e_wo_losv2b/Control Systems/DP control/DP tau_yaw", 0, "",
    offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, DPtau_yaw), BLOCKIO_SIG, 0, 1, 2,
    910, 0 },

  { 456, "ca_cse1_v1e_wo_losv2b/Control Systems/DP control/K_e/Gain K_e1_DP", 0,
    "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, GainK_e1_DP_d), BLOCKIO_SIG, 0,
    1, 2, 912, 0 },

  { 457, "ca_cse1_v1e_wo_losv2b/Control Systems/DP control/K_e/Gain K_e2_DP", 0,
    "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, GainK_e2_DP_b), BLOCKIO_SIG, 0,
    1, 2, 914, 0 },

  { 458, "ca_cse1_v1e_wo_losv2b/Control Systems/DP control/K_e/Gain K_e3_DP", 0,
    "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, GainK_e3_DP_g), BLOCKIO_SIG, 0,
    1, 2, 916, 0 },

  { 459, "ca_cse1_v1e_wo_losv2b/Control Systems/DP control/K_e/Gain K_e4_DP", 0,
    "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, GainK_e4_DP_k), BLOCKIO_SIG, 0,
    1, 2, 918, 0 },

  { 460, "ca_cse1_v1e_wo_losv2b/Control Systems/DP control/K_e/Gain K_e5_DP", 0,
    "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, GainK_e5_DP_p), BLOCKIO_SIG, 0,
    1, 2, 920, 0 },

  { 461,
    "ca_cse1_v1e_wo_losv2b/Control Systems/DP control/K_e/Thruster Gain matrix",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, ThrusterGainmatrix_f),
    BLOCKIO_SIG, 25, 25, 2, 922, 0 },

  { 462, "ca_cse1_v1e_wo_losv2b/Control Systems/DP control/K_e^-1", 0, "",
    offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, K_e1_b), BLOCKIO_SIG, 25, 25, 2, 924,
    0 },

  { 463, "ca_cse1_v1e_wo_losv2b/Control Systems/DP control/T_e/-l_x1", 0, "",
    offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, l_x1_jy), BLOCKIO_SIG, 0, 1, 2, 926,
    0 },

  { 464, "ca_cse1_v1e_wo_losv2b/Control Systems/DP control/T_e/-l_y2", 0, "",
    offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, l_y2_n), BLOCKIO_SIG, 0, 1, 2, 928,
    0 },

  { 465, "ca_cse1_v1e_wo_losv2b/Control Systems/DP control/T_e/-l_x2", 0, "",
    offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, l_x2_jn), BLOCKIO_SIG, 0, 1, 2, 930,
    0 },

  { 466, "ca_cse1_v1e_wo_losv2b/Control Systems/DP control/T_e/3x5", 0, "",
    offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, x5_o), BLOCKIO_SIG, 29, 15, 2, 932,
    0 },

  { 467, "ca_cse1_v1e_wo_losv2b/Control Systems/DP control/T_e^+", 0, "",
    offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, T_e_a), BLOCKIO_SIG, 28, 15, 2, 934,
    0 },

  { 468, "ca_cse1_v1e_wo_losv2b/Control Systems/DP control/Product", 0, "",
    offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, Product_b), BLOCKIO_SIG, 28, 15, 2,
    936, 0 },

  { 469, "ca_cse1_v1e_wo_losv2b/Control Systems/DP control/Product1", 0, "",
    offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, Product1_be), BLOCKIO_SIG, 18, 5, 2,
    938, 0 },

  { 470, "ca_cse1_v1e_wo_losv2b/Control Systems/DP control/DP u_1", 0, "",
    offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, DPu_1_d), BLOCKIO_SIG, 0, 1, 2, 940,
    0 },

  { 471, "ca_cse1_v1e_wo_losv2b/Control Systems/DP control/DP u_2", 0, "",
    offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, DPu_2_b), BLOCKIO_SIG, 0, 1, 2, 942,
    0 },

  { 472, "ca_cse1_v1e_wo_losv2b/Control Systems/DP control/DP u_3", 0, "",
    offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, DPu_3_g), BLOCKIO_SIG, 0, 1, 2, 944,
    0 },

  { 473, "ca_cse1_v1e_wo_losv2b/Control Systems/DP control/DP u_4", 0, "",
    offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, DPu_4_l), BLOCKIO_SIG, 0, 1, 2, 946,
    0 },

  { 474, "ca_cse1_v1e_wo_losv2b/Control Systems/DP control/DP u_5", 0, "",
    offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, DPu_5_l), BLOCKIO_SIG, 0, 1, 2, 948,
    0 },

  { 475,
    "ca_cse1_v1e_wo_losv2b/Control Systems/DP control/Passive DP wave filter1/Gain1",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, Gain1_o), BLOCKIO_SIG, 17, 3,
    2, 950, 0 },

  { 476,
    "ca_cse1_v1e_wo_losv2b/Control Systems/DP control/Passive DP wave filter1/Integrator2",
    0, "xi_w", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, xi_w), BLOCKIO_SIG, 17, 3,
    2, 952, 0 },

  { 477,
    "ca_cse1_v1e_wo_losv2b/Control Systems/DP control/Passive DP wave filter1/Gain2",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, Gain2), BLOCKIO_SIG, 17, 3, 2,
    954, 0 },

  { 478,
    "ca_cse1_v1e_wo_losv2b/Control Systems/DP control/Passive DP wave filter1/Sum4",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, Sum4), BLOCKIO_SIG, 17, 3, 2,
    956, 0 },

  { 479,
    "ca_cse1_v1e_wo_losv2b/Control Systems/DP control/Passive DP wave filter1/Sum2",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, Sum2_d), BLOCKIO_SIG, 17, 3,
    2, 958, 0 },

  { 480,
    "ca_cse1_v1e_wo_losv2b/Control Systems/DP control/Passive DP wave filter1/[-inf inf] to [-pi pi]1/Saturation",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, Saturation_n), BLOCKIO_SIG, 0,
    1, 2, 960, 0 },

  { 481,
    "ca_cse1_v1e_wo_losv2b/Control Systems/DP control/Passive DP wave filter1/[-inf inf] to [-pi pi]1/Sign",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, Sign_h), BLOCKIO_SIG, 0, 1, 2,
    962, 0 },

  { 482,
    "ca_cse1_v1e_wo_losv2b/Control Systems/DP control/Passive DP wave filter1/[-inf inf] to [-pi pi]1/Gain",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, Gain_f), BLOCKIO_SIG, 0, 1, 2,
    964, 0 },

  { 483,
    "ca_cse1_v1e_wo_losv2b/Control Systems/DP control/Passive DP wave filter1/[-inf inf] to [-pi pi]1/Sum1",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, Sum1_cq), BLOCKIO_SIG, 0, 1,
    2, 966, 0 },

  { 484,
    "ca_cse1_v1e_wo_losv2b/Control Systems/DP control/Passive DP wave filter1/[-inf inf] to [-pi pi]1/Math Function",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, MathFunction_j), BLOCKIO_SIG,
    0, 1, 2, 968, 0 },

  { 485,
    "ca_cse1_v1e_wo_losv2b/Control Systems/DP control/Passive DP wave filter1/[-inf inf] to [-pi pi]1/Sum",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, Sum_i), BLOCKIO_SIG, 0, 1, 2,
    970, 0 },

  { 486,
    "ca_cse1_v1e_wo_losv2b/Control Systems/DP control/Passive DP wave filter1/K4",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, K4), BLOCKIO_SIG, 17, 3, 2,
    972, 0 },

  { 487,
    "ca_cse1_v1e_wo_losv2b/Control Systems/DP control/Passive DP wave filter1/Transposed rotation  matrix in yaw/Row1",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, Row1_c), BLOCKIO_SIG, 0, 1, 2,
    974, 0 },

  { 488,
    "ca_cse1_v1e_wo_losv2b/Control Systems/DP control/Passive DP wave filter1/Transposed rotation  matrix in yaw/Row2",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, Row2_bf), BLOCKIO_SIG, 0, 1,
    2, 976, 0 },

  { 489,
    "ca_cse1_v1e_wo_losv2b/Control Systems/DP control/Passive DP wave filter1/Transposed rotation  matrix in yaw/Row3",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, Row3_nq), BLOCKIO_SIG, 0, 1,
    2, 978, 0 },

  { 490,
    "ca_cse1_v1e_wo_losv2b/Control Systems/DP control/Passive DP wave filter1/Integrator3",
    0, "bias", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, bias), BLOCKIO_SIG, 17, 3,
    2, 980, 0 },

  { 491,
    "ca_cse1_v1e_wo_losv2b/Control Systems/DP control/Passive DP wave filter1/Transposed rotation  matrix in yaw1/Row1",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, Row1_kz), BLOCKIO_SIG, 0, 1,
    2, 982, 0 },

  { 492,
    "ca_cse1_v1e_wo_losv2b/Control Systems/DP control/Passive DP wave filter1/Transposed rotation  matrix in yaw1/Row2",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, Row2_bv), BLOCKIO_SIG, 0, 1,
    2, 984, 0 },

  { 493,
    "ca_cse1_v1e_wo_losv2b/Control Systems/DP control/Passive DP wave filter1/Transposed rotation  matrix in yaw1/Row3",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, Row3_l), BLOCKIO_SIG, 0, 1, 2,
    986, 0 },

  { 494,
    "ca_cse1_v1e_wo_losv2b/Control Systems/DP control/Passive DP wave filter1/Sum1",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, Sum1_az), BLOCKIO_SIG, 17, 3,
    2, 988, 0 },

  { 495,
    "ca_cse1_v1e_wo_losv2b/Control Systems/DP control/Passive DP wave filter1/Gain6",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, Gain6), BLOCKIO_SIG, 17, 3, 2,
    990, 0 },

  { 496,
    "ca_cse1_v1e_wo_losv2b/Control Systems/DP control/Passive DP wave filter1/Sum8",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, Sum8), BLOCKIO_SIG, 17, 3, 2,
    992, 0 },

  { 497,
    "ca_cse1_v1e_wo_losv2b/Control Systems/DP control/Passive DP wave filter1/Gain3",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, Gain3), BLOCKIO_SIG, 17, 3, 2,
    994, 0 },

  { 498,
    "ca_cse1_v1e_wo_losv2b/Control Systems/DP control/Passive DP wave filter1/K11",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, K11), BLOCKIO_SIG, 17, 3, 2,
    996, 0 },

  { 499,
    "ca_cse1_v1e_wo_losv2b/Control Systems/DP control/Passive DP wave filter1/K12",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, K12), BLOCKIO_SIG, 17, 3, 2,
    998, 0 },

  { 500,
    "ca_cse1_v1e_wo_losv2b/Control Systems/DP control/Passive DP wave filter1/K2",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, K2), BLOCKIO_SIG, 17, 3, 2,
    1000, 0 },

  { 501,
    "ca_cse1_v1e_wo_losv2b/Control Systems/DP control/Passive DP wave filter1/K3",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, K3), BLOCKIO_SIG, 17, 3, 2,
    1002, 0 },

  { 502,
    "ca_cse1_v1e_wo_losv2b/Control Systems/DP control/Passive DP wave filter1/Rotation matrix in yaw 1/Fcn",
    0, "x_dot", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, x_dot), BLOCKIO_SIG, 0,
    1, 2, 1004, 0 },

  { 503,
    "ca_cse1_v1e_wo_losv2b/Control Systems/DP control/Passive DP wave filter1/Rotation matrix in yaw 1/Fcn1",
    0, "y_dot", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, y_dot), BLOCKIO_SIG, 0,
    1, 2, 1006, 0 },

  { 504,
    "ca_cse1_v1e_wo_losv2b/Control Systems/DP control/Passive DP wave filter1/Rotation matrix in yaw 1/Fcn2",
    0, "psi_dot", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, psi_dot), BLOCKIO_SIG,
    0, 1, 2, 1008, 0 },

  { 505,
    "ca_cse1_v1e_wo_losv2b/Control Systems/DP control/Passive DP wave filter1/Sum3",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, Sum3_k), BLOCKIO_SIG, 17, 3,
    2, 1010, 0 },

  { 506,
    "ca_cse1_v1e_wo_losv2b/Control Systems/DP control/Passive DP wave filter1/Sum5",
    0, "psi_WF", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, psi_WF), BLOCKIO_SIG,
    17, 3, 2, 1012, 0 },

  { 507,
    "ca_cse1_v1e_wo_losv2b/Control Systems/DP control/Passive DP wave filter1/Sum6",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, Sum6), BLOCKIO_SIG, 17, 3, 2,
    1014, 0 },

  { 508,
    "ca_cse1_v1e_wo_losv2b/Control Systems/DP control/Passive DP wave filter1/inv(T_b)",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, invT_b), BLOCKIO_SIG, 17, 3,
    2, 1016, 0 },

  { 509,
    "ca_cse1_v1e_wo_losv2b/Control Systems/DP control/Passive DP wave filter1/Sum7",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, Sum7), BLOCKIO_SIG, 17, 3, 2,
    1018, 0 },

  { 510, "ca_cse1_v1e_wo_losv2b/Control Systems/DP control/Saturation", 0, "",
    offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, Saturation_f), BLOCKIO_SIG, 18, 5, 2,
    1020, 0 },

  { 511, "ca_cse1_v1e_wo_losv2b/Control Systems/DP control/VSP_speeds", 0, "",
    offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, VSP_speeds), BLOCKIO_SIG, 0, 1, 2,
    1022, 0 },

  { 512, "ca_cse1_v1e_wo_losv2b/Control Systems/if DP Control Mode/Compare", 0,
    "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, Compare), BLOCKIO_SIG, 3, 1, 2,
    1024, 0 },

  { 513, "ca_cse1_v1e_wo_losv2b/Control Systems/if iceberg control mode/Compare",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, Compare_f), BLOCKIO_SIG, 3, 1,
    2, 1026, 0 },

  { 514,
    "ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/u to tau/Rate Limiter Dynamic/Saturation Dynamic/LowerRelop1",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, LowerRelop1), BLOCKIO_SIG, 8,
    1, 2, 1028, 0 },

  { 515,
    "ca_cse1_v1e_wo_losv2b/Plants/Linear Simulator/u to tau/Rate Limiter Dynamic/Saturation Dynamic/UpperRelop",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, UpperRelop), BLOCKIO_SIG, 8,
    1, 2, 1030, 0 },

  { 516,
    "ca_cse1_v1e_wo_losv2b/Plants/CSE1/Bow Thruster/Saturation Dynamic/LowerRelop1",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, LowerRelop1_n), BLOCKIO_SIG,
    8, 1, 2, 1032, 0 },

  { 517,
    "ca_cse1_v1e_wo_losv2b/Plants/CSE1/Bow Thruster/Saturation Dynamic/UpperRelop",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, UpperRelop_d), BLOCKIO_SIG, 8,
    1, 2, 1034, 0 },

  { 518,
    "ca_cse1_v1e_wo_losv2b/Plants/CSE1/Bow Thruster/Saturation Dynamic1/LowerRelop1",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, LowerRelop1_o), BLOCKIO_SIG,
    8, 1, 2, 1036, 0 },

  { 519,
    "ca_cse1_v1e_wo_losv2b/Plants/CSE1/Bow Thruster/Saturation Dynamic1/UpperRelop",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, UpperRelop_o), BLOCKIO_SIG, 8,
    1, 2, 1038, 0 },

  { 520,
    "ca_cse1_v1e_wo_losv2b/Plants/CSE1/Bow Thruster/Saturation Dynamic2/LowerRelop1",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, LowerRelop1_j), BLOCKIO_SIG,
    8, 1, 2, 1040, 0 },

  { 521,
    "ca_cse1_v1e_wo_losv2b/Plants/CSE1/Bow Thruster/Saturation Dynamic2/UpperRelop",
    0, "", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, UpperRelop_h), BLOCKIO_SIG, 8,
    1, 2, 1042, 0 },

  { 522,
    "ca_cse1_v1e_wo_losv2b/Guidance Systems/Path generator (iceberg towing)/v_s and v_s_t maker/null checker1",
    0, "y", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, sf_nullchecker1.y),
    BLOCKIO_SIG, 0, 1, 2, 1044, 0 },

  { 523,
    "ca_cse1_v1e_wo_losv2b/Guidance Systems/Path generator (iceberg towing)/v_s and v_s_t maker/null checker",
    0, "y", offsetof(BlockIO_CA_CSE1_V1e_wo_LOSV2b, sf_nullchecker.y),
    BLOCKIO_SIG, 0, 1, 2, 1046, 0 },

  { -1, "", -1, "", 0, 0, 0 }
};

static int NI_VirtualBlockSources[1][1];
static int NI_VirtualBlockOffsets[1][1];
static int NI_VirtualBlockLengths[1][1];
static int NI_SigDimList[] = {
  16, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
  1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
  1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 5, 5, 5, 5, 1, 1, 1, 1, 1, 1, 3, 5,
  5, 3, 5, 3, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 5, 1, 5,
  1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 3, 1, 1, 1, 1, 1, 1,
  1, 3, 1, 1, 1, 1, 1, 1, 1, 3, 1, 3, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
  1, 1, 1, 1, 3, 3, 6, 6, 1, 6, 1, 6, 1, 3, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
  1, 1, 1, 1, 5, 5, 5, 5, 1, 1, 1, 1, 1, 1, 3, 5, 5, 3, 5, 3, 1, 1, 1, 1, 1, 1,
  1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
  1, 1, 1, 1, 1, 1, 1, 1, 1, 3, 1, 1, 1, 1, 1, 1, 1, 3, 1, 1, 1, 1, 1, 1, 1, 1,
  1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 3, 1, 3, 1, 3, 1, 3, 1, 3, 1, 3,
  1, 3, 1, 3, 1, 3, 1, 1, 1, 1, 1, 1, 1, 3, 1, 3, 1, 1, 1, 1, 1, 3, 1, 3, 1, 3,
  1, 1, 1, 1, 1, 1, 1, 3, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
  1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 3, 1, 1, 1, 1,
  1, 1, 1, 3, 1, 3, 1, 1, 1, 1, 1, 1, 1, 3, 1, 3, 1, 1, 1, 1, 1, 1, 1, 1, 1, 3,
  1, 3, 1, 1, 1, 1, 1, 1, 1, 1, 1, 3, 1, 3, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
  1, 1, 1, 1, 1, 1, 1, 3, 1, 3, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 3, 1, 5,
  1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 5, 1, 7, 1, 7, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
  1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 6, 1, 3, 1, 3, 1, 1, 1, 1,
  1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 3, 3, 6, 6, 1, 6, 1, 1, 1, 1, 1, 1,
  1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
  1, 1, 1, 1, 1, 1, 3, 3, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 3, 1, 3, 1, 1,
  1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 3, 3, 3, 3, 1, 3, 1, 1, 1, 1, 1, 1, 3, 5, 1, 1,
  1, 1, 1, 1, 1, 1, 1, 1, 5, 5, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 3, 3, 1, 3,
  1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
  1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 3, 1, 1, 1, 1, 1, 1,
  1, 3, 1, 3, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
  1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
  1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
  1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 3, 5, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
  5, 5, 1, 3, 1, 1, 1, 1, 1, 1, 1, 3, 1, 1, 1, 3, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
  1, 1, 1, 3, 1, 1, 1, 1, 1, 1, 1, 3, 1, 1, 1, 1, 1, 1, 1, 3, 1, 3, 1, 3, 1, 3,
  1, 3, 1, 1, 1, 1, 1, 1, 1, 1, 1, 3, 1, 3, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
  1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
  1, 1, 1, 3, 1, 3, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 3, 1, 3, 1, 1, 1, 1, 1, 1,
  1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 5, 5, 5, 5, 1, 1, 1, 1, 1, 1, 3, 5, 5, 3,
  5, 3, 1, 5, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 3, 1, 3, 1, 3, 1, 3, 1, 3, 1, 1,
  1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 3, 1, 1, 1, 1, 1, 1, 1, 3, 1, 1, 1, 1, 1, 1,
  1, 3, 1, 3, 1, 3, 1, 3, 1, 3, 1, 3, 1, 3, 1, 3, 1, 1, 1, 1, 1, 1, 1, 3, 1, 3,
  1, 3, 1, 3, 1, 3, 1, 5, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
  1, 1, 1, 1, 1, 1, 1, 1, };

static long NI_ExtListSize = 11;
static NI_ExternalIO NI_ExtList[] = {
  { 0, "Naviagation Systems/Qualisys 6 DOF/QTM In", 0, EXT_IN, 16, 16, 1 },

  { 1, "HMI/SIT zAI0", 1, EXT_IN, 1, 1, 1 },

  { 2, "HMI/SIT zAI1", 1, EXT_IN, 1, 1, 1 },

  { 3, "HMI/SIT zAI2", 1, EXT_IN, 1, 1, 1 },

  { 0, "Plants/CSE1/Bow Thruster/SIT Out5 BT", 0, EXT_OUT, 1, 1, 1 },

  { 1, "Plants/CSE1/Voith Schneider Propeller /SIT Out1 Servo1", 0, EXT_OUT, 1,
    1, 1 },

  { 2, "Plants/CSE1/Voith Schneider Propeller /SIT Out2 Servo2", 0, EXT_OUT, 1,
    1, 1 },

  { 3, "Plants/CSE1/Voith Schneider Propeller /SIT Out3 Servo3", 0, EXT_OUT, 1,
    1, 1 },

  { 4, "Plants/CSE1/Voith Schneider Propeller /SIT Out4 Servo4", 0, EXT_OUT, 1,
    1, 1 },

  { 5, "Plants/CSE1/Voith Schneider Propeller /SIT Out6 VSPS Port", 0, EXT_OUT,
    1, 1, 1 },

  { 6, "Plants/CSE1/Voith Schneider Propeller /SIT Out7 VSPS Starboard", 0,
    EXT_OUT, 1, 1, 1 },

  { -1, "", 0, 0, 0, 0, 0 }
};

/* This Task List is generated to allow access to the task specs without
 * initializing the model.
 * 0th entry is for scheduler (base rate)
 * rest for multirate model's tasks.
 */
NI_Task NI_TaskList[] = {
  { 0, 0.1, 0 }
};

int NI_NumTasks = 1;
int NIRT_ComputeNextCycleSampleHits(void)
{
  int retVal = 1+TID01EQ;              /* TID zero is always a sample hit, unless TID01EQ==1 */

#if defined(MULTITASKING)

  int i = 1;
  int tick, schedule_ticks;
  for (; i < NUMST-TID01EQ; ++i) {
    tick = S->Timing.TaskCounters.TID[i+TID01EQ] + 1;
    schedule_ticks = (int) ((NI_TaskList[i].tstep/NI_TaskList[0].tstep)+0.5);//Round to closest tick count
    if (tick == schedule_ticks)
      retVal |= (1 << (i+TID01EQ));
  }

#endif                                 /* defined(MULTITASKING) */

  return retVal;
}

static char* NI_CompiledModelName = "ca_cse1_v1e_wo_losv2b";
static char* NI_CompiledModelVersion = "1.274";
static char* NI_CompiledModelDateTime = "Wed Apr 17 14:28:19 2013";

/* Model Information Query fucntions for MATLAB
 */
/* dll information
 * Returns 1 for RTW DLL
 *		   2 for AutoCode DLL
 */
DLL_EXPORT long NIRT_GetBuildInfo(char* detail, long* len)
{
  static char* builder = "10.0.0 SIT RTW Build";

  //There are no console properties to set for VxWorks, because the console is simply serial output data.
  //Just do printf for VxWorks and ignore all console properties.
#ifndef VXWORKS

  HANDLE hStdout = GetStdHandle(STD_OUTPUT_HANDLE);
  SetConsoleTextAttribute(hStdout, FOREGROUND_INTENSITY | FOREGROUND_BLUE |
    FOREGROUND_GREEN | FOREGROUND_RED);

#endif

  printf("\n*******************************************************************************\n");
  printf("%s\nModel Name: %s\nModel Version: %s\nCompiled On: %s",
         builder, NI_CompiledModelName, NI_CompiledModelVersion,
         NI_CompiledModelDateTime);
  printf("\n*******************************************************************************\n");

#ifndef VXWORKS

  SetConsoleTextAttribute(hStdout, FOREGROUND_BLUE | FOREGROUND_GREEN |
    FOREGROUND_RED);

#endif

  if (*len>=(long)strlen(builder))
    *len = strlen(builder)+1;
  strncpy(detail,builder,*len);
  return 1;
}

/*
 * Distinction between Index and ID:
 * Index is a long datatype (used to set parameter/probe signals).
 * ID on the other hand is a string (tag "2-3-2-12" for MatrixX/ Full path "f14/Gain/Gain" for Matlab).
 * NOTE: ID may not be the same as Paramname or signal name.
 */

/* signal information
   NOTE: signal ID == the blockname and port that feeds it.

   The port number in Simulation Environment is 1 indexed.. but on RT is 0 indexed.
 */
DLL_EXPORT long NIRT_GetSignalSpec(long* sidx, char* ID, long* ID_len, char
  * blkname, long *bnlen,
  long *portnum, char* signame, long *snlen, long *dattype, long* dims, long
  * numdim)
{
  long sigidx = *sidx;
  int i = 0;
  char *IDblk = 0;
  int IDport = 0;
  if (sigidx<0) {
    // check if ID has been specified.
    if (ID && *ID_len>0) {
      // parse ID into blkname and port
      i = strrchr(ID, ':') - ID;

      // malformed ID
      if (i<=0)
        return NI_SigListSize;
      ID[i] = 0;
      IDblk = ID;
      IDport = atoi(ID+i+1);

      // lookup the table for matching ID
      for (i=0;i<NI_SigListSize;i++) {
        if (!strcmp(IDblk,NI_SigList[i].blockname) && IDport==(NI_SigList[i].
             portno+1))
          break;
      }

      if (i<NI_SigListSize)
        sigidx = *sidx = i;
      else
        return NI_SigListSize;
    } else                             // no index or ID specified.
      return NI_SigListSize;
  }

  if (sigidx>=0 && sigidx<NI_SigListSize) {
    if (ID) {
      // no need for return string to be null terminated!
      // 10 to accomodate ':', port number and null character
      char *tempID = (char *)calloc(strlen(NI_SigList[sigidx].blockname) + 10,
        sizeof(char));
      sprintf(tempID,"%s:%d",NI_SigList[sigidx].blockname,NI_SigList[sigidx].
              portno+1);
      if ((long)strlen(tempID)<*ID_len)
        *ID_len = strlen(tempID);
      strncpy(ID, tempID, *ID_len);
      free(tempID);
    }

    if (blkname) {
      // no need for return string to be null terminated!
      if ((long)strlen(NI_SigList[sigidx].blockname)<*bnlen)
        *bnlen = strlen(NI_SigList[sigidx].blockname);
      strncpy(blkname, NI_SigList[sigidx].blockname, *bnlen);
    }

    if (signame) {
      // no need for return string to be null terminated!
      if ((long)strlen(NI_SigList[sigidx].signalname)<*snlen)
        *snlen = strlen(NI_SigList[sigidx].signalname);
      strncpy(signame, NI_SigList[sigidx].signalname, *snlen);
    }

    if (portnum)
      *portnum = NI_SigList[sigidx].portno;
    if (dattype)
      *dattype = NI_SigList[sigidx].datatype;
    if (dims && *numdim>=NI_SigList[sigidx].numofdims) {
      *numdim = NI_SigList[sigidx].numofdims;
      for (i=0;i < *numdim; i++)
        dims[i] = NI_SigDimList[NI_SigList[sigidx].dimListOffset +i];
    } else
      *numdim = 0;                     // set numdim to 0 to indicate that no enough memory to return the info.
    return 0;
  }

  return NI_SigListSize;
}

/*
 * Get parameter indices
 */
DLL_EXPORT long NIRT_GetParameterIndices(long* indices, long* len)
{
  long i;
  for (i=0;i<NI_ParamListSize && i<*len;i++)
    indices[i] = NI_ParamList[i].idx;
  *len = i;
  return NI_OK;
}

/*
 * parameter information
 *
 * if *pidx < 0, Lookup parameter by ID if ID != NULL.
 * if ID == NULL or no matching ID found, return number of parameters.
 *
 * plen  -> size of path
 * pnlen -> size of paramname
 * numdim -> size of dims array
 */
DLL_EXPORT long NIRT_GetParameterSpec(long* pidx, char* ID, long* ID_len, char
  * paramname, long *pnlen,
  long *dattype, long* dims, long* numdim)
{
  int i= 0;
  int paramidx = *pidx;
  if (paramidx<0) {
    // check if ID has been specified.
    if (ID && *ID_len>0) {
      // lookup the table for matching ID
      for (i=0;i<NI_ParamListSize;i++) {
        if (!strcmp(ID,NI_ParamList[i].paramname))
          break;
      }

      if (i<NI_ParamListSize)
        paramidx = *pidx = i;
      else
        return NI_ParamListSize;
    } else                             // no index or ID specified.
      return NI_ParamListSize;
  }

  if (paramidx>=0 && paramidx<NI_ParamListSize) {
    if (ID) {
      if ((long)strlen(NI_ParamList[paramidx].paramname)<*ID_len)
        *ID_len = strlen(NI_ParamList[paramidx].paramname);
      strncpy(ID, NI_ParamList[paramidx].paramname, *ID_len);
    }

    if (paramname) {
      // no need for return string to be null terminated!
      if ((long)strlen(NI_ParamList[paramidx].paramname)<*pnlen)
        *pnlen = strlen(NI_ParamList[paramidx].paramname);
      strncpy(paramname, NI_ParamList[paramidx].paramname, *pnlen);
    }

    if (dattype)
      *dattype = NI_ParamList[paramidx].datatype;
    if (!numdim)
      return 0;
    if (*numdim>=NI_ParamList[paramidx].numofdims) {
      *numdim = NI_ParamList[paramidx].numofdims;
      for (i=0;i < *numdim; i++)
        dims[i] = NI_ParamDimList[NI_ParamList[paramidx].dimListOffset +i];
    } else
      *numdim = 0;                     // set numdim to 0 to indicate that no enough memory to return the info.
    return 0;
  }

  return NI_ParamListSize;
}

/*
 * parameter expression information
 * If paramidx is outside of limit returns number of parameters, else 0.
 *
 * explen  -> size of expression
 */
DLL_EXPORT long NIRT_GetParameterExpression(long paramidx, char* expression,
  long *exp_len)
{
  if (paramidx>=0 && paramidx<NI_ParamListSize) {//If paramidx is valid then get expression
    if (expression && exp_len) {       //Make sure expression and exp_len are defined (don't point to NULL)
      if ((long)strlen(NI_ParamList[paramidx].expression)<*exp_len)
        *exp_len = strlen(NI_ParamList[paramidx].expression);
      strncpy(expression, NI_ParamList[paramidx].expression, *exp_len);//Copy string up to exp_len or actual expression length
    }

    return 0;
  }

  if (exp_len)
    *exp_len = 0;
  return NI_ParamListSize;
}

/*
 * variables information
 * If paramidx is outside of limit returns number of variables in list, else 0.
 *
 * varlen  -> size of variable name
 */
DLL_EXPORT long NIRT_GetVariableName(long varidx, char* variable_name, long
  *var_len)
{
  if (varidx>=0 && varidx<NI_VariablesListSize) {//If varidx is in valid range then get variable name
    if (variable_name && var_len) {    //Make sure variable name and var_len are defined (don't point to NULL
      if ((long)strlen(NI_VariablesList[varidx])<*var_len)
        *var_len = strlen(NI_VariablesList[varidx]);
      strncpy(variable_name, NI_VariablesList[varidx], *var_len);//Copy string up to var_len or actual variable length (which ever is shorter)
    }

    return 0;
  }

  if (var_len)
    *var_len = 0;
  return NI_VariablesListSize;
}

/*
 * NIRT_GetExtIOSpec
 *
 * Inputs:
 *		index: index of the task
 * Outputs:
 *		idx:  idx of the IO.
 *		name: Name of the IO block
 *		tid: task id
 *		type: EXT_IN or EXT_OUT
 *		dimX: size of 0th dimension
 *		dimY: size of 1th dimension
 * Return value: 0 if no error. (if index == -1, return number of tasks in the model)
 */
DLL_EXPORT long NIRT_GetExtIOSpec(long index, long *idx, char* name, long* tid,
  long *type, long *dims, long* numdims)
{
  if (index==-1)
    return NI_ExtListSize;
  if (idx)
    *idx = NI_ExtList[index].idx;
  if (name) {
    int sz = strlen(name);
    strncpy(name, NI_ExtList[index].name, sz-1);
    name[sz-1]= 0;
  }

  if (tid)
    *tid = NI_ExtList[index].TID;
  if (type)
    *type = NI_ExtList[index].type;
  if (numdims && dims) {
    if (*numdims>=2) {
      *numdims= 2;
      dims[0] = NI_ExtList[index].dimX;
      dims[1] = NI_ExtList[index].dimY;
    } else
      *numdims= 0;
  }

  return 0;
}

/* Helper function to probe one	signal. baseaddr must NOT be VIRTUAL_SIG */
static long NI_ProbeOneSignal(long idx, double *value, long len, long *count,
  long vOffset, long vLength)
{
  char *ptr = (char*)((NI_SigList[idx].baseaddr == BLOCKIO_SIG) ?
                      S->ModelData.blockIO : S->ModelData.inputs ) + (int)
    NI_SigList[idx].addr;
  long subindex = (vLength == -1) ? 0 : vOffset;
  long sublength = (vLength == -1) ? NI_SigList[idx].width : (vLength + vOffset);
  while ((subindex < sublength) && (*count < len))
    value[(*count)++] = NIRT_GetValueByDataType(ptr, subindex++, NI_SigList[idx]
      .datatype, NI_SigList[idx].IsComplex);
  return *count;
}

/*
 * NIRT_ProbeSignals
 *
 * Inputs:
 *		sigindices: indeces of signals
 *		numsigs: number of signals
 *		len: total length of all signals
 * Outputs:
 *		value: probed signal data
 *		len: length of data (may vary from input)
 * Return value: equal to len
 */
DLL_EXPORT long NIRT_ProbeSignals(long* sigindices, long numsigs,
  double* value, long* len)
{
  int i, j, count = 0, idx;
  if (!SITexportglobals.inCriticalSection)
    SetSITErrorMessage("SignalProbe should only be called between ScheduleTasks and PostOutputs",
                       1);
  if ((*len > 1) && (numsigs > 0)) {
    value[count++] = sigindices[0];
    value[count++] = 0;
  }

  for (i = 1; (i < numsigs) && (count < *len); i++) {
    idx = sigindices[i];
    if (idx < 0)
      break;
    if (idx < NI_SigListSize) {
      if (NI_SigList[idx].baseaddr == VIRTUAL_SIG) {
        for (j = 0; j < 0; j++) {
          long vidx = NI_VirtualBlockSources[NI_SigList[idx].addr][j];
          long voff = NI_VirtualBlockOffsets[NI_SigList[idx].addr][j];
          long vlen = NI_VirtualBlockLengths[NI_SigList[idx].addr][j];
          if (vidx == -1)
            break;
          NI_ProbeOneSignal(vidx, value, *len, &count, voff, vlen);
        }
      } else
        NI_ProbeOneSignal(idx, value, *len, &count, 0, -1);
    }
  }

  *len = count;
  return count;
}

/* Copy the	statically initialized params into our copy of the param struct
   The undef allows us to access the real CA_CSE1_V1e_wo_LOSV2b_P
   In the rest of the code CA_CSE1_V1e_wo_LOSV2b_P is redefine to be the read-side
   of rtParameter.
 */
#undef CA_CSE1_V1e_wo_LOSV2b_P

int NI_InitializeParamStruct()
{
  memcpy(&rtParameter[0], &CA_CSE1_V1e_wo_LOSV2b_P, sizeof
         (Parameters_CA_CSE1_V1e_wo_LOSV2));
  return NI_OK;
}

/*  After the model has initialized and updated the parameters in
   rtParameter[0] (aka CA_CSE1_V1e_wo_LOSV2b_P) we make a copy to rtParameter[1] so
   that it is double buffered. We also do a memcpy to each task's copy.
 */
int NI_InitParamDoubleBuf()
{
  int idx = 1;

#ifdef MULTITASKING

  for (; idx <= NUMST - TID01EQ; idx++)
#endif

    memcpy(&rtParameter[idx], &rtParameter[0], sizeof
           (Parameters_CA_CSE1_V1e_wo_LOSV2));
  return NI_OK;
}

static int NI_SetParamTxStatus = NI_OK;

// This function is called by the BGL to set parameters.  When a commit is requested (index < 0),
// the code enters a critical section shared with the TCL. This ensures that the flip occurs only
// when safe, and acts as a messaging scheme for us to copy back the parameters.
DLL_EXPORT long NIRT_SetParameter(long index, long subindex, double value)
{
  char* ptr = NULL;
  if (index>=NI_ParamListSize)
    return NI_SetParamTxStatus= NI_ERROR;
  if (index < 0) {
    if (NI_SetParamTxStatus==NI_ERROR) {
      // fail the transaction.
      // copy old	list of parameters to the failed TX buffer
      memcpy(&rtParameter[READSIDE], &rtParameter[1-READSIDE], sizeof
             (Parameters_CA_CSE1_V1e_wo_LOSV2));

      // reset the status.
      NI_SetParamTxStatus = NI_OK;
      return NI_ERROR;
    }

    // commit changes
    S->ModelData.defaultParam = (double *)&rtParameter[1-READSIDE];
    WaitForSingleObject(SITexportglobals.flipCriticalSection, INFINITE);
    READSIDE = 1 - READSIDE;
    SITexportglobals.copyTaskBitfield = 0xFFFFFFFF;
    ReleaseSemaphore(SITexportglobals.flipCriticalSection, 1, NULL);

    // Copy back the newly set parameters to the writeside.
    memcpy(&rtParameter[1-READSIDE], &rtParameter[READSIDE], sizeof
           (Parameters_CA_CSE1_V1e_wo_LOSV2));
    return NI_OK;
  }

  // verify that subindex is within bounds.
  if (subindex>=NI_ParamList[index].width)
    return NI_SetParamTxStatus= NI_ERROR;
  ptr = (char *)(&rtParameter[1-READSIDE]);
  ptr += (int)NI_ParamList[index].addr;
  return NIRT_SetValueByDataType(ptr,subindex,value,NI_ParamList[index].datatype,
    NI_ParamList[index].IsComplex);
}

DLL_EXPORT long NIRT_GetParameter(long index, long subindex, double *value)
{
  char* ptr = NULL;
  if (index>=NI_ParamListSize || index < 0)
    return NI_ERROR;

  // verify that subindex is within bounds.
  if (subindex>=NI_ParamList[index].width)
    return NI_ERROR;
  ptr = (char *)(&rtParameter[READSIDE]);
  ptr += (int)NI_ParamList[index].addr;
  *value = NIRT_GetValueByDataType(ptr,subindex,NI_ParamList[index].datatype,
    NI_ParamList[index].IsComplex);
  return NI_OK;
}

#endif                                 // of NI_ROOTMODEL_CA_CSE1_V1e_wo_LOSV2b
